
/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident "$File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>
#include <57xx_fcoe_constants.h>
#include <fw_defs.h>


#define	BURST1			0x01
#define	BURST2			0x02
#define	BURST4			0x04
#define	BURST8			0x08
#define	BURST16			0x10
#define	BURST32			0x20
#define	BURST64			0x40
#define	DEFAULT_BURSTSIZE \
		(BURST64| BURST32 | BURST16 | BURST8 |BURST4 | BURST2 | BURST1)

/* Prototypes */
static int bnxef_open(dev_t *devp, int flag, int otype, cred_t *crep);
static int bnxef_close(dev_t dev, int flag, int otype, cred_t *credp);
static int bnxef_ioctl(dev_t dev, int cmd, intptr_t data, int mode,
		    cred_t *credp, int *rval);
static int bnxef_attach(dev_info_t *dip, ddi_attach_cmd_t cmd);
int bnxef_attach_handler(bnxef_driver_state_t *dsp);
static int bnxef_detach(dev_info_t *dip, ddi_detach_cmd_t cmd);
int nxef_attach_handler(bnxef_driver_state_t *dsp);
int bnxef_detach_handler(bnxef_driver_state_t *dsp, uint32_t stage);
extern void bnxef_trigger_fp_attach(void *arg);
opaque_t bnxef_bind_port(dev_info_t *dip, fc_fca_port_info_t *pip,
	fc_fca_bind_info_t *bip);
void bnxef_unbind_port(opaque_t fca_handle);
int bnxef_init_pkt(opaque_t fca_handle, fc_packet_t *pktp, int sleep);
int bnxef_un_init_pkt(opaque_t fca_handle, fc_packet_t *pktp);
int bnxef_transport(opaque_t fca_handle, fc_packet_t *pktp);
int bnxef_send_els(opaque_t fca_handle, fc_packet_t *pktp);
int bnxef_ub_alloc(opaque_t fca_handle, uint64_t tokens[], uint32_t size,
	uint32_t *countp, uint32_t type);
int bnxef_ub_release(opaque_t fca_handle, uint32_t count, uint64_t tokens[]);
int bnxef_ub_free(opaque_t fca_handle, uint32_t count, uint64_t tokens[]);
int bnxef_get_cap(opaque_t fca_handle, char *cap, void *bufp);
int bnxef_set_cap(opaque_t fca_handle, char *cap, void *bufp);
int bnxef_getmap(opaque_t fca_handle, fc_lilpmap_t *mbp);
int bnxef_abort(opaque_t fca_handle, fc_packet_t *pktp, int flags);
int bnxef_reset(opaque_t fca_handle, uint32_t cmd);
int bnxef_port_manage(opaque_t fc_handle, fc_fca_pm_t *cmdp);
int bnxef_notify(opaque_t fca_handle, uint32_t cmd);
int bnxef_is_intf_used_for_mba_boot(bnxef_driver_state_t *dsp);
void bnxef_destroy_kmem_cache(bnxef_driver_state_t *dsp, uint32_t stage);
extern int bnxef_task_bd_table_pre_free(bnxef_driver_state_t *dsp,
		bnxef_fcoe_task_t *taskp, uint32_t stage);
extern int bnxef_task_bd_table_pre_alloc(bnxef_driver_state_t *dsp,
		bnxef_fcoe_task_t *taskp);


#ifdef TESTING
extern void bnxef_test_driver_task(bnxef_driver_state_t *dsp);
extern void bnxef_test_driver_port(bnxef_driver_state_t *dsp);
extern void bnxef_test_driver_session(bnxef_driver_state_t *dsp);
#endif

extern int bnxef_unsol_buf_cache_destroy(bnxef_driver_state_t *dsp);
extern int bnxef_unsol_buf_cache_create(bnxef_driver_state_t *dsp);
extern int bnxef_port_get_id(bnxef_port_t *portp, int cmd);
extern void bnxef_fc_port_online(void *arg);
extern void bnxef_fc_port_offline(void *arg);
extern void bnxef_cleanup_port(bnxef_port_t *portp);
extern void bnxef_shutdown_port(bnxef_port_t *portp);
extern void bnxef_timeout_fip_ka(void *arg);
extern void bnxef_stats_update(void *arg);
extern void bnxef_stats_mcp_report(void *arg);
extern void bnxef_fcf_list_purge(bnxef_driver_state_t *dsp);
extern int bnxef_get_active_ub_count(bnxef_port_t *portp);

char _depends_on[] = "misc/fctl";

#define	BNXEF_FCOE_PROD_INFO 	"Broadcom NXII FCoE v" BNXEF_FCOE_VERSION

/* Global debugging information */
bnxef_driver_state_t *global_state[BNXEF_MAX_INSTANCES];
int num_instances;
/*
 * Driver identificaton stuff
 */
static struct cb_ops bnxef_cb_ops = {
	bnxef_open,
	bnxef_close,
	nodev,
	nodev,
	nodev,
	nodev,
	nodev,
	bnxef_ioctl,
	nodev,
	nodev,
	nodev,
	nochpoll,
	ddi_prop_op,
	0,
	D_MP | D_NEW | D_HOTPLUG,
	CB_REV,
	nodev,
	nodev
};

static struct dev_ops bnxef_ops = {
	DEVO_REV,
	0,
	nodev,
	nulldev,
	nulldev,
	bnxef_attach,
	bnxef_detach,
	nodev,
	&bnxef_cb_ops,
	NULL,
#if defined(__S11) || defined(__S12)
	    NULL, /* ddi_power? */
	NULL /* Quiesce */
#else
	ddi_power,
#endif
};

static struct modldrv modldrv = {
	&mod_driverops,
	BNXEF_FCOE_PROD_INFO,
	&bnxef_ops,
};

static struct modlinkage modlinkage = {
	MODREV_1,
	&modldrv,
	NULL
};

void  * bnxef_state = NULL;


/*
 * The following are the DMA Limit, attr and access structures provided to
 * leadville stack for creating dmaable buffers for data, cmd and response.
 */

ddi_dma_lim_t bnxef_dma_lim = {
	(uint32_t)0,		/* dlim_addr_lo */
	(uint32_t)0xffffffff,	/* dlim_addr_hi */
	(uint32_t)0xffffffff,	/* dlim_cntr_max */
	DEFAULT_BURSTSIZE, /* dlim_burstsizes */
	1,
	0			/* No optimization done based on speed */
};


ddi_dma_attr_t bnxef_dma_attr = {
	DMA_ATTR_V0,			 /* DMA Attribute version */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* dma_attr_addr_lo */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_HI,  /* dma_attr_addr_hi */
	(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* dma_attr_count_max */
	BNXEF_DMA_ATTR_ALIGN,	 /* dma_attr_align */
	BNXEF_DMA_ATTR_BURST_SIZE, /* dma_attr_burstsizes */
	BNXEF_DMA_ATTR_MIN_XFER,  /* dma_attr_minxfer */
	(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* dma_attr_maxxfer */
	(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* dma_attr_seg */
	BNXEF_DMA_ATTR_1_SEG_COUNT,	 /* dma_attr_segllen - Revisit */
	BNXEF_DMA_ATTR_128_GRANULARITY,	 /* dma_attr_granular */
	BNXEF_DMA_ATTR_DMA_FLAGS		 /* dma_attr_flags */
};

ddi_dma_attr_t bnxef_data_dma_attr = {
	DMA_ATTR_V0,			 /* DMA Attribute version */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* dma_attr_addr_lo */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_HI,  /* dma_attr_addr_hi */
	(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* dma_attr_count_max */
	BNXEF_DMA_ATTR_BYTE_ALIGN,	 /* dma_attr_align */
	DEFAULT_BURSTSIZE,	 /* dma_attr_burstsizes */
	BNXEF_DMA_ATTR_MIN_XFER,	 /* dma_attr_minxfer */
	(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* dma_attr_maxxfer */
	(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* dma_attr_seg */
	128,	 /* dma_attr_segllen - Revisit */
	BNXEF_DMA_ATTR_128_GRANULARITY,	 /* dma_attr_granular */
	BNXEF_DMA_ATTR_DMA_FLAGS		 /* dma_attr_flags */
};

ddi_dma_attr_t bnxef_cmdrsp_dma_attr = {
	DMA_ATTR_V0,			 /* DMA Attribute version */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* dma_attr_addr_lo */
	(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* dma_attr_addr_hi */
	(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* dma_attr_count_max */
	8,				 /* dma_attr_align */
	DEFAULT_BURSTSIZE,	 /* dma_attr_burstsizes */
	BNXEF_DMA_ATTR_MIN_XFER,	 /* dma_attr_minxfer */
	(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* dma_attr_maxxfer */
	(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* dma_attr_seg */
	BNXEF_DMA_ATTR_1_SEG_COUNT,	 /* dma_attr_segllen - Revisit */
	BNXEF_DMA_ATTR_128_GRANULARITY,	 /* dma_attr_granular */
	BNXEF_DMA_ATTR_DMA_FLAGS	 /* dma_attr_flags */
};

ddi_device_acc_attr_t bnxef_dev_acc_attr = {
	DDI_DEVICE_ATTR_V1,	/* device_attr_version */
	DDI_NEVERSWAP_ACC,	/* PCI is little endian */
	DDI_STRICTORDER_ACC,	/* devacc_attr_dataorder */
	DDI_DEFAULT_ACC		/* devacc_attr_Access */
};



/*
 * Common loadable module entry points _init, _fini, _info
 */

int
_init(void)
{
	int ret;

	ret = ddi_soft_state_init(&bnxef_state,
			sizeof (bnxef_driver_state_t), 0);
	if (ret != DDI_SUCCESS) {
		return (ret);
	}

	ret = mod_install(&modlinkage);
	if (ret != 0) {
		ddi_soft_state_fini(&bnxef_state);
		return (ret);
	}

	fc_fca_init(&bnxef_ops);
	return (ret);
}

int
_fini(void)
{
	int ret;

	ret = mod_remove(&modlinkage);
	if (ret != 0) {
		return (ret);
	}

	ddi_soft_state_fini(&bnxef_state);
	return (ret);
}


int
_info(struct modinfo *modinfop)
{
	return (mod_info(&modlinkage, modinfop));
}


/*
 * THis will be the auto configuration entry points for this driver.
 */

int
bnxef_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
{
	int		 ret;
	int		instance;
	bnxef_driver_state_t *dsp;

	instance = ddi_get_instance(dip);
	switch (cmd) {
	case DDI_ATTACH:
		ret = ddi_soft_state_zalloc(bnxef_state, instance);
		if (ret != DDI_SUCCESS) {
			return (ret);
		}

		dsp = ddi_get_soft_state(bnxef_state, instance);
		dsp->dip = dip;
		dsp->instance = instance;
		if (instance < BNXEF_MAX_INSTANCES)
			global_state[instance] = dsp;
		num_instances++;

		cmn_err(CE_NOTE, "%s", BNXEF_PRODUCT_BANNER);
		ret = bnxef_attach_handler(dsp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: attach failed",
				BNXEF_DRIVER_NAME, instance);
			ddi_soft_state_free(bnxef_state, instance);
			return (DDI_FAILURE);
		}

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state = BNXEF_ATTACH_COMPLETED;
		mutex_exit(&dsp->state_mutex);
		return (DDI_SUCCESS);

	case DDI_RESUME:
		return (DDI_SUCCESS);
	default:
		BNXEF_AUTO_DEBUG("%s%d: Unknown Command at attach",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (DDI_FAILURE);
	}
}


static int
bnxef_detach(dev_info_t *dip, ddi_detach_cmd_t cmd)
{

	int	 ret;
	int	instance;
	bnxef_driver_state_t *dsp;
	uint32_t	state;

	instance = ddi_get_instance(dip);

	dsp = ddi_get_soft_state(bnxef_state, instance);
	if (dsp == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to retrieve driver state\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (DDI_FAILURE);
	}

	switch (cmd) {
	case DDI_DETACH:
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		state = dsp->state;
		mutex_exit(&dsp->state_mutex);
		if ((state & BNXEF_ATTACH_COMPLETED) == 0) {
			BNXEF_AUTO_DEBUG("%s%d, Awaiting fp attach\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (DDI_FAILURE);
		}

		if ((state & BNXEF_L2_UNLOAD_CALLED) == 0) {
			BNXEF_AUTO_DEBUG("%s%d: L2 Is not unloading",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (DDI_FAILURE);
		}

		if (dsp->num_fc_ports > 0) {
			BNXEF_AUTO_DEBUG("%s%d: Atleast one port bound\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (DDI_FAILURE);
		}

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state |= BNXEF_DETACH_IN_PROGRESS;
		mutex_exit(&dsp->state_mutex);


		ret = bnxef_detach_handler(dsp, BNXEF_ATTACH_ALL);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: Detach Failed for  dip %p,"
					" ret - %d", BNXEF_DRIVER_NAME,
					dsp->instance, dip, ret);
			return (DDI_FAILURE);
		}

		BNXEF_AUTO_DEBUG("%s%d: Detach succeeded\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		num_instances--;

		ddi_soft_state_free(bnxef_state, instance);
		if (instance < BNXEF_MAX_INSTANCES)
			global_state[instance] = NULL;
		return (DDI_SUCCESS);
	case DDI_SUSPEND:
		return (DDI_SUCCESS);

	default:
		BNXEF_AUTO_DEBUG("%s%d: Unknown Detach command\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		return (DDI_FAILURE);
	}
}

#define	ispower2(x)  ((x & (x-1)) == 0)

/*
 * The following routine gets the list of tunable parameters configured in
 * conf file and updates the values associated with it in the state structure
 */
int
bnxef_get_tunables(bnxef_driver_state_t *dsp)
{
	int  t, i;
	char propbuf[KSTAT_STRLEN];

	ASSERT(dsp != NULL);

#ifdef DEBUG
	dsp->bnxef_debug = ddi_prop_get_int(DDI_DEV_T_ANY, dsp->dip,
		DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, "bnxef-debug-enable",
		0);
	if (dsp->bnxef_debug == 0) {
		snprintf(propbuf, KSTAT_STRLEN,
			"bnxef%d-debug-enable", dsp->instance);
		dsp->bnxef_debug = ddi_prop_get_int(DDI_DEV_T_ANY, dsp->dip,
			DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, propbuf, 0);
	}

	if (dsp->bnxef_debug & BNXEF_PORT_SPECIFIC_DEBUG) {
		dsp->bnxef_debug_ports = &bnxef_debug_ports[dsp->instance][0];
		snprintf(propbuf, KSTAT_STRLEN, "bnxef%d-port-debug",
				dsp->instance);
		ddi_prop_lookup_int_array(DDI_DEV_T_ANY, dsp->dip,
				    DDI_PROP_DONTPASS | DDI_PROP_NOTPROM,
				    propbuf,
				    &dsp->bnxef_debug_ports,
				    &dsp->port_debug_num_ports);
		BNXEF_AUTO_DEBUG("%s%d: Num debug ports %d",
			BNXEF_DRIVER_NAME, dsp->instance,
				dsp->port_debug_num_ports);
		for (i = 0; i < dsp->port_debug_num_ports; i++) {
			BNXEF_AUTO_DEBUG("%s%d: Port ID [%d] = 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				i, dsp->bnxef_debug_ports[i]);
		}
	}

	if (dsp->bnxef_debug & BNXEF_TRACE_EVENTS) {
		dsp->bnxef_max_trace_events = ddi_prop_get_int(DDI_DEV_T_ANY,
				dsp->dip,
				DDI_PROP_DONTPASS | DDI_PROP_NOTPROM,
				"bnxef-max-trace-events",
				1024);
		dsp->global_event_logp = (bnxef_trace_events_t *)kmem_zalloc(
				dsp->bnxef_max_trace_events *
				sizeof (bnxef_trace_events_t), KM_SLEEP);
		if (dsp->global_event_logp == NULL) {
			cmn_err(CE_NOTE,
			"Unable to allocate event log buf- instance 0x%x",
				dsp->instance);
			return (BNXEF_FAILURE);
		}
		dsp->gev_log_idx = 0;
	}
#endif

#if defined(__S11) || defined(__S12)
	/* The following will query for max ports that can be confirgured */
	dsp->max_fc_ports = ddi_prop_get_int(DDI_DEV_T_ANY, dsp->dip,
		DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, "max-npiv-ports",
		BNXEF_MAX_FC_PORTS);
	if (dsp->max_fc_ports > BNXEF_MAX_FC_PORTS)
		return (BNXEF_FAILURE);
#else
	dsp->max_fc_ports = 1;
#endif


	/* The following will query the max sessions allowed */
	dsp->max_sessions = ddi_prop_get_int(DDI_DEV_T_ANY, dsp->dip,
		DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, "max-sessions-allowed",
		BNXEF_MAX_SESSIONS_SUPPORTED);
	if (dsp->max_sessions > BNXEF_MAX_SESSIONS_SUPPORTED)
		return (BNXEF_FAILURE);
	BNXEF_AUTO_DEBUG("%s%d: The Max sessions requested %d",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->max_sessions);

	if (!ispower2(dsp->max_sessions)) {
		for (i = 0; i < 12; i++) {
			if (dsp->max_sessions < (1 << i)) break;
		}
		dsp->max_sessions = (1 << (i -1));
		BNXEF_AUTO_DEBUG("%s%d: Rounding to Lower Power 2 %d",
			BNXEF_DRIVER_NAME, dsp->instance,
			dsp->max_sessions);
	}
	/* The following will query the max exchanges supported */
	dsp->max_exchanges = ddi_prop_get_int(DDI_DEV_T_ANY, dsp->dip,
		DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, "max-exchanges-supported",
		BNXEF_MAX_EXCHGS_SUPPORTED);

	if (dsp->max_exchanges > BNXEF_MAX_EXCHGS_SUPPORTED)
		return (BNXEF_FAILURE);

	t = dsp->max_exchanges % 32;
	if (t) {
		uint16_t orig_exchanges = dsp->max_exchanges;
		dsp->max_exchanges += (32-t);
		BNXEF_AUTO_DEBUG("%s%d: Rounding the Max Exhcnages \
			supported to %d, when compared to configured %d",
			BNXEF_DRIVER_NAME, dsp->instance, dsp->max_exchanges,
			orig_exchanges);
	}


	/*
	 * By default only FPMA is the only mode supported for FIP.
	 * Therefor no tunable parameter provided in the conf file for that.
	 */
	dsp->flags_fpma_spma = BNXEF_FPMA_SUPPORTED;
	return (BNXEF_SUCCESS);
}

/*
 * Closes the L2 handle completely.
 */
int
bnxef_l2_close(bnxef_driver_state_t *dsp)
{
	ASSERT(dsp != NULL);


	return (BNXEF_SUCCESS);
}

/*
 *  THis routine opens the devices and gets the current configuration of
 *  MAC address and MTU size. Leaves the device open for use for life of the
 *  driver.
 */
int
bnxef_l2_open(bnxef_driver_state_t *dsp)
{
	dev_info_t *pdip;
	int retval = BNXEF_SUCCESS;
	BnxeFcoeCaps caps;

	ASSERT(dsp != NULL);
	ASSERT(dsp->dip != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_GET_MAC_ADDR,
			(void *)dsp->mac_add, 6)) {
		cmn_err(CE_WARN, "%s%d: Unable to get MAC address configured\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		retval = BNXEF_FAILURE;
		goto bnxef_l2_param_error;
	}

	BNXEF_AUTO_DEBUG("%s%d: Mac Address %x:%x:%x:%x:%x:%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->mac_add[5],
		dsp->mac_add[4], dsp->mac_add[3], dsp->mac_add[2],
		dsp->mac_add[1], dsp->mac_add[0]);

	if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_QUERY_PARAMS,
			(void *)&dsp->bnxe_params, sizeof (BnxeFcoeInfo))) {
		cmn_err(CE_WARN, "%s%d: Unable to get the Params from Bnxe",
				BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_l2_param_error;
	}
	dsp->bnxe_params.max_fcoe_exchanges =
		htonl(dsp->bnxe_params.max_fcoe_exchanges);
	dsp->bnxe_params.max_fcoe_conn =
		htonl(dsp->bnxe_params.max_fcoe_conn);
	BNXEF_AUTO_DEBUG("%s%d: PRV_CTL_QUERY_PARAMS Completed\n",
		BNXEF_DRIVER_NAME, dsp->instance);
	BNXEF_STATS_SET(dsp, max_exchanges,
		dsp->bnxe_params.max_fcoe_exchanges);
	BNXEF_STATS_SET(dsp, max_connections,
			dsp->bnxe_params.max_fcoe_conn);

	memset(&caps, 0, sizeof (caps));
	caps.fcoe_caps.capability1  = (FCOE_IOS_PER_CONNECTION_MASK &
					(BNXEF_SQ_WQES_MAX <<
					FCOE_IOS_PER_CONNECTION_SHIFT));
	caps.fcoe_caps.capability1 |= (FCOE_LOGINS_PER_PORT_MASK &
					(BNXEF_MAX_SESSIONS_SUPPORTED <<
					FCOE_LOGINS_PER_PORT_SHIFT));
	caps.fcoe_caps.capability2  = (FCOE_NUMBER_OF_EXCHANGES_MASK &
					(BNXEF_MAX_EXCHGS_SUPPORTED <<
					FCOE_NUMBER_OF_EXCHANGES_SHIFT));
	caps.fcoe_caps.capability2 |= (FCOE_NPIV_WWN_PER_PORT_MASK &
					(dsp->max_fc_ports <<
					FCOE_NPIV_WWN_PER_PORT_SHIFT));
	caps.fcoe_caps.capability3  = (FCOE_TARGETS_SUPPORTED_MASK &
					(BNXEF_MAX_SESSIONS_SUPPORTED <<
					FCOE_TARGETS_SUPPORTED_SHIFT));
	caps.fcoe_caps.capability3 |= (FCOE_OUTSTANDING_COMMANDS_MASK &
					(BNXEF_MAX_EXCHGS_SUPPORTED <<
					FCOE_OUTSTANDING_COMMANDS_SHIFT));
	caps.fcoe_caps.capability4  = (FCOE_CAPABILITY4_STATEFUL |
				FCOE_CAPABILITY4_CAPABILITIES_REPORTED_VALID);
	if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_SET_CAPS,
			(void *)&caps, sizeof (caps))) {
		cmn_err(CE_WARN, "%s%d: Failed to set capabilities",
				BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_l2_param_error;
	}

	/* Set the VLAN priority for now */
	dsp->pri = 3;
	dsp->max_fcoe_size = 2158;
	dsp->flags_fpma_spma = 1;
#if 0
	ret = ldi_ioctl(dsp->lh, BNXEF_GET_MTU_SIZE, (intptr_t)&dsp->mtu_size,
				    FKIOCTL, NULL, &rval);
	if (ret != 0) {
		cmn_err(CE_WARN, "%s%d: Unable to get MTU size configured\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		retval = BNXEF_FAILURE;
		goto bnxef_l2_param_error;
	}
#endif
	dsp->mtu_size = BNXEF_OPTIMAL_MTU_SIZE;
	/*
	 * The MTU size is administrators choice, however for FCoE operation
	 * 2500 is the optimal size. However, if some one sets less than that
	 * we should adjust the FC frame size we can support and allow the LOGI
	 * negotiation to change the MAX Receive data field size to be
	 * different.
	 */
	if (dsp->mtu_size < BNXEF_OPTIMAL_MTU_SIZE) {
		BNXEF_AUTO_DEBUG("%s%d:MTU size non optimal for FCoE operation",
			    BNXEF_DRIVER_NAME, dsp->instance);
		cmn_err(CE_WARN, "%s%d: MTU size not optimal, set to >= %d\b",
			    BNXEF_DRIVER_NAME, dsp->instance,
				BNXEF_OPTIMAL_MTU_SIZE);
	}

	BNXEF_AUTO_DEBUG("%s%d: MTU size %d", BNXEF_DRIVER_NAME, dsp->instance,
		dsp->mtu_size);

bnxef_l2_param_error:
	return (retval);
}

/*
 * This destroys the caches allocated.
 */
void
bnxef_destroy_kmem_cache(bnxef_driver_state_t *dsp, uint32_t stage)
{
	ASSERT(dsp != NULL);


	if (stage & BNXEF_UNSOL_BUF_CACHE_CREATED) {
		(void) bnxef_unsol_buf_cache_destroy(dsp);
	}
	if ((stage & BNXEF_TASK_CACHE_CREATED)
			== BNXEF_TASK_CACHE_CREATED) {
		(void) bnxef_task_cache_destroy(dsp);
	}
	if ((stage & BNXEF_FCF_CACHE_CREATED)
			== BNXEF_FCF_CACHE_CREATED) {
		(void) bnxef_fcf_cache_destroy(dsp);
	}
	if ((stage & BNXEF_PORT_CACHE_CREATED)
			== BNXEF_PORT_CACHE_CREATED) {
		(void) bnxef_port_cache_destroy(dsp);
	}
	if ((stage & BNXEF_SESSION_CACHE_CREATED)
			== BNXEF_SESSION_CACHE_CREATED) {
		(void) bnxef_session_cache_destroy(dsp);
	}
	if ((stage & BNXEF_TQ_PARAM_CACHE_CREATED)
			== BNXEF_TQ_PARAM_CACHE_CREATED) {
		(void) bnxef_tq_param_cache_destroy(dsp);
	}

}

/*
 * This allocates all the kmem caches planned for this driver. This includes the
 * port cache, session cache, Task queue params cache, task cache,i fcf_cache.
 */

int
bnxef_alloc_kmem_cache(bnxef_driver_state_t *dsp)
{

	int ret = BNXEF_FAILURE;
	int stage = 0;

	ASSERT(dsp != NULL);

	BNXEF_AUTO_DEBUG("%s%d: %s Called", BNXEF_DRIVER_NAME, dsp->instance,
		__func__);
	/* Create Session Cache */
	ret = bnxef_session_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to Create session cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}

	stage |= BNXEF_SESSION_CACHE_CREATED;
	BNXEF_AUTO_DEBUG("%s%d: Session cache created",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Create port cache */
	ret = bnxef_port_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to create Port cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}
	stage |= BNXEF_PORT_CACHE_CREATED;
	BNXEF_AUTO_DEBUG("%s%d: Port cache created",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Create Task Queue params */
	ret = bnxef_tq_param_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable create Tq params cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}
	stage |= BNXEF_TQ_PARAM_CACHE_CREATED;
	BNXEF_AUTO_DEBUG("%s%d: TQ PARAM cache created",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* FCF cache create */
	ret = bnxef_fcf_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to create fcf cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}

	stage |= BNXEF_FCF_CACHE_CREATED;

	BNXEF_AUTO_DEBUG("%s%d: FCF cache created",
		BNXEF_DRIVER_NAME, dsp->instance);
	/* TAsk Cache create */
	ret = bnxef_task_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to create task cache\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}

	stage |= BNXEF_TASK_CACHE_CREATED;
	BNXEF_AUTO_DEBUG("%s%d: Task cache created",
		BNXEF_DRIVER_NAME, dsp->instance);

	ret = bnxef_unsol_buf_cache_create(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to Create unsolicited buf cache",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_cache_alloc_error;
	}

	stage |= BNXEF_UNSOL_BUF_CACHE_CREATED;
	BNXEF_AUTO_DEBUG("%s%d: Unsol Buf cache Creeated",
			BNXEF_DRIVER_NAME, dsp->instance);

	return (BNXEF_SUCCESS);

bnxef_cache_alloc_error:
	BNXEF_AUTO_DEBUG("%s%d: Kmem Cache Allocation Failed 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, stage);
	(void) bnxef_destroy_kmem_cache(dsp, stage);
	return (BNXEF_FAILURE);
}

/*
 * This uninit all the list that has been  initialized
 */
int
bnxef_fini_lists(bnxef_driver_state_t *dsp, uint32_t stage)
{
	int ret = BNXEF_FAILURE;

	ASSERT(dsp != NULL);

	if ((stage & BNXEF_FCF_LIST_INIT) == BNXEF_FCF_LIST_INIT)
		ret = bnxef_fcf_list_fini(dsp);

	if ((stage & BNXEF_TASK_FREE_LIST_INIT) == BNXEF_TASK_FREE_LIST_INIT)
		ret = bnxef_task_free_list_fini(dsp);

	if ((stage & BNXEF_PORT_LIST_INIT) == BNXEF_PORT_LIST_INIT)
		ret = bnxef_port_list_fini(dsp);

	return (ret);
}


/*
 * The following routine initializes all the lists needed for the functioning
 * of this driver. This initializes the following list for subsequent use.
 *  fcf list, task free list, lport list.
 */
int
bnxef_init_lists(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	uint32_t stage = 0;

	ret =  bnxef_fcf_list_init(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable initialize the FCF list\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_list_init_error;
	}
	stage |= BNXEF_FCF_LIST_INIT;

	ret = bnxef_task_free_list_init(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to initialize task free list\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_list_init_error;
	}
	stage |= BNXEF_TASK_FREE_LIST_INIT;

	ret = bnxef_port_list_init(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to initialize local port list\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_list_init_error;
	}

	stage |= BNXEF_PORT_LIST_INIT;

	return (BNXEF_SUCCESS);
bnxef_list_init_error:
	(void) bnxef_fini_lists(dsp, stage);
	return (BNXEF_FAILURE);
}

/*
 * This will free the task resource allocated.
 */
int
bnxef_task_resource_free(bnxef_driver_state_t *dsp, uint32_t stage)
{
	int ret = BNXEF_FAILURE;

	ASSERT(dsp != NULL);

	/*
	 * Freeing of DMA resources should go in this order.
	 * This is reverse of what is done when we allocated the resources
	 * in the alloc routine.
	 */
	if ((stage & BNXEF_TASK_CTX_BD_MEM_BOUND) ==
		BNXEF_TASK_CTX_BD_MEM_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->task_ctx_bd_handle);
	}

	if ((stage & BNXEF_TASK_CTX_BD_MEM_ALLOCATED) ==
		BNXEF_TASK_CTX_BD_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->task_ctx_bd_acc_handle);
	}

	if ((stage & BNXEF_TASK_CTX_BD_HANDLE_ALLOCATED) ==
		BNXEF_TASK_CTX_BD_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->task_ctx_bd_handle);
	}

	return (ret);
}

int
bnxef_indiv_task_resource_free(bnxef_driver_state_t *dsp, int stage, int index)
{

	int ret;

	/* Now release all the resources allocated with task DMA */
	if ((stage & BNXEF_INDIV_TASK_DMA_MEM_BOUND) ==
		BNXEF_INDIV_TASK_DMA_MEM_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->task_dma_handle[index]);
	}

	if ((stage & BNXEF_INDIV_TASK_DMA_MEM_ALLOCATED) ==
		BNXEF_INDIV_TASK_DMA_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->task_acc_handle[index]);
	}

	if ((stage & BNXEF_INDIV_TASK_DMA_HANDLE_ALLOCATED) ==
		BNXEF_INDIV_TASK_DMA_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->task_dma_handle[index]);
	}

	return (ret);
}



int
bnxef_indiv_task_resource_alloc(bnxef_driver_state_t *dsp, int index)
{
	ddi_dma_attr_t taskdmaattr =  {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_16K_ALIGN,	/* 16K aligned  */
		BNXEF_DMA_ATTR_BURST_SIZE, /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4G */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list allowed */
		BNXEF_DMA_ATTR_128_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	int ret, stage = 0;
	ddi_device_acc_attr_t dev_acc_attr;

	BNXEF_AUTO_DEBUG("%s%d: Entering %s", BNXEF_DRIVER_NAME, dsp->instance,
		__func__);
	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	ret = ddi_dma_alloc_handle(dsp->dip, &taskdmaattr, DDI_DMA_SLEEP, NULL,
			&dsp->task_dma_handle[index]);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate DMA handle\
			 for %d", BNXEF_DRIVER_NAME, dsp->instance,
			index);
		goto bnxef_indiv_task_res_alloc_error;
	}

	stage |= BNXEF_INDIV_TASK_DMA_HANDLE_ALLOCATED;

	/*
	 * This will allocate the required memory, which is physically
	 * contiguous
	 */
	ret = ddi_dma_mem_alloc(dsp->task_dma_handle[index],
			BNXEF_PAGE_SIZE,
			&dev_acc_attr,
			DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
			&(dsp->task_ctx[index]), &dsp->task_ctx_length[index],
			&dsp->task_acc_handle[index]);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate Task DMA mem\
			for %d", BNXEF_DRIVER_NAME, dsp->instance, index);
		goto bnxef_indiv_task_res_alloc_error;
	}

	stage |= BNXEF_INDIV_TASK_DMA_MEM_ALLOCATED;
	memset(dsp->task_ctx[index], 0, BNXEF_PAGE_SIZE);
	BNXEF_AUTO_DEBUG("%s%d: DMA mem Allocated at 0x%p, size 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->task_ctx[index],
			dsp->task_ctx_length[index]);

	/*
	 * Now map or pin this buffer for subsequent DMA based data
	 * movement
	 */
	ret = ddi_dma_addr_bind_handle(dsp->task_dma_handle[index],
		NULL, dsp->task_ctx[index], dsp->task_ctx_length[index],
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->task_dma_cookie[index], &dsp->task_dma_cookie_cnt[index]);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to bind dma mem \
			for  %d, ret = %d\n",
			BNXEF_DRIVER_NAME, dsp->instance, index, ret);
		goto bnxef_indiv_task_res_alloc_error;
	}
	/* We have indicated no scatter gather allowed */
	stage |= BNXEF_INDIV_TASK_DMA_MEM_BOUND;
	BNXEF_AUTO_DEBUG("%s%d: Number of Cookies %d", BNXEF_DRIVER_NAME,
		dsp->instance, dsp->task_dma_cookie_cnt[index]);

	return (BNXEF_SUCCESS);

bnxef_indiv_task_res_alloc_error:
	bnxef_indiv_task_resource_free(dsp, stage, index);
	return (BNXEF_FAILURE);
}

/*
 * This allocates the task resources for firmware to operate. It also prepares
 * the page descriptor list for passing it to init routine. The page descriptor
 * list is available in the driver state structure's  task_ctx_bd_table
 */
int
bnxef_task_resource_alloc(bnxef_driver_state_t *dsp)
{
	int ret, i, j;
	ddi_dma_attr_t bddmaattr = {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_ALIGN, /* 4K byte alignment */
		DEFAULT_BURSTSIZE | BURST32 | BURST64, /* bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4G  */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list  */
		BNXEF_DMA_ATTR_8_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	struct regpair *pbl = NULL;
	int stage = 0;
	ddi_device_acc_attr_t dev_acc_attr;


	ASSERT(dsp != NULL);

	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	dsp->num_task_dma_handles = (dsp->max_exchanges *
			sizeof (struct fcoe_task_ctx_entry))/BNXEF_PAGE_SIZE;
	if ((dsp->max_exchanges * sizeof (struct fcoe_task_ctx_entry))
		% BNXEF_PAGE_SIZE)
		dsp->num_task_dma_handles ++;

	BNXEF_AUTO_DEBUG("%s%d: Num Dma HAndles to be allocated 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->num_task_dma_handles);
	for (i = 0; i < dsp->num_task_dma_handles; i++) {
		BNXEF_AUTO_DEBUG("%s%d: Calling Indiv Alloc for %d",
			BNXEF_DRIVER_NAME, dsp->instance, i);
		ret = 	bnxef_indiv_task_resource_alloc(dsp, i);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: Unable allocate Indiv 4K\
				task resource for index %d",
				BNXEF_DRIVER_NAME, dsp->instance, i);
			goto bnxef_task_res_alloc_error1;
		}
	}

	/*
	 * Now allocate a page size worth of page descriptor to describe the
	 * allocated buffer,just above
	 */
	ret = ddi_dma_alloc_handle(dsp->dip, &bddmaattr, DDI_DMA_SLEEP, NULL,
			&dsp->task_ctx_bd_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate task ctx handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_task_res_alloc_error;
	}
	stage |= BNXEF_TASK_CTX_BD_HANDLE_ALLOCATED;

	/* Allocate a page size worth of DMA memory */
	ret = ddi_dma_mem_alloc(dsp->task_ctx_bd_handle,
		BNXEF_PAGE_SIZE, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&(dsp->task_ctx_bd_table),
		&dsp->task_ctx_bd_table_len,
		&dsp->task_ctx_bd_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate CTX BD DMA mem\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_task_res_alloc_error;
	}
	stage |= BNXEF_TASK_CTX_BD_MEM_ALLOCATED;

	memset((uint8_t *)dsp->task_ctx_bd_table, 0, BNXEF_PAGE_SIZE);

	/* MAp this page descriptor table */
	ret = ddi_dma_addr_bind_handle(dsp->task_ctx_bd_handle,
		NULL,
		(caddr_t)dsp->task_ctx_bd_table, dsp->task_ctx_bd_table_len,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->task_ctx_bd_cookie, &dsp->task_ctx_bd_cookie_cnt);

	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
			"%s%d: Unable to bind CTX BD dma mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_task_res_alloc_error;
	}
	ASSERT(dsp->task_ctx_bd_cookie_cnt == 1);
	stage |= BNXEF_TASK_CTX_BD_MEM_BOUND;

	/* LINTED: alignment */
	pbl = (struct regpair *)dsp->task_ctx_bd_table;
	for (i = 0; i < dsp->num_task_dma_handles; i++) {
		pbl->hi =
		CPU_TO_LE32((uint64_t)dsp->task_dma_cookie[i].dmac_laddress >>
			32);
		pbl->lo =
		CPU_TO_LE32((uint64_t)dsp->task_dma_cookie[i].dmac_laddress &
			0xFFFFFFFF);
		BNXEF_AUTO_DEBUG("%s%d: Entry %d, Low 0x%x, high 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, i, pbl->lo, pbl->hi);
		pbl++;
	}

	stage |= BNXEF_TASK_BD_PBL_SETUP;

	return (BNXEF_SUCCESS);

bnxef_task_res_alloc_error1:
	for (j = 0;  j <  i; j++) {
		bnxef_indiv_task_resource_free(dsp,
				    BNXEF_INDIV_TASK_RESOURCE_ALL, j);
	}

	return (BNXEF_FAILURE);

bnxef_task_res_alloc_error:
	(void) bnxef_task_resource_free(dsp, stage);
	return (BNXEF_FAILURE);
}

/*
 * This will free the resources allocated for the hash table.
 */
int
bnxef_hash_table_free(bnxef_driver_state_t *dsp, uint32_t stage)
{

	int ret = BNXEF_FAILURE;
	ASSERT(dsp != NULL);

	if ((stage & BNXEF_HASH_TABLE_PBL_MEM_BOUND) ==
		BNXEF_HASH_TABLE_PBL_MEM_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->hash_table_pbl_handle);
	}

	if ((stage &  BNXEF_HASH_TABLE_PBL_MEM_ALLOCATED) ==
			    BNXEF_HASH_TABLE_PBL_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->hash_table_pbl_acc_handle);
	}

	if ((stage & BNXEF_HASH_TABLE_PBL_HANDLE_ALLOCATED) ==
		BNXEF_HASH_TABLE_PBL_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->hash_table_pbl_handle);

	}

	if ((stage & BNXEF_HASH_TABLE_BOUND) ==
		BNXEF_HASH_TABLE_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->hash_tbl_dma_handle);
	}

	if ((stage & BNXEF_HASH_TABLE_DMA_MEM_ALLOCATED) ==
		BNXEF_HASH_TABLE_DMA_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->hash_tbl_acc_handle);
	}

	if ((stage & BNXEF_HASH_TABLE_DMA_HANDLE_ALLOCATED) ==
		BNXEF_HASH_TABLE_DMA_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->hash_tbl_dma_handle);
	}

	return (ret);
}

/*
 * This will allocate the hash table for firmware use and create the buffer
 * descriptor list describing the DMAable memory in chunks of 16 K.
 */
int
bnxef_hash_table_alloc(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	uint32_t hash_table_size = 0;
	int stage = 0;
	uint64_t tempphyaddr = 0;

	ddi_dma_attr_t hashtabledmaattr =  {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_16K_ALIGN, /* 16K aligned  */
		BNXEF_DMA_ATTR_BURST_SIZE, /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER, /* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4GB */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list */
		BNXEF_DMA_ATTR_128_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};

	ddi_dma_attr_t hashtblbddmaattr = {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_ALIGN, /* 4K alignment */
		BNXEF_DMA_ATTR_BURST_SIZE,	 /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		BNXEF_DMA_ATTR_BOUNDARY_CROSS,	/* Donot cross 4GB Boundary */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list allowed */
		BNXEF_DMA_ATTR_8_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	struct regpair *pbl = NULL;
	ddi_device_acc_attr_t dev_acc_attr;
	int i;

	ASSERT(dsp != NULL);

	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	hash_table_size = dsp->max_sessions * BNXEF_MAX_ROWS_IN_HASH_TBL *
		sizeof (struct fcoe_hash_table_entry);
	BNXEF_AUTO_DEBUG("%s%d: Num sessions %d, Hash Table size 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->max_sessions,
		hash_table_size);
	dsp->hash_tbl_seg_count = hash_table_size +
				BNXEF_HASH_TBL_CHUNK_SIZE -1;
	dsp->hash_tbl_seg_count /= BNXEF_HASH_TBL_CHUNK_SIZE;

	BNXEF_AUTO_DEBUG("%s%d: Hash Table seg count 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->hash_tbl_seg_count);
	/* Allocate the dma handle first */
	ret = ddi_dma_alloc_handle(dsp->dip, &hashtabledmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->hash_tbl_dma_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate DMA handle",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_hash_tbl_alloc_error;
	}
	stage |= BNXEF_HASH_TABLE_DMA_HANDLE_ALLOCATED;

	/* Allocate the DMA memory needed for use */
	ret = ddi_dma_mem_alloc(dsp->hash_tbl_dma_handle,
		dsp->hash_tbl_seg_count * BNXEF_HASH_TBL_CHUNK_SIZE,
		&dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->hash_tbl, &dsp->hash_tbl_len,
		&dsp->hash_tbl_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate Hash Table mem",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_hash_tbl_alloc_error;
	}
	BNXEF_AUTO_DEBUG("%s%d:HAsh Table ptr 0x%p, Table Size 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->hash_tbl,
		dsp->hash_tbl_len);

	stage |=  BNXEF_HASH_TABLE_DMA_MEM_ALLOCATED;
	memset((uint8_t *)dsp->hash_tbl, 0,
		dsp->hash_tbl_seg_count * BNXEF_HASH_TBL_CHUNK_SIZE);

	/* Now bind that memory allocated, using the handle */
	ret = ddi_dma_addr_bind_handle(dsp->hash_tbl_dma_handle,
		NULL, dsp->hash_tbl, dsp->hash_tbl_len,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->hash_tbl_dma_cookie, &dsp->hash_tbl_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
			"%s%d:Unable to bind Hash Table with handle ret= %d\n",
			BNXEF_DRIVER_NAME, dsp->instance, ret);
		goto bnxef_hash_tbl_alloc_error;
	}

	stage |= BNXEF_HASH_TABLE_BOUND;
	BNXEF_AUTO_DEBUG("%s%d: Hash Table Bound", BNXEF_DRIVER_NAME,
		dsp->instance);

	/* We have indicated we donot support scatter gather */
	ASSERT(dsp->hash_tbl_cookie_cnt == 1);
	ddi_dma_sync(dsp->hash_tbl_dma_handle,
		0, dsp->hash_tbl_len, DDI_DMA_SYNC_FORDEV);

	/* Now create a handle for the PBL to describe the hash table */
	ret = ddi_dma_alloc_handle(dsp->dip, &hashtblbddmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->hash_table_pbl_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate task ctx handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_hash_tbl_alloc_error;
	}
	stage |= BNXEF_HASH_TABLE_PBL_HANDLE_ALLOCATED;

	BNXEF_AUTO_DEBUG("%s%d: Hash Table PBL Handle allocated",
			BNXEF_DRIVER_NAME, dsp->instance);

	/* Now allocate a page size worth of memory */
	ret = ddi_dma_mem_alloc(dsp->hash_table_pbl_handle,
		BNXEF_PAGE_SIZE, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->hash_table_pbl, &dsp->hash_table_pbl_len,
		&dsp->hash_table_pbl_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate CTX BD DMA mem\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_hash_tbl_alloc_error;
	}
	stage |= BNXEF_HASH_TABLE_PBL_MEM_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: Hash Table PBL memory allocated",
			BNXEF_DRIVER_NAME, dsp->instance);

	memset((uint8_t *)dsp->hash_table_pbl, 0, dsp->hash_table_pbl_len);

	/* MAp this page descriptor table */
	ret = ddi_dma_addr_bind_handle(dsp->hash_table_pbl_handle,
		NULL, dsp->hash_table_pbl, dsp->hash_table_pbl_len,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->hash_table_pbl_cookie, &dsp->hash_table_pbl_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
			"%s%d: Unable to bind Hash tbl pbl mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_hash_tbl_alloc_error;
	}
	ASSERT(dsp->hash_table_pbl_cookie_cnt == 1);
	stage |= BNXEF_HASH_TABLE_PBL_MEM_BOUND;
	BNXEF_AUTO_DEBUG("%s%d: Hash Table PBL Bound ",
			BNXEF_DRIVER_NAME, dsp->instance);
	/* Now setup the PBL list ready to give to firmware */
	/* LINTED: alignment */
	pbl = (struct regpair *)dsp->hash_table_pbl;
	/* Only one entry done, as we got one full chunk */
	for (i = 0; i < dsp->hash_tbl_seg_count; i++) {
		tempphyaddr = dsp->hash_tbl_dma_cookie.dmac_laddress +
			i * BNXEF_HASH_TBL_CHUNK_SIZE;
		pbl->hi = CPU_TO_LE32(tempphyaddr >> 32);
		pbl->lo = CPU_TO_LE32(tempphyaddr & 0xFFFFFFFF);
		BNXEF_AUTO_DEBUG("%s%d: PBL contents: low 0x%x, high 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, pbl->lo, pbl->hi);
		pbl++;
	}
	ddi_dma_sync(dsp->hash_table_pbl_handle, 0,
		dsp->hash_table_pbl_len, DDI_DMA_SYNC_FORDEV);


	BNXEF_AUTO_DEBUG("%s%d: Hash Tabke PBL setup",
		BNXEF_DRIVER_NAME, dsp->instance);
	stage |= BNXEF_HASH_TABLE_PBL_SETUP;

	return (BNXEF_SUCCESS);
bnxef_hash_tbl_alloc_error:
	bnxef_hash_table_free(dsp, stage);
	return (BNXEF_FAILURE);
}


int
bnxef_t2_hash_table_free(bnxef_driver_state_t *dsp, uint32_t stage)
{

	int ret = BNXEF_FAILURE;

	ASSERT(dsp != NULL);
	if ((stage & BNXEF_T2_HASH_TABLE_PTR_BOUND) ==
		BNXEF_T2_HASH_TABLE_PTR_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->t2_hash_table_dma_ptr_handle);

	}

	if ((stage & BNXEF_T2_HASH_TABLE_PTR_MEM_ALLOCATED) ==
		BNXEF_T2_HASH_TABLE_PTR_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->t2_hash_table_ptr_acc_handle);

	}

	if ((stage & BNXEF_T2_HASH_TABLE_PTR_HANDLE_ALLOCATED) ==
		BNXEF_T2_HASH_TABLE_PTR_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->t2_hash_table_dma_ptr_handle);

	}

	if ((stage & BNXEF_T2_HASH_TABLE_BOUND) ==
		BNXEF_T2_HASH_TABLE_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->t2_hash_table_dma_handle);

	}

	if ((stage &  BNXEF_T2_HASH_TABLE_MEM_ALLOCATED) ==
			    BNXEF_T2_HASH_TABLE_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->t2_hash_table_acc_handle);
	}

	if ((stage & BNXEF_T2_HASH_TABLE_HANDLE_ALLOCATED) ==
		BNXEF_T2_HASH_TABLE_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->t2_hash_table_dma_handle);
	}

	return (ret);
}

int
bnxef_t2_hash_table_alloc(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	int stage = 0, i;
	ddi_dma_attr_t t2hashtabledmaattr =  {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_ALIGN, /* 4K aligned  */
		BNXEF_DMA_ATTR_BURST_SIZE, /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4GB */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list */
		BNXEF_DMA_ATTR_128_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	ddi_device_acc_attr_t dev_acc_attr;
	uint32_t	mem_size;
	struct fcoe_t2_hash_table_entry *t2p;
	uint64_t	addr;

	ASSERT(dsp != NULL);

	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	/* Allocate the DMA handle first */
	ret = ddi_dma_alloc_handle(dsp->dip, &t2hashtabledmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->t2_hash_table_dma_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate T2 hash dma handle",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	stage |= BNXEF_T2_HASH_TABLE_HANDLE_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: T2 Hash table handle allocated",
		BNXEF_DRIVER_NAME, dsp->instance);

	mem_size =
		dsp->max_sessions * sizeof (struct fcoe_t2_hash_table_entry);

	ret = ddi_dma_mem_alloc(dsp->t2_hash_table_dma_handle,
		mem_size, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->t2_hash_table, &dsp->t2_hash_table_len,
		&dsp->t2_hash_table_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate T2 hash tbl mem",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	stage |= BNXEF_T2_HASH_TABLE_MEM_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: T2 Hash table memory allocated",
		BNXEF_DRIVER_NAME, dsp->instance);
	memset(dsp->t2_hash_table, 0, dsp->t2_hash_table_len);
	/* MAp this  t2 hash table */
	ret = ddi_dma_addr_bind_handle(dsp->t2_hash_table_dma_handle,
		NULL, dsp->t2_hash_table, dsp->t2_hash_table_len,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->t2_hash_table_dma_cookie,
		&dsp->t2_hash_table_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
			"%s%d: Unable to bind T2 Hash tbl mem with handle",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	ASSERT(dsp->t2_hash_table_cookie_cnt == 1);
	ddi_dma_sync(dsp->t2_hash_table_dma_handle, 0,
			dsp->t2_hash_table_len, DDI_DMA_SYNC_FORDEV);

	stage |= BNXEF_T2_HASH_TABLE_BOUND;
	BNXEF_AUTO_DEBUG("%s%d: T2 Hash table Bound",
		BNXEF_DRIVER_NAME, dsp->instance);
	/* Allocate the DMA handle first */
	ret = ddi_dma_alloc_handle(dsp->dip, &t2hashtabledmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->t2_hash_table_dma_ptr_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable allocate T2 hash ptr handle",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	stage |= BNXEF_T2_HASH_TABLE_PTR_HANDLE_ALLOCATED;

	BNXEF_AUTO_DEBUG("%s%d: T2 Hash Table PTR handle allocated",
		BNXEF_DRIVER_NAME, dsp->instance);
	mem_size = dsp->max_sessions * sizeof (struct regpair);
	ret = ddi_dma_mem_alloc(dsp->t2_hash_table_dma_ptr_handle,
		mem_size, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->t2_hash_tbl_ptr, &dsp->t2_hash_tbl_ptr_len,
		&dsp->t2_hash_table_ptr_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG(
			"%s%d:Unable to allocate T2 hash tbl ptr mem",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	stage |= BNXEF_T2_HASH_TABLE_PTR_MEM_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: T2 Hash Table PTR memory allocated",
		BNXEF_DRIVER_NAME, dsp->instance);
	memset(dsp->t2_hash_tbl_ptr, 0, dsp->t2_hash_tbl_ptr_len);
	ret = ddi_dma_addr_bind_handle(dsp->t2_hash_table_dma_ptr_handle,
		NULL, dsp->t2_hash_tbl_ptr, dsp->t2_hash_tbl_ptr_len,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->t2_hash_table_dma_ptr_cookie,
		&dsp->t2_hash_table_ptr_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
		"%s%d: Unable to bind T2 Hash tbl ptr mem with handle",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_t2_hash_tbl_alloc_error;
	}
	ASSERT(dsp->t2_hash_table_ptr_cookie_cnt == 1);

	stage |= BNXEF_T2_HASH_TABLE_PTR_BOUND;
	BNXEF_AUTO_DEBUG("%s%d: T2 Hash Table PTR memory bound",
		BNXEF_DRIVER_NAME, dsp->instance);
	addr = (uint64_t)dsp->t2_hash_table_dma_cookie.dmac_laddress;
	/* LINTED: alignment */
	t2p = (struct fcoe_t2_hash_table_entry *)dsp->t2_hash_table;
	for (i = 0; i < dsp->max_sessions; i++) {
		addr += sizeof (struct fcoe_t2_hash_table_entry);
		t2p->next.lo = CPU_TO_LE32(addr & 0xFFFFFFFF);
		t2p->next.hi = CPU_TO_LE32((uint32_t)(addr >> 32));
		t2p++;
	}
	ddi_dma_sync(dsp->t2_hash_table_dma_ptr_handle, 0,
		dsp->t2_hash_tbl_ptr_len, DDI_DMA_SYNC_FORDEV);

	return (BNXEF_SUCCESS);

bnxef_t2_hash_tbl_alloc_error:
	bnxef_t2_hash_table_free(dsp, stage);
	return (BNXEF_FAILURE);
}

int
bnxef_dummy_buffer_free(bnxef_driver_state_t *dsp, uint32_t stage)
{

	int ret = BNXEF_FAILURE;

	if ((stage & BNXEF_DUMMY_BUF_BOUND) ==
			BNXEF_DUMMY_BUF_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->dummy_dma_handle);
	}

	if ((stage & BNXEF_DUMMY_BUF_MEM_ALLOCATED) ==
			BNXEF_DUMMY_BUF_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->dummy_dev_acc_handle);
	}

	if ((stage & BNXEF_DUMMY_BUF_HANDLE_ALLOCATED) ==
		BNXEF_DUMMY_BUF_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->dummy_dma_handle);
	}

	return (ret);
}

int
bnxef_dummy_buffer_alloc(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	ddi_dma_attr_t dummybufdmaattr =  {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_ALIGN, /* 4K aligned  */
		BNXEF_DMA_ATTR_BURST_SIZE, /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4GB */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list, */
		BNXEF_DMA_ATTR_128_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	ddi_device_acc_attr_t dev_acc_attr;
	int stage = 0;

	ASSERT(dsp != NULL);

	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	/* Allocate the DMA handle first */
	ret = ddi_dma_alloc_handle(dsp->dip, &dummybufdmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->dummy_dma_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable allocate dummy bufdma handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_dummy_buf_alloc_error;
	}
	stage = BNXEF_DUMMY_BUF_HANDLE_ALLOCATED;

	ret = ddi_dma_mem_alloc(dsp->dummy_dma_handle,
		BNXEF_PAGE_SIZE, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->dummy_buffer, &dsp->dummy_size,
		&dsp->dummy_dev_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG(
			"%s%d:Unable to allocate dummy buf mem\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_dummy_buf_alloc_error;
	}
	stage |= BNXEF_DUMMY_BUF_MEM_ALLOCATED;
	ret = ddi_dma_addr_bind_handle(dsp->dummy_dma_handle,
		NULL, dsp->dummy_buffer, dsp->dummy_size,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->dummy_dma_cookie,
		&dsp->dummy_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
		"%s%d: Unable to bind dummy buf mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_dummy_buf_alloc_error;
	}
	ASSERT(dsp->dummy_cookie_cnt == 1);

	stage |= BNXEF_DUMMY_BUF_BOUND;

	return (BNXEF_SUCCESS);

bnxef_dummy_buf_alloc_error:
	(void) bnxef_dummy_buffer_free(dsp, stage);
	return (BNXEF_SUCCESS);
}

int
bnxef_stats_buffer_free(bnxef_driver_state_t *dsp, uint32_t stage)
{

	int ret = BNXEF_FAILURE;

	if ((stage & BNXEF_STATS_BUF_BOUND) ==
			BNXEF_STATS_BUF_BOUND) {
		ret = ddi_dma_unbind_handle(dsp->stats_dma_handle);
	}

	if ((stage & BNXEF_STATS_BUF_MEM_ALLOCATED) ==
			BNXEF_STATS_BUF_MEM_ALLOCATED) {
		ddi_dma_mem_free(&dsp->stats_dev_acc_handle);
	}

	if ((stage & BNXEF_STATS_BUF_HANDLE_ALLOCATED) ==
		BNXEF_STATS_BUF_HANDLE_ALLOCATED) {
		ddi_dma_free_handle(&dsp->stats_dma_handle);
	}

	return (ret);
}

int
bnxef_stats_buffer_alloc(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	ddi_dma_attr_t statsbufdmaattr =  {
		DMA_ATTR_V0,		/* Version number */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_LO, /* low address */
		(uint64_t)BNXEF_DMA_ATTR_ADDR_HI, /* High address */
		(uint64_t)BNXEF_DMA_ATTR_COUNT_MAX, /* DMA counter max */
		(uint64_t)BNXEF_DMA_ATTR_ALIGN, /* 4K aligned  */
		BNXEF_DMA_ATTR_BURST_SIZE, /* 128 bytes of bursts */
		BNXEF_DMA_ATTR_MIN_XFER,	/* Minimum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_MAX_XFER, /* MAximum transfer size */
		(uint64_t)BNXEF_DMA_ATTR_BOUNDARY_CROSS, /* Donot cross 4GB */
		BNXEF_DMA_ATTR_1_SEG_COUNT, /* no scatter gather list, */
		BNXEF_DMA_ATTR_128_GRANULARITY,	/* Granularity */
		BNXEF_DMA_ATTR_DMA_FLAGS	/* DMA flags */
	};
	ddi_device_acc_attr_t dev_acc_attr;
	int stage = 0;

	ASSERT(dsp != NULL);

	/* Set the device access attribute */
	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
	dev_acc_attr.devacc_attr_endian_flags = DDI_NEVERSWAP_ACC;
	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;

	/* Allocate the DMA handle first */
	ret = ddi_dma_alloc_handle(dsp->dip, &statsbufdmaattr,
			DDI_DMA_SLEEP, NULL,
			&dsp->stats_dma_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable allocate stats bufdma handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_stats_buf_alloc_error;
	}
	stage = BNXEF_STATS_BUF_HANDLE_ALLOCATED;

	ret = ddi_dma_mem_alloc(dsp->stats_dma_handle,
		BNXEF_PAGE_SIZE, &dev_acc_attr,
		DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, NULL,
		&dsp->stats_buffer, &dsp->stats_size,
		&dsp->stats_dev_acc_handle);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG(
			"%s%d:Unable to allocate stats buf mem\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_stats_buf_alloc_error;
	}
	stage |= BNXEF_STATS_BUF_MEM_ALLOCATED;
	memset(dsp->stats_buffer, 0, BNXEF_PAGE_SIZE);
	ret = ddi_dma_addr_bind_handle(dsp->stats_dma_handle,
		NULL, dsp->stats_buffer, dsp->stats_size,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		&dsp->stats_dma_cookie,
		&dsp->stats_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_AUTO_DEBUG(
		"%s%d: Unable to bind stats buf mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_stats_buf_alloc_error;
	}
	ASSERT(dsp->stats_cookie_cnt == 1);

	stage |= BNXEF_STATS_BUF_BOUND;

	return (BNXEF_SUCCESS);

bnxef_stats_buf_alloc_error:
	(void) bnxef_stats_buffer_free(dsp, stage);
	return (BNXEF_SUCCESS);
}


/*
 * This will allocate all the host memory resource needed for fw to function.
 * These resources include task resource for as many number of tasks we want
 * to host. The hash tables as many sessions we want to host. This includes
 * main hash table as well as the t2 hash tables. Also a page size worth of
 * dummy buffer for the firmware.
 */
int
bnxef_fw_resources_alloc(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	int stage = 0;


	ret = bnxef_task_resource_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to alloc Task DMA resources\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_fw_res_alloc_error;
	}

	stage |= BNXEF_FW_TASK_RES_ALLOC_COMPLETE;

	ret = bnxef_hash_table_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d:Unable to allocate hash table\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto  bnxef_fw_res_alloc_error;
	}

	stage |= BNXEF_FW_HASH_TABLE_COMPLETE;

	ret = bnxef_t2_hash_table_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate T2 hash table\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_fw_res_alloc_error;
	}

	stage |= BNXEF_FW_T2_HASH_TABLE_COMPLETE;
	ret = bnxef_dummy_buffer_alloc(dsp);
	if (ret !=  BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate dummy buffer\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_fw_res_alloc_error;
	}

	stage |= BNXEF_FW_DUMMY_BUFFER_COMPLETE;

	ret = bnxef_stats_buffer_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate stats buffer",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_fw_res_alloc_error;
	}

	stage |= BNXEF_FW_STATS_BUFFER_COMPLETE;

	return (BNXEF_SUCCESS);
bnxef_fw_res_alloc_error:
	(void) bnxef_fw_resources_free(dsp, stage);
	return (BNXEF_FAILURE);

}

void
bnxef_fw_resources_free(bnxef_driver_state_t *dsp, uint32_t stage)
{

	ASSERT(dsp != NULL);
	if ((stage & BNXEF_FW_STATS_BUFFER_COMPLETE) ==
			BNXEF_FW_STATS_BUFFER_COMPLETE) {
		(void) bnxef_stats_buffer_free(dsp, BNXEF_STATS_BUF_ALL);
	}

	if ((stage &  BNXEF_FW_DUMMY_BUFFER_COMPLETE) ==
			    BNXEF_FW_DUMMY_BUFFER_COMPLETE) {
		(void) bnxef_dummy_buffer_free(dsp, BNXEF_DUMMY_BUF_ALL);
	}

	if ((stage & BNXEF_FW_T2_HASH_TABLE_COMPLETE) ==
		BNXEF_FW_T2_HASH_TABLE_COMPLETE) {
		(void) bnxef_t2_hash_table_free(dsp, BNXEF_T2_HASH_TABLE_ALL);
	}

	if ((stage & BNXEF_FW_HASH_TABLE_COMPLETE) ==
		BNXEF_FW_HASH_TABLE_COMPLETE) {
		(void) bnxef_hash_table_free(dsp, BNXEF_HASH_TABLE_ALL);
	}

	if ((stage & BNXEF_FW_TASK_RES_ALLOC_COMPLETE) ==
		BNXEF_FW_TASK_RES_ALLOC_COMPLETE) {
		(void) bnxef_task_resource_free(dsp, BNXEF_TASK_RESOURCE_ALL);
	}

}

/*
 * This free all the driver task resources allocated
 */
int
bnxef_driver_task_resources_free(bnxef_driver_state_t *dsp)
{

	bnxef_fcoe_task_t *taskp = NULL;

	ASSERT(dsp != NULL);

	while ((taskp = bnxef_task_list_get_first(dsp)) != NULL) {
		bnxef_task_bd_table_pre_free(dsp, taskp,
				BNXEF_TASK_BD_TABLE_ALL);
		kmem_cache_free(dsp->task_cache, taskp);
	}

	return (BNXEF_SUCCESS);
}

/*
 * This will allocate all the driver task resources and put them in free list
 * so that it can be used by other software once the attach is complete.
 */
int
bnxef_driver_task_resources_alloc(bnxef_driver_state_t *dsp)
{
	int	 i, j;
	bnxef_fcoe_task_t *taskp = NULL;
	struct fcoe_task_ctx_entry *fwtskp = NULL;
	int num_entries_per_dma_handle;

	ASSERT(dsp != NULL);

	/* Pre-Allocate the bd table */
	dsp->task_bd_table_pre_alloc = 1;

	for (j = 0; j < dsp->num_task_dma_handles; j++) {
		/* LINTED: alignment */
		fwtskp = (struct fcoe_task_ctx_entry *)dsp->task_ctx[j];
		BNXEF_AUTO_DEBUG("%s%d:Initializing FCOE task at Page Index %d",
			BNXEF_DRIVER_NAME, dsp->instance, j);
		num_entries_per_dma_handle =
			BNXEF_PAGE_SIZE/sizeof (struct fcoe_task_ctx_entry);
		for (i = 0; i <  num_entries_per_dma_handle; i++) {
			/*
			 * Allocate a driver task structure from the Kmem
			 * cache
			 */
			taskp = (bnxef_fcoe_task_t *)
				kmem_cache_alloc(dsp->task_cache, KM_SLEEP);
			if (taskp == NULL) {
				BNXEF_AUTO_DEBUG(
				"%s%d: Unable to alloc driver task structure",
					BNXEF_DRIVER_NAME, dsp->instance);
				goto bnxef_driver_task_res_alloc_error;
			}

			taskp->x_id = j*num_entries_per_dma_handle + i;

			/* This will move to next tsk entry */
			taskp->fwtaskp = fwtskp++;

			taskp->dma_handle_idx = j;

			/* Set the driver state structure ptr */
			taskp->dsp = (void *) dsp;

			if (dsp->task_bd_table_pre_alloc) {
				/* Pre Alloc DMA memory for BD table */
				bnxef_task_bd_table_pre_alloc(dsp, taskp);
			}

			/* Now add this to the end of free list */
			(void) bnxef_task_list_add(dsp, taskp);
			dsp->taskarray[j*num_entries_per_dma_handle + i] =
				taskp;
		}
	}
	return (BNXEF_SUCCESS);

bnxef_driver_task_res_alloc_error:
	(void) bnxef_driver_task_resources_free(dsp);
	return (BNXEF_FAILURE);
}

/*
 * The following routine will free all kstat related resources.
 */
void
bnxef_kstat_resource_free(bnxef_driver_state_t *dsp)
{
	ASSERT(dsp != NULL);

	kstat_delete(dsp->stats);
	dsp->stats = NULL;
	kstat_delete(dsp->fwstats);
	dsp->fwstats = NULL;
}


/*
 * The following will allocate all kstat related resources for collecting stats
 */

int
bnxef_kstat_resource_alloc(bnxef_driver_state_t *dsp)
{
	char kstatname[KSTAT_STRLEN];

	ASSERT(dsp != NULL);

	if (dsp->stats == (kstat_t *)NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Allocating All kstat resources",
			BNXEF_DRIVER_NAME, dsp->instance);
		(void) sprintf(kstatname, "driver-stats", dsp->instance);
		dsp->stats = kstat_create(BNXEF_DRIVER_NAME, dsp->instance,
			kstatname, "FCA", KSTAT_TYPE_NAMED,
			sizeof (bnxef_driver_stats_t)/sizeof (kstat_named_t),
			KSTAT_FLAG_PERSISTENT);

		if (dsp->stats) {
			bnxef_driver_stats_t  *statp;
			char buf[32];
			uint64_t addr_64;
			uint32_t addr_lo, addr_hi;

			statp = (bnxef_driver_stats_t *)dsp->stats->ks_data;
			kstat_named_init(&statp->max_exchanges,
				"Max. Exchanges Supported",
				KSTAT_DATA_UINT32);
			kstat_named_init(&statp->max_connections,
				"Max. Ofld Conns Supported",
				KSTAT_DATA_UINT32);
			kstat_named_init(&statp->init_cqe_tx,
				"Init Wqes Transmitted",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->scsi_bsy_ret,
				"SCSI Trans BUSY Ret",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->init_comp_cqe_rx,
				"Init Wqes Completed",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->ofld_cqe_tx,
				"Offload Wqes Transmitted",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->ofld_comp_cqe_rx,
				"Offload Wqes Completed",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->enable_cqe_tx,
				"Enable Wqes transmitted",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->enable_comp_cqe_rx,
				"Enable Wqes Completed",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fp_completion_tx,
				"Fast path Reqs",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fp_completion_rx,
				"Fast path completions",
				KSTAT_DATA_UINT64);

			kstat_named_init(&statp->successfull_scsi_cmds,
					"Successfull SCSI Completion ",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->errored_scsi_cmds,
					"Errored SCSI commands",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->scsi_dispatched,
					"SCSI Tasks",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->els_dispatched,
					"ELS Tasks",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->timeout_tasks,
					"Timedout Tasks",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->ct_dispatched,
					"FC-CT Tasks",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->driver_version,
					"Driver Version",
					KSTAT_DATA_CHAR);
			kstat_named_init(&statp->firmware_version,
					"Firmware Version",
					KSTAT_DATA_CHAR);
			kstat_named_init(&statp->l2_rx,
					"Rx L2 Packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_tx,
					"Tx L2 packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_rx_free,
					"Freed L2 packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fip_rx,
					"Rx L2 FIP packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fip_tx,
					"Tx L2 FIP packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fip_rx_free,
					"Freed L2 FIP packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fcoe_rx,
					"Rx L2 FCoE packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fcoe_tx,
					"Tx L2 FCoE packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_fcoe_rx_free,
					"Freed L2 FCoE packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_unknown_rx,
					"Unknown L2 Rx packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->l2_unknown_rx_free,
					"Freed L2 Unknown Rx packets",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->rscn_rx,
				"No. RSCN Received",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->rscn_acc_tx,
					"No. of RSCN Local acc sent",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->rscn_acc_lv_tx,
					"No of RSCN LV Acc Dropped",
					KSTAT_DATA_UINT64);
			kstat_named_init(&statp->state_hi,
					"State Struct Ptr Hi",
					KSTAT_DATA_CHAR);
			kstat_named_init(&statp->state_lo,
					"State Struct Ptr Lo",
					KSTAT_DATA_CHAR);
			dsp->stats->ks_private = dsp;
			dsp->stats->ks_update = nulldev;

			kstat_install(dsp->stats);
			(void) strncpy(&statp->driver_version.value.c[0],
					BNXEF_FCOE_VERSION, 16);
		(void) snprintf(&statp->firmware_version.value.c[0], 16,
			"%d.%d.%d",
			BCM_5710_FW_MAJOR_VERSION,
			BCM_5710_FW_MINOR_VERSION,
			BCM_5710_FW_REVISION_VERSION);
			addr_64 = (uint64_t)dsp;
			addr_lo = addr_64 & 0xFFFFFFFF;
			addr_hi = (addr_64 >> 32) & 0xFFFFFFFF;
			(void) sprintf(buf, "%x", addr_hi);
			(void) strncpy(&statp->state_hi.value.c[0],
					buf, 16);
			(void) sprintf(buf, "%x", addr_lo);
			(void) strncpy(&statp->state_lo.value.c[0],
					buf, 16);

		} else return (BNXEF_FAILURE);
	}

	if (dsp->fwstats ==  (kstat_t *)NULL) {
		(void) sprintf(kstatname, "fw-stats", dsp->instance);
		dsp->fwstats = kstat_create(BNXEF_DRIVER_NAME, dsp->instance,
			kstatname, "FW", KSTAT_TYPE_NAMED,
			sizeof (bnxef_fw_stats_t)/sizeof (kstat_named_t),
			KSTAT_FLAG_PERSISTENT);
		if (dsp->fwstats) {
			bnxef_fw_stats_t *statp;

			statp = (bnxef_fw_stats_t *)dsp->fwstats->ks_data;
			kstat_named_init(&statp->fcoe_tx_pkt_cnt,
				"Number of tx FCoE packets",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcoe_tx_byte_cnt,
				"Number of tx FCoE bytes",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcp_tx_pkt_cnt,
				"Number of tx fcp packets",
				KSTAT_DATA_UINT64);

			kstat_named_init(&statp->fcp_rx_pkt_cnt,
				"Number of rx fcp packets",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcoe_rx_drop_pkt_cnt,
				"Number of rx FCoE pkts dropped",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcoe_ver_cnt,
				"Number of FCoE Ver mismatch pkts",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->drop_seq_cnt,
				"Number of sequence dropped",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->seq_timeout_cnt,
				"Number of sequence timeouts",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->miss_frame_cnt,
				"Number of missing frames",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->eofa_del_cnt,
				"Number of rx frames with EoFa",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fc_crc_cnt,
				"Number of CRC errors",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcoe_rx_pkt_cnt,
				"Number of Rx FCoE pkts",
				KSTAT_DATA_UINT64);
			kstat_named_init(&statp->fcoe_rx_byte_cnt,
				"Number of rx bytes",
				KSTAT_DATA_UINT64);
			dsp->fwstats->ks_private = dsp;
			dsp->fwstats->ks_update = nulldev;

			kstat_install(dsp->fwstats);
		}

	}

	return (BNXEF_SUCCESS);
}

/*
 * To be discussed with Eric on this.
 */
/* ARGSUSED0 */
int
prv_uninit_pkt_descr(dev_info_t *dip)
{
	return (DDI_SUCCESS);
}
/*
 * Routine to unregister callbacks.
 */
int
bnxef_l2_unregister(bnxef_driver_state_t *dsp)
{

	int ret;

	dev_info_t *pdip = NULL;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);
	ret = prv_uninit_pkt_descr(pdip);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to uninit the Rx pkt descr\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	ret = ((struct dev_info *)pdip)->devi_ops->devo_cb_ops->cb_ioctl(0,
			BNXE_UNBIND_FCOE, (intptr_t)&dsp->callbacks, 0, 0, 0);
	if (ret != 0) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to unregister l2 callbacks\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	return (BNXEF_SUCCESS);

}

/*
 * Routine to register callbacks with L2 driver.
 */
int
bnxef_l2_register(bnxef_driver_state_t *dsp)
{
	int ret;
	dev_info_t *pdip = NULL;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	if (pdip == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Parent dip is NULL",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	dsp->callbacks.version	= BNXE_BINDING_VERSION;
	dsp->callbacks.pCliDev	= dsp->dip;
	dsp->callbacks.pPrvDev  = pdip;
	dsp->callbacks.cliCtl  = bnxef_l2_ctl;
	dsp->callbacks.cliIndicateTx = bnxef_l2_tx_completion;
	dsp->callbacks.cliIndicateRx = bnxef_l2_rx;
	dsp->callbacks.cliIndicateCqes = bnxef_l2_cqe_rx;
	dsp->callbacks.numRxDescs = 128;
	dsp->callbacks.numTxDescs = 128;

	ret = ((struct dev_info *)pdip)->devi_ops->devo_cb_ops->cb_ioctl(0,
			BNXE_BIND_FCOE, (intptr_t)&dsp->callbacks, 0, 0, 0);
	if (ret != 0) {
		cmn_err(CE_WARN, "%s%d: Unable to register l2 callbacks",
				BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (BNXEF_SUCCESS);
}

/*
 * This routine unregisters the fc transport structure with higher level layers
 */
int
bnxef_leadville_unregister(bnxef_driver_state_t *dsp)
{

	ASSERT(dsp != NULL);
	ASSERT(dsp->dip != NULL);

	fc_fca_detach(dsp->dip);

	return (BNXEF_SUCCESS);
}


/*
 * This routine will register the fc transport structure and associated
 * parameters with the leadville stack.
 */
int
bnxef_leadville_register(bnxef_driver_state_t *dsp)
{
	fc_fca_tran_t *tranp;

	ASSERT(dsp != NULL);

	tranp = &dsp->tran;
	ASSERT(tranp != NULL);

	memset((uint8_t *)tranp, 0, sizeof (fc_fca_tran_t));
#if defined(__S11) || defined(__S12)
	tranp->fca_version = FCTL_FCA_MODREV_5;
#else
	tranp->fca_version = FCTL_FCA_MODREV_3;
#endif
	tranp->fca_numports = 1;
	tranp->fca_pkt_size = sizeof (void *); /* just enough to set task ptr */
	tranp->fca_cmd_max =  dsp->max_exchanges;
#if defined(__S11) || defined(__S12)
	tranp->fca_num_npivports = dsp->max_fc_ports-1;
#endif

	tranp->fca_dma_attr = &bnxef_dma_attr;
	tranp->fca_acc_attr = &bnxef_dev_acc_attr;
	tranp->fca_dma_lim  = &bnxef_dma_lim;
	tranp->fca_dma_fcp_cmd_attr = &bnxef_cmdrsp_dma_attr;
	tranp->fca_dma_fcp_rsp_attr = &bnxef_cmdrsp_dma_attr;
	tranp->fca_dma_fcp_data_attr = &bnxef_data_dma_attr;

	tranp->fca_bind_port = bnxef_bind_port;
	tranp->fca_unbind_port = bnxef_unbind_port;
	tranp->fca_init_pkt = bnxef_init_pkt;
	tranp->fca_un_init_pkt = bnxef_un_init_pkt;
	tranp->fca_els_send = bnxef_send_els;
	tranp->fca_get_cap = bnxef_get_cap;
	tranp->fca_set_cap = bnxef_set_cap;
	tranp->fca_getmap = bnxef_getmap;
	tranp->fca_transport = bnxef_transport;
	tranp->fca_ub_alloc = bnxef_ub_alloc;
	tranp->fca_ub_free = bnxef_ub_free;
	tranp->fca_ub_release = bnxef_ub_release;
	tranp->fca_abort = bnxef_abort;
	tranp->fca_reset = bnxef_reset;
	tranp->fca_port_manage = bnxef_port_manage;
	tranp->fca_get_device = NULL;
	tranp->fca_notify = bnxef_notify;

	if (fc_fca_attach(dsp->dip, tranp) != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to register Trans structure",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	BNXEF_AUTO_DEBUG("%s%d: Successfully registered the Trans structure",
		BNXEF_DRIVER_NAME, dsp->instance);
	return (BNXEF_SUCCESS);
}
/*
 * This will unmap the door bell bar
 */
int
bnxef_door_bell_bar_unmap(bnxef_driver_state_t *dsp, bnxef_session_t *sessionp)
{
	dev_info_t *pdip = NULL;
	void *vaddr = NULL;
	ddi_acc_handle_t acchdl;
	uint32_t	cid;


	ASSERT(dsp != NULL);

	mutex_enter(&sessionp->session_mutex);
	vaddr = sessionp->doorbell_reg;
	acchdl = sessionp->doorbell_acc;
	cid = sessionp->context_id;
	mutex_exit(&sessionp->session_mutex);

	pdip = ddi_get_parent(dsp->dip);

	BNXEF_AUTO_DEBUG("%s%d: Door Bell Unmap called 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, dsp->doorbellbar);
	if (!dsp->callbacks.prvUnmapMailboxq(pdip, cid, vaddr, acchdl)) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to unmap PCI door bell BAR\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (BNXEF_SUCCESS);
}

/*
 * This will map the door bell register bar.
 */
int
bnxef_door_bell_bar_map(bnxef_driver_state_t *dsp, bnxef_session_t *sessionp)
{
	dev_info_t *pdip = NULL;
	void *vaddr = NULL;
	ddi_acc_handle_t acchdl;
	uint32_t	cid;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);
	mutex_enter(&sessionp->session_mutex);
	cid = sessionp->context_id;
	mutex_exit(&sessionp->session_mutex);
	if (!dsp->callbacks.prvMapMailboxq(pdip, cid, &vaddr, &acchdl)) {
		BNXEF_AUTO_DEBUG(
			"%s%d: Unable to map door bell bar for session 0x%p\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	if (vaddr == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Invalid map for door bell bar\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	mutex_enter(&sessionp->session_mutex);
	sessionp->doorbell_reg = vaddr;
	sessionp->doorbell_acc = acchdl;
	mutex_exit(&sessionp->session_mutex);
	BNXEF_AUTO_DEBUG("%s%d: The Bar address 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp->doorbell_reg);
	return (BNXEF_SUCCESS);
}

/*
 * This routine allocates few miscellaneous memory for easy indexing.
 */
int
bnxef_mem_alloc(bnxef_driver_state_t *dsp)
{

	dsp->sessp = kmem_zalloc(BNXEF_MAX_SESSIONS_SUPPORTED *
		sizeof (void *), KM_SLEEP);

	dsp->taskarray = kmem_zalloc(BNXEF_MAX_EXCHGS_SUPPORTED *
		sizeof (void *), KM_SLEEP);

	return (BNXEF_SUCCESS);
}

int
bnxef_mem_free(bnxef_driver_state_t *dsp)
{
	kmem_free(dsp->taskarray, BNXEF_MAX_EXCHGS_SUPPORTED * sizeof (void *));

	kmem_free(dsp->sessp, BNXEF_MAX_SESSIONS_SUPPORTED* sizeof (void *));

	return (BNXEF_SUCCESS);
}

int
bnxef_uninit_fcoe_fw(bnxef_driver_state_t *dsp)
{

	int ret = BNXEF_FAILURE;

	ret = bnxef_send_fw_fcoe_uninit_msg(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to uninit fcoe fw\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	mutex_enter(&dsp->fw_init_mutex);
	if ((ret = cv_timedwait(&dsp->fw_init_cond, &dsp->fw_init_mutex,
			(ddi_get_lbolt()+ BNXEF_SEC2TICK(2)))) < 0) {
		mutex_exit(&dsp->fw_init_mutex);
		BNXEF_AUTO_DEBUG("%s%d: Response from f/w not received",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	dsp->fw_init_state &= ~BNXEF_INIT_MSG_SENT;
	mutex_exit(&dsp->fw_init_mutex);

	cv_destroy(&dsp->fw_init_cond);
	mutex_destroy(&dsp->fw_init_mutex);

	return (BNXEF_SUCCESS);
}


/*
 * This will send 3 KWQEs and wait for the response to come back. This
 * waiting will happen using the condition variable.
 */
int
bnxef_init_fcoe_fw(bnxef_driver_state_t *dsp)
{
	int ret = BNXEF_FAILURE;
	char name[KSTAT_STRLEN];

	ASSERT(dsp != NULL);

	/* Initialize the condition Variable and mutex first */
	(void) snprintf(name, KSTAT_STRLEN, "fwinit%d-mutex", dsp->instance);
	mutex_init(&dsp->fw_init_mutex, name, MUTEX_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "fwinit%d-cv", dsp->instance);
	cv_init(&dsp->fw_init_cond, name, CV_DRIVER, NULL);

	ret = bnxef_send_fw_fcoe_init_msg(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to initialize fcoe firmware\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		debug_enter("Failed Init");
		goto  bnxef_init_fw_error;
	}
	BNXEF_AUTO_DEBUG("%s%d: Waiting for Reponse from firmware",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(&dsp->fw_init_mutex);
	dsp->fw_init_state |= BNXEF_INIT_MSG_SENT;
	ret = cv_timedwait(&dsp->fw_init_cond, &dsp->fw_init_mutex,
		(ddi_get_lbolt() + BNXEF_SEC2TICK(2)));
	if (ret < 0) {
		mutex_exit(&dsp->fw_init_mutex);
		BNXEF_AUTO_DEBUG("%s%d: No response from f/w for init msg",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	if (dsp->fw_init_error !=  FCOE_KCQE_COMPLETION_STATUS_SUCCESS) {
		mutex_exit(&dsp->fw_init_mutex);
		BNXEF_AUTO_DEBUG("%s%d: Firmware init failed - 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, dsp->fw_init_error);
		return (BNXEF_FAILURE);
	}
	mutex_exit(&dsp->fw_init_mutex);

	return (BNXEF_SUCCESS);

bnxef_init_fw_error:
	return (BNXEF_FAILURE);
}

/*
 * This gives the max receive field size that can be progammed based on
 * mtu size configure for this fcoe interface.
 */
int
bnxef_get_recv_size(bnxef_driver_state_t *dsp)
{
	uint16_t pldsz = 0;
	uint16_t fcoe_hdr_size = 0;

	ASSERT(dsp != NULL);
	ASSERT(dsp->mtu_size <= 2500);

	pldsz =  2048;
	fcoe_hdr_size = sizeof (struct ether_header) +
			sizeof (struct ether_vlan_extinfo) + 12 +
			sizeof (fc_frame_hdr_t) + 1 + 1;

	if (dsp->mtu_size >  (pldsz + fcoe_hdr_size)) {
		return (pldsz);
	}

	pldsz = 1024;
	if (dsp->mtu_size > (pldsz + fcoe_hdr_size)) {
		return (pldsz);
	}

	pldsz = 512;
	if (dsp->mtu_size > (pldsz + fcoe_hdr_size)) {
		return (pldsz);
	}

	/* Cannot work with anything less than 512 */
	ASSERT(0);
	return (-1);
}



/*
 * This initializes the default plogi params, except the WWN. The WWN need
 * to be initialized appropriately per port.
 */
void
bnxef_set_default_logi_params(bnxef_driver_state_t *dsp)
{
	la_els_logi_t  *logip;
	svc_param_t	*class3_param;

	ASSERT(dsp != NULL);
#ifdef TEST_LOGIN
	dsp->bnxe_params.wwn.fcp_pwwn_provided = 1;
	dsp->bnxe_params.wwn.fcp_pwwn[0] = 0x10;
	dsp->bnxe_params.wwn.fcp_pwwn[7] = 0x01;
	dsp->bnxe_params.wwn.fcp_nwwn_provided = 1;
#endif

	logip = &dsp->logi_params;
	if (dsp->bnxe_params.wwn.fcp_pwwn_provided) {
		BNXEF_AUTO_DEBUG("%s%d:New Port Name Set",
			BNXEF_DRIVER_NAME, dsp->instance);
		bcopy(dsp->bnxe_params.wwn.fcp_pwwn,
			&logip->nport_ww_name.raw_wwn, 8);
	} else {
		BNXEF_AUTO_DEBUG("%s%d System Generated Port name set",
			BNXEF_DRIVER_NAME, dsp->instance);
		logip->nport_ww_name.raw_wwn[0] = 0x20;
		logip->nport_ww_name.raw_wwn[1] = 0x00;
		bcopy(dsp->mac_add, &logip->nport_ww_name.raw_wwn[2], 6);
	}

	if (dsp->bnxe_params.wwn.fcp_nwwn_provided) {
		BNXEF_AUTO_DEBUG("%s%d:Now node name set",
			BNXEF_DRIVER_NAME, dsp->instance);
		bcopy(dsp->bnxe_params.wwn.fcp_nwwn,
			&logip->node_ww_name.raw_wwn, 8);
	} else {
		BNXEF_AUTO_DEBUG("%s%d: System generated Node name set",
				BNXEF_DRIVER_NAME, dsp->instance);
		logip->node_ww_name.raw_wwn[0] = 0x10;
		logip->node_ww_name.raw_wwn[1] = 0x00;
		bcopy(dsp->mac_add,  &logip->node_ww_name.raw_wwn[2], 6);
	}

	logip->common_service.fcph_version = 0x2008;
	logip->common_service.btob_credit = 3;
	logip->common_service.cmn_features = 0x8800;
	logip->common_service.conc_sequences = 0xff;
	logip->common_service.relative_offset = 3;
	logip->common_service.e_d_tov = 0x07d0;
	class3_param = (svc_param_t *)&logip->class_3;
	class3_param->class_opt = 0x8800;

	class3_param->rcv_size = logip->common_service.rx_bufsize =
		(dsp->mtu_size >= 2500) ? 2048 : bnxef_get_recv_size(dsp);
	class3_param->conc_sequences = 0xff;
	class3_param->open_seq_per_xchng = 1;

}



/*
 * This function is the work horse for getting the attach completed successfully
 */
int
bnxef_attach_handler(bnxef_driver_state_t *dsp)
{
	int ret;
	char name[KSTAT_STRLEN];
	uint32_t  state = 0;

	ASSERT(dsp != NULL);

	dsp->magic = BNXEF_DRIVER_MAGIC;

	/* Initialize state Mutex */
	(void) snprintf(name, KSTAT_STRLEN, "state%d-mutex", dsp->instance);
	mutex_init(&dsp->state_mutex, name, MUTEX_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "global%d-offload-mutex",
			dsp->instance);
	mutex_init(&dsp->global_offload_mutex, name, MUTEX_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "global_%d_event_log_mutex",
		dsp->instance);
	mutex_init(&dsp->global_event_log_mutex, name, MUTEX_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "port-offline%d-cv", dsp->instance);
	cv_init(&dsp->port_offline_cv, name, CV_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "fcf-select%d-cv", dsp->instance);
	cv_init(&dsp->fcf_cv, name, CV_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "stats%d-cv", dsp->instance);
	cv_init(&dsp->stats_cv, name, CV_DRIVER, NULL);
	(void) snprintf(name, KSTAT_STRLEN, "fp-up%d-cv", dsp->instance);
	cv_init(&dsp->fp_up_cv, name, CV_DRIVER, NULL);

	/* Get tuable parameter configured in conf files */
	ret = bnxef_get_tunables(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Tunable parameters out of bounds\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_TUNABLES_VALIDATED;

	BNXEF_AUTO_DEBUG("%s%d: Tunables understood\n",
			BNXEF_DRIVER_NAME, dsp->instance);

	/* allocate all Kernel memory caches */
	ret = bnxef_alloc_kmem_cache(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate memory caches\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_CACHE_ALLOC_COMPLETED;

	BNXEF_AUTO_DEBUG("%s%d: Kmem caches created\n",
			BNXEF_DRIVER_NAME, dsp->instance);

	/* Initialize all the global List with required mutexes */
	ret = bnxef_init_lists(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to initialize gloabl lists",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}
	state |= BNXEF_LISTS_INITIALIZED;
	BNXEF_AUTO_DEBUG("%s%d: All Lists Initialized\n",
			BNXEF_DRIVER_NAME, dsp->instance);

	/* Allocate firmware required DMA resources for Initializing */
	ret = bnxef_fw_resources_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate fw resources",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}
	state |= BNXEF_FIRMWARE_RES_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: Firmware resources allocated for Init",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * Allocate misc memory resources for easy indexing of Session
	 * and task.
	 */
	ret = bnxef_mem_alloc(dsp);
	if (ret  != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to alloc memory for task array\
			and session array", BNXEF_DRIVER_NAME,
			dsp->instance);
		goto bnxef_attach_error;
	}
	state |= BNXEF_MISC_MEM_ALLOCATED;

	BNXEF_AUTO_DEBUG("%s%d: All Miscelaneous Mem requirements allocated",
			BNXEF_DRIVER_NAME, dsp->instance);

	/* This will allocate driver task structure and populate in free list */
	ret = bnxef_driver_task_resources_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to alloc drv task resources\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_DRIVER_TASK_RES_ALLOCATED;

	BNXEF_AUTO_DEBUG("%s%d: Task resources allocated \n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Install all the the kernel statistics information */
	ret = bnxef_kstat_resource_alloc(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to install statistics\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}
	state |= BNXEF_KSTAT_RES_ALLOCATED;
	BNXEF_AUTO_DEBUG("%s%d: Kstat resources allocated \n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Enable task Queue for doing miscellanous functions */
	snprintf(name, KSTAT_STRLEN, "bnxef_task%d_queue", dsp->instance);
	dsp->tq = ddi_taskq_create(dsp->dip, name, 32, TASKQ_DEFAULTPRI,
			DDI_SLEEP);
	if (dsp->tq == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate task Queue\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_TASK_QUEUE_CREATED;

	snprintf(name, KSTAT_STRLEN, "bnxef_misc_task%d_queue", dsp->instance);
	dsp->mtq = ddi_taskq_create(dsp->dip, name, 128, TASKQ_DEFAULTPRI,
			DDI_SLEEP);
	if (dsp->mtq == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to allocate misc taskq ",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_MISC_TASK_QUEUE_CREATED;

	BNXEF_AUTO_DEBUG("%s%d: TAsk Queue Created with %d threads\n",
		BNXEF_DRIVER_NAME, dsp->instance, 32);

	/*
	 * Initialize Leadville specific parameters includind transport
	 * entry points. and Indicate to higher level.
	 */
	ret = bnxef_leadville_register(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to install trans structures\n"
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}
	/* At this point there could be other calls using dsp */
	state |= BNXEF_LEADVILLE_REG_COMPLETE;

	BNXEF_AUTO_DEBUG("%s%d: Leadville Registration Complete\n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* This will register callback with L2 driver */
	ret = bnxef_l2_register(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to register client with L2\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}
	state |= BNXEF_L2_REG_COMPLETE;

	BNXEF_AUTO_DEBUG("%s%d: L2 registration Complete\n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Get L2 specific Parameters from L2 driver */
	ret = bnxef_l2_open(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to get L2 parameters\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

	state |= BNXEF_L2_PARAMS_RECEIVED;
	BNXEF_AUTO_DEBUG("%s%d: L2 Parameters Understood\n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* Set the default login params based on the MTU size set.  */
	(void) bnxef_set_default_logi_params(dsp);

	BNXEF_AUTO_DEBUG("%s%d: Default logi parameters set\n",
		BNXEF_DRIVER_NAME, dsp->instance);

	/* start the FCoE firmware, at this point you can receive callback */
	ret = bnxef_init_fcoe_fw(dsp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to start FCOE firmware\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_attach_error;
	}

#ifdef TESTING
		/*	bnxef_test_driver_task(dsp); */
		/* bnxef_test_driver_port(dsp); */
		bnxef_test_driver_session(dsp);
#endif
	state |= BNXEF_FCOE_FW_STARTED;

	BNXEF_AUTO_DEBUG("%s%d: Firmware Init completed\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	/* Now probe whether the L2 interface is up and is online */
	/* If it is not online we will get a callback definitely */
	if ((ret = bnxef_is_l2_interface_online(dsp)) == BNXEF_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: L2 Interface is online\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		dsp->physical_port_state = BNXEF_PHYPORT_ONLINE;
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_fip_sm_start, dsp,
					DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d:Unable to schedule tq\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			goto bnxef_attach_error;
		}
		BNXEF_AUTO_DEBUG("%s%d: Fip State machine Triggered\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	} else  {
		dsp->physical_port_state = BNXEF_PHYPORT_OFFLINE;
		/* Trigget FP Attach here - Irrespective of the Online status */
		if ((dsp->state & BNXEF_TRIGGER_FP_ATTACH) == 0) {
				dsp->state |= BNXEF_TRIGGER_FP_ATTACH;
				(void) timeout(bnxef_trigger_fp_attach, dsp,
					    BNXEF_SEC2TICK(1));
		}
	}

	/* Report the device to the system */
	ddi_report_dev(dsp->dip);

	if ((ret = bnxef_is_intf_used_for_mba_boot(dsp)) == BNXEF_SUCCESS) {
		if (dsp->bnxe_params.flags & FCOE_INFO_FLAG_FORCE_LOAD) {
			mutex_enter(&dsp->state_mutex);
			cv_timedwait(&dsp->fp_up_cv, &dsp->state_mutex,
					BNXEF_SEC2TICK(60));
			mutex_exit(&dsp->state_mutex);
		}
	}
	/* Start a timeout routine to periodically pull the Stats */
	dsp->stats_pull_timeout = timeout(bnxef_stats_update, (void *) dsp,
			BNXEF_SEC2TICK(1));
	dsp->state |= BNXEF_STAT_PULL_TIMEOUT_VALID;

	/* Start a timeout routine to periodically report the Stats to MCP */
	dsp->stats_report_timeout = timeout(bnxef_stats_mcp_report,
		(void *) dsp, BNXEF_SEC2TICK(15));
	dsp->state |= BNXEF_STAT_REPORT_TIMEOUT_VALID;

	BNXEF_AUTO_DEBUG("%s%d: Attach Succeeded\n",
		BNXEF_DRIVER_NAME, dsp->instance);
	return (BNXEF_SUCCESS);

bnxef_attach_error:
	BNXEF_AUTO_DEBUG("%s%d: Attach Failed at stage  0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, dsp->state);
	bnxef_detach_handler(dsp, state);
	return (BNXEF_FAILURE);
}

/* ARGSUSED0 */
int
bnxef_is_l2_interface_online(bnxef_driver_state_t *dsp)
{
	boolean_t state;
	dev_info_t *pdip;

	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d: Entering the Check for Link online",
		BNXEF_DRIVER_NAME, dsp->instance);
	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_LINK_STATE, (void *) &state,
		sizeof (boolean_t))) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to get the Link state",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (state ? BNXEF_SUCCESS: BNXEF_FAILURE);
}

int
bnxef_is_intf_used_for_mba_boot(bnxef_driver_state_t *dsp)
{

	boolean_t state;
	dev_info_t *pdip;

	ASSERT(dsp != NULL);
	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_MBA_BOOT, (void *) &state,
		sizeof (boolean_t))) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to get the MBA Boot usage state",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}
	return (state ? BNXEF_SUCCESS: BNXEF_FAILURE);
}


int
bnxef_detach_handler(bnxef_driver_state_t *dsp, uint32_t stage)
{
	int ret = BNXEF_SUCCESS;

	ASSERT(dsp != NULL);

	BNXEF_AUTO_DEBUG("%s%d: Entering %s", BNXEF_DRIVER_NAME, dsp->instance,
			__func__);

	/* Wait for STATS pull routine not to ARM timeout - again */
	delay(BNXEF_SEC2TICK(3));

	if (dsp->state & BNXEF_STAT_PULL_TIMEOUT_VALID) {
		untimeout(dsp->stats_pull_timeout);
		dsp->state &= ~BNXEF_STAT_PULL_TIMEOUT_VALID;
	}
	if (dsp->state & BNXEF_STAT_REPORT_TIMEOUT_VALID) {
		untimeout(dsp->stats_report_timeout);
		dsp->state &= ~BNXEF_STAT_REPORT_TIMEOUT_VALID;
	}
	if (dsp->fip_disc_status & FIP_KEEP_ALIVE_TIMER_ARMED) {
		untimeout(dsp->fip_keep_alive_tmr_hdl);
		dsp->fip_disc_status &= ~FIP_KEEP_ALIVE_TIMER_ARMED;
	}

	if (dsp->fip_disc_status & FIP_TIMEOUT_ARMED) {
		untimeout(dsp->fip_timeout);
		dsp->fip_disc_status &= ~FIP_TIMEOUT_ARMED;
	}

	if ((stage & BNXEF_FCOE_FW_STARTED) == BNXEF_FCOE_FW_STARTED) {
		ret = bnxef_uninit_fcoe_fw(dsp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: F/w uninit failed",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (ret);
		}
		stage &= ~BNXEF_FCOE_FW_STARTED;
	}

	if ((stage & BNXEF_L2_REG_COMPLETE) ==
		BNXEF_L2_REG_COMPLETE) {
		ret =  bnxef_l2_unregister(dsp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: Unable to Unregister from L2",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (ret);
		}
		stage &= ~ BNXEF_L2_REG_COMPLETE;
	}

	if ((stage & BNXEF_LEADVILLE_REG_COMPLETE) ==
			BNXEF_LEADVILLE_REG_COMPLETE) {
		(void) bnxef_leadville_unregister(dsp);
		stage &= ~ BNXEF_LEADVILLE_REG_COMPLETE;
	}


	if ((stage & BNXEF_TASK_QUEUE_CREATED) ==
		BNXEF_TASK_QUEUE_CREATED) {
		(void) ddi_taskq_destroy(dsp->tq);
		stage &= ~BNXEF_TASK_QUEUE_CREATED;
	}

	if ((stage & BNXEF_MISC_TASK_QUEUE_CREATED) ==
		BNXEF_MISC_TASK_QUEUE_CREATED) {
		(void) ddi_taskq_destroy(dsp->mtq);
		stage &= ~BNXEF_MISC_TASK_QUEUE_CREATED;
	}

	if ((stage & BNXEF_KSTAT_RES_ALLOCATED) ==
		BNXEF_KSTAT_RES_ALLOCATED) {
		(void) bnxef_kstat_resource_free(dsp);
		stage &= ~ BNXEF_KSTAT_RES_ALLOCATED;
	}

	if ((stage & BNXEF_DRIVER_TASK_RES_ALLOCATED) ==
		BNXEF_DRIVER_TASK_RES_ALLOCATED) {
		int i, count = 0;
		bnxef_fcoe_task_t *taskp;

		for (i = 0; i < BNXEF_MAX_EXCHGS_SUPPORTED; i++) {
			taskp = (bnxef_fcoe_task_t *)dsp->taskarray[i];
			if (taskp->task_flags & BNXEF_FCOE_TASK_ALLOCATED) {
				count++;
				bnxef_task_free(dsp, taskp);
			}
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Number of Task not freed 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, count);

		(void) bnxef_driver_task_resources_free(dsp);
		stage &= ~BNXEF_DRIVER_TASK_RES_ALLOCATED;
	}

	if (stage & BNXEF_MISC_MEM_ALLOCATED) {
		(void) bnxef_mem_free(dsp);
		stage &= ~ BNXEF_MISC_MEM_ALLOCATED;
	}

	if ((stage & BNXEF_FIRMWARE_RES_ALLOCATED) ==
		BNXEF_FIRMWARE_RES_ALLOCATED) {
		(void) bnxef_fw_resources_free(dsp, BNXEF_FW_RES_ALL);
		stage &= ~BNXEF_FIRMWARE_RES_ALLOCATED;
	}

	if ((stage & BNXEF_LISTS_INITIALIZED) ==
		BNXEF_LISTS_INITIALIZED) {
		ret = bnxef_fini_lists(dsp, BNXEF_LIST_INIT_ALL);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_AUTO_DEBUG("%s%d: Unable to fini lists",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (ret);
		}
		stage &= ~BNXEF_LISTS_INITIALIZED;
	}

	if ((stage & BNXEF_CACHE_ALLOC_COMPLETED) ==
		BNXEF_CACHE_ALLOC_COMPLETED) {
		(void) bnxef_destroy_kmem_cache(dsp, BNXEF_CACHE_ALL);
		stage &= ~ BNXEF_CACHE_ALLOC_COMPLETED;
	}

	if ((stage & BNXEF_L2_PARAMS_RECEIVED) ==
		BNXEF_L2_PARAMS_RECEIVED) {
		(void) bnxef_l2_close(dsp);
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	dsp->state &= ~BNXEF_DETACH_IN_PROGRESS;
	dsp->state = 0;
	mutex_exit(&dsp->state_mutex);

#ifdef DEBUG
	if (dsp->bnxef_debug & BNXEF_TRACE_EVENTS) {
		kmem_free(dsp->global_event_logp,
			dsp->bnxef_max_trace_events *
				sizeof (bnxef_trace_events_t));
	}

	/* Destroy the global_event log mutex */
	mutex_destroy(&dsp->global_event_log_mutex);
#endif

	/* Destroy Cv */
	cv_destroy(&dsp->fp_up_cv);
	cv_destroy(&dsp->stats_cv);
	cv_destroy(&dsp->fcf_cv);
	cv_destroy(&dsp->port_offline_cv);
	/* Detroy global offload Mutex */
	mutex_destroy(&dsp->global_offload_mutex);
	/* Detroy the mutex */
	mutex_destroy(&dsp->state_mutex);


	return (DDI_SUCCESS);
}


/* ARGSUSED0 */
static int
bnxef_open(dev_t *devp, int flag, int otype, cred_t *credp)
{

	bnxef_driver_state_t *dsp;
	ASSERT(devp != NULL);

	dsp = ddi_get_soft_state(bnxef_state, (int)getminor(*devp));
	if (dsp == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable get Soft state for instance\n"
				BNXEF_DRIVER_NAME, (int)getminor(*devp));
		return (ENXIO);
	}

	if (otype != OTYP_CHR) {
		BNXEF_AUTO_DEBUG("%s%d: Unknown type\n", BNXEF_DRIVER_NAME,
			(int)getminor(*devp));
		return (EINVAL);
	}

	if (drv_priv(credp)) {
		BNXEF_AUTO_DEBUG("%s%d, No permission to use the device\n",
			BNXEF_DRIVER_NAME, (int)getminor(*devp));
		return (EINVAL);
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->ioctl_flags & BNXEF_IOCTL_FLAG_OPEN) {
		/* We donot support concurrent open */
		mutex_exit(&dsp->state_mutex);
		return (EBUSY);
	}

	dsp->ioctl_flags |= BNXEF_IOCTL_FLAG_OPEN;
	mutex_exit(&dsp->state_mutex);

	return (0);
}

/*
 * CLose routine for the character device interface
 */
/* ARGSUSED0 */
static int
bnxef_close(dev_t dev, int flag, int otype, cred_t *credp)
{

	bnxef_driver_state_t *dsp = NULL;

	dsp = ddi_get_soft_state(bnxef_state, (int)getminor(dev));
	if (dsp == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable get Soft state for instance\n"
				BNXEF_DRIVER_NAME, (int)getminor(dev));
		return (ENXIO);
	}
	if (otype != OTYP_CHR) {
		BNXEF_AUTO_DEBUG("%s%d: Unknown type\n", BNXEF_DRIVER_NAME,
			(int)getminor(dev));
		return (EINVAL);
	}

	if (drv_priv(credp)) {
		BNXEF_AUTO_DEBUG("%s%d, No permission to use the device\n",
			BNXEF_DRIVER_NAME, (int)getminor(dev));
		return (EINVAL);
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (!(dsp->ioctl_flags & BNXEF_IOCTL_FLAG_OPEN)) {
		/* If it is not open, we return nodev. */
		mutex_exit(&dsp->state_mutex);
		return (ENODEV);
	}

	dsp->ioctl_flags &= ~BNXEF_IOCTL_FLAG_OPEN;
	mutex_exit(&dsp->state_mutex);

	return (0);
}


/* ARGSUSED2 */
int
bnxef_ioctl(dev_t dev, int cmd, intptr_t data, int mode,
		    cred_t *credp, int *rval)
{

	bnxef_driver_state_t *dsp;
	int	ret = 0;

	/* Get the soft state for this instance */
	dsp = ddi_get_soft_state(bnxef_state, (int)getminor(dev));
	if (dsp == NULL) {
		BNXEF_AUTO_DEBUG("%s%d: Unable to get soft state",
			BNXEF_DRIVER_NAME, (int)getminor(dev));
		return (ENXIO);
	}

	if (drv_priv(credp) != 0) {
		BNXEF_AUTO_DEBUG("%s%d: No permission to use the device\n",
			BNXEF_DRIVER_NAME, (int)getminor(dev));
		return (EPERM);
	}


	switch (cmd) {
	default:
		BNXEF_AUTO_DEBUG("%s%d: Unknown ioctl cmd %d",
			BNXEF_DRIVER_NAME, dsp->instance, cmd);
		ret = ENOTTY;
	}

	*rval = ret;
	return (ret);
}

boolean_t
bnxef_bringup_all_ports(bnxef_driver_state_t *dsp)
{

	bnxef_port_t *portp;
	int ret, i;
	timeout_id_t	tid, tid2;
	uint32_t	flags;

	portp = bnxef_port_list_find_flags(dsp,
		BNXEF_FC_PORT_N_PORT |
		BNXEF_FC_PORT_ID_NOT_ACQUIRED);
	if (portp == NULL) {
		return (B_TRUE);
	}

	mutex_enter(&portp->port_mutex);
	if (portp->flags & BNXEF_FC_PORT_ACQUISITION_INPROGRESS) {
		mutex_exit(&portp->port_mutex);
		return (B_TRUE);
	}
	portp->flags |= BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
	flags = portp->flags;
	mutex_exit(&portp->port_mutex);

	/* If Shutdown is in progress, wait for Shut down to complete */
	if (flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		/* Wait for shutdown to complete */
		mutex_enter(&portp->port_mutex);
		cv_timedwait(&portp->shutdown_cv, &portp->port_mutex,
			ddi_get_lbolt() + BNXEF_SEC2TICK(2));
		mutex_exit(&portp->port_mutex);
	}


	ASSERT((flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) == 0);
	if (flags & BNXEF_FC_PORT_SOL_BOUND) {
		ASSERT(flags & BNXEF_FC_PORT_ID_NOT_ACQUIRED);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: ID being acquired for use as N Port",
			BNXEF_DRIVER_NAME, dsp->instance);
		ret = bnxef_port_get_id(portp, LA_ELS_FLOGI);
		if (ret != BNXEF_SUCCESS)  {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: ID Acquisition FAiled for N Port",
				BNXEF_DRIVER_NAME, dsp->instance);
			mutex_enter(&portp->port_mutex);
			portp->flags &= ~BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
			mutex_exit(&portp->port_mutex);
			return (B_TRUE);
		}
		mutex_enter(&dsp->state_mutex);
		dsp->fip_disc_state = FIP_VLINK_MAINT_STATE;
		mutex_exit(&dsp->state_mutex);
		portp->kaarg1.portp = portp;
		portp->kaarg1.flags = 0;
		tid = timeout(bnxef_timeout_fip_ka, &portp->kaarg1,
			BNXEF_SEC2TICK(portp->vn_period));
		portp->kaarg2.portp = portp;
		portp->kaarg2.flags = VN_PORT_FLAG;
		tid2 = timeout(bnxef_timeout_fip_ka, &portp->kaarg2,
			BNXEF_SEC2TICK(FKA_VN_PERIOD));

		mutex_enter(&portp->port_mutex);
		portp->keep_alive_tmr_hdl = tid;
		portp->keep_alive_tmr2_hdl = tid2;
		portp->fip_state |=
			FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS;
		portp->fip_state |= FIP_KEEP_ALIVE_ARMED;
		portp->fip_state |= FIP_KEEP_ALIVE_TIMER2_ARMED;
		portp->count = 0;
		portp->flags &= ~BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
		mutex_exit(&portp->port_mutex);

		bnxef_fc_port_online((void *) portp);
		for (i = 0; i < dsp->num_fc_ports-1; i++) {
			BNXEF_DEBUG(dsp, ERROR, -1,  "%s%d: ID for port # %d",
				BNXEF_DRIVER_NAME, dsp->instance,
					i);
			portp = bnxef_port_list_find_flags(dsp,
					BNXEF_FC_PORT_VN_PORT |
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
			if (portp == NULL) continue;
			BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Port Pointer %p",
				BNXEF_DRIVER_NAME, dsp->instance,
				portp);
			mutex_enter(&portp->port_mutex);
			portp->flags |= BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
			flags = portp->flags;
			mutex_exit(&portp->port_mutex);
			if (flags & BNXEF_FC_PORT_SOL_BOUND) {
				ASSERT(portp->flags &
					BNXEF_FC_PORT_ID_NOT_ACQUIRED);
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: ID being acquired for use as N Port",
					BNXEF_DRIVER_NAME, dsp->instance);
				ret = bnxef_port_get_id(portp, LA_ELS_FDISC);
				if (ret != BNXEF_SUCCESS)  {
					mutex_enter(&portp->port_mutex);
					portp->flags &=
					~BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
					mutex_exit(&portp->port_mutex);
					continue;
				}
				portp->kaarg1.portp = portp;
				portp->kaarg1.flags = 0;
				tid = timeout(
					    bnxef_timeout_fip_ka,
					    &portp->kaarg1,
					    BNXEF_SEC2TICK(portp->vn_period));
				mutex_enter(&portp->port_mutex);
				portp->keep_alive_tmr_hdl = tid;
				portp->fip_state |=
				FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS;
				portp->fip_state |=
					FIP_KEEP_ALIVE_ARMED;
				portp->count = 0;
				portp->flags &=
					~BNXEF_FC_PORT_ACQUISITION_INPROGRESS;
				mutex_exit(&portp->port_mutex);
				bnxef_fc_port_online((void *) portp);
			}
		}
	}

	return (B_TRUE);
}

void
bnxef_bringup_ports(void *arg)
{
	bnxef_driver_state_t *dsp;
	boolean_t rc;

	dsp = (bnxef_driver_state_t *)arg;
	ASSERT(dsp != NULL);

	rc = bnxef_bringup_all_ports(dsp);
	ASSERT(rc == B_TRUE);
}

void
bnxef_port_online_handler(void *arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	uint32_t	state;
	int		 ret;

	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, ERROR, -1,  "%s%d: Physical Port Online",
			BNXEF_DRIVER_NAME, dsp->instance);
	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Physical Port Online",
		BNXEF_DRIVER_NAME, dsp->instance);


	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline in Progress, waiting...",
			BNXEF_DRIVER_NAME, dsp->instance);
		cv_wait(&dsp->port_offline_cv, &dsp->state_mutex);
	}
	state = dsp->physical_port_state;
	dsp->fip_disc_state = 0;
	dsp->fip_disc_status = 0;
	mutex_exit(&dsp->state_mutex);

	/* If the state is Online, then start FIP State machine */
	if (state) {
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->port_bring_up = 1;
		mutex_exit(&dsp->state_mutex);
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_fip_sm_start, dsp,
					DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d:Unable to schedule tq\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			dsp->state &= ~BNXEF_PORT_ONLINE_HANDLER_INPROGRESS;
			mutex_exit(&dsp->state_mutex);
			return;
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Fip State machine Triggered\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	dsp->state &= ~BNXEF_PORT_ONLINE_HANDLER_INPROGRESS;
	mutex_exit(&dsp->state_mutex);
}


void
bnxef_port_offline_handler(void *arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	bnxef_port_t	*portp;
	int i;
	timeout_id_t  tid;
	int	 tid_valid = 0;

	BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Physical port offline",
		BNXEF_DRIVER_NAME, dsp->instance);
	ASSERT(dsp != NULL);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	dsp->state |= BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS;
	if (dsp->fip_disc_status & FIP_KEEP_ALIVE_TIMER_ARMED) {
		tid = dsp->fip_keep_alive_tmr_hdl;
		tid_valid = 1;
		dsp->fip_disc_status &= ~FIP_KEEP_ALIVE_TIMER_ARMED;
	}
	mutex_exit(&dsp->state_mutex);

	if (tid_valid)
		untimeout(tid);


	for (i = 0; i < dsp->num_fc_ports; i++) {
		/* First MAke all VN_Ports Provided Offline */
		portp = bnxef_port_list_find_flags(dsp,
			(BNXEF_FC_PORT_ID_ACQUIRED | BNXEF_FC_PORT_VN_PORT));
		if (portp == NULL) continue;
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline for Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);
		bnxef_fc_port_offline((void *) portp);
		/* This will cleanup all sessions and I/Os */
		bnxef_shutdown_port(portp);
	}
	/*
	 * For the Orininal N_PORt Cleanup
	 */
	portp = bnxef_port_list_find_flags(dsp,
		(BNXEF_FC_PORT_ID_ACQUIRED | BNXEF_FC_PORT_N_PORT));
	if (portp != NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline for Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);
		bnxef_fc_port_offline(portp);
		bnxef_shutdown_port(portp);
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->fip_disc_status & FIP_KEEP_ALIVE_TIMER_ARMED) {
		mutex_exit(&dsp->state_mutex);
		untimeout(dsp->fip_keep_alive_tmr_hdl);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->fip_disc_status &= ~FIP_KEEP_ALIVE_TIMER_ARMED;
	}

	if (dsp->fip_disc_status & FIP_TIMEOUT_ARMED) {
		mutex_exit(&dsp->state_mutex);
		untimeout(dsp->fip_timeout);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->fip_disc_status &= ~FIP_TIMEOUT_ARMED;
	}
	dsp->state &= ~BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS;
	cv_signal(&dsp->port_offline_cv);
	mutex_exit(&dsp->state_mutex);
}

/* ARGSUSED0 */
boolean_t
bnxef_l2_ctl(dev_info_t *dip, int cmd, void *data, int datalen)
{
	int instance, ret, i;
	bnxef_driver_state_t *dsp;
	uint32_t	state, phy_port_state;
	timeout_id_t	tid;
	int		tid_valid = 0;
	bnxef_port_t	*portp;
	uint32_t active_ubs = 0;

	ASSERT(dip != NULL);
	instance = ddi_get_instance(dip);

	dsp = ddi_get_soft_state(bnxef_state, instance);
	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d:Received callback for an event 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, cmd);
	switch (cmd) {
	case CLI_CTL_LINK_UP:
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
			/* Set the Link State to be Up */
			dsp->physical_port_state = BNXEF_PHYPORT_ONLINE;
			mutex_exit(&dsp->state_mutex);
		} else {
			mutex_exit(&dsp->state_mutex);
			cmn_err(CE_NOTE, "%s%d: Already online",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* This is already online, donot proceed */
			return (B_FALSE);
		}

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		state = dsp->state;
		mutex_exit(&dsp->state_mutex);
		if (state & BNXEF_PORT_ONLINE_HANDLER_INPROGRESS)
				return (B_TRUE);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state |= BNXEF_PORT_ONLINE_HANDLER_INPROGRESS;
		mutex_exit(&dsp->state_mutex);
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_port_online_handler,
			dsp, DDI_NOSLEEP);
		if (ret  != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d: Unable to Schedule Port online handler",
					    BNXEF_DRIVER_NAME, dsp->instance);
			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			dsp->state &= ~BNXEF_PORT_ONLINE_HANDLER_INPROGRESS;
			mutex_enter(&dsp->state_mutex);
			return (B_FALSE);
		}
		break;

	case CLI_CTL_LINK_DOWN:
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		if (dsp->physical_port_state == BNXEF_PHYPORT_ONLINE) {
			dsp->physical_port_state = BNXEF_PHYPORT_OFFLINE;
			if (dsp->fip_disc_status &
				FIP_KEEP_ALIVE_TIMER_ARMED) {
				tid = dsp->fip_keep_alive_tmr_hdl;
				tid_valid = 1;
				dsp->fip_disc_status &=
					~FIP_KEEP_ALIVE_TIMER_ARMED;
			}
			mutex_exit(&dsp->state_mutex);
			if (tid_valid) untimeout(tid);
		} else {
			mutex_exit(&dsp->state_mutex);
			cmn_err(CE_NOTE, "%s%d: Already Offline",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Physical Port Already offline, donot proceed */
			return (B_FALSE);
		}
		/* Purge the FCFs identified */
		bnxef_fcf_list_purge(dsp);


		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->fcf_ident = NULL;
		if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d:Port CVL in progress, Offline handler not called",
			BNXEF_DRIVER_NAME, dsp->instance);
			mutex_exit(&dsp->state_mutex);
			return (B_FALSE);
		}
		mutex_exit(&dsp->state_mutex);
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_port_offline_handler,
			dsp, DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unable to schedule port offline handler",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (B_FALSE);
		}

		break;
	case CLI_CTL_UNLOAD:

		for (i = 0; i < dsp->num_fc_ports; i++) {
			/* First MAke all VN_Ports Provided Offline */
			portp = bnxef_port_list_find_flags(dsp,
				(BNXEF_FC_PORT_ID_ACQUIRED |
				BNXEF_FC_PORT_VN_PORT));
			if (portp == NULL) continue;
			active_ubs = bnxef_get_active_ub_count(portp);
			if (active_ubs > 0) {
				BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d: There is a pending Unsolicited request\
					with Leadville - Cannot unload",
				BNXEF_DRIVER_NAME, dsp->instance);
				return (B_FALSE);
			}
		}

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		phy_port_state = dsp->physical_port_state;
		dsp->state |= BNXEF_L2_UNLOAD_CALLED;
		state = dsp->state;
		mutex_exit(&dsp->state_mutex);
		BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Unload is called",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (phy_port_state == BNXEF_PHYPORT_OFFLINE) {
			/* It is already offline */
			/* Make sure it not executing the offline handler */
			if (state & BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS) {
				/*
				 * Wait for the Offline Handler to complete ,
				 * We have nothing to do, return B_TRUE
				 */
				/*
				 * Allow the FIP state machine to come
				 * to LOGIN READY state
				 */
				for (i = 0; i < 60; i++) {
					mutex_enter(&dsp->state_mutex);
					state = (volatile uint32_t) dsp->state;
					mutex_exit(&dsp->state_mutex);
					if ((state &
					BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS)
							== 0) {
						delay(BNXEF_SEC2TICK(1));
					} else break;
				}
				ASSERT((dsp->state &
					BNXEF_PORT_OFFLINE_HANDLER_INPROGRESS)
						== 0);
			}
			return (B_TRUE);
		}
		BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d:Not in Offline Handler",
			BNXEF_DRIVER_NAME, dsp->instance);

		if (state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
			/* Wait for CVL processing to complete */
			for (i = 0; i < 60; i++) {
				mutex_enter(&dsp->state_mutex);
				state = (volatile uint32_t) dsp->state;
				mutex_exit(&dsp->state_mutex);
				if ((state &
					BNXEF_PORT_CVL_PROCESSING_INPROGRESS)
					== 0) {
					delay(BNXEF_SEC2TICK(1));
				} else break;
			}
			ASSERT((dsp->state &
				BNXEF_PORT_CVL_PROCESSING_INPROGRESS) == 0);
		}
		BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Not in CVL processing",
			BNXEF_DRIVER_NAME, dsp->instance);

		// bnxef_port_offline_handler((void *)dsp);

		break;
	default:
		BNXEF_DEBUG(dsp, ERROR, -1, "Unknown Command");
		break;
	}

	return (B_TRUE);
}

/* ARGSUSED0 */
boolean_t
bnxef_l2_tx_completion(dev_info_t *dip, mblk_t *mblkp)
{

	return (BNXEF_SUCCESS);
}
