/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File: //servers/main/nx2/drivers/solaris/fcoe/src/bnxef_debug.h $$Revision: #13 $$Change: 190127 $$DateTime: 2012/07/06 17:05:01 $"

#ifndef	__BNXEF_DEBUG_H__
#define	__BNXEF_DEBUG_H__

#include <sys/types.h>
#include <sys/conf.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/errno.h>
#include <sys/cred.h>
#include <sys/poll.h>
#include <sys/modctl.h>
#include <sys/stat.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/ddifm.h>
#include <sys/fm/protocol.h>
#include <sys/fm/util.h>
#include <sys/fm/io/ddi.h>
#include <sys/pattr.h>
#include <sys/sysmacros.h>
#include <sys/strsun.h>
#include <sys/ksynch.h>
#include <sys/kstat.h>
#include <sys/strsubr.h>
#include <sys/ksynch.h>
#include <note.h>

/* Debug Flags that can be enabled */
#define	BNXEF_FIP_DEBUG		0x00000001
#define	BNXEF_SCSI_DEBUG	0x00000002
#define	BNXEF_FCCT_DEBUG	0x00000004
#define	BNXEF_ELS_DEBUG		0x00000008
#define	BNXEF_ERROR_DEBUG	0x00000010
#define	BNXEF_AUTOCONF_DEBUG	0x00000020
#define	BNXEF_GENERAL_DEBUG	0x00000040
#define	BNXEF_TRACE_EVENTS	0x40000000
#define	BNXEF_PORT_SPECIFIC_DEBUG	0x80000000

#ifdef DEBUG
#define	BNXEF_MAX_INSTANCE		2
int bnxef_debug_ports[BNXEF_MAX_INSTANCE][BNXEF_MAX_FC_PORTS];
#define	BNXEF_AUTO_DEBUG(a, ...) {\
		if (dsp->bnxef_debug & BNXEF_AUTOCONF_DEBUG) \
			cmn_err(CE_NOTE, a, ##__VA_ARGS__); \
	}

#define	BNXEF_DEBUG(a, b, c, ...)    {\
	int i;\
	int found = 0;\
	int m_port = c; \
	if (a->bnxef_debug & BNXEF_##b##_DEBUG) {\
		if (a->bnxef_debug & BNXEF_PORT_SPECIFIC_DEBUG) {\
			for (i = 0; i < a->port_debug_num_ports; i++) {\
				if (m_port == -1) {\
					found++;\
					break; \
				}\
				if (m_port == a->bnxef_debug_ports[i]) { \
					found ++;\
					break; \
				}\
			} \
			if (found) cmn_err(CE_NOTE, ##__VA_ARGS__); \
		} else {\
			cmn_err(CE_NOTE, ##__VA_ARGS__); \
		}\
	}\
}

#else
/*VARARGS*/
#define	BNXEF_DEBUG(a, b, c, ...)
/*VARARGS*/
#define	BNXEF_AUTO_DEBUG(a, ...)
#endif
#endif
