/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#ifndef __BNXEF_FCOE_H__
#define	__BNXEF_FCOE_H__

#include <sys/types.h>
#include <sys/conf.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/errno.h>
#include <sys/cred.h>
#include <sys/poll.h>
#include <sys/modctl.h>
#include <sys/stat.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/ddifm.h>
#include <sys/fm/protocol.h>
#include <sys/fm/util.h>
#include <sys/fm/io/ddi.h>
#include <sys/pattr.h>
#include <sys/sysmacros.h>
#include <sys/strsun.h>
#include <sys/ksynch.h>
#include <sys/kstat.h>
#include <sys/strsubr.h>
#include <sys/ksynch.h>
#include <sys/ethernet.h>

#define	FCOE_FRAME_VERSION	0x01 /* TBD */
/*
 * This gives a template for the frame format
 */

typedef struct __fcoe_pdu_hdr__ {
	uint8_t version;
	uint8_t reserved[12];
	uint8_t sof;
} fcoe_pdu_hdr_t;

typedef struct __bnxef_fcoe_frame__ {
	struct ether_header ether;
	struct ether_vlan_extinfo vlan;
	fcoe_pdu_hdr_t pdu;
	uint8_t desc[1];
} bnxef_fcoe_frame_t;

typedef struct __bnxef_fcoe_novlan_frame__ {
	struct ether_header ether;
	fcoe_pdu_hdr_t pdu;
	uint8_t desc[1];
} bnxef_fcoe_novlan_frame_t;

typedef struct __fcoe_trailer__ {
	uint8_t eof;
	uint8_t reserved[3];
} fcoe_trailer_t;

#define	SOFi3 		0x2E
#define	SOFn3		0x36
#define	SOFf		0x28
#define	SOFi2		0x2D
#define	SOFn2		0x35

#define	EOFn		0x41
#define	EOFt		0x42
#define	EOFni		0x49
#define	EOFa		0x50

#endif
