
/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident "$File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>

/* REC Request Payload definition */
typedef struct la_els_rec {
	uint8_t ls_code;
	uint8_t	mbz[3];
	uint32_t  s_id; 	/* Exchange originator s_id */
	uint16_t  ox_id; 	/* Exchange ID assigned by Originator */
	uint16_t  rx_id; 	/* Excchange ID assigned by Responder */
} la_els_rec_t;

/* REC Reply Payload definition */
typedef struct la_els_rec_reply {
	uint8_t		ls_code;
	uint8_t		mbz[3];
	uint16_t	ox_id; 	/* Exchange Id Assigned by originator */
	uint16_t	rx_id; 	/* Exchange Id Assigned by responded */
	uint32_t	org_addr_id; /* Originator Address identifier */
	uint32_t	resp_addr_id; /* Responder address identifier */
	uint32_t	fc4value; 	/* FC-4 value */
	uint32_t	estat;    	/* Exchange Status block */
} la_els_rec_reply_t;



/* FCP LS SRR payload defintion */
typedef  struct la_fcpls_srr {
	uint8_t	 ls_code;
	uint8_t	 mbz[3];
	uint16_t  ox_id; 	/* Exchange ID assigned by the originator */
	uint16_t  rx_id;	/* Exchange ID assined by the responder */
	uint32_t  reloff;	/* Relative Offset for Retransmission */
	uint8_t	rctl;		/* Whether Data or XFER RDY is requested */
	uint8_t	reserv[3];	/* Reserved - set to zero */
} la_fcpls_srr_t;


/* FCP LS SRR Reply payload definition */
typedef struct la_fcpls_srr_reply {
	uint8_t		ls_code;
	uint8_t		mbz[3];
	uint8_t		action;
	uint8_t		reason;
	uint8_t		expln;
	uint8_t		vu;
} la_fcpls_srr_reply_t;

/* The following are ESTAT bit definitions */
#define	EXCH_COMPLETE   0x20000000
#define	SEQUENCE_INITIATIVE_HELD_BY_TARGET  0x40000000
