/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#if !(defined(__S11) || defined(__S12))
#include <sys/fibre-channel/ulp/fcp.h>
#endif

#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>

#include <dev_info.h>
#define	PATH_MAX NVM_PATH_MAX
#include <mac_drv_info.h>

void bnxef_abts_timeout(void *arg);
void bnxef_abts_timeout_handler(void *arg);
void bnxef_cleanup_port(bnxef_port_t *portp);
extern int bnxef_cleanup_task(bnxef_session_t *sessionp,
		bnxef_fcoe_task_t *taskp);
void bnxef_pkt_cmd_res_free(fc_packet_t *pktp, int stage);
void bnxef_pkt_resp_res_free(fc_packet_t *pktp,  int stage);
void bnxef_timeout_handler(void *arg);
void bnxef_trigger_fp_attach_handler(void *arg);
void bnxef_fip_ka(void *arg);
void bnxef_fip_disc_adv_enforce(void *arg);
void bnxef_shutdown_port(bnxef_port_t *portp);
void bnxef_rrq_timeout_handler(void *arg);
void bnxef_stats_update(void *);


extern boolean_t bnxef_send_frame(bnxef_driver_state_t  *dsp, mblk_t *mp,
		uint16_t vlan_id);
extern void bnxef_big_endian(void *bufp, int size);
extern ddi_device_acc_attr_t bnxef_dev_acc_attr;
extern bnxef_fcoe_task_t *bnxef_task_alloc(bnxef_driver_state_t *dsp,
	int sleepflag);
extern void bnxef_init_mp_task(bnxef_session_t *sessionp, fc_packet_t *pktp);
extern void bnxef_add_2_sq(bnxef_session_t *sessionp, uint16_t xid);
extern void bnxef_ring_doorbell(bnxef_session_t *sessionp);
extern mblk_t  *bnxef_prepare_fcoe_mblk_from_pkt(bnxef_driver_state_t *dsp,
			bnxef_port_t *portp, fc_packet_t *pktp);
extern void bnxef_task_free(void *arg, bnxef_fcoe_task_t *taskp);
extern void bnxef_complete_pkt(fc_packet_t *pktp, uint8_t state,
		uint8_t action, uint32_t reason, uint32_t expln);
extern void bnxef_implicit_fabric_logout(void *arg);
extern bnxef_session_t *bnxef_get_first_session(bnxef_port_t *portp,
	int bucket);
extern int bnxef_session_cleanup(bnxef_session_t *sessionp);
extern ddi_dma_attr_t bnxef_cmdrsp_dma_attr;
extern int bnxef_fip_sm_send_fka(bnxef_driver_state_t *dsp,
		bnxef_lport_t *portp);
extern void bnxef_session_cq_handler(bnxef_session_t *sessionp);
extern bnxef_session_t *bnxef_get_next_session(bnxef_port_t *portp,
		int bucket, bnxef_session_t *sessionp);
extern int
bnxef_session_disable_taskclean_enable(bnxef_session_t *sessionp);

extern void bnxef_fc_port_offline(void *arg);
extern void bnxef_fc_port_online(void *arg);
extern boolean_t bnxef_bringup_all_ports(bnxef_driver_state_t *dsp);
extern void bnxef_pkt_callback(void *arg);
extern int bnxef_task_bd_table_free(fc_packet_t *pktp, uint32_t stage);
extern int bnxef_send_stats_req(bnxef_driver_state_t *dsp);
extern bnxef_fcoe_task_t *bnxef_rrq_task_alloc(bnxef_driver_state_t *dsp, int
sleep);




// #define TEST
// #define TEST_ADV


/*
 * This is the actual timeout handler which will dispatch a task queue to send
 * the actual FIP frame out on the wire. The conversion to task context is
 * done to allow sleeping while allocating mblk and other structures.
 */
void
bnxef_timeout_fip_ka(void *arg)
{
	ka_arg_t *kaargp = (ka_arg_t *)arg;
	bnxef_port_t *portp = (bnxef_port_t *)kaargp->portp;
	bnxef_driver_state_t *dsp = portp->statep;
	int ret;

	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	if (kaargp->flags & VN_PORT_FLAG) {
		mutex_enter(&portp->port_mutex);
		portp->fip_state &= ~FIP_KEEP_ALIVE_TIMER2_ARMED;
		mutex_exit(&portp->port_mutex);
	} else {
		mutex_enter(&portp->port_mutex);
		portp->fip_state &= ~FIP_KEEP_ALIVE_ARMED;
		mutex_exit(&portp->port_mutex);
	}

	mutex_enter(&portp->port_mutex);
	if ((portp->fip_state & FIP_LOGO_SENT) ||
			(portp->fip_state & FIP_LOGO_LS_ACC_RECEIVED)) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	mutex_exit(&portp->port_mutex);

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_fip_ka, (void *)arg,
					DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d:Unable to schedule tq\n", BNXEF_DRIVER_NAME,
				dsp->instance);
		return;
	}

}



/*
 * This is called in task context, it will send out the keep alive frames
 * with appropriate descriptors on the wire.
 */
void
bnxef_fip_ka(void *arg)
{
	ka_arg_t	*kaargp = arg;
		bnxef_port_t *portp = (bnxef_port_t *)kaargp->portp;
		bnxef_driver_state_t *dsp = portp->statep;
		int ret;
		timeout_id_t tid;
	bnxef_port_t vnport;

#ifdef TEST
	if (portp->flags & BNXEF_FC_PORT_N_PORT) {
		if ((kaargp->flags & VN_PORT_FLAG) == 0)  {
		if ((portp->count >= 2) && (portp->count <= 4)) {
			portp->count++;
			BNXEF_DEBUG(dsp, ERROR,  -1, "%s%d: Dropping FIPKA",
				BNXEF_DRIVER_NAME, dsp->instance);
			portp->kaarg1.portp = portp;
			portp->kaarg1.flags = 0;
			/* Re arm the keep alive appropriately to resend KA */
			tid = timeout(bnxef_timeout_fip_ka, &portp->kaarg1,
				BNXEF_SEC2TICK(portp->vn_period));
			mutex_enter(&portp->port_mutex);
			portp->keep_alive_tmr_hdl = tid;
			portp->fip_state |= FIP_KEEP_ALIVE_ARMED;
			mutex_exit(&portp->port_mutex);
			if (portp->count == 4) portp->count = 0;
			BNXEF_DEBUG(dsp, FIP, -1,
				"%s%d: Rearming the keep alive timer- Done",
				BNXEF_DRIVER_NAME, dsp->instance);
			return;
		}
		portp->count++;
		}
	}
#endif

#ifdef TEST_ADV
	if ((portp->flags & BNXEF_FC_PORT_N_PORT) && (dsp->instance == 3)) {
		if (portp->count ==  4) {
			portp->count = 0;
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Assumed Disc ADV Dropped",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_fip_disc_adv_enforce(dsp);
		}
		portp->count++;
	}
#endif

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
		return;
	}

	if ((dsp->physical_port_state & BNXEF_PHYPORT_ONLINE) == 0) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	if (dsp->fcf_ident == NULL) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	mutex_enter(&portp->port_mutex);
	if (portp->fip_state & FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	if (portp->flags & BNXEF_FC_PORT_LOGO_TO_FABRIC_CTLR) {
		mutex_exit(&portp->port_mutex);
		return;
	}

	if (portp->fip_state & FIP_LOGO_SENT) {
		mutex_exit(&portp->port_mutex);
		return;
	}

	if (portp->flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	mutex_exit(&portp->port_mutex);


	BNXEF_DEBUG(dsp, FIP, -1,
		"%s%d: Sending Keep Alive for port 0%x",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id);

	if (kaargp->flags & VN_PORT_FLAG) {
		bcopy(portp, &vnport, sizeof (bnxef_port_t));
		vnport.flags &= ~BNXEF_FC_PORT_N_PORT;
		vnport.flags |= (BNXEF_FC_PORT_VN_PORT | BNXEF_FC_PORT_CLONE);
		ret = bnxef_fip_sm_send_fka(dsp, &vnport);
		if (ret == BNXEF_FAILURE) {
			return;
		}
		ASSERT(ret == BNXEF_SUCCESS);
		portp->kaarg2.portp = portp;
		portp->kaarg2.flags = VN_PORT_FLAG;
		tid = timeout(bnxef_timeout_fip_ka, &portp->kaarg2,
			BNXEF_SEC2TICK(FKA_VN_PERIOD));
		mutex_enter(&portp->port_mutex);
		portp->keep_alive_tmr2_hdl = tid;
		portp->fip_state |= FIP_KEEP_ALIVE_TIMER2_ARMED;
		mutex_exit(&portp->port_mutex);
	} else {
		ret = bnxef_fip_sm_send_fka(dsp, portp);
		if (ret == BNXEF_FAILURE) {
				return;
		}
		ASSERT(ret == BNXEF_SUCCESS);

		portp->kaarg1.portp = portp;
		portp->kaarg1.flags = 0;

		if (portp->flags & BNXEF_FC_PORT_N_PORT) {
			tid = timeout(bnxef_timeout_fip_ka, &portp->kaarg1,
			BNXEF_SEC2TICK(dsp->fcf_ident->fka_adv_period/1000));
		} else {
			/* Re arm the keep alive appropriately to resend KA */
			tid = timeout(bnxef_timeout_fip_ka, &portp->kaarg1,
					BNXEF_SEC2TICK(portp->vn_period));
		}
		mutex_enter(&portp->port_mutex);
		portp->keep_alive_tmr_hdl = tid;
		portp->fip_state |= FIP_KEEP_ALIVE_ARMED;
		mutex_exit(&portp->port_mutex);
		BNXEF_DEBUG(dsp, FIP, -1,
			"%s%d: Rearming the keep alive timer- Done",
			BNXEF_DRIVER_NAME, dsp->instance);
		}


}


void
bnxef_stats_update_handler(void *arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	timeout_id_t tid;
	uint32_t	 state;

	ASSERT(dsp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	state = dsp->state;
	dsp->state &= ~BNXEF_STAT_PULL_TIMEOUT_VALID;
	mutex_exit(&dsp->state_mutex);

	if ((state & BNXEF_DETACH_IN_PROGRESS) == 0)  {
		mutex_enter(&dsp->global_offload_mutex);
		mutex_enter(&dsp->state_mutex);
		bnxef_send_stats_req(dsp);
		cv_wait(&dsp->stats_cv, &dsp->state_mutex);
		mutex_exit(&dsp->state_mutex);
		mutex_exit(&dsp->global_offload_mutex);

		tid = timeout(bnxef_stats_update, (void *)dsp,
				BNXEF_SEC2TICK(1));

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state |= BNXEF_STAT_PULL_TIMEOUT_VALID;
		dsp->stats_pull_timeout = tid;
		mutex_exit(&dsp->state_mutex);
	}
}

void
bnxef_stats_update(void *arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	int ret;
	uint32_t state;
	timeout_id_t tid;

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	state = dsp->state;
	dsp->state &= ~BNXEF_STAT_PULL_TIMEOUT_VALID;
	mutex_exit(&dsp->state_mutex);

	ret = ddi_taskq_dispatch(dsp->tq,
		bnxef_stats_update_handler, (void *)dsp,  DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to schedule the stats Update handler\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		if ((state & BNXEF_DETACH_IN_PROGRESS) == 0)  {
			tid = timeout(bnxef_stats_update, (void *)dsp,
					BNXEF_SEC2TICK(1));

			MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
			dsp->state |= BNXEF_STAT_PULL_TIMEOUT_VALID;
			dsp->stats_pull_timeout = tid;
			mutex_exit(&dsp->state_mutex);
		}
		return;
	}
}




void
bnxef_stats_mcp_report(void *arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	dev_info_t *pdip;
	struct fcoe_stats_info fcoe_stats;
	timeout_id_t tid;
	uint32_t	 state;
	uint64_t	 val;
	uint64_t	 tmp;
	bnxef_fw_stats_t *statsp;

	ASSERT(dsp != NULL);

	if (!dsp->fwstats) {
		tid = timeout(bnxef_stats_mcp_report, (void *)dsp,
				BNXEF_SEC2TICK(15));
		return;
	}

	statsp = (bnxef_fw_stats_t *)dsp->fwstats->ks_data;
	pdip = ddi_get_parent(dsp->dip);

	memset(&fcoe_stats, 0, sizeof (fcoe_stats));

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	state = dsp->state;
	dsp->state &= ~BNXEF_STAT_REPORT_TIMEOUT_VALID;
	mutex_exit(&dsp->state_mutex);

	if ((state & BNXEF_DETACH_IN_PROGRESS) == 0)  {
		mutex_enter(&dsp->global_offload_mutex);
		mutex_enter(&dsp->state_mutex);

		memcpy(&fcoe_stats.version, BNXEF_FCOE_VERSION, 12);
		memcpy(&fcoe_stats.mac_local, dsp->mac_add, 6);

		/* Locally Admin Addr.   */
		// u8 mac_local[8];
		/* Additional Programmed MAC Addr 1. */
		// u8 mac_add1[8];
		/* Additional Programmed MAC Addr 2. */
		// u8 mac_add2[8];
		/* QoS Priority (per 802.1p). 0-7255 */
		// u32 qos_priority;
		/* FCoE TX Descriptors Queue Size. */
		// u32 txq_size;
		/* FCoE RX Descriptors Queue Size. */
		// u32 rxq_size;
		/* FCoE TX Descriptor Queue Avg Depth. */
		// u32 txq_avg_depth;
		/* FCoE RX Descriptors Queue Avg Depth. */
		// u32 rxq_avg_depth;

		/* copied for macro exp */
		val = statsp->fcoe_rx_pkt_cnt.value.ui64;
		tmp = LE_64(val);
		fcoe_stats.rx_frames_lo = *((uint32_t *)(&tmp));
		fcoe_stats.rx_frames_hi = *(((uint32_t *)(&tmp)) + 1);

		/* copied for macro exp */
		val = statsp->fcoe_rx_byte_cnt.value.ui64;
		tmp = LE_64(val);
		fcoe_stats.rx_bytes_lo = *((uint32_t *)(&tmp));
		fcoe_stats.rx_bytes_hi = *(((uint32_t *)(&tmp)) + 1);

		/* copied for macro exp */
		val = statsp->fcoe_tx_pkt_cnt.value.ui64;
		tmp = LE_64(val);
		fcoe_stats.tx_frames_lo = *((uint32_t *)(&tmp));
		fcoe_stats.tx_frames_hi = *(((uint32_t *)(&tmp)) + 1);

		/* copied for macro exp */
		val = statsp->fcoe_tx_byte_cnt.value.ui64;
		tmp = LE_64(val);
		fcoe_stats.tx_bytes_lo = *((uint32_t *)(&tmp));
		fcoe_stats.tx_bytes_hi = *(((uint32_t *)(&tmp)) + 1);

		/* number of receive packets with FCS errors */
		// u32 rx_fcs_errors;

		val = statsp->fc_crc_cnt.value.ui64; /* copied for macro exp */
		tmp = LE_64(val);
		fcoe_stats.rx_fc_crc_errors = *((uint32_t *)(&tmp));
		fcoe_stats.rx_fc_crc_errors = *(((uint32_t *)(&tmp)) + 1);

		/* number of FCoE/FIP Login failures */
		// u32 fip_login_failures;

		if (!dsp->callbacks.prvCtl(pdip, PRV_CTL_REPORT_FCOE_STATS,
					&fcoe_stats, sizeof (fcoe_stats))) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Failed to report stats to MCP\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		}

		mutex_exit(&dsp->state_mutex);
		mutex_exit(&dsp->global_offload_mutex);

		tid = timeout(bnxef_stats_mcp_report, (void *)dsp,
				BNXEF_SEC2TICK(15));

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state |= BNXEF_STAT_REPORT_TIMEOUT_VALID;
		dsp->stats_report_timeout = tid;
		mutex_exit(&dsp->state_mutex);
	}
}


void
bnxef_rrq_timeout(void *arg)
{
	bnxef_tq_params_t *tqp = arg;
	bnxef_fcoe_task_t *rrqtaskp, *otaskp;
	fc_packet_t	*opktp, *pktp;
	bnxef_driver_state_t *dsp;
	uint32_t	flags;
	bnxef_session_t *sessionp;
	int ret;

	ASSERT(tqp != NULL);

	rrqtaskp = tqp->taskp;
	sessionp = (bnxef_session_t *)tqp->sessp;
	ASSERT(rrqtaskp != NULL);
	pktp = rrqtaskp->pktp;
	dsp = tqp->dsp;
	ASSERT(dsp != NULL);

	mutex_enter(&rrqtaskp->task_mutex);
	if (rrqtaskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED)
		rrqtaskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
	flags = rrqtaskp->task_flags;
	mutex_exit(&rrqtaskp->task_mutex);

	ASSERT(flags & BNXEF_FCOE_TASK_RRQ);

#if 0
	if (flags & BNXEF_FCOE_SEC_X_ID_VALID) {
		uint32_t	task_flags;

		otaskp = dsp->taskarray[rrqtaskp->secondary_x_id];
		opktp = otaskp->pktp;
		mutex_enter(&otaskp->task_mutex);
		task_flags = otaskp->task_flags;
		otaskp->sec_flags |= BNXEF_RRQ_TIMEDOUT;
		mutex_exit(&otaskp->task_mutex);
		if (task_flags &  BNXEF_FCOE_TASK_ALLOCATED) {
			bnxef_task_session_list_remove(otaskp->sessionp,
					otaskp);
			if (task_flags & BNXEF_FCOE_TASK_TIMEDOUT)
				bnxef_complete_pkt(opktp, FC_PKT_TRAN_ERROR, 0,
					FC_REASON_ABORTED, 0);
			else
				bnxef_complete_pkt(opktp, FC_PKT_LOCAL_RJT,
					0, FC_REASON_ABORTED, 0);
		}
	}
#endif
	// cmn_err(CE_NOTE, "RRQ TIMEOUT 0X%x",
	//	rrqtaskp->x_id);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_RRQ_TIMEOUT,
		rrqtaskp->secondary_x_id, rrqtaskp->x_id, 0,
		sessionp, 0, 0, 0);
	if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
		ret = bnxef_cleanup_task(sessionp, rrqtaskp);
		ASSERT(ret == BNXEF_SUCCESS);
	} else {
		if (flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			uint32_t	task_flags;

			otaskp = dsp->taskarray[rrqtaskp->secondary_x_id];
			opktp = otaskp->pktp;
			mutex_enter(&otaskp->task_mutex);
			task_flags = otaskp->task_flags;
			otaskp->sec_flags |= BNXEF_RRQ_TIMEDOUT;
			mutex_exit(&otaskp->task_mutex);
			if (task_flags &  BNXEF_FCOE_TASK_ALLOCATED) {
				bnxef_task_session_list_remove(otaskp->sessionp,
					otaskp);
				bnxef_complete_pkt(opktp, FC_PKT_TIMEOUT,
						0, FC_REASON_ABORTED, 0);
			}
		}
		bnxef_task_session_list_remove(sessionp, rrqtaskp);
		/* Free all DMA resources allocated for RRQ */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		kmem_free(pktp, sizeof (fc_packet_t));
		bnxef_task_free(dsp, rrqtaskp);
		rrqtaskp->tq_params.reserved2 = 4;
	}
}


void
bnxef_rrq_timeout_handler(void *arg)
{
	bnxef_tq_params_t *tqp = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t *dsp;
	int ret;

	dsp = tqp->dsp;
	ASSERT(dsp != NULL);

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_rrq_timeout,
		arg, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to scheduule rrq_timeout routine",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}


/*
 * The task represents the errored task which requires abort sequence to be
 * sent. The session represent the session on which the abort need to be sent.
 */
int
bnxef_initiate_abts(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t		*portp;
	bnxef_port_t		*rportp;
	fc_packet_t		*pktp;
	fc_packet_t		*opktp;
	timeout_id_t		tid;
	bnxef_tq_params_t	*tqp;
	mblk_t			*mp;
	bnxef_fcoe_task_t	*abtstaskp;
	dev_info_t		*pdip;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	rportp = sessionp->rport;

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Initiating ABTS for task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	/* original packet */
	opktp = taskp->pktp;

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_ELS) {
		if (taskp->orig_payloadp != NULL)
			bcopy(taskp->orig_payloadp, opktp->pkt_cmd,
				opktp->pkt_cmdlen);
	}
	mutex_exit(&taskp->task_mutex);

	/*
	 * Check if the session is offloaded and it is enabled to continue
	 * ABTS sending. Else Just return, as it should be in Session cleanup
	 */
	mutex_enter(&sessionp->session_mutex);
	if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
		if ((sessionp->state & BNXEF_SESSION_ENABLED) == 0) {
			mutex_exit(&sessionp->session_mutex);
			return (BNXEF_SUCCESS);
		}
	}
	mutex_exit(&sessionp->session_mutex);
	/*
	 * This just a packet allocated to create the cmd hdr so that
	 * other routines can be used as is.
	 */
	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
#if 0
	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		(taskp->x_id %32) *sizeof (struct fcoe_task_ctx_entry),
		sizeof (struct fcoe_task_ctx_entry),
		DDI_DMA_SYNC_FORCPU);
	ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
		0, BNXEF_PAGE_SIZE, DDI_DMA_SYNC_FORCPU);
	ASSERT(ret == DDI_SUCCESS);
#endif
#if 0
	/* Workaround */
	(void) ddi_get32(sessionp->doorbell_acc, sessionp->doorbell_reg);
#endif
	pktp->pkt_cmd_fhdr.d_id = rportp->id;
	pktp->pkt_cmd_fhdr.s_id = portp->id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_BASIC_LS;
	pktp->pkt_cmd_fhdr.ox_id =  taskp->x_id;
	if ((taskp->task_flags & BNXEF_FCOE_TASK_ELS) ||
		(taskp->task_flags & BNXEF_FCOE_TASK_RRQ))
		pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	else
		pktp->pkt_cmd_fhdr.rx_id =
			LE16_TO_CPU(taskp->fwtaskp->rxwr_txrd.var_ctx.rx_id);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Rx Id received from firmware 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
			taskp->fwtaskp->rxwr_txrd.var_ctx.rx_id);
	// if (taskp->fwtaskp->rxwr_txrd.var_ctx.rx_id == 0)
	//	 debug_enter("Rx Id Bad");
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_LS_ABTS;
	pktp->pkt_cmd_fhdr.ro	=  0; /* abort the exchange */
	pktp->pkt_cmd_fhdr.f_ctl = F_CTL_FIRST_SEQ | F_CTL_END_SEQ |
				F_CTL_SEQ_INITIATIVE;
	pktp->pkt_timeout	 = 2 * BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = 0; /* No Payload for ABTS */


	abtstaskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(abtstaskp != NULL);

	abtstaskp->pktp = pktp;
	pktp->pkt_fca_private = abtstaskp;
	abtstaskp->task_flags |= BNXEF_FCOE_TASK_ABTS;
	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_SEC_X_ID_VALID;
	taskp->secondary_x_id = abtstaskp->x_id;
	taskp->sec_flags = BNXEF_ABTS_INITIATED;
	mutex_exit(&taskp->task_mutex);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: ABTS Task Id Received 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
			abtstaskp->x_id);
	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_ABTS_INITIATED,
		taskp->x_id, taskp->secondary_x_id, 0, sessionp,
		0, 0, 0);

	/* ARM the timer to catch run away condition */
	tqp = &abtstaskp->tq_params;
	tqp->dsp = dsp;
	tqp->taskp = taskp; /* The original task */
	tqp->sessp = sessionp;
	tqp->mp  = NULL;
	tqp->type = BNXEF_ABTS_TIMEOUT_TYPE;

	tid = timeout(bnxef_abts_timeout_handler, (void *)tqp,
		BNXEF_SEC2TICK(pktp->pkt_timeout));

	if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Initializing the Task Structure",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_enter(&abtstaskp->task_mutex);
		abtstaskp->timerhdl = tid;
		abtstaskp->task_flags |= (BNXEF_FCOE_TASK_TIMER_ARMED |
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
		mutex_exit(&abtstaskp->task_mutex);

		/* Init mp task */
		bnxef_init_mp_task(sessionp, pktp);

		/* Update the SQ to start this */
		bnxef_add_2_sq(sessionp, abtstaskp->x_id);


		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Ringing the door bell register",
			BNXEF_DRIVER_NAME, dsp->instance);
#if 0
		ddi_dma_sync(sessionp->conn_db_dma_handle,
			0, sessionp->conn_db_length,
			DDI_DMA_SYNC_FORCPU);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: ARM Bit value as read 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
				((struct fcoe_conn_db *)
				(sessionp->conn_db_addr))->cq_arm.lo);
		if (((struct fcoe_conn_db *)
				(sessionp->conn_db_addr))->cq_arm.lo == 0) {
			((struct fcoe_conn_db *)
				(sessionp->conn_db_addr))->cq_arm.lo = -1;
			ddi_dma_sync(sessionp->conn_db_dma_handle,
				0, sessionp->conn_db_length,
				DDI_DMA_SYNC_FORDEV);
		}
#endif
		/* Now ring the door bell register appropriately */
		bnxef_ring_doorbell(sessionp);
	} else {
		abtstaskp->frame_hdrp =
			kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
		ASSERT(abtstaskp->frame_hdrp != NULL);
		mutex_enter(&abtstaskp->task_mutex);
		abtstaskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;
		mutex_exit(&abtstaskp->task_mutex);
		bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, abtstaskp->frame_hdrp,
			sizeof (fc_frame_hdr_t));
		bnxef_big_endian(abtstaskp->frame_hdrp,
			sizeof (fc_frame_hdr_t));


		/* We have to transmit ABTS using L2 method. */
		mp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
		if (mp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to create ABTS packet\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Free the task allocated for ABTS */
			bnxef_task_free(dsp, abtstaskp);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			/* Un timeout the timer enabled */
			untimeout(tid);
			/* Complete Original Packet Indicating abort failed */
			bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return (BNXEF_FAILURE);
		}

		/* Transmit the Mblk prepared */
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to transmit ABTS frame\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Free the task allocated for ABTS */
			bnxef_task_free(dsp, abtstaskp);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			/* Complete Original Packet Indicating abort failed */
			bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return (BNXEF_FAILURE);
		}

		mutex_enter(&abtstaskp->task_mutex);
		abtstaskp->timerhdl = tid;
		abtstaskp->task_flags |= (BNXEF_FCOE_TASK_TIMER_ARMED |
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
		mutex_exit(&abtstaskp->task_mutex);
	}
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Completed Sending the ABTS",
			BNXEF_DRIVER_NAME, dsp->instance);

	return (BNXEF_SUCCESS);

}

int
bnxef_initiate_ba_rjt(bnxef_session_t *sessionp, uint16_t ox_id, uint16_t rx_id,
	la_ba_rjt_t *payloadp)
{
	bnxef_port_t	*portp;
	bnxef_driver_state_t *dsp;
	bnxef_port_t	*rportp;
	fc_packet_t	*pktp;
	dev_info_t		*pdip;
	mblk_t		*mp;
	bnxef_fcoe_task_t *taskp;

	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	rportp = sessionp->rport;

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Initiating BA RJT for OX_id 0x%x, RX_id",
		BNXEF_DRIVER_NAME, dsp->instance, ox_id, rx_id);
	/*
	 * This just a packet allocated to create the cmd hdr so that
	 * other routines can be used as is.
	 */
	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = rportp->id;
	pktp->pkt_cmd_fhdr.s_id = portp->id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_BASIC_LS;
	pktp->pkt_cmd_fhdr.ox_id = ox_id;
	pktp->pkt_cmd_fhdr.rx_id = rx_id;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_LS_BA_RJT;
	pktp->pkt_cmd_fhdr.ro	=  0; /* abort the exchange */
	pktp->pkt_cmd_fhdr.f_ctl =  F_CTL_END_SEQ |
				F_CTL_SEQ_INITIATIVE;
	pktp->pkt_timeout	 = 2 * BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = sizeof (la_ba_rjt_t); /* No Payload for ABTS */
	pktp->pkt_cmd = (char *)payloadp;
	pktp->pkt_fca_private = (void *) bnxef_task_alloc(dsp, KM_SLEEP);
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	taskp->payloadsz = sizeof (la_ba_rjt_t);
	taskp->frame_hdrp = (uint8_t *)&pktp->pkt_cmd_fhdr;
	taskp->payloadp = (uint8_t *)payloadp;

	if (sessionp->state & BNXEF_SESSION_OFFLOADED)  {
		/* for now Not implemented */
		ASSERT(0);
	} else {
		/* We have to transmit ABTS using L2 method. */
		mp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
		if (mp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to create BA_RJT packet\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_task_free(dsp, pktp->pkt_fca_private);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			return (BNXEF_FAILURE);
		}

		/* Transmit the Mblk prepared */
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to transmit ABTS frame\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_task_free(dsp, pktp->pkt_fca_private);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			return (BNXEF_FAILURE);
		}
		bnxef_task_free(dsp, pktp->pkt_fca_private);
	}

	kmem_free(pktp, sizeof (fc_packet_t));
	return (BNXEF_SUCCESS);
}


int
bnxef_initiate_ba_acc(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp,
	uint16_t ox_id)
{

	la_ba_acc_t  baaccp;
	bnxef_port_t *portp, *rportp;
	bnxef_driver_state_t *dsp;
	dev_info_t	*pdip;
	int		ret;
	mblk_t		*mp;
	uint16_t  rx_id;
	fc_packet_t	*pktp;

	ASSERT(sessionp != NULL);
	ASSERT(taskp != NULL);
	portp = sessionp->lport;
	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	rportp = sessionp->rport;

	pdip = ddi_get_parent(dsp->dip);
	ASSERT(pdip != NULL);

	/*
	 * This just a packet allocated to create the cmd hdr so that
	 * other routines can be used as is.
	 */
	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	if (sessionp->state & BNXEF_SESSION_OFFLOADED)  {
		ret = ddi_dma_sync(dsp->task_dma_handle[taskp->dma_handle_idx],
			(taskp->x_id %32) *sizeof (struct fcoe_task_ctx_entry),
			sizeof (struct fcoe_task_ctx_entry),
			DDI_DMA_SYNC_FORCPU);
		ASSERT(ret == DDI_SUCCESS);
		ox_id = ox_id;
		rx_id = taskp->x_id;
	} else {
		rx_id = taskp->x_id;
		ox_id =  ox_id;
	}

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Initiating BA ACC for task id 0x%x, RX_id",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id, rx_id);

	pktp->pkt_cmd_fhdr.d_id = rportp->id;
	pktp->pkt_cmd_fhdr.s_id = portp->id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_BASIC_LS;
	pktp->pkt_cmd_fhdr.ox_id =  ox_id;
	pktp->pkt_cmd_fhdr.rx_id = rx_id;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_LS_BA_ACC;
	pktp->pkt_cmd_fhdr.ro	=  0; /* abort the exchange */
	pktp->pkt_cmd_fhdr.f_ctl = F_CTL_END_SEQ | F_CTL_SEQ_INITIATIVE;
	pktp->pkt_timeout	 = 2 * BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = sizeof (la_ba_acc_t);
	pktp->pkt_cmd = (char *)&baaccp;

	if (sessionp->state & BNXEF_SESSION_OFFLOADED)  {
		/* for now Not implemented */
		ASSERT(0);
	} else {
		/* We have to transmit ABTS using L2 method. */
		mp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
		if (mp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to create BA_RJT packet\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			return (BNXEF_FAILURE);
		}

		/* Transmit the Mblk prepared */
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to transmit ABTS frame\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			return (BNXEF_FAILURE);
		}
	}

	kmem_free(pktp, sizeof (fc_packet_t));
	return (BNXEF_SUCCESS);
}

void
bnxef_abts_timeout_handler(void *arg)
{
	bnxef_tq_params_t *tqp;
	bnxef_driver_state_t *dsp;
	int ret;

	tqp = (bnxef_tq_params_t *)arg;
	dsp = tqp->dsp;

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_abts_timeout,
		arg, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to scheduule abts_timeout routine",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}

/*
 * If ABTS timeout without completion. Then this will recover and indicate the
 * appropriate error code for the original packet which underwent the recovery.
 */
void
bnxef_abts_timeout(void *arg)
{
	bnxef_tq_params_t	  *tqp;
	bnxef_fcoe_task_t	 *taskp;
	fc_packet_t			*pktp;
	bnxef_session_t		*sessionp;
	bnxef_driver_state_t	 *dsp;
	uint32_t		flags;
	uint16_t		secondary_x_id;
	timeout_id_t		tid;
	bnxef_fcoe_task_t	*sectaskp;
	bnxef_port_t		*portp;
	int	ret;

	tqp = (bnxef_tq_params_t *)arg;

	ASSERT(tqp != NULL);

	dsp = tqp->dsp;
	taskp = tqp->taskp;
	sessionp = tqp->sessp;

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d:Abts timeout for Task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	ASSERT(sessionp != NULL);
	portp = (bnxef_port_t *)sessionp->lport;
	if (portp == NULL) {
		/* Nothing to do */
		return;
	}
	ASSERT(portp != NULL);

	mutex_enter(&portp->port_mutex);
	if (portp->fip_state & FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	mutex_exit(&portp->port_mutex);

#if 0
	mutex_enter(&sessionp->session_mutex);
	if (sessionp->state & BNXEF_TM_CLEANUP_IN_PROGRESS) {
		mutex_exit(&sessionp->session_mutex);
		return;
	}

	mutex_exit(&sessionp->session_mutex);
#endif


	mutex_enter(&taskp->task_mutex);
	/*
	 * if there is recovery started before completion came.
	 * Then subsequently completion happened, But even if we do
	 * cleanup task,  firmware will not give cleanup completion, therefore
	 * ignore such ABTS timeouts. This i have seen it happen when
	 * task management(Target Reset) is issued and the target
	 * takes long to cleanup and the ABTS generated for such task
	 * management is also cleaned up.
	 */
	if ((taskp->task_flags & BNXEF_FCOE_TASK_ALLOCATED) == 0) {
		mutex_exit(&taskp->task_mutex);
		return;
	}

	pktp = taskp->pktp;
	flags = taskp->task_flags;
	secondary_x_id = taskp->secondary_x_id;
	taskp->sec_flags |= BNXEF_ABTS_TIMEDOUT;
	mutex_exit(&taskp->task_mutex);
	ASSERT(pktp != NULL);
	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_ABTS_TIMEOUT,
		taskp->x_id, taskp->secondary_x_id, 0,
		sessionp, 0, 0, 0);

	if (flags & BNXEF_FCOE_SEC_X_ID_VALID) {
		sectaskp = dsp->taskarray[secondary_x_id];
		mutex_enter(&sectaskp->task_mutex);
		tid = sectaskp->timerhdl;
		mutex_exit(&sectaskp->task_mutex);
		if (sectaskp->task_flags &  BNXEF_FCOE_TASK_TIMER_ARMED) {
			untimeout(tid);
			mutex_enter(&sectaskp->task_mutex);
			sectaskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
			sectaskp->task_flags |= BNXEF_FCOE_TASK_COMPLETED;
			mutex_exit(&sectaskp->task_mutex);
		}
		kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
		/* Now free the secondary ID */
		bnxef_task_free((void *)dsp, sectaskp);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
		mutex_exit(&taskp->task_mutex);
	}

	mutex_enter(&taskp->task_mutex);
	taskp->state = FC_PKT_TRAN_ERROR;
	taskp->action = 0;
	taskp->reason = FC_REASON_ABORT_FAILED;
	taskp->expln = 0;
	mutex_exit(&taskp->task_mutex);
	if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
		mutex_enter(&taskp->task_mutex);
		if (taskp->task_flags & BNXEF_FCOE_TASK_ELS) {
			ASSERT(taskp->task_flags & BNXEF_FCOE_TASK_OFFLOADED);
		}
		mutex_exit(&taskp->task_mutex);
		/*
		 * If the session on which this task timedout happen
		 * to be Offloaded CLean up the task from firmware.
		 */
		ret = bnxef_cleanup_task(sessionp, taskp);
		ASSERT(ret == BNXEF_SUCCESS);
	} else {
		bnxef_task_session_list_remove(sessionp, taskp);

		mutex_enter(&taskp->task_mutex);
		cv_signal(&taskp->task_cv);
		mutex_exit(&taskp->task_mutex);

		bnxef_complete_pkt(pktp, taskp->state, taskp->action,
			taskp->reason, taskp->expln);
	}
}


/*
 * If this  routine is called that means the frequent discovery advertizement
 * has not come from FCF. Therefore, we have to take action. If it has come on
 * time, this timer should not have poped.
 */
void
bnxef_fip_disc_adv_enforce(void *arg)
{

	bnxef_driver_state_t *dsp = arg;
	int			ret;

	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: bnxef_fip_disc_adv_enforce",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * This should be handled as implicit fabric logout with all the
	 * VN_ports already logged into this FCF creating virtual links.
	 * Since this is a timeout context, let us complete the major
	 * cleanup work in the normal kernel thread context. Therefore,
	 * schedulea  task queue to complete the implicit logout.
	 */

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_implicit_fabric_logout,
		dsp, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to dispatch implicit logout routine\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		ASSERT(ret == DDI_SUCCESS);
	}
}

/*
 * This routine is called via task queue method. That way we can sleep or do
 * whatever without any sleep restrictions.
 */
void
bnxef_implicit_fabric_logout(void *arg)
{

	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	int i;
	bnxef_port_t *portp;
	timeout_id_t	tid;
	int tid_valid = 0;
	int  ret;
	uint32_t state;

	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Implicit Fabric logout ",
		BNXEF_DRIVER_NAME, dsp->instance);
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	dsp->state |= BNXEF_IMPLICIT_FABRIC_LOGO_IN_PROGRESS;
	mutex_exit(&dsp->state_mutex);

	/*
	 * This will allow thread trying FLOGI to exit
	 * looking at the IMPLICT LOGOUT PROGRESS flag.
	 */
	delay(BNXEF_SEC2TICK(3));

	for (i = 0; i < dsp->num_fc_ports; i++) {
		/* First MAke all VN_Ports Provided Offline */
		portp = bnxef_port_list_find_flags(dsp,
			(BNXEF_FC_PORT_ID_ACQUIRED | BNXEF_FC_PORT_VN_PORT));
		if (portp == NULL) continue;
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline for Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);
		bnxef_fc_port_offline((void *) portp);
		/* Just cleanup port for reacquiring ID */
		bnxef_shutdown_port(portp);
	}
	/*
	 * For the Orininal N_PORt Cleanup and then
	 * Get the ID.
	 */
	portp = bnxef_port_list_find_flags(dsp,
			(BNXEF_FC_PORT_ID_ACQUIRED | BNXEF_FC_PORT_N_PORT));
	if (portp != NULL) {
		ASSERT(portp != NULL);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Offline for Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);
		bnxef_fc_port_offline(portp);
		bnxef_shutdown_port(portp);
	}
	// delay(BNXEF_SEC2TICK(2));

	/*
	 * Here do the VLAN discovery and discovery
	 * advertizements to get fip_disc_state to LOGIN
	 * ready state.
	 */
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	state = dsp->physical_port_state;
	if (dsp->fip_disc_status & FIP_KEEP_ALIVE_TIMER_ARMED) {
		tid = dsp->fip_keep_alive_tmr_hdl;
		tid_valid = 1;
		dsp->fip_disc_status &= ~FIP_KEEP_ALIVE_TIMER_ARMED;
	}
	dsp->fip_disc_state = 0;
	dsp->fip_disc_status = 0;
	dsp->port_bring_up = 1;
	mutex_exit(&dsp->state_mutex);
	if (tid_valid) untimeout(tid);


	/*
	 * If the state is Online, then start FIP State
	 * machine
	 */
	if (state) {
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_fip_sm_start, dsp,
					DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d:Unable to schedule tq\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			ASSERT(ret == DDI_SUCCESS);
			return;
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Fip State machine Triggered\n",
			BNXEF_DRIVER_NAME, dsp->instance);

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state &= ~BNXEF_IMPLICIT_FABRIC_LOGO_IN_PROGRESS;
		mutex_exit(&dsp->state_mutex);

	} else {
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		dsp->state &= ~BNXEF_IMPLICIT_FABRIC_LOGO_IN_PROGRESS;
		mutex_exit(&dsp->state_mutex);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d; Implicit Logout didnot bringup ports",
				BNXEF_DRIVER_NAME, dsp->instance);
	}
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Implicit logout called",
		BNXEF_DRIVER_NAME, dsp->instance);
}

/*
 * This will just shutdown all the FIP timer and get the port prepared for the
 * re-acquiring the I. This will not cleanup all the sessions.
 */
void
bnxef_shutdown_port(bnxef_port_t *portp)
{
	int i;
	timeout_id_t		tid, tid2, tid3;
	bnxef_driver_state_t	*dsp;
	uint8_t		tid_valid = 0;
	uint8_t		tid2_valid = 0;
	uint8_t		tid3_valid = 0;
	bnxef_session_t		*sessionp;

	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&portp->port_mutex);
	if (portp->flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Shutdown already in Progress for id 0x%xx",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id);
		mutex_exit(&portp->port_mutex);
		return;
	}
	if (portp->flags & BNXEF_FC_PORT_ID_NOT_ACQUIRED) {
		mutex_exit(&portp->port_mutex);
		return;
	}
		portp->flags |= BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS;
	mutex_exit(&portp->port_mutex);

	// delay(BNXEF_SEC2TICK(1));


	BNXEF_DEBUG(dsp, ERROR, portp->id,
		"%s%d: Shutdown port Called for Port Id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id);
	/* Cleanup all the sessions associated with this port */
	for (i = 0; i < BNXEF_MAX_HASH_BUCKETS; i++) {
		sessionp = bnxef_get_first_session(portp, i);
		if (sessionp == NULL) continue;
		ASSERT(sessionp != NULL);
		while (sessionp != NULL) {
			bnxef_session_t *nextsessionp;
			nextsessionp =
				bnxef_get_next_session(portp, i, sessionp);
			bnxef_session_cleanup(sessionp);
			sessionp = nextsessionp;
		}
	}


	mutex_enter(&portp->port_mutex);
	if (portp->fip_state & FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS) {
		if (portp->fip_state & FIP_KEEP_ALIVE_ARMED) {
			tid = portp->keep_alive_tmr_hdl;
			portp->fip_state &= ~FIP_KEEP_ALIVE_ARMED;
			tid_valid = 1;
		}
		if (portp->fip_state & FIP_KEEP_ALIVE_TIMER2_ARMED) {
			tid2 = portp->keep_alive_tmr2_hdl;
			portp->fip_state &= ~FIP_KEEP_ALIVE_TIMER2_ARMED;
			tid2_valid = 1;
		}
		portp->fip_state &= ~FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS;
	}

	if (portp->flags & BNXEF_FC_PORT_RSCN_TIMEOUT_VALID) {
		tid3_valid = 1;
		tid3 = portp->rscn_tid;
		portp->flags &= ~BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
	}

	/*
	 * since we are in the clean up of port which could happen when
	 * Virtual link maintenance wanted to take through the implicit
	 * logout and also when the physical link goes down.
	 */
	portp->flags &= ~BNXEF_FC_PORT_ID_ACQUIRED;
	portp->flags |= BNXEF_FC_PORT_ID_NOT_ACQUIRED | BNXEF_FC_PORT_SOL_BOUND;
	portp->previd = portp->id;
	bcopy(portp->mac_addr, portp->prev_mac_addr, 6);
	portp->prevvlanid = portp->vlan_id;
	portp->id = 0x0;
	bzero(portp->mac_addr, 0);
	portp->vlan_id = 0;
	memset(&portp->fcf_logi_info, 0, sizeof (la_els_logi_t));
	memset(&portp->rnid_info, 0, sizeof (fc_fca_rnid_t));
	mutex_exit(&portp->port_mutex);

	/* Untimeout the timer. */
	if (tid_valid) {
		untimeout(tid);
		tid_valid = 0;
	}

	if (tid2_valid) {
		untimeout(tid2);
		tid2_valid = 0;
	}
	if (tid3_valid) {
		untimeout(tid3);
		tid3_valid = 0;
	}
	mutex_enter(&portp->port_mutex);
	portp->flags &= ~BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS;
	cv_signal(&portp->shutdown_cv);
	mutex_exit(&portp->port_mutex);
}

/*
 * This will bring the port structure to a state where it has to reacquire ID
 * and restart.
 */
void
bnxef_cleanup_port(bnxef_port_t *portp)
{
	bnxef_session_t		*sessionp;
	int i;
	timeout_id_t		tid, tid2, tid3;
	bnxef_driver_state_t	*dsp;
	uint8_t tid_valid = 0;
	uint8_t tid2_valid = 0;
	uint8_t tid3_valid = 0;

	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, ERROR, portp->id,
		"%s%d: Cleanup port Called for Port Id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id);
	/* Cleanup all the sessions associated with this port */
	for (i = 0; i < BNXEF_MAX_HASH_BUCKETS; i++) {
		sessionp = bnxef_get_first_session(portp, i);
		if (sessionp == NULL) continue;
		ASSERT(sessionp != NULL);
		while (sessionp != NULL) {
			bnxef_session_cleanup(sessionp);
			sessionp = bnxef_get_first_session(portp, i);
		}
	}
	mutex_enter(&portp->port_mutex);
	if (portp->fip_state & FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS) {
		if (portp->fip_state & FIP_KEEP_ALIVE_ARMED) {
			tid = portp->keep_alive_tmr_hdl;
			portp->fip_state &= ~FIP_KEEP_ALIVE_ARMED;
			tid_valid = 1;
		}
		if (portp->fip_state & FIP_KEEP_ALIVE_TIMER2_ARMED) {
			tid2 = portp->keep_alive_tmr2_hdl;
			portp->fip_state &= ~FIP_KEEP_ALIVE_TIMER2_ARMED;
			tid2_valid = 1;
		}
		portp->fip_state &= ~FIP_VIRTUAL_LINK_MAINTENANCE_IN_PROGRESS;
	}

	if (portp->flags & BNXEF_FC_PORT_RSCN_TIMEOUT_VALID) {
		tid3_valid = 1;
		tid3 = portp->rscn_tid;
		portp->flags &= ~BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
	}

	/*
	 * since we are in the clean up of port which could happen when
	 * Virtual link maintenance wanted to take through the implicit
	 * logout and also when the physical link goes down.
	 */
	portp->flags &= ~BNXEF_FC_PORT_ID_ACQUIRED;
	portp->flags |= BNXEF_FC_PORT_ID_NOT_ACQUIRED;
	portp->id = 0x0;
	bzero(portp->mac_addr, 0);
	portp->vlan_id = 0;
	memset(&portp->fcf_logi_info, 0, sizeof (la_els_logi_t));
	memset(&portp->rnid_info, 0, sizeof (fc_fca_rnid_t));
	mutex_exit(&portp->port_mutex);

	/* Untimeout the timer. */
	if (tid_valid) {
		untimeout(tid);
		tid_valid = 0;
	}

	if (tid2_valid) {
		untimeout(tid2);
		tid2_valid = 0;
	}

	if (tid3_valid) {
		untimeout(tid3);
		tid3_valid = 0;
	}
}

/*
 * This will trigger the fp driver to attach as this driver is a pseudo
 * device driver and not a real HBA.
 */
void
bnxef_trigger_fp_attach(void *arg)
{
	bnxef_driver_state_t *dsp = arg;
	int			ret = NDI_FAILURE;

	ASSERT(dsp != NULL);

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_trigger_fp_attach_handler,
		(void *)dsp, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_AUTO_DEBUG("%s%d: Unable Trigger FP Attach",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}

}

/*
 * This trigger the fp attach in task context instead of the timer context
 */
void
bnxef_trigger_fp_attach_handler(void *arg)
{
	bnxef_driver_state_t *dsp = arg;
	dev_info_t	*child = NULL;
	int		rval = NDI_FAILURE;


	ndi_devi_alloc_sleep(dsp->dip, "fp", DEVI_PSEUDO_NODEID, &child);
	if (child == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Can't alloc Child dev_info for fp\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	dsp->fp_child_dip = child;
	/*
	 * fp/fctl need this property.
	 */
	if (ddi_prop_update_string(DDI_DEV_T_NONE, child,
		"bus-addr", "0,0") != DDI_PROP_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Update bus-addr failed\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		(void) ndi_devi_free(child);
		return;
	}
	/*
	 * If it's physical HBA, fp.conf will register the property.
	 * fcoei is one software HBA, so we need register it manually
	 */
	if (ddi_prop_update_int(DDI_DEV_T_NONE, child,
		"port", 0) != DDI_PROP_SUCCESS) {
	    BNXEF_DEBUG(dsp, ERROR, -1, "%s%d:update port failed\n",
		BNXEF_DRIVER_NAME, dsp->instance);
		(void) ndi_devi_free(child);
		return;
	}

	/*
	 * It will call fp_attach eventually
	 */
	rval = ndi_devi_online(child, NDI_ONLINE_ATTACH);
	if (rval != NDI_SUCCESS) {
	    BNXEF_DEBUG(dsp, ERROR, -1, "%s%d:devi_online: %d\n",
		BNXEF_DRIVER_NAME, dsp->instance, rval);
	} else {
		BNXEF_DEBUG(dsp, GENERAL, -1,
		"%s%d:triggered successfully",
		BNXEF_DRIVER_NAME, dsp->instance);
	}

	mutex_enter(&dsp->state_mutex);
		dsp->state &= ~BNXEF_TRIGGER_FP_ATTACH;
	// cv_signal(&dsp->fp_up_cv);
	mutex_exit(&dsp->state_mutex);
}

/*
 * This will allocate the fc pkt command DMA resources.
 */
int
bnxef_pkt_cmd_res_alloc(bnxef_tq_params_t *tqp, fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;
	int stage = 0, ret;
	bnxef_fcoe_task_t *taskp;
	int size;
	unsigned long realsize;

	ASSERT(tqp != NULL);

	dsp = tqp->dsp;
	portp = tqp-> portp;
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	// ASSERT(sessionp != NULL);

	ASSERT(pktp != NULL);

	size = pktp->pkt_cmdlen;

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);
	/* Allocate the DMA resources for cmd and response */
	ret = ddi_dma_alloc_handle(dsp->dip, &bnxef_cmdrsp_dma_attr,
		DDI_DMA_SLEEP, NULL,
		&pktp->pkt_cmd_dma);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate Pkt CMD dma handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_pkt_cmd_res_alloc_error;
	}

	stage |= BNXEF_PKT_CMD_DMA_HANDLE_ALLOCATED;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: pkt cmd DMA handle allocated rsplen 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, pktp->pkt_cmdlen);

	ret = ddi_dma_mem_alloc(pktp->pkt_cmd_dma,
			size,
			&bnxef_dev_acc_attr, DDI_DMA_CONSISTENT,
			DDI_DMA_SLEEP, NULL,
			&pktp->pkt_cmd, &realsize,
			&pktp->pkt_cmd_acc);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate dma pkt CMD memory\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_pkt_cmd_res_alloc_error;
	}
	pktp->pkt_cmdlen = (uint32_t)realsize;

	stage |=  BNXEF_PKT_CMD_DMA_MEM_ALLOCATED;
	BNXEF_DEBUG(dsp, ERROR, -1,
	"%s%d: pkt cmd DMA memory allocated size 0x%x, pkt_cmdlem 0x%x,\
		 pkt_rsplen 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, size, pktp->pkt_cmdlen,
		pktp->pkt_rsplen);

	memset(pktp->pkt_cmd, 0, pktp->pkt_cmdlen);

	BNXEF_DEBUG(dsp, ERROR, -1,
	"%s%d: After memset size 0x%x, pkt_cmdlem 0x%x, pkt_rsplen 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, size,
		pktp->pkt_cmdlen, pktp->pkt_rsplen);

	pktp->pkt_cmd_cookie = &taskp->rrq_cmd_cookie;
	/* Now map the buffer for use with firmware */
	ret = ddi_dma_addr_bind_handle(pktp->pkt_cmd_dma,
		NULL, pktp->pkt_cmd, pktp->pkt_cmdlen,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		pktp->pkt_cmd_cookie, &pktp->pkt_cmd_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Unable to bind dma mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_pkt_cmd_res_alloc_error;
	}
	/* We have indicated no scatter gather allowed */
	ASSERT(pktp->pkt_cmd_cookie_cnt == 1);
	stage |= BNXEF_PKT_CMD_DMA_MEM_BOUND;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: pkt cmd DMA bind complete for task 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	return (BNXEF_SUCCESS);

bnxef_pkt_cmd_res_alloc_error:
	bnxef_pkt_cmd_res_free(pktp, stage);
	return (BNXEF_FAILURE);
}


/*
 * This allocates the pkt response dma resources for RRQ.
 */
int
bnxef_pkt_resp_res_alloc(bnxef_tq_params_t *tqp, fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;
	bnxef_session_t *sessionp;
	int stage = 0, ret;
	bnxef_fcoe_task_t *taskp;
	int size;
	unsigned long realsize;

	ASSERT(tqp != NULL);

	dsp = tqp->dsp;
	portp = tqp-> portp;
	sessionp = tqp->sessp;
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	ASSERT(sessionp != NULL);

	ASSERT(pktp != NULL);
	size = pktp->pkt_rsplen;

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	/* Allocate the DMA resources for response */
	ret = ddi_dma_alloc_handle(dsp->dip, &bnxef_cmdrsp_dma_attr,
		DDI_DMA_SLEEP, NULL,
		&pktp->pkt_resp_dma);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate pkt RESP dma handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_pkt_resp_res_alloc_error;
	}

	stage |= BNXEF_PKT_RESP_DMA_HANDLE_ALLOCATED;
	BNXEF_DEBUG(dsp, ERROR, -1,
	"%s%d: pkt response DMA handle allocated, size= 0x%x, rsp_len 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, size, pktp->pkt_rsplen);

	ret = ddi_dma_mem_alloc(pktp->pkt_resp_dma,
			size,
			&bnxef_dev_acc_attr, DDI_DMA_CONSISTENT,
			DDI_DMA_SLEEP, NULL,
			&pktp->pkt_resp, &realsize,
			&pktp->pkt_resp_acc);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate dma pkt RESP memory 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, size);
		goto bnxef_pkt_resp_res_alloc_error;
	}
	pktp->pkt_rsplen = (uint32_t)realsize;

	stage |=  BNXEF_PKT_RESP_DMA_MEM_ALLOCATED;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: pkt response DMA memory allocated",
		BNXEF_DRIVER_NAME, dsp->instance);

	memset(pktp->pkt_resp, 0, pktp->pkt_rsplen);
	pktp->pkt_resp_cookie = &taskp->rrq_resp_cookie;
	/* Now map the buffer for use with firmware */
	ret = ddi_dma_addr_bind_handle(pktp->pkt_resp_dma,
		NULL, pktp->pkt_resp, pktp->pkt_rsplen,
		DDI_DMA_CONSISTENT | DDI_DMA_RDWR, DDI_DMA_SLEEP, NULL,
		pktp->pkt_resp_cookie, &pktp->pkt_resp_cookie_cnt);
	if (ret != DDI_DMA_MAPPED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to bind pkt dma mem with handle\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		goto bnxef_pkt_resp_res_alloc_error;
	}
	/* We have indicated no scatter gather allowed */
	ASSERT(pktp->pkt_resp_cookie_cnt == 1);
	stage |= BNXEF_PKT_RESP_DMA_MEM_BOUND;

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: pkt response DMA Binding completed",
		BNXEF_DRIVER_NAME, dsp->instance);
	return (BNXEF_SUCCESS);

bnxef_pkt_resp_res_alloc_error:
	bnxef_pkt_resp_res_free(pktp, stage);
	return (BNXEF_FAILURE);
}

void
bnxef_pkt_resp_res_free(fc_packet_t *pktp,  int stage)
{
	ASSERT(pktp != NULL);

	if (stage & BNXEF_PKT_RESP_DMA_MEM_BOUND)
		(void) ddi_dma_unbind_handle(pktp->pkt_resp_dma);

	if (stage & BNXEF_PKT_RESP_DMA_MEM_ALLOCATED)
		ddi_dma_mem_free(&pktp->pkt_resp_acc);

	if (stage & BNXEF_PKT_RESP_DMA_HANDLE_ALLOCATED)
			(void) ddi_dma_free_handle(&pktp->pkt_resp_dma);
}

void
bnxef_pkt_cmd_res_free(fc_packet_t *pktp, int stage)
{
	ASSERT(pktp != NULL);

	if (stage & BNXEF_PKT_CMD_DMA_MEM_BOUND)
		(void) ddi_dma_unbind_handle(pktp->pkt_cmd_dma);

	if (stage & BNXEF_PKT_CMD_DMA_MEM_ALLOCATED)
		ddi_dma_mem_free(&pktp->pkt_cmd_acc);

	if (stage & BNXEF_PKT_CMD_DMA_HANDLE_ALLOCATED)
		(void) ddi_dma_free_handle(&pktp->pkt_cmd_dma);

}


void
bnxef_send_rrq(void *arg)
{
	bnxef_session_t  *sessionp;
	bnxef_port_t	 *portp;
	bnxef_port_t	 *rportp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t	*taskp;
	bnxef_fcoe_task_t	*rrqtaskp;
	fc_packet_t		*pktp;
	la_els_rrq_t		rrqpayload;
	bnxef_tq_params_t	*tqp;
	struct fcoe_task_ctx_entry 	*fwtaskp;
	int ret;
	timeout_id_t		tid;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	sessionp = tqp->sessp;
	portp = tqp->portp;
	dsp	= tqp->dsp;
	taskp = tqp->taskp;
	fwtaskp = taskp->fwtaskp;

	ASSERT(sessionp != NULL);
	ASSERT(portp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(taskp != NULL);

	rportp = sessionp->rport;
	ASSERT(rportp != NULL);


	/*
	 * Wait for RA_TOV time before you send RRQ, this will waste
	 * processor busy waiting may be convert to timeout. This is in
	 * the error recovery path therefore it should not matter.
	 */
	delay(BNXEF_SEC2TICK(2));
	if (dsp->physical_port_state & BNXEF_PHYPORT_OFFLINE) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Physical port offline, cannot continue",
		BNXEF_DRIVER_NAME, dsp->instance);
		/* For the Original Packet, silently tell Abort Completed */
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR, 0,
			FC_REASON_ABORT_FAILED, 0);
		return;
	}

	if (portp->flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Port Shutdown in progress, RRQ not sent",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* For the Original Packet, silently tell Abort Completed */
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR, 0,
			FC_REASON_ABORT_FAILED, 0);
		return;
	}



	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Sending RRQ for TAsk 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = rportp->id;
	pktp->pkt_cmd_fhdr.s_id = portp->id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_EXTENDED_LS;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_REQ;
	pktp->pkt_cmd_fhdr.ro	=  0;
	pktp->pkt_cmd_fhdr.f_ctl = F_CTL_FIRST_SEQ | F_CTL_END_SEQ |
				F_CTL_SEQ_INITIATIVE;
	pktp->pkt_timeout	 = BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_NO_INTR);
	pktp->pkt_cmdlen = sizeof (la_els_rrq_t); /* No Payload for ABTS */
	pktp->pkt_rsplen = 4;

	rrqtaskp = bnxef_rrq_task_alloc(dsp, KM_SLEEP);
	ASSERT(rrqtaskp != NULL);

	rrqtaskp->pktp = pktp;
	rrqtaskp->task_flags |= BNXEF_FCOE_TASK_RRQ | BNXEF_FCOE_TASK_ELS;

	pktp->pkt_fca_private = rrqtaskp;
	pktp->pkt_cmd_fhdr.ox_id =  rrqtaskp->x_id;
	memset(&rrqpayload, 0, sizeof (la_els_rrq_t));
	rrqpayload.ls_code = LA_ELS_RRQ;
	rrqpayload.source_id[2] =  (portp->id & 0xff);
	rrqpayload.source_id[1] = (portp->id >> 8) & 0xff;
	rrqpayload.source_id[0] = (portp->id >> 16) & 0xff;
	rrqpayload.ox_id = htons(taskp->x_id);
	if (sessionp->state & BNXEF_SESSION_OFFLOADED)
		rrqpayload.rx_id = htons(fwtaskp->rxwr_txrd.var_ctx.rx_id);
	else
		rrqpayload.rx_id = 0xffff;

	ret = bnxef_pkt_cmd_res_alloc(tqp, pktp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate packet cmd resources\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		debug_enter("alloc failure");
		bnxef_task_free(dsp, rrqtaskp);
		kmem_free(pktp, sizeof (fc_packet_t));
		/* For the Original Packet, silently tell Abort Completed */
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR, 0,
			FC_REASON_ABORT_FAILED, 0);
		return;
	}

	/* copy the rrq payload data into cmd DMA buffer */
	ddi_rep_put8(pktp->pkt_cmd_acc, (uint8_t *)&rrqpayload,
		(uint8_t *)pktp->pkt_cmd, sizeof (la_els_rrq_t),
		DDI_DEV_AUTOINCR);

	ret = bnxef_pkt_resp_res_alloc(tqp, pktp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Unable to allocate pkt resp resources for RRQ\n",
		BNXEF_DRIVER_NAME, dsp->instance);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_task_free(dsp, rrqtaskp);
		kmem_free(pktp, sizeof (fc_packet_t));
		/* For the Original Packet, silently tell Abort Completed */
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR, 0,
			FC_REASON_ABORT_FAILED, 0);
		return;
	}

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: RRQ PAcket Set up with Required information",
		BNXEF_DRIVER_NAME, dsp->instance);
	/*
	 * We can also get the original X_ID from RRQ payload, but done
	 * this way here.
	 */
	rrqtaskp->task_flags |= BNXEF_FCOE_SEC_X_ID_VALID;
	rrqtaskp->secondary_x_id = taskp->x_id; /* Back link to original task */
	rrqtaskp->sessionp = NULL;
	taskp->sec_flags |= BNXEF_RRQ_SENT;

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_RRQ_INITIATED,
		taskp->x_id, rrqtaskp->x_id, 0, sessionp,
		0, 0, 0);
	/* Free the tq params structure as we have got the information */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	if (dsp->physical_port_state & BNXEF_PHYPORT_OFFLINE) {
		/*
		 * Now if the Link has gone down, do not set the timeout
		 * for RRQ  donot set the RRQ out as well.
		 */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		bnxef_task_free(dsp, rrqtaskp);
		kmem_free(pktp, sizeof (fc_packet_t));
		/*
		 * For the Original Packet, silently tell
		 * Abort Completed
		 */
		bnxef_task_session_list_remove(taskp->sessionp, taskp);
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR, 0,
			FC_REASON_ABORT_FAILED, 0);
		return;
	}


	/* ARM the timer to catch run away condition */
	tqp = &rrqtaskp->tq_params;
	tqp->dsp = dsp;
	tqp->taskp = rrqtaskp;
	tqp->sessp = sessionp;
	tqp->mp  = NULL;
	tqp->type = BNXEF_RRQ_TIMEOUT_TYPE;
	tqp->reserved2 = taskp->task_flags;
	tqp->reserved3 = taskp->sec_flags;

	tid = timeout(bnxef_rrq_timeout_handler, tqp,
			BNXEF_SEC2TICK(pktp->pkt_timeout));


	ret = bnxef_task_session_list_add(sessionp, rrqtaskp);
	if (ret == BNXEF_FAILURE) {
		/* This will untimeout the timer we started */
		untimeout(tid);

		/* Free the task allocated for ABTS */
		bnxef_task_free(dsp, rrqtaskp);
		bnxef_pkt_cmd_res_free(pktp,
			BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp,
			BNXEF_PKT_RESP_ALL);

		/* Free the Packet memory allocated for ABTS pkt */
		kmem_free(pktp, sizeof (fc_packet_t));

		bnxef_task_session_list_remove(taskp->sessionp, taskp);

		/* Complete Original Packet Indicating abort failed */
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR,
			0, FC_REASON_ABORT_FAILED, 0);
		return;
	}


	if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Initializing the Task structure for RRQ",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* Init mp task */
		bnxef_init_mp_task(sessionp, pktp);

		/* Update the SQ to start this */
		bnxef_add_2_sq(sessionp, rrqtaskp->x_id);

		mutex_enter(&rrqtaskp->task_mutex);
		rrqtaskp->timerhdl = tid;
		rrqtaskp->task_flags |= (BNXEF_FCOE_TASK_TIMER_ARMED |
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
		mutex_exit(&rrqtaskp->task_mutex);

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Ringing the door bell to send RRQ",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* Now ring the door bell register appropriately */
		bnxef_ring_doorbell(sessionp);
	} else {
		/*
		 * Always RRQ is sent only for offloaded session
		 * otherwise it is possible the session is undergoing
		 * changes. Therefore quitely complete the original task
		 * without sending RRQ.
		 */
		untimeout(tid);

		/* Remove the RRQ task from the list */
		bnxef_task_session_list_remove(sessionp, rrqtaskp);

		/* Free the task allocated for ABTS */
		bnxef_task_free(dsp, rrqtaskp);
		bnxef_pkt_cmd_res_free(pktp,
			BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp,
			BNXEF_PKT_RESP_ALL);

		/* Free the Packet memory allocated for ABTS pkt */
		kmem_free(pktp, sizeof (fc_packet_t));

		bnxef_task_session_list_remove(taskp->sessionp, taskp);

		/* Complete Original Packet Indicating abort failed */
		bnxef_complete_pkt(taskp->pktp, FC_PKT_TIMEOUT,
			0, FC_REASON_ABORT_FAILED, 0);

#if 0
		/* We have to transmit ABTS using L2 method. */
		mp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
		if (mp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to create RRQ packet\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_task_session_list_remove(sessionp, rrqtaskp);
			/* Free the task allocated for ABTS */
			bnxef_task_free(dsp, rrqtaskp);
			bnxef_pkt_cmd_res_free(pktp,
				BNXEF_PKT_CMD_ALL);
			bnxef_pkt_resp_res_free(pktp,
				BNXEF_PKT_RESP_ALL);
			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));
			/* Un timeout the timer enabled */
			untimeout(tid);
			/* Complete Original Packet Indicating abort failed */
			bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return;
		}

		/* Transmit the Mblk prepared */
		if (!bnxef_send_frame(dsp, mp, dsp->fcf_ident->vlan_id)) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to transmit ABTS frame\n",
				BNXEF_DRIVER_NAME, dsp->instance);

			bnxef_task_session_list_remove(sessionp, rrqtaskp);

			/* Free the task allocated for ABTS */
			bnxef_task_free(dsp, rrqtaskp);
			bnxef_pkt_cmd_res_free(pktp,
				BNXEF_PKT_CMD_ALL);
			bnxef_pkt_resp_res_free(pktp,
				BNXEF_PKT_RESP_ALL);

			/* Free the Packet memory allocated for ABTS pkt */
			kmem_free(pktp, sizeof (fc_packet_t));

			bnxef_task_session_list_remove(taskp->sessionp, taskp);

			/* Complete Original Packet Indicating abort failed */
			bnxef_complete_pkt(taskp->pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return;
		}

		mutex_enter(&rrqtaskp->task_mutex);
		rrqtaskp->timerhdl = tid;
		rrqtaskp->task_flags |= (BNXEF_FCOE_TASK_TIMER_ARMED |
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
		mutex_exit(&rrqtaskp->task_mutex);
#endif
	}

}


/*
 * The generic ULP timeout handler for all types of exchanges.
 */
void
bnxef_timeout(void *arg)
{

	int  ret;
	bnxef_tq_params_t *tqp = (bnxef_tq_params_t *)arg;
	bnxef_driver_state_t *dsp;
	bnxef_port_t		*portp;
	bnxef_session_t		*sessionp;


	ASSERT(tqp != NULL);
	dsp  = tqp->dsp;
	portp = tqp->portp;
	sessionp = tqp->sessp;
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	/*
	 * If CVL or Port Shutdown in progress the commands queued up to
	 * session task queue will be cleared as part of the session cleanup.
	 * For commands like PLOGI and SCR which could come without session
	 * still need to be cleared out as they are not part of any queue.
	 * Therefore before we check all those states, just schedule
	 * the timeout handler and then return.
	 */
	if (sessionp == NULL) {
		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_timeout_handler, (void *)tqp, DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to schedule the timeout handler\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		}
		return;
	}

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	mutex_exit(&dsp->state_mutex);
	/*
	 * If the shutdown is in progress, donot do anything
	 * just return, the shutdown process will clear this I/O.
	 */
	mutex_enter(&portp->port_mutex);
	if (portp->flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	mutex_exit(&portp->port_mutex);

	ret = ddi_taskq_dispatch(dsp->tq,
		bnxef_timeout_handler, (void *)tqp, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to schedule the timeout handler\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}

/*
 * This will handle the ELS SCR/PLOGI timeouts. This SCR ELS is special
 * as it is sent to FFFFFD (Fabric controller) which does not require
 * a login to be done. Also ELS PLOGI is the frame which establishes
 * session, therefore that does not need an ABTS to be generated, just
 * replay it, it wll clear the previous session, as PLOGI sent on a
 * existing session will behave like a implicit logout. Therefore,
 * for this special case which does not have a session established,
 * we donot do ABTS, instead replay the command with different task ID.
 */
void
bnxef_els_nosession_timeout_handler(bnxef_driver_state_t *dsp,
		bnxef_fcoe_task_t *taskp)
{
	fc_packet_t *pktp;
	uint32_t task_flags;
	uint8_t *payloadp, *orig_payloadp;
	uint32_t payloadsz;
	uint8_t *framehdrp;
	int ret;

	ASSERT(dsp != NULL);
	ASSERT(taskp != NULL);

	pktp = taskp->pktp;
	ASSERT(pktp != NULL);

	mutex_enter(&taskp->task_mutex);
	task_flags = taskp->task_flags;
	payloadp = taskp->payloadp;
	framehdrp = taskp->frame_hdrp;
	orig_payloadp = taskp->orig_payloadp;
	payloadsz = taskp->payloadsz;
	mutex_exit(&taskp->task_mutex);

	if (task_flags & BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC) {
		kmem_free(orig_payloadp, payloadsz);
	}
	if (task_flags & BNXEF_FCOE_TASK_PAYLOAD_ALLOC) {
		kmem_free(payloadp, payloadsz);
	}
	if (task_flags & BNXEF_FCOE_TASK_FRAME_HDR_ALLOC) {
		kmem_free(framehdrp, sizeof (fc_frame_hdr_t));
	}

	if (dsp->task_bd_table_pre_alloc == 0) {
		if ((task_flags &  BNXEF_FCOE_TASK_BD_LIST_ALLOC) ==
			BNXEF_FCOE_TASK_BD_LIST_ALLOC) {
			ret = bnxef_task_bd_table_free(pktp,
				BNXEF_TASK_BD_TABLE_ALL);
			ASSERT(ret == BNXEF_SUCCESS);
		}
	}

	/*
	 * Now return the packet back to higher level layer with appropriate
	 * status and reason code.
	 */
	pktp->pkt_state = FC_PKT_TIMEOUT;
	pktp->pkt_reason = FC_REASON_ABORTED;
	pktp->pkt_expln = 0;
	pktp->pkt_action = 0;


	mutex_enter(&taskp->task_mutex);
	taskp->task_flags &= ~task_flags;
	/*
	 * Only these two flags should be pending, sort of cleared all and
	 * reset what we want. This is to optimize code as we donot want to
	 * check for each one that is set to be reset.
	 */
	taskp->task_flags =
		(BNXEF_FCOE_TASK_COMPLETED | BNXEF_FCOE_TASK_ALLOCATED);
	taskp->sec_flags = 0;
	if (pktp->pkt_tran_flags & FC_TRAN_NO_INTR) {
		cv_signal(&taskp->task_cv);

	}
	mutex_exit(&taskp->task_mutex);

	bnxef_task_free(dsp, taskp);

	/* Allocate a New task for use */
	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);
	/* Put the link here, so that leadville we replay with new task */
	pktp->pkt_fca_private = taskp;
	taskp->pktp = pktp;

	if (pktp->pkt_tran_flags & FC_TRAN_INTR) {
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_pkt_callback,
			(void *)pktp, DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Schedule Pkt callback routine\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			return;
		}
	}

}



/*
 * This is the generic timeout handler in task Queue thread context instead
 * of timeout context.
 */
void
bnxef_timeout_handler(void *arg)
{
	bnxef_tq_params_t *tqp = (bnxef_tq_params_t *)arg;
	bnxef_session_t *sessionp = tqp->sessp;
	bnxef_driver_state_t *dsp = tqp->dsp;
	bnxef_port_t		*portp;
	bnxef_fcoe_task_t *taskp = tqp->taskp;
	int ret, task_target_reset = 0;


#if 0
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Entering the Timeout routine for 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);

	BNXEF_STATS(dsp, timeout_tasks);
#endif

	if (sessionp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Session Is NULL task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		ASSERT(taskp != NULL);
		mutex_enter(&taskp->task_mutex);
		if (taskp->task_flags & BNXEF_FCOE_TASK_ELS) {
			if (taskp->task_flags &
				BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC) {
				ls_code_t *elsp;
				/* LINTED: alignment */
				elsp = (ls_code_t *)taskp->orig_payloadp;
				BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: Original Payload Copied\
					already task id 0x%x\n",
					BNXEF_DRIVER_NAME, dsp->instance,
					taskp->x_id);
				if (elsp->ls_code == LA_ELS_PLOGI) {
					mutex_exit(&taskp->task_mutex);
					BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Completing the PLOGI with TIMEOUT",
					BNXEF_DRIVER_NAME, dsp->instance);
					bnxef_els_nosession_timeout_handler(dsp,
						taskp);
					mutex_enter(&taskp->task_mutex);
				}
				if (elsp->ls_code == LA_ELS_SCR) {
					mutex_exit(&taskp->task_mutex);
					BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: Completing the SCR with Timeout",
					BNXEF_DRIVER_NAME, dsp->instance);
					bnxef_els_nosession_timeout_handler(dsp,
						taskp);
					mutex_enter(&taskp->task_mutex);
				}
			}
		}
		mutex_exit(&taskp->task_mutex);
		return;
	}

	ASSERT(sessionp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(taskp != NULL);
	portp = sessionp->lport;
	if (portp == NULL) {
		/* Do nothing */
		return;
	}
	ASSERT(portp != NULL);

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_ELS) {
		if (taskp->task_flags & BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC) {
			ls_code_t *elsp;
			fc_packet_t *pktp;
			/* LINTED: alignment */
			elsp = (ls_code_t *)taskp->orig_payloadp;
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Original Payload Copied already task id 0x%x\n",
					BNXEF_DRIVER_NAME, dsp->instance,
					taskp->x_id);
			if ((elsp->ls_code == LA_ELS_PLOGI) ||
				(elsp->ls_code == LA_ELS_PRLI)) {
				if (elsp->ls_code == LA_ELS_PRLI) {
					pktp = taskp->pktp;
					bcopy(taskp->orig_payloadp,
						pktp->pkt_cmd,
						pktp->pkt_cmdlen);
				}
				mutex_exit(&taskp->task_mutex);
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Completing the PLOGI with TIMEOUT 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
				if (elsp->ls_code == LA_ELS_PRLI)
					bnxef_task_session_list_remove(sessionp,
						taskp);
				bnxef_els_nosession_timeout_handler(dsp, taskp);
				return;
			}
		}
	}
	mutex_exit(&taskp->task_mutex);


	// debug_enter("Timeout");
	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	/*
	 * If the shutdown is in progress, donot do anything
	 * just return, the shutdown process will clear this I/O.
	 */
	mutex_enter(&portp->port_mutex);
	if (portp->flags & BNXEF_FC_PORT_SHUTDOWN_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
		return;
	}
	mutex_exit(&portp->port_mutex);

	BNXEF_TRACE_EVENT(dsp, BNXEF_SCSI_TASK_TIMEOUT,
		taskp->x_id, -1, 0, sessionp, 0, 0, 0);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_RECOVERY_IN_PROGRESS;
	taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
	if ((taskp->task_flags & BNXEF_FCOE_TASK_MGMT_CMD) ==
		BNXEF_FCOE_TASK_MGMT_CMD) {
		fcp_cmd_t *cmdp;
		fc_packet_t *pktp;

		pktp = taskp->pktp;
		if (pktp != NULL) {
			/* LINTED: alignment */
			cmdp = (fcp_cmd_t *)pktp->pkt_cmd;
			if (cmdp->fcp_cntl.cntl_reset_tgt) {
				task_target_reset = 1;
			}
		}
	}
	mutex_exit(&taskp->task_mutex);

	if (task_target_reset) {
		mutex_enter(&sessionp->session_mutex);
		sessionp->state &= ~BNXEF_TM_CLEANUP_IN_PROGRESS;
		mutex_exit(&sessionp->session_mutex);
	}
	/*
	 * This will take through the complete state machine to
	 * complete the task in error.
	 */
	ret = bnxef_initiate_abts(sessionp, taskp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to initiate ABTS\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}

}

#if 0
void
bnxef_poll_scsi_timeout(void *args)
{
	bnxef_port_t *portp = (bnxef_port_t *)args;
	bnxef_driver_state_t *dsp;
	bnxef_tq_params_t *tqp;
	int ret;

	ASSERT(portp != NULL);
	dsp  = portp->statep;
	ASSERT(dsp != NULL);

	tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
	ASSERT(tqp != NULL);

	tqp->dsp = dsp;
	tqp->portp = portp;

	ret = ddi_taskq_dispatch(dsp->tq,
		bnxef_poll_scsi_completion, tqp, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to schedule scsi poll completion",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
	timeout(bnxef_poll_scsi_timeout, (void *)portp, BNXEF_SEC2TICK(1));
}



/*
 * THis will poll for completion of SCSI I/Os. This is done as a work around.
 * This will not be used if bnxe puts such a workaround. The bnxe driver is the
 * best place for such workaround as it covers other types of WQE completion
 * other than the SCSI completions.
 */
void
bnxef_poll_scsi_completion(void  *tqp)
{
	bnxef_driver_state_t *dsp;
	bnxef_tq_params_t	*params;
	bnxef_port_t	*portp;
	int i;
	bnxef_session_t	 *sessionp;
	uint16_t	iterate_cnt;

	params = (bnxef_tq_params_t *)tqp;
	ASSERT(params != NULL);
	dsp = params->dsp;
	portp = params->portp;
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);
	kmem_cache_free(dsp->tq_params_cache, tqp);
	for (i = 0; i < BNXEF_MAX_HASH_BUCKETS; i++) {
		sessionp = bnxef_get_first_session(portp, i);
		if (sessionp == NULL) continue;
		ASSERT(sessionp != NULL);
		while (sessionp != NULL) {
			if ((sessionp->state & BNXEF_SESSION_OFFLOADED) &&
				(sessionp->state & BNXEF_SESSION_ENABLED)) {
				mutex_enter(&sessionp->session_mutex);
				if (sessionp->prev_cq_cons_idx !=
					sessionp->cq_cons_idx)  {
					sessionp->iterate_cnt = 0;
					sessionp->prev_cq_cons_idx =
						sessionp->cq_cons_idx;
					} else  {
					    sessionp->iterate_cnt ++;
					    sessionp->prev_cq_cons_idx =
					sessionp->cq_cons_idx;
					    iterate_cnt = sessionp->iterate_cnt;
				}
				mutex_exit(&sessionp->session_mutex);
				if (iterate_cnt >= 3) {
					mutex_enter(&sessionp->session_mutex);
					sessionp->iterate_cnt = 0;
					mutex_exit(&sessionp->session_mutex);
					bnxef_session_cq_handler(sessionp);
				}
			}
			sessionp = bnxef_get_next_session(portp, i, sessionp);
		}
	}

}
#endif


/* TBD - HAndler to be written */
void
bnxef_fip_tq_handler(void * paramsp)
{
	bnxef_tq_params_t *tqp = (bnxef_tq_params_t *)paramsp;
	bnxef_driver_state_t *dsp;

	ASSERT(tqp != NULL);

	dsp = tqp->dsp;
	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Tq Hander called for no resources",
		BNXEF_DRIVER_NAME, dsp->instance);

	switch (tqp->type)  {
	case BNXEF_TQ_FIP_VLAN_REQ_NO_RESOURCE:
		break;
	case BNXEF_TQ_FIP_VLAN_REQ_SEND_FAILURE:
		break;
	default:
		break;
	}
}
