/*
 * The information contained in this file is confidential and proprietary to
 * Broadcom Corporation.  No part of this file may be reproduced or
 * distributed, in any form or by any means for any purpose, without the
 * express written permission of Broadcom Corporation.
 *
 * (c) COPYRIGHT 2010-2012 Broadcom Corporation, ALL RIGHTS RESERVED.
 */

#pragma ident "(C) 2010-2012 Broadcom Corporation"
#pragma ident " $File$$Revision$$Change$$DateTime$"

#include <sys/conf.h>
#include <sys/ddi.h>
#include <sys/stat.h>
#include <sys/pci.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>
#include <sys/file.h>
#include <sys/cred.h>
#include <sys/byteorder.h>
#include <sys/atomic.h>
#include <sys/scsi/scsi.h>
#include <sys/modhash.h>
#include <sys/sunldi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/stream.h>
#include <sys/sunldi.h>
#include <sys/crc32.h>
/*
 * leadville header files
 */
#include <sys/fibre-channel/fc_types.h>
#include <sys/fibre-channel/impl/fc_fcaif.h>
#include <bnxe_binding.h>
#include <bnxef_tq_param.h>
#include <bnxef_fcf_info.h>
#include <bnxef_hsi.h>
#include <bnxef_fcoe_task.h>
#include <bnxef_fcoe_session.h>
#include <bnxef_state.h>
#include <bnxef_fip.h>
#include <bnxef_fcoe.h>
#include <bnxef_debug.h>

frtn_t mpfree;
/* External Prototype */
extern void  * bnxef_state;
extern bnxef_session_t *
bnxef_session_find_remote_port(bnxef_port_t *portp, int16_t vlan_id,
		uint32_t d_id, uint8_t *macaddr);
extern void bnxef_init_mp_task(bnxef_session_t *sessionp, fc_packet_t *pktp);
extern void bnxef_add_2_sq(bnxef_session_t *sessionp, uint16_t xid);
extern void bnxef_ring_doorbell(bnxef_session_t *sessionp);
extern void bnxef_timeout(void *arg);
extern boolean_t bnxef_send_frame(bnxef_driver_state_t  *dsp,
		mblk_t *mp, uint16_t vlan_id);
extern int bnxef_fip_rx_handler(dev_info_t *dip, mblk_t *mp, int flags);
extern void bnxef_fcct_rx_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp, mblk_t *mp,
		int flags);
extern void bnxef_send_rrq(void *);
extern int bnxef_pkt_cmd_res_alloc(bnxef_tq_params_t *tqp,
		fc_packet_t *pktp);
extern int bnxef_task_session_list_init(bnxef_driver_state_t *dsp,
		bnxef_session_t *sessionp);
extern int bnxef_task_session_list_fini(bnxef_session_t *sessionp);
extern void bnxef_pkt_resp_res_free(fc_packet_t *pktp,  int stage);
extern void bnxef_pkt_cmd_res_free(fc_packet_t *pktp, int stage);
extern int bnxef_alloc_session_con_id(bnxef_driver_state_t *dsp,
		bnxef_session_t *sessionp);
extern void bnxef_free_session_con_id(bnxef_driver_state_t *dsp, int con_id);
extern uint8_t bnxef_session_gen_hash(int16_t vlan_id, uint32_t d_id,
		uint8_t *macaddr);
extern int bnxef_session_list_add(bnxef_port_t *portp,
		bnxef_session_t *sessionp, uint8_t hashbucket);
extern int bnxef_alloc_session_resources(bnxef_session_t *sessionp);
extern int bnxef_offload_session(bnxef_session_t *sessionp,
		uint8_t sparamw3byte2, uint8_t sparamw3byte3);
extern int bnxef_session_enable(bnxef_session_t *sessionp);
extern int bnxef_task_bd_table_free(fc_packet_t *pktp, uint32_t stage);
extern int bnxef_session_disable(bnxef_session_t *sessionp);
extern int bnxef_cleanup_task(bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp);
extern int bnxef_session_destroy(bnxef_session_t *sessionp);
extern int bnxef_free_session_resources(bnxef_session_t *sessionp,
	uint32_t stage);
extern int
bnxef_session_list_remove(bnxef_port_t *portp, bnxef_session_t *sessionp,
	uint8_t hashbucket);
extern bnxef_unsol_buf_t *bnxef_find_unsol_buf(bnxef_port_t *portp,
	uchar_t type);
extern void bnxef_big_endian(void *bufp, int size);
extern int
bnxef_initiate_ba_acc(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp,
	uint16_t ox_id);
extern int
bnxef_initiate_ba_rjt(bnxef_session_t *sessionp, uint16_t ox_id, uint16_t rx_id,
	la_ba_rjt_t *payloadp);
extern bnxef_fcoe_task_t *bnxef_task_alloc(bnxef_driver_state_t *dsp,
	int sleepflag);
extern int
bnxef_ub_release(opaque_t fca_handle, uint32_t count, uint64_t tokens[]);
extern bnxef_unsol_buf_t *
bnxef_find_non_rel_unsol_buf(bnxef_port_t *portp,
	uint16_t ox_id, uint32_t d_id);
extern int bnxef_get_active_ios(bnxef_session_t *sessionp);
extern int bnxef_find_session(bnxef_port_t *portp, bnxef_session_t *sp);


extern int bnxef_get_active_ub_count(bnxef_port_t *portp);







/* prototypes */
static int
bnxef_plogi_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
			fc_packet_t *pktp);
static int
bnxef_flogi_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_fdisc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_els_tx_handler_noresp(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags);
static int
bnxef_build_ls_rjt(la_els_rjt_t *rjtp, fc_packet_t *pktp, uint8_t rjt_reason,
		uint32_t pkt_state, uint32_t pkt_reason);
static int
bnxef_build_ls_acc(ls_code_t *acc, fc_packet_t *pktp, uint32_t size);
static int
bnxef_els_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
		fc_packet_t *pktp);
void
bnxef_els_tx_ofld_session_noresp(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags);
int
bnxef_els_tx_nonofld_session_noresp(bnxef_port_t *portp,
		bnxef_session_t *sessionp, fc_packet_t *pktp, int flags);
static void
bnxef_els_tx_ofld_session(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_els_tx_nonofld_session(bnxef_port_t *portp, bnxef_session_t *sessionp,
				fc_packet_t *pktp);
int bnxef_start_polling(bnxef_driver_state_t *dsp);
void bnxef_stop_polling(bnxef_driver_state_t *dsp);
mblk_t  *bnxef_prepare_fcoe_mblk_from_pkt(bnxef_driver_state_t *dsp,
		bnxef_port_t *portp, fc_packet_t *pktp);
int
bnxef_implicit_logout_handler(bnxef_port_t *portp, bnxef_session_t *sessionp);
void bnxef_poll(void * dsp);
void bnxef_mblk_free(char *arg);
void bnxef_generate_fabric_rscn_impl(void  *arg);
static uint32_t bnxef_compute_crc32(mblk_t *mp, int flags);
static void bnxef_fcoe_rx_handler(dev_info_t *dip, mblk_t *mp, int flags);
static int bnxef_els_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp,  bnxef_fcoe_frame_t *fcoep, uint32_t
		frame_length, int flags);
static int bnxef_scsi_rx_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp, mblk_t *mp,
	int flags);
static int bnxef_bls_rx_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp, mblk_t *mp,
	int flags);
void
bnxef_complete_pkt(fc_packet_t *pktp, uint8_t state,
	uint8_t action, uint32_t reason, uint32_t expln);
static int
bnxef_ls_acc_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, bnxef_fcoe_frame_t *fcoep,
	uint32_t frame_length, void *fcp, int flags);
static int
bnxef_ls_rjt_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, bnxef_fcoe_frame_t *fcoep, uint32_t
			frame_length, void *fcp, int flags);
static void bnxef_plogi_rx_handler(void * arg);
static void bnxef_logo_rx_handler(void * arg);
static int bnxef_unsolicited_els_rx_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp,
	bnxef_fcoe_frame_t *fcoep, uint32_t frame_length, void *fp);
static void bnxef_plogi_ls_acc_rx_handler(void *arg);
static void bnxef_prli_ls_acc_rx_handler(void *arg);
static void bnxef_logo_ls_acc_rx_handler(void *arg);
static void bnxef_els_ls_acc_rx_handler(void * arg);
int bnxef_session_cleanup(bnxef_session_t *sessionp);
static int bnxef_scr_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static void bnxef_scr_ls_acc_rx_handler(void *arg);
static int
bnxef_ls_rjt_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags);

static int
bnxef_ls_acc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags);
static void bnxef_prli_rx_handler(void *arg);

static void bnxef_adisc_rx_handler(void *arg);
static int bnxef_prli_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_adisc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_rls_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static void bnxef_rscn_rx_handler(void * arg);
static int bnxef_unsol_rscn_ls_acc_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, fc_packet_t *pktp);
void bnxef_l2_rx_handler(void *arg);
static int
bnxef_unsol_prlo_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static int
bnxef_unsol_adisc_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);

void bnxef_unsol_els_l2_rx_handler(void *arg);
void
bnxef_build_ls_rjt_cmd(la_els_rjt_t *rjt, fc_packet_t *pktp, uint8_t reason,
		uint8_t expln);
void
bnxef_send_ls_rjt(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp, uint8_t reason, uint8_t expln);
static int
bnxef_logo_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp);
static void bnxef_adisc_ls_acc_rx_handler(void *arg);
int bnxef_wwn_cmp(la_wwn_t *src, la_wwn_t *dst);
fc_packet_t *
bnxef_prep_ls_rjt_with_fhdr(bnxef_driver_state_t *dsp, fc_frame_hdr_t *fcp);
extern int bnxef_start_task(bnxef_driver_state_t *dsp,
	fc_packet_t *pktp, int sleep);
extern int bnxef_end_task(bnxef_driver_state_t *dsp, fc_packet_t *pktp);
void
bnxef_complete_polling(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp);
extern void bnxef_session_cq_handler(void *sessionp);

/* ARGSUSED0 */
void
bnxef_mblk_free(char *arg)
{

}


fc_packet_t	*global_pktp;
uint32_t	given_d_id;
ls_code_t	*global_elsp;

/*
 * This will manage the exchange needed to complete ELS request.
 * This routine will distinguish between already offloaded connection and non
 * offloaded connection and handle the request appropriately.
 * This routine is capable of handling the polled mode or non polled mode
 * completion.
 */
int
bnxef_send_els(opaque_t fca_handle, fc_packet_t *pktp)
{
	bnxef_port_t *portp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	bnxef_session_t	 *sesp;
	uint32_t d_id;
	uint8_t *macaddrp;
	uint16_t vlan_id;
	int rval;
	la_els_rjt_t  rjt;
	ls_code_t els;
	timeout_id_t	tid;
	bnxef_tq_params_t *tqp;
	fc_unsol_buf_t		*ubp;
	uint32_t phyport_state;
#if !(defined(__S11) || defined(__S12))
	bnxef_unsol_buf_t *unsolbufp;
#endif

	ASSERT(pktp != NULL);

	portp = (bnxef_port_t *)fca_handle;
	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	BNXEF_DEBUG(dsp, ELS, portp->id, "%s%d: Send ELS called",
		BNXEF_DRIVER_NAME, dsp->instance);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	phyport_state = dsp->physical_port_state;
	mutex_exit(&dsp->state_mutex);

	if (!phyport_state) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Returning the ELS because no link",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (FC_TRANSPORT_ERROR);
	}


	/* Check whether the port is bound with solaris */
	mutex_enter(&portp->port_mutex);
	if ((portp->flags & BNXEF_FC_PORT_SOL_BOUND) == 0) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: els req cannot be processed on unbound port\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		mutex_exit(&portp->port_mutex);
		return (FC_UNBOUND);
	}
	macaddrp = portp->fcf->mac_addr;
	vlan_id  = portp->fcf->vlan_id;
	mutex_exit(&portp->port_mutex);

	if ((pktp->pkt_cmdlen == 0) ||
		(pktp->pkt_cmd_acc == NULL)) {
		return (FC_TRANSPORT_ERROR);
	}


	/* Set up the response frame header */
	bcopy((void *)&pktp->pkt_cmd_fhdr, (void *)&pktp->pkt_resp_fhdr,
		sizeof (fc_frame_hdr_t));
	pktp->pkt_resp_fhdr.d_id = portp->id;
	pktp->pkt_resp_fhdr.s_id = pktp->pkt_cmd_fhdr.d_id;
	pktp->pkt_resp_fhdr.r_ctl =
		R_CTL_EXTENDED_SVC | R_CTL_SOLICITED_CONTROL;
	pktp->pkt_resp_fhdr.f_ctl =
		F_CTL_XCHG_CONTEXT | F_CTL_LAST_SEQ | F_CTL_END_SEQ;


	if (pktp->pkt_fca_private == NULL)
		bnxef_start_task(dsp, pktp, KM_SLEEP);

	/* During init pkt, the task structure should have been allocated */
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;

	if (taskp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: TAsk structure bad in pkt private field\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (FC_TRAN_BUSY);
	}
	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: Task allocated for this 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);


	/* Determine whether the connection already exists for this D_ID */
	d_id = pktp->pkt_cmd_fhdr.d_id;
	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: Request to send ELS to 0%x",
		BNXEF_DRIVER_NAME, dsp->instance, d_id);
	/* find the session if it is already existing */
	sesp = bnxef_session_find_remote_port(portp, vlan_id,  d_id, macaddrp);
	/* Start the timer for this ELS request */
	tqp = &taskp->tq_params;
	tqp->dsp = dsp;
	tqp->portp = portp;
	tqp->sessp = sesp;
	tqp->taskp = taskp;
	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%dTimeout value for ELS 0x%x, for OX_ID 0x%x\n",
		BNXEF_DRIVER_NAME, dsp->instance, pktp->pkt_timeout,
		taskp->x_id);


	tid = timeout(bnxef_timeout, tqp, BNXEF_SEC2TICK(pktp->pkt_timeout));
	mutex_enter(&taskp->task_mutex);
	/* Could happen for retried commands */
	if (taskp->task_flags & BNXEF_FCOE_TASK_COMPLETED)
		taskp->task_flags &= ~BNXEF_FCOE_TASK_COMPLETED;

	taskp->task_flags |= (BNXEF_FCOE_TASK_ELS |
				BNXEF_FCOE_TASK_TIMER_ARMED);
	taskp->timerhdl = tid;
	mutex_exit(&taskp->task_mutex);
	if (sesp != NULL) {
		/*
		 * There is already a session established. Include the task
		 * into session task list
		 */
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Session identified 0x%p, Task ID 0x%x flags 0x%x sess state 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, sesp, taskp->x_id,
			taskp->task_flags, sesp->state);
		bnxef_task_session_list_add(sesp, taskp);
	} else {
		BNXEF_DEBUG(dsp, GENERAL, -1,
			"%s%d: Session Identified to be NULL",
			BNXEF_DRIVER_NAME, dsp->instance);
	}
	if (pktp->pkt_cmdlen > 0) {
		taskp->orig_payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
		ASSERT(taskp->orig_payloadp != NULL);
	}
	mutex_enter(&taskp->task_mutex);
	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC;
		taskp->payloadsz = pktp->pkt_cmdlen;
	}
	mutex_exit(&taskp->task_mutex);

	/* Copy the original Data */
	bcopy(pktp->pkt_cmd, taskp->orig_payloadp, pktp->pkt_cmdlen);

	/* Get the ELS code for analysis from pkt_cmd field. */
	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)&els,
		(uint8_t *)pktp->pkt_cmd, sizeof (els), DDI_DEV_AUTOINCR);
	BNXEF_DEBUG(dsp, ELS, portp->id,
		"%s%d: ELS Code 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, els.ls_code);
	global_pktp = pktp;
	global_elsp = &els;
	given_d_id = d_id;
	switch (els.ls_code) {
	case LA_ELS_PLOGI:
		rval = bnxef_plogi_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_FLOGI:
		rval = bnxef_flogi_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_FDISC:
		rval = bnxef_fdisc_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_PRLI:
		rval = bnxef_prli_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_RLS:
		rval = bnxef_rls_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_ADISC:
		rval = bnxef_adisc_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_LOGO:
		rval = bnxef_logo_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_RNID:
		rval = bnxef_els_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_SCN:
		/* There is no response for this ELS. */
		rval = bnxef_els_tx_handler_noresp(portp, sesp, pktp,
			BNXEF_USE_OX_ID);
		break;
	case LA_ELS_SCR:
		rval = bnxef_scr_tx_handler(portp, sesp, pktp);
		break;
	case LA_ELS_RJT:
		rval = bnxef_ls_rjt_tx_handler(portp, sesp, pktp,
			BNXEF_USE_RX_ID);
		break;
	case LA_ELS_ACC:
		rval = bnxef_ls_acc_tx_handler(portp, sesp, pktp,
			BNXEF_USE_RX_ID);
		break;
	default:
		/*
		 * We have to look into fca_tran_flags to call pkt_comp
		 * routine.
		 */
		/*
		 * The following is the workaround for stupid endian issue
		 * with LV stack.
		 */
		bnxef_big_endian(&els, 4);
#if !(defined(__S11) || defined(__S12))
		unsolbufp = bnxef_find_non_rel_unsol_buf(portp,
			pktp->pkt_cmd_fhdr.ox_id, pktp->pkt_cmd_fhdr.d_id);
		BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: unsol_ls_acc:Unsolbufp identified 0x%p",
				BNXEF_DRIVER_NAME, dsp->instance, unsolbufp);
		if (unsolbufp != NULL) {
			ubp = unsolbufp->unsol_bufp;
		} else ubp = NULL;
#else
		ubp = pktp->pkt_ub_resp_token;
#endif
		if (ubp != NULL) {
			if ((els.ls_code == LA_ELS_ACC) &&
				(ubp->ub_buffer[0] == LA_ELS_ACC)) {
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Workaround for PRLO- Endian issue",
					BNXEF_DRIVER_NAME, dsp->instance);
				rval = bnxef_ls_acc_tx_handler(portp,
					sesp, pktp, BNXEF_USE_RX_ID);
				break;
			}
		}
		/* Revert back to original endianness */
		bnxef_big_endian(&els, 4);

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unkown ELS requested to be sent code 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, els.ls_code);

		bzero(&rjt, sizeof (rjt));
		rjt.ls_code.ls_code = LA_ELS_RJT;
		rjt.reason = FC_REASON_CMD_UNSUPPORTED;
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
			(uint8_t *)pktp->pkt_resp, sizeof (rjt),
				DDI_DEV_AUTOINCR);
		pktp->pkt_state = FC_PKT_LOCAL_RJT;
		pktp->pkt_reason = FC_REASON_UNSUPPORTED;
		rval = FC_SUCCESS;
		break;
	}

	BNXEF_STATS(dsp, els_dispatched);

	return (rval);
}


/*
 * This handles the request to send out FLOGI using this port handle.
 * In our driver, we already get the ID from the chip by sending the
 * FIP FLOGI, therefore here we need to fake completion with the ID already
 * received and mimicing the logi information already sent by the switch.
 * This routine does not send any frame out on the wire as this functionality
 * is completed as part of the FIP state machine/bind port call.
 */
static int
bnxef_flogi_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	int ret;
	la_els_logi_t *loginp;
	svc_param_t *class3_param;
	bnxef_fcoe_task_t *taskp;
	timeout_id_t	tid;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	/* This is the first frame therefore should be NULL */
	// ASSERT(sessionp == NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: FLOGI TX handler called",
		BNXEF_DRIVER_NAME, dsp->instance);
	mutex_enter(&portp->port_mutex);
	if ((portp->flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
		(portp->flags & BNXEF_FC_PORT_SOL_BOUND)) {
		if (pktp->pkt_cmd_fhdr.d_id != FS_FABRIC_F_PORT) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Sending LS RJT, not for correct port",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Given ID 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				pktp->pkt_cmd_fhdr.d_id);
			mutex_exit(&portp->port_mutex);

			mutex_enter(&taskp->task_mutex);

			tid = taskp->timerhdl;
			mutex_exit(&taskp->task_mutex);
			if (sessionp != NULL)
				bnxef_task_session_list_remove(sessionp, taskp);
			untimeout(tid);
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_LOGICAL_ERR,
				FC_PKT_LOCAL_RJT, FC_REASON_ILLEGAL_REQ);
			ASSERT(ret == BNXEF_SUCCESS);
			return (FC_SUCCESS);
		}

		pktp->pkt_resp_fhdr.d_id = portp->id;
		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d: Response sent for id %d",
			BNXEF_DRIVER_NAME, dsp->instance, portp->id);

		/*
		 * Now just massage the fcf_logi_info received so that
		 * LV will understand it
		 */
		loginp = &portp->fcf_logi_info;
		loginp->common_service.fcph_version =
			htons(loginp->common_service.fcph_version);
		loginp->common_service.btob_credit =
			htons(loginp->common_service.btob_credit);
		loginp->common_service.cmn_features =
			htons(loginp->common_service.cmn_features);
		loginp->common_service.conc_sequences =
			htons(loginp->common_service.conc_sequences);
		loginp->common_service.relative_offset =
			htons(loginp->common_service.relative_offset);
		loginp->common_service.e_d_tov =
				htonl(loginp->common_service.e_d_tov);
		loginp->common_service.rx_bufsize  =
			htonl(loginp->common_service.rx_bufsize);
		class3_param = (svc_param_t *)&loginp->class_3;
		class3_param->class_opt = htons(class3_param->class_opt);

		/* Copy the LS_ACC received from FCF as is */
		ddi_rep_put8(pktp->pkt_resp_acc,
			(uint8_t *)&portp->fcf_logi_info,
			(uint8_t *)pktp->pkt_resp,
			sizeof (la_els_logi_t), DDI_DEV_AUTOINCR);
		pktp->pkt_state = FC_PKT_SUCCESS;
		pktp->pkt_reason = 0;
		pktp->pkt_action = pktp->pkt_expln = 0;
		pktp->pkt_resp_resid = 0;
		pktp->pkt_data_resid = 0;
		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d:Returning Success with Pkt flags %x",
			BNXEF_DRIVER_NAME, dsp->instance,
			pktp->pkt_tran_flags);
		mutex_exit(&portp->port_mutex);
		mutex_enter(&taskp->task_mutex);
		taskp->task_flags |= BNXEF_FCOE_TASK_COMPLETED;
		tid = taskp->timerhdl;
		mutex_exit(&taskp->task_mutex);
		untimeout(tid);
		if (sessionp != NULL)
			bnxef_task_session_list_remove(sessionp, taskp);
		if (pktp->pkt_tran_flags & FC_TRAN_INTR) {
			if (pktp->pkt_comp)
				pktp->pkt_comp(pktp);
		}
		return (FC_SUCCESS);
	} else  {
		mutex_exit(&portp->port_mutex);
		mutex_enter(&taskp->task_mutex);
		tid = taskp->timerhdl;
		mutex_exit(&taskp->task_mutex);
		if (sessionp != NULL)
			bnxef_task_session_list_remove(sessionp, taskp);
		untimeout(tid);
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,
			FC_PKT_LOCAL_RJT, 0);
		ASSERT(ret == BNXEF_SUCCESS);
		return (FC_SUCCESS);
	}
}

/*
 * The following routine handles FDISC transport if apporpritate.
 * This validates whether FDISC has been sent to Fabric controller or not
 * to decide how it need to handle this request.
 */
static int
bnxef_fdisc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	uint32_t flags;
	int ret = FC_UNBOUND;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&portp->port_mutex);
	flags  = portp->flags;
	mutex_exit(&portp->port_mutex);

	if ((flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
		(flags & BNXEF_FC_PORT_SOL_BOUND)) {
		if (pktp->pkt_cmd_fhdr.d_id != FS_FABRIC_F_PORT) {
			/*
			 * Check whether session is vaild and whether it is
			 * offloaded or not.
			 */
			ASSERT(sessionp != NULL);
			if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
				/*
				 * Now we have to Transmit FDISC using
				 * offloaded session.
				 */
				bnxef_els_tx_ofld_session(portp,
						sessionp, pktp);
				ret = FC_SUCCESS;
			} else { /* Non offloaded path follows */
				/*
				 * Session is not offloaded
				 * Send via L2 interface
				 */
				ret = bnxef_els_tx_nonofld_session(portp,
					sessionp, pktp);
				if (ret != FC_SUCCESS) {
					ret = bnxef_build_ls_rjt(&rjt, pktp,
					BNXEF_LA_RJT_UNABLE_TO_PERFORM,
						FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
				}
			}
		} else {  /* sent to fabric controller */
			ASSERT(sessionp == NULL);
			/*
			 * In this case we have already acquired ID
			 * This should be an VN_PORT
			 */
			ASSERT((portp->flags & BNXEF_FC_PORT_VN_PORT) ==
				BNXEF_FC_PORT_VN_PORT);

			mutex_enter(&portp->port_mutex);
			pktp->pkt_resp_fhdr.d_id = portp->id;
			mutex_exit(&portp->port_mutex);

			/* Copy the LS_ACC received from FCF as is */
			ddi_rep_put8(pktp->pkt_resp_acc,
				(uint8_t *)&portp->fcf_logi_info,
				(uint8_t *)pktp->pkt_resp,
				sizeof (la_els_logi_t),
				DDI_DEV_AUTOINCR);
			pktp->pkt_state = FC_PKT_SUCCESS;
			pktp->pkt_reason = 0;
			pktp->pkt_action = pktp->pkt_expln = 0;
			if (pktp->pkt_tran_flags & FC_TRAN_INTR) {
				if (pktp->pkt_comp)
					pktp->pkt_comp(pktp);
			}

			ret = FC_SUCCESS;
		}
	} /* Solaris Bound check */

	return (ret);
}
/*
 * This will send the FC frame but will not wait for any response. Examples are
 * LS_ACC/LS_RJT for unsolicited frames. There are exchanges which does not
 * expect any response as well, those exchanges will go through this, example
 * SCN, TEST etc..
 */

void
bnxef_els_tx_ofld_session_noresp(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags)
{
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t	*taskp;

	ASSERT(portp != NULL);
	ASSERT(sessionp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;

	/* Update the pkt_cmdfhdr with this x_id allocated for this exchange */
	if ((flags & BNXEF_USE_OX_ID) == BNXEF_USE_OX_ID) {
		pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
		pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	} else
		pktp->pkt_cmd_fhdr.rx_id = taskp->x_id;


	/* intialise the task with appropriate entries for transmission */
	bnxef_init_mp_task(sessionp, pktp);

	/* Now add the task XID to the send Q */
	bnxef_add_2_sq(sessionp, taskp->x_id);

	/* Now ring the door bell register appropriately */
	bnxef_ring_doorbell(sessionp);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= (BNXEF_FCOE_TASK_COMPLETED |
				BNXEF_FCOE_TASK_OFFLOADED);
	mutex_exit(&taskp->task_mutex);
#if 0
	/* Set the  pkt_state and pkt_reason etc.. */
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	pktp->pkt_action = pktp->pkt_expln = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);
#endif

}

/*
 * This will send the FDISC ELS request on an offloaded connection using
 * firmware Send Q.
 */
static void
bnxef_els_tx_ofld_session(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{

	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t	*taskp;

	ASSERT(portp != NULL);
	ASSERT(sessionp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp->pktp != NULL);
	ASSERT(taskp->pktp == pktp);

	BNXEF_DEBUG(dsp, ELS, portp->id,
		"%s%d: Transporting ELS Via firmware for Task Id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	/* intialise the task with appropriate entries for transmission */
	bnxef_init_mp_task(sessionp, pktp);

	/* Now add the task XID to the send Q */
	bnxef_add_2_sq(sessionp, taskp->x_id);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= (BNXEF_FCOE_SUBMITTED_TO_FIRMWARE |
				BNXEF_FCOE_TASK_OFFLOADED);
	mutex_exit(&taskp->task_mutex);

	/* Now ring the door bell register appropriately */
	bnxef_ring_doorbell(sessionp);

	if (pktp->pkt_tran_flags & FC_TRAN_NO_INTR) {
		/* Complete this exchange initiated in polled mode */
		bnxef_start_polling(dsp);
		mutex_enter(&taskp->task_mutex);
		/* Now wait for your event to show up */
		cv_wait(&taskp->task_cv, &taskp->task_mutex);
		/* If it wakes up */
		mutex_exit(&taskp->task_mutex);
		bnxef_stop_polling(dsp);
	}
}

/*
 * This will send the ELS frame without expecting any response.
 */
/* ARGSUSED1 */
int
bnxef_els_tx_nonofld_session_noresp(bnxef_port_t *portp,
		bnxef_session_t *sessionp, fc_packet_t *pktp, int flags)
{
	bnxef_driver_state_t *dsp;
	mblk_t		*mblkp;
	bnxef_fcoe_task_t *taskp = NULL;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	/* Get the task pointer */
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;


	/* Prepare the Mblk for transporting using L2 services */
	mblkp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
	if (mblkp == NULL) {
		return (FC_TRANSPORT_ERROR);
	}

	/* Transmit the Mblk prepared */
	if (!bnxef_send_frame(dsp, mblkp, portp->fcf->vlan_id)) {
		return (FC_TRANSPORT_ERROR);
	}
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: no response frame for sent out",
		BNXEF_DRIVER_NAME, dsp->instance);

	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fcoe_tx);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= (BNXEF_FCOE_TASK_COMPLETED);
	mutex_exit(&taskp->task_mutex);

#if 0
	/* Set the  pkt_state and pkt_reason etc.. */
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	pktp->pkt_action = pktp->pkt_expln = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);
#endif


	return (FC_SUCCESS);
}
/*
 * This will handle ELS transmission for non offloaded session
 */
/* ARGSUSED1 */
static int
bnxef_els_tx_nonofld_session(bnxef_port_t *portp, bnxef_session_t *sessionp,
				fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	mblk_t		*mblkp;
	bnxef_fcoe_task_t *taskp = NULL;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	/* Get the task pointer */
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;

#if 0
	/* Update the pkt_cmdfhdr with this OX_id allocated for this exchange */
	mutex_enter(&taskp->task_mutex);
	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	mutex_exit(&taskp->task_mutex);
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
#endif

	/* Prepare the Mblk for transporting using L2 services */
	mblkp = bnxef_prepare_fcoe_mblk_from_pkt(dsp, portp, pktp);
	if (mblkp == NULL) {
		return (FC_TRANSPORT_ERROR);
	}


	/* Transmit the Mblk prepared */
	if (!bnxef_send_frame(dsp, mblkp, portp->fcf->vlan_id)) {
		return (FC_TRANSPORT_ERROR);
	}

	BNXEF_STATS(dsp, l2_tx);
	BNXEF_STATS(dsp, l2_fcoe_tx);
	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_SUBMITTED_TO_FIRMWARE;
	mutex_exit(&taskp->task_mutex);
	/*
	 * The assumption is when the LS_ACC or LS_RJT comes for this
	 * handler of such frame will set all the status for return to
	 * higher level layer in the packet structure.
	 */
	if (pktp->pkt_tran_flags & FC_TRAN_NO_INTR) {
		/* Complete this exchange initiated in polled mode */
		bnxef_start_polling(dsp);
		mutex_enter(&taskp->task_mutex);
		/* Now wait for your event to show up */
		cv_wait(&taskp->task_cv, &taskp->task_mutex);
		/* If it wakes up */
		mutex_exit(&taskp->task_mutex);
		bnxef_stop_polling(dsp);
	}

	return (FC_SUCCESS);
}


/* ARGSUSED1 */
static int
bnxef_unsol_prli_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	uint8_t *fhdrp;
	uint8_t  *payloadp;
	typedef struct __bnxef_prli_service_params__ {
		uint8_t type;
		uint8_t reserved;
		uint16_t  flags;
		uint32_t   opa;
		uint32_t   rpa;
		uint32_t   serv_params;
	} prli_service_params_t;
	prli_service_params_t  *prlisvp;
	fc_frame_hdr_t *fp;
	uint8_t		*prlisvcp;


	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	fhdrp = taskp->frame_hdrp;
	payloadp = taskp->payloadp;
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, fhdrp,
		sizeof (fc_frame_hdr_t));
	/* LINTED: alignment */
	fp = (fc_frame_hdr_t *)fhdrp;

	if (fp->r_ctl == R_CTL_ELS_REQ)
		fp->r_ctl = R_CTL_ELS_RSP;
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: PRLI LS_ACC The OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, fp->ox_id, fp->rx_id);
	bnxef_big_endian(fhdrp, sizeof (fc_frame_hdr_t));

	ddi_rep_get8(pktp->pkt_cmd_acc, payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(payloadp, 4); /* First 4 bytes swap it */
	/* LINTED: alignment */
	prlisvp = (prli_service_params_t *)(payloadp + 4);
	prlisvcp = (uint8_t *)prlisvp;
	/* Image pair established is set */
	prlisvp->flags = htons(prlisvp->flags);
	/* Image Pair established is set */
	prlisvcp[2] |= 0x1;
	prlisvp->opa = htonl(prlisvp->opa);
	prlisvp->rpa = htonl(prlisvp->rpa);
	/* Hard coded value as we respond to Unsol PRLI */
	prlisvp->serv_params = htonl(0x01A2);

	return (BNXEF_SUCCESS);

}

static int
bnxef_unsol_adisc_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	uint8_t *fhdrp;
	la_els_adisc_t  *payloadp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	fhdrp = taskp->frame_hdrp;
	/* LINTED: alignment */
	payloadp = (la_els_adisc_t *)taskp->payloadp;
	mutex_exit(&taskp->task_mutex);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: UNsol ADISC handling, copying frame",
		BNXEF_DRIVER_NAME, dsp->instance);
	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, fhdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(fhdrp, sizeof (fc_frame_hdr_t));

	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian((uint8_t *)payloadp, 4);
	bnxef_big_endian((uint8_t *)&payloadp->nport_id, 4);

	if (sessionp != NULL) {
		if ((sessionp->state & BNXEF_SESSION_OFFLOADED) &&
			(sessionp->state & BNXEF_SESSION_ENABLED)) {
			bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		}
	}

	return (BNXEF_SUCCESS);
}

/*ARGSUSED*/
static int
bnxef_unsol_prlo_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	uint8_t *fhdrp;
	uint8_t  *payloadp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	fhdrp = taskp->frame_hdrp;
	payloadp = taskp->payloadp;
	mutex_exit(&taskp->task_mutex);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: UNsol PRLO handling, copying frame and payload as is",
		BNXEF_DRIVER_NAME, dsp->instance);
	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, fhdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(fhdrp, sizeof (fc_frame_hdr_t));

	ddi_rep_get8(pktp->pkt_cmd_acc, payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	return (BNXEF_SUCCESS);
}


/* ARGSUSED1 */
static int
bnxef_unsol_rscn_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	uint8_t *fhdrp;
	uint8_t  *payloadp;
	fc_frame_hdr_t *fp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	fhdrp = taskp->frame_hdrp;
	payloadp = taskp->payloadp;
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, fhdrp,
		sizeof (fc_frame_hdr_t));
	/* LINTED: alignment */
	fp = (fc_frame_hdr_t *)fhdrp;

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: RSCN LS_ACC The OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, fp->ox_id, fp->rx_id);


	bnxef_big_endian(fhdrp, sizeof (fc_frame_hdr_t));



	ddi_rep_get8(pktp->pkt_cmd_acc, payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(payloadp, 4); /* First 4 bytes swap it */

	if (sessionp != NULL) {
		if ((sessionp->state & BNXEF_SESSION_OFFLOADED) &&
			(sessionp->state & BNXEF_SESSION_ENABLED)) {
			bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		}
	}

	return (BNXEF_SUCCESS);
}

/* ARGSUSED1 */
static int
bnxef_unsol_logo_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{

	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	uint8_t *fhdrp;
	uint8_t  *payloadp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	fhdrp = taskp->frame_hdrp;
	payloadp = taskp->payloadp;
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, fhdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(fhdrp, sizeof (fc_frame_hdr_t));

	ddi_rep_get8(pktp->pkt_cmd_acc, payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(payloadp, 4); /* First 4 bytes swap it */
	if (sessionp != NULL) {
		if ((sessionp->state & BNXEF_SESSION_OFFLOADED) &&
			(sessionp->state & BNXEF_SESSION_ENABLED)) {
			bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		}
	}

	return (BNXEF_SUCCESS);

}

/* ARGSUSED1 */
static int
bnxef_unsol_plogi_ls_acc_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{

	bnxef_fcoe_task_t	*taskp;
	la_els_logi_t	*loginp;
	svc_param_t	*class3_param;
	la_els_logi_t	*srcloginp;
	svc_param_t	*src_class3_param;
	bnxef_driver_state_t *dsp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
	/* LINTED: alignment */
	loginp = (la_els_logi_t *)taskp->payloadp;
	/* LINTED: alignment */
	srcloginp = (la_els_logi_t *)pktp->pkt_cmd;
	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	bnxef_big_endian(loginp, 4);
	bcopy(&srcloginp->nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&srcloginp->node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(srcloginp->common_service.fcph_version);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(srcloginp->common_service.cmn_features);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);

	return (BNXEF_SUCCESS);
}

static int
bnxef_ls_rjt_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags)
{

	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	int ret = FC_UNBOUND;
	bnxef_fcoe_task_t	*taskp;
	timeout_id_t		tid;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);



	if ((portp->flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
		(portp->flags & BNXEF_FC_PORT_SOL_BOUND)) {
		/*
		 * Now allocate the buffers needed for Frame and
		 * and payload.
		 */
		taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
		ASSERT(taskp != NULL);
		taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t),
				KM_SLEEP);
		ASSERT(taskp->frame_hdrp != NULL);
		if (pktp->pkt_cmdlen > 0)
			taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen,
						KM_SLEEP);
		ASSERT(taskp->payloadp != NULL);

		mutex_enter(&taskp->task_mutex);
		taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

		if (pktp->pkt_cmdlen > 0) {
			taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		}
		taskp->task_flags |=
			(BNXEF_FCOE_TASK_UNSOLICITED_ELS |
				BNXEF_FCOE_TASK_SUBMITTED_L2);

		pktp->pkt_cmd_fhdr.rx_id = taskp->x_id;
		pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
		mutex_exit(&taskp->task_mutex);

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: ELS LS_RJT sent for ox_id 0x%x, rx_id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			pktp->pkt_cmd_fhdr.ox_id, taskp->x_id);
	}

	if (sessionp == NULL) {
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
			sessionp, pktp, flags);
		if (ret != FC_SUCCESS) {
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT,
					FC_REASON_NOMEM);
			return (ret);
		}
		/* Cancel the timer to indicate completion */
		mutex_enter(&taskp->task_mutex);
		tid = taskp->timerhdl;
		mutex_exit(&taskp->task_mutex);

		untimeout(tid);

		/* Free the task allocated */
		bnxef_end_task(dsp, pktp);

		/* Set the  pkt_state and pkt_reason etc.. */
		pktp->pkt_state = FC_PKT_SUCCESS;
		pktp->pkt_reason = 0;
		pktp->pkt_action = pktp->pkt_expln = 0;
		if (pktp->pkt_comp)
			pktp->pkt_comp(pktp);

		return (BNXEF_SUCCESS);
	}


	ASSERT(sessionp != NULL);

	/*
	 * Session is offloaded or not offloaded
	 * Send via L2 interface only.
	 */
	ret = bnxef_els_tx_nonofld_session_noresp(portp,
			sessionp, pktp, flags);
	if (ret != FC_SUCCESS) {
		bnxef_task_session_list_remove(sessionp, taskp);
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,
			FC_PKT_LOCAL_RJT,
			FC_REASON_NOMEM);
		return (ret);
	}

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags &= ~BNXEF_FCOE_TASK_UNSOLICITED_ELS;
	mutex_exit(&taskp->task_mutex);
	/*
	 * since LS ACC does not have response, We included the
	 * task in the session list. We need to remove it here.
	 */
	BNXEF_DEBUG(dsp, SCSI, -1, "%s%d Session 0x%p, taskp 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp, taskp);

	/* Remove the task from the session task list */
	bnxef_task_session_list_remove(sessionp, taskp);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
	mutex_exit(&taskp->task_mutex);

	untimeout(tid);


	/* Free the task allocated */
	bnxef_end_task(dsp, pktp);

	/* Set the  pkt_state and pkt_reason etc.. */
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	pktp->pkt_action = pktp->pkt_expln = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);


	return (ret);
}

/*
 * This will handle sending ELS on the wire without any response expected.
 */
static int
bnxef_ls_acc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags)
{
	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	int ret = FC_UNBOUND;
	bnxef_fcoe_task_t	*taskp;
	fc_unsol_buf_t		*ubp;
	timeout_id_t		tid;
#if !(defined(__S11) || defined(__S12))
	bnxef_unsol_buf_t *unsolbufp;
#endif

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	if ((portp->flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
		(portp->flags & BNXEF_FC_PORT_SOL_BOUND)) {
		/*
		 * Now allocate the buffers needed for Frame and
		 * and payload.
		 */
		taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
		ASSERT(taskp != NULL);
		taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t),
				KM_SLEEP);
		ASSERT(taskp->frame_hdrp != NULL);
		if (pktp->pkt_cmdlen > 0)
			taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen,
						KM_SLEEP);
		ASSERT(taskp->payloadp != NULL);

		mutex_enter(&taskp->task_mutex);
		taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

		if (pktp->pkt_cmdlen > 0) {
			taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		}
		taskp->task_flags |=
			(BNXEF_FCOE_TASK_UNSOLICITED_ELS |
				BNXEF_FCOE_TASK_SUBMITTED_L2);

		pktp->pkt_cmd_fhdr.rx_id = taskp->x_id;
		pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
		mutex_exit(&taskp->task_mutex);

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: ELS LS_ACC sent for ox_id 0x%x, rx_id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			pktp->pkt_cmd_fhdr.ox_id, taskp->x_id);
#if !(defined(__S11) || defined(__S12))
		unsolbufp = bnxef_find_non_rel_unsol_buf(portp,
			pktp->pkt_cmd_fhdr.ox_id, pktp->pkt_cmd_fhdr.d_id);
		BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: unsol_ls_acc:Unsolbufp identified 0x%p",
				BNXEF_DRIVER_NAME, dsp->instance, unsolbufp);
		ubp = unsolbufp->unsol_bufp;
#else

		/*
		 * Now check the Original Request and find out should we
		 * massage the data.
		 */
		ubp = pktp->pkt_ub_resp_token;
#endif
		switch (ubp->ub_buffer[0]) {
		case LA_ELS_PLOGI:
			bnxef_unsol_plogi_ls_acc_handler(portp, sessionp, pktp);
			break;
		case LA_ELS_PRLI:
			bnxef_unsol_prli_ls_acc_handler(portp, sessionp, pktp);
			break;
		case LA_ELS_LOGO:
			bnxef_unsol_logo_ls_acc_handler(portp, sessionp, pktp);
			break;
		case LA_ELS_RSCN:
			bnxef_unsol_rscn_ls_acc_handler(portp, sessionp, pktp);
			break;
		case LA_ELS_ACC:
		case LA_ELS_PRLO:
			/* PRLO handler at fp driver causes this craziness */
			bnxef_unsol_prlo_ls_acc_handler(portp, sessionp, pktp);
			break;
		case LA_ELS_ADISC:
			bnxef_unsol_adisc_ls_acc_handler(portp, sessionp, pktp);
			break;
		default:
			ASSERT(0);
			break;
		}

		if (((sessionp == NULL) &&
			(ubp->ub_buffer[0] == LA_ELS_RSCN) &&
			((taskp->task_flags &
			BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP) == 0)) ||
			((ubp->ub_buffer[0] == LA_ELS_PLOGI) &&
			(taskp->task_flags &
				BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP) == 0)) {
			uint32_t  flags;
			fc_frame_hdr_t *framep;
			uint8_t *payloadp, *origpayloadp;
			uint32_t payloadsz;

			BNXEF_STATS(dsp, rscn_acc_lv_tx);

			/* Cancel the timer to indicate completion */
			mutex_enter(&taskp->task_mutex);
			tid = taskp->timerhdl;
			flags = taskp->task_flags;
			/* LINTED: alignment */
			framep = (fc_frame_hdr_t *)taskp->frame_hdrp;
			payloadp = taskp->payloadp;
			payloadsz = taskp->payloadsz;
			origpayloadp = taskp->orig_payloadp;
			taskp->payloadsz = 0;
			mutex_exit(&taskp->task_mutex);
			if ((ubp->ub_buffer[0] == LA_ELS_PLOGI) &&
				(sessionp != NULL)) {
				if (sessionp != taskp->sessionp) {
					if ((taskp->task_flags &
					    BNXEF_FCOE_TASK_ALLOCATED) == 0) {
						/*
						 * if the task is
						 * already cleaned up
						 * do nothing.
						 */
						return (BNXEF_SUCCESS);
					}
				}

				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);
			}


			untimeout(tid);

			bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
			if (flags & BNXEF_FCOE_TASK_FRAME_HDR_ALLOC) {
				kmem_free(framep, sizeof (fc_frame_hdr_t));
			}

			if (flags & BNXEF_FCOE_TASK_PAYLOAD_ALLOC) {
				kmem_free(payloadp, payloadsz);
			}

			if (flags & BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC) {
				kmem_free(origpayloadp, payloadsz);
			}

			mutex_enter(&taskp->task_mutex);
			if (flags & BNXEF_FCOE_TASK_FRAME_HDR_ALLOC) {
				taskp->task_flags &=
					~BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;
			}
			if (flags & BNXEF_FCOE_TASK_PAYLOAD_ALLOC) {
				taskp->task_flags &=
					~BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
			}
			if (flags & BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC) {
				taskp->task_flags &=
					~BNXEF_FCOE_TASK_ORIG_PAYLOAD_ALLOC;
			}
			mutex_exit(&taskp->task_mutex);

			return (BNXEF_SUCCESS);
		}



		/*
		 * For LOGO does not require a session to be established
		 * therefore send whatever the upper layer wants us to do
		 */
		if (((sessionp == NULL) &&
			(ubp->ub_buffer[0] == LA_ELS_PRLI)) ||
			((sessionp == NULL) &&
			(ubp->ub_buffer[0] == LA_ELS_LOGO)) ||
			((sessionp == NULL) &&
			(ubp->ub_buffer[0] == LA_ELS_PRLO)) ||
			((sessionp == NULL) &&
				(ubp->ub_buffer[0] == LA_ELS_RSCN) &&
				(taskp->task_flags &
				BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP))) {
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Going the Path Session is NULL",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, rscn_acc_tx);
			ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, flags);
			if (ret != FC_SUCCESS) {
				ret = bnxef_build_ls_rjt(&rjt, pktp,
					BNXEF_LA_RJT_UNABLE_TO_PERFORM,
					FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
			}
			/* Cancel the timer to indicate completion */
			mutex_enter(&taskp->task_mutex);
			tid = taskp->timerhdl;
			mutex_exit(&taskp->task_mutex);

			untimeout(tid);

			/* Free the task allocated */
			bnxef_end_task(dsp, pktp);

			/* Set the  pkt_state and pkt_reason etc.. */
			pktp->pkt_state = FC_PKT_SUCCESS;
			pktp->pkt_reason = 0;
			pktp->pkt_action = pktp->pkt_expln = 0;
			if (pktp->pkt_comp)
				pktp->pkt_comp(pktp);

			return (BNXEF_SUCCESS);
		}



		if (((sessionp == NULL) && (taskp->task_flags &
				BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP)) ||
			((sessionp == NULL) &&
			(pktp->pkt_cmd_fhdr.d_id >= NPORT_ID_DOM_CTLR_START) &&
			(pktp->pkt_cmd_fhdr.d_id < NPORT_ID_DOM_CTLR_END))) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: D_ID to which this LS_ACC sent 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				pktp->pkt_cmd_fhdr.d_id);
			ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, flags);
			if (ret != FC_SUCCESS) {
				ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
			}
			/* Cancel the timer to indicate completion */
			mutex_enter(&taskp->task_mutex);
			tid = taskp->timerhdl;
			mutex_exit(&taskp->task_mutex);

			untimeout(tid);

			/* Free the task structure */
			bnxef_end_task(dsp, pktp);

			/* Set the  pkt_state and pkt_reason etc.. */
			pktp->pkt_state = FC_PKT_SUCCESS;
			pktp->pkt_reason = 0;
			pktp->pkt_action = pktp->pkt_expln = 0;
			if (pktp->pkt_comp)
				pktp->pkt_comp(pktp);

			return (BNXEF_SUCCESS);
		}

		ASSERT(sessionp != NULL);
#if 0
		/*
		 * Check whether session is vaild and whether it is
		 * offloaded or not.
		 */
		if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
			/*
			 * Now we have to Transmit ELS using
			 * offloaded session.
			 */
			bnxef_els_tx_ofld_session_noresp(portp,
				sessionp, pktp, flags);
			ret = FC_SUCCESS;

		} else { /* Non offloaded path follows */
#endif
			/*
			 * Session is not offloaded
			 * Send via L2 interface
			 */
			ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, flags);
			if (ret != FC_SUCCESS) {
				bnxef_task_session_list_remove(sessionp, taskp);
				ret = bnxef_build_ls_rjt(&rjt, pktp,
					BNXEF_LA_RJT_UNABLE_TO_PERFORM,
					FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
			}
#if 0
		}
#endif
	}

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags &= ~BNXEF_FCOE_TASK_UNSOLICITED_ELS;
	mutex_exit(&taskp->task_mutex);
	/*
	 * since LS ACC does not have response, We included the
	 * task in the session list. We need to remove it here.
	 */
	BNXEF_DEBUG(dsp, SCSI, -1, "%s%d Session 0x%p, taskp 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp, taskp);

	/* Remove the task from the session task list */
	bnxef_task_session_list_remove(sessionp, taskp);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
	mutex_exit(&taskp->task_mutex);

	untimeout(tid);


#if 0
	/* Now that we have sent the LS_ACC for LOGO go cleanup the session */
	if (ubp->ub_buffer[0] == LA_ELS_LOGO) {
		if (sessionp != NULL) {
			/* Means we have got a LOGO over existing connection */
			bnxef_session_cleanup(sessionp);
		}
	}
#endif
	/* Free the task allocated */
	bnxef_end_task(dsp, pktp);

	/* Set the  pkt_state and pkt_reason etc.. */
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	pktp->pkt_action = pktp->pkt_expln = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);


	return (ret);
}

/*
 * This will handle sending ELS on the wire without any response expected.
 */
static int
bnxef_els_tx_handler_noresp(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp, uint32_t flags)
{
	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	int ret = FC_UNBOUND;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	if ((flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
		(flags & BNXEF_FC_PORT_SOL_BOUND)) {
		/*
		 * Check whether session is vaild and whether it is
		 * offloaded or not.
		 */
		ASSERT(sessionp != NULL);
		if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
			/*
			 * Now we have to Transmit ELS using
			 * offloaded session.
			 */
			bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, flags);
			ret = FC_SUCCESS;
		} else { /* Non offloaded path follows */
			/*
			 * Session is not offloaded
			 * Send via L2 interface
			 */
			ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, flags);
			if (ret != FC_SUCCESS) {
				ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
			}
		}
	}

	/* Set the  pkt_state and pkt_reason etc.. */
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	pktp->pkt_action = pktp->pkt_expln = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);

	return (ret);
}

/*
 * The following handles sending the  ELS out on the wire.
 */
static int
bnxef_els_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
		fc_packet_t *pktp)
{
	bnxef_driver_state_t *dsp;
	la_els_rjt_t  rjt;
	uint32_t flags;
	int ret = FC_UNBOUND;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&portp->port_mutex);
	flags  = portp->flags;
	mutex_exit(&portp->port_mutex);

	if ((flags & BNXEF_FC_PORT_ID_ACQUIRED) &&
			(flags & BNXEF_FC_PORT_SOL_BOUND)) {
		/*
		 * Check whether session is vaild and whether it is
		 * offloaded or not.
		 */
		ASSERT(sessionp != NULL);
		if (sessionp->state & BNXEF_SESSION_OFFLOADED) {
			/*
			 * Now we have to Transmit FDISC using
			 * offloaded session.
			 */
			bnxef_els_tx_ofld_session(portp, sessionp, pktp);
			ret = FC_SUCCESS;
		} else { /* Non offloaded path follows */
			/*
			 * Session is not offloaded
			 * Send via L2 interface
			 */
			ret = bnxef_els_tx_nonofld_session(portp,
				sessionp, pktp);
			if (ret != FC_SUCCESS) {
				ret = bnxef_build_ls_rjt(&rjt, pktp,
				    BNXEF_LA_RJT_UNABLE_TO_PERFORM,
					FC_PKT_LOCAL_RJT,
						FC_REASON_NOMEM);
					return (ret);
			}
		}
	}
	return (ret);
}

static int
bnxef_prli_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t	*dsp;
	int ret;
	bnxef_fcoe_task_t	*taskp;
	la_els_rjt_t rjt;
	timeout_id_t		tid;
	la_els_prli_t		prli_info, *prli_infop;
	uint8_t sec_state;

	typedef struct __bnxef_prli_service_params__ {
		uint8_t type;
		uint8_t reserved;
		uint16_t  flags;
		uint32_t   opa;
		uint32_t   rpa;
		uint32_t   serv_params;
	} prli_service_params_t;
	prli_service_params_t  *prlisvp;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	mutex_exit(&taskp->task_mutex);

	if (sessionp == NULL)  {
		untimeout(tid);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to process- No connection",
			BNXEF_DRIVER_NAME, dsp->instance);
		ret = bnxef_build_ls_rjt(&rjt, pktp, FC_REASON_CMD_UNABLE,
			FC_PKT_LS_RJT, FC_REASON_LOGICAL_ERROR);
		return (FC_SUCCESS);
	} else {
		/* If already offloaded something is logically wrong */
		if ((sessionp->state &  BNXEF_SESSION_OFFLOADED) &&
			(sessionp->state & BNXEF_SESSION_ENABLED)) {
			untimeout(tid);
			bnxef_task_session_list_remove(sessionp, taskp);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"PRLI LS_ACC sent for task id 0x%x",
					taskp->x_id);
			prli_info.ls_code = 0x02;
			prli_info.page_length = 0x16;
			prli_info.payload_length = 0x14;
			prli_infop = &prli_info;

			/* LINTED: alignment */
			prlisvp = (prli_service_params_t *)
				((uint8_t *)prli_infop + 4);
			prlisvp->type = 0x08;
			prlisvp->reserved = 0x00;
			prlisvp->flags = 0x2100;
			prlisvp->opa = 0;
			prlisvp->rpa = 0;
			prlisvp->serv_params = 0x192;

			bnxef_build_ls_acc((ls_code_t *)&prli_info, pktp,
				sizeof (la_els_prli_t));
			return (FC_SUCCESS);
		} else {
			BNXEF_DEBUG(dsp, ELS, -1, "%s%d: Sessionp 0x%p, state 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, sessionp,
				sessionp->state);
			mutex_enter(&sessionp->session_mutex);
			sec_state = sessionp->sec_state;
			mutex_exit(&sessionp->session_mutex);
			if (sec_state & BNXEF_SESSION_PRLI_INPROGRESS) {
				untimeout(tid);
				bnxef_task_session_list_remove(sessionp, taskp);
				BNXEF_DEBUG(dsp, ELS, -1, 
					"PRLI LS_ACC sent PRLI Already pending task id 0x%x",
						taskp->x_id);
				prli_info.ls_code = 0x02;
				prli_info.page_length = 0x16;
				prli_info.payload_length = 0x14;
				prli_infop = &prli_info;

				/* LINTED: alignment */
				prlisvp = (prli_service_params_t *)
					((uint8_t *)prli_infop + 4);
				prlisvp->type = 0x08;
				prlisvp->reserved = 0x00;
				prlisvp->flags = 0x2100;
				prlisvp->opa = 0;
				prlisvp->rpa = 0;
				prlisvp->serv_params = 0x192;

				bnxef_build_ls_acc((ls_code_t *)&prli_info, pktp,
					sizeof (la_els_prli_t));
				return (FC_SUCCESS);
			}
		
		}
	}


	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->num_sessions >= (dsp->bnxe_params.max_fcoe_conn)) {
		mutex_exit(&dsp->state_mutex);
		untimeout(tid);
		cmn_err(CE_NOTE,
		"%s%d: PRLI rejected because exceed max sessions allowed",
				BNXEF_DRIVER_NAME, dsp->instance);
		if (sessionp)
			bnxef_task_session_list_remove(sessionp, taskp);
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			FC_REASON_CMD_UNABLE,
			FC_PKT_LS_RJT, FC_REASON_CMD_UNABLE);
		return (FC_SUCCESS);
	}
	mutex_exit(&dsp->state_mutex);

	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));

	/* Also reverse the  payload received. */
	ddi_rep_get8(pktp->pkt_cmd_acc, taskp->payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);


	mutex_enter(&sessionp->session_mutex);
	sessionp->sec_state |= BNXEF_SESSION_PRLI_INPROGRESS;
	mutex_exit(&sessionp->session_mutex);
	/* Send PRLI out depending on the session is offloaded or not */
	if ((sessionp->state &  BNXEF_SESSION_OFFLOADED) &&
		(sessionp->state & BNXEF_SESSION_ENABLED)) {
		bnxef_big_endian(pktp->pkt_cmd, 4);
		/* LINTED: alignment */
		prlisvp = (prli_service_params_t *)
			((uint8_t *)pktp->pkt_cmd + 4);
		prlisvp->flags = htons(prlisvp->flags);
		prlisvp->opa = htonl(prlisvp->opa);
		prlisvp->rpa = htonl(prlisvp->rpa);
#if 0
		if (prlisvp->serv_params & (0x1 << 8)) {
			prlisvp->serv_params &= ~(0x1 << 8);
			/* Shutoff Retry */
		}
		if (prlisvp->serv_params & (0x1 << 7)) /* Shut off conf */
			prlisvp->serv_params &= ~(0x01 << 7);
#endif
		prlisvp->serv_params = htonl(prlisvp->serv_params);

		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d: Transporting PRLI as middle path exchange 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		(void) bnxef_els_tx_ofld_session(portp, sessionp, pktp);
		ret = FC_SUCCESS;
	} else {
		bnxef_big_endian(taskp->payloadp, 4);

		prlisvp =
			/* LINTED : alignment */
		    (prli_service_params_t *)((uint8_t *)taskp->payloadp + 4);
		prlisvp->flags = htons(prlisvp->flags);
		prlisvp->opa = htonl(prlisvp->opa);
		prlisvp->rpa = htonl(prlisvp->rpa);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Serv params for PRLI 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, prlisvp->serv_params);
#if 0
		if (prlisvp->serv_params & (0x1 << 8)) {
			prlisvp->serv_params &= ~(0x1 << 8);
			/* Shutoff Retry */
		}
		if (prlisvp->serv_params & (0x1 << 7)) /* Shut off conf */
			prlisvp->serv_params &= ~(0x01 << 7);
#endif
		prlisvp->serv_params = htonl(prlisvp->serv_params);

		/*
		 * The PRLI will be sent out on wire using non-offloaded path if
		 * The session is no offloaded
		 */
		ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
		if (ret != FC_SUCCESS) {
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
			mutex_enter(&sessionp->session_mutex);
			sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
			mutex_exit(&sessionp->session_mutex);
			return (ret);
		}
	}
	return (ret);
}

static int
bnxef_adisc_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t	*dsp;
	int ret;
	bnxef_fcoe_task_t	*taskp;
	la_els_rjt_t rjt;
	timeout_id_t		tid;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);
#if 0
	mutex_enter(&sessionp->session_mutex);
	sess_state = sessionp->state;
	mutex_exit(&sessionp->session_mutex);
	if (sess_state & BNXEF_SESSION_LPORT_SHUTDOWN_COMPLETE) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Shutdown Complete and ADISC came in ",
			BNXEF_DRIVER_NAME, dsp->instance);
		bzero(&rjt, sizeof (rjt));
		rjt.ls_code.ls_code = LA_ELS_RJT;
		rjt.reason = FC_REASON_CMD_UNABLE;
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
			(uint8_t *)pktp->pkt_resp, sizeof (rjt),
				DDI_DEV_AUTOINCR);
		pktp->pkt_resp_resid = 0;
		pktp->pkt_state = FC_PKT_LS_RJT;
		pktp->pkt_reason = FC_REASON_CMD_UNABLE;

		/* Remove the task from the session task list */
		bnxef_task_session_list_remove(sessionp, taskp);

		mutex_enter(&taskp->task_mutex);
		tid = taskp->timerhdl;
		taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);

		mutex_enter(&sessionp->session_mutex);
		sessionp->state &= ~BNXEF_SESSION_LPORT_SHUTDOWN_COMPLETE;
		mutex_exit(&sessionp->session_mutex);
		untimeout(tid);
		if (pktp->pkt_comp) {
			pktp->pkt_comp(pktp);
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Completed ADISC processing",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (FC_SUCCESS);
	}
#endif

	if (sessionp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Shutdown Complete and ADISC came in ",
			BNXEF_DRIVER_NAME, dsp->instance);
		bzero(&rjt, sizeof (rjt));
		rjt.ls_code.ls_code = LA_ELS_RJT;
		rjt.reason = FC_REASON_CMD_UNABLE;
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
			(uint8_t *)pktp->pkt_resp, sizeof (rjt),
				DDI_DEV_AUTOINCR);
		pktp->pkt_resp_resid = 0;
		pktp->pkt_state = FC_PKT_LS_RJT;
		pktp->pkt_reason = FC_REASON_CMD_UNABLE;


		if (sessionp)
			bnxef_task_session_list_remove(sessionp, taskp);

		mutex_enter(&taskp->task_mutex);
		tid = taskp->timerhdl;
		taskp->task_flags &= ~BNXEF_FCOE_TASK_TIMER_ARMED;
		mutex_exit(&taskp->task_mutex);

		untimeout(tid);
		if (pktp->pkt_comp) {
			pktp->pkt_comp(pktp);
		}
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Completed ADISC processing for task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		return (FC_SUCCESS);
	}

	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		// taskp->payloadsz = pktp->pkt_cmdlen;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));

	/* Also reverse the  payload received. */
	ddi_rep_get8(pktp->pkt_cmd_acc, taskp->payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(taskp->payloadp, 8);
	bnxef_big_endian(((uint8_t *)taskp->payloadp + 24), 4);

	/* Send ADISC out depending on the session is offloaded or not */
	if ((sessionp->state &  BNXEF_SESSION_OFFLOADED) &&
		(sessionp->state & BNXEF_SESSION_ENABLED)) {
		bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d: Transporting RLS as middle path exchange 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		(void) bnxef_els_tx_ofld_session(portp, sessionp, pktp);
		ret = FC_SUCCESS;
	} else {
		ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
		if (ret != FC_SUCCESS) {
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
			return (ret);
		}
	}
	return (ret);
}

static int
bnxef_logo_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t	*dsp;
	int ret;
	bnxef_fcoe_task_t	*taskp;
	la_els_rjt_t rjt;
	timeout_id_t  tid;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	if (sessionp == NULL) {
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			FC_REASON_CMD_UNABLE,
			FC_PKT_LS_RJT, FC_REASON_CMD_UNABLE);
		return (FC_SUCCESS);
	}


	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);
	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);
	if (pktp->pkt_cmd_fhdr.d_id == 0xfffffe) {
		mutex_enter(&portp->port_mutex);
		portp->flags |= BNXEF_FC_PORT_LOGO_TO_FABRIC_CTLR;
		mutex_exit(&portp->port_mutex);

		mutex_enter(&taskp->task_mutex);
		tid = taskp->timerhdl;
		mutex_exit(&taskp->task_mutex);
		untimeout(tid);
		if (sessionp)
			bnxef_task_session_list_remove(sessionp, taskp);
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			FC_REASON_CMD_UNABLE,
			FC_PKT_LS_RJT, FC_REASON_CMD_UNABLE);
		return (FC_SUCCESS);
	}

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));

	/* Also reverse the  payload received. */
	ddi_rep_get8(pktp->pkt_cmd_acc, taskp->payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	/* leave the last 8 bytes as it is the WWN name */
	bnxef_big_endian(taskp->payloadp, pktp->pkt_cmdlen-8);

	/* The RLS will always be sent out on wire using offloaded path */
	if ((sessionp->state &  BNXEF_SESSION_OFFLOADED) &&
		(sessionp->state & BNXEF_SESSION_ENABLED)) {
		bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		taskp->payloadsz = pktp->pkt_cmdlen;
		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d: Transporting RLS as middle path exchange 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		(void) bnxef_els_tx_ofld_session(portp, sessionp, pktp);
		ret = FC_SUCCESS;
	} else {
		ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
		if (ret != FC_SUCCESS) {
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
			return (ret);
		}
	}
	return (ret);
}



static int
bnxef_rls_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{
	bnxef_driver_state_t	*dsp;
	int ret;
	bnxef_fcoe_task_t	*taskp;
	la_els_rjt_t rjt;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);
	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		// taskp->payloadsz = pktp->pkt_cmdlen;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));

	/* Also reverse the  payload received. */
	ddi_rep_get8(pktp->pkt_cmd_acc, taskp->payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(taskp->payloadp, pktp->pkt_cmdlen);

	/* The RLS will always be sent out on wire using offloaded path */
	if ((sessionp->state &  BNXEF_SESSION_OFFLOADED) &&
		(sessionp->state & BNXEF_SESSION_ENABLED)) {
		bcopy(taskp->payloadp, pktp->pkt_cmd, pktp->pkt_cmdlen);
		BNXEF_DEBUG(dsp, ELS, portp->id,
			"%s%d: Transporting RLS as middle path exchange 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		(void) bnxef_els_tx_ofld_session(portp, sessionp, pktp);
		ret = FC_SUCCESS;
	} else {
		ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
		if (ret != FC_SUCCESS) {
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
			return (ret);
		}
	}
	return (ret);


}

static int
bnxef_scr_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	fc_packet_t *pktp)
{

	bnxef_driver_state_t	*dsp;
	int ret;
	bnxef_fcoe_task_t	*taskp;
	la_els_rjt_t rjt;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);
	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		// taskp->payloadsz = pktp->pkt_cmdlen;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));

	/* Also reverse the  payload received. */
	ddi_rep_get8(pktp->pkt_cmd_acc, taskp->payloadp,
		(uint8_t *)pktp->pkt_cmd, pktp->pkt_cmdlen, DDI_DEV_AUTOINCR);

	bnxef_big_endian(taskp->payloadp, pktp->pkt_cmdlen);

	/* The SCR will always be sent out on wire using non-offloaded path */
	ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
	if (ret != FC_SUCCESS) {
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,
			FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
		return (ret);
	}
	return (ret);
}



/*
 * The following handles sending the PLOGI ELS out on the wire.
 */
static int
bnxef_plogi_tx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
			fc_packet_t *pktp)
{
	int ret;
	la_els_rjt_t rjt;
	bnxef_fcoe_task_t	*taskp;
	la_els_logi_t	*loginp;
	svc_param_t	*class3_param;
	la_els_logi_t	*srcloginp;
	svc_param_t	*src_class3_param;
	bnxef_driver_state_t *dsp;
	timeout_id_t	tid;

	ASSERT(portp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	BNXEF_DEBUG(dsp, ERROR, -1,
	"%s%d: Plogi Sent from 0x%x, to 0%x using task 0x%x",
	BNXEF_DRIVER_NAME, dsp->instance, pktp->pkt_cmd_fhdr.s_id,
	pktp->pkt_cmd_fhdr.d_id, taskp->x_id);

	mutex_enter(&taskp->task_mutex);
	tid = taskp->timerhdl;
	mutex_exit(&taskp->task_mutex);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->num_sessions >= (dsp->bnxe_params.max_fcoe_conn)) {
		mutex_exit(&dsp->state_mutex);
		untimeout(tid);
		cmn_err(CE_NOTE,
		"%s%d: PLOGI Rejected because exceeds max sessions",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (sessionp)
			bnxef_task_session_list_remove(sessionp, taskp);
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			FC_REASON_CMD_UNABLE,
			FC_PKT_LS_RJT, FC_REASON_CMD_UNABLE);
		return (FC_SUCCESS);
	}
	mutex_exit(&dsp->state_mutex);

	/*
	 * This sesssion does not exists and therefore a session needed to be
	 * be allocated when the PLOGI is accepted.
	 * If a session already exists, then  it means there is a PLOGI sent
	 * over PLOGI, which means we have to implicit logout first and then
	 * send the PLOGI out for a new connection.
	 */
	if (sessionp) {
		bnxef_task_session_list_remove(sessionp, taskp);
		delay(BNXEF_SEC2TICK(2));
		/* call implicit logout handler on that session */
		ret = bnxef_implicit_logout_handler(portp, sessionp);
		if (ret != BNXEF_SUCCESS) {
			/*
			 * Implicit logout failed- send reject for PLOGI Req
			 * Indicate that the port is unable to perform this req
			 */
			ret = bnxef_build_ls_rjt(&rjt, pktp,
				BNXEF_LA_RJT_UNABLE_TO_PERFORM,
				FC_PKT_LOCAL_RJT, FC_REASON_CMD_UNABLE);
			return (ret);
		}
	} else  {
		ASSERT(sessionp == NULL);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Sessionp Is NULL task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	}

	/*
	 * Since we have to massage data to convert even payload appropriately.
	 * we allocate temp buffers.
	 */
	taskp = (bnxef_fcoe_task_t *)pktp-> pkt_fca_private;
	ASSERT(taskp != NULL);
	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;
	/* PLOGI is the one establishing session */
	taskp->tq_params.sessp = NULL;
	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
		//	taskp->payloadsz = pktp->pkt_cmdlen;
	}

	pktp->pkt_cmd_fhdr.ox_id = taskp->x_id;
	pktp->pkt_cmd_fhdr.rx_id = 0xffff;
	pktp->pkt_cmd_fhdr.f_ctl |= F_CTL_END_SEQ; /* Not set in LV */
	mutex_exit(&taskp->task_mutex);

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
		sizeof (fc_frame_hdr_t));
	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
	/* LINTED: alignment */
	loginp = (la_els_logi_t *)taskp->payloadp;
	/* LINTED: alignment */
	srcloginp = (la_els_logi_t *)pktp->pkt_cmd;
	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	bnxef_big_endian(loginp, 4);
	bcopy(&portp->plogi_info.nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&portp->plogi_info.node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(0x2020);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(0x8000);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);



	/* The PLOGI will always be sent out on wire using non-offloaded path */
	ret = bnxef_els_tx_nonofld_session(portp, sessionp, pktp);
	if (ret != FC_SUCCESS) {
		ret = bnxef_build_ls_rjt(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,
			FC_PKT_LOCAL_RJT, FC_REASON_NOMEM);
		return (ret);
	}
	return (ret);
}

/*
 * This will start the polling by requesting the poll routine to be
 * called by the task queue.
 */
int
bnxef_start_polling(bnxef_driver_state_t *dsp)
{
	int curcnt = 0;
	int ret;
	dev_info_t *pdip;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);


	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if ((dsp->poll_ref_cnt == 0) && (ddi_in_panic())) {
		mutex_exit(&dsp->state_mutex);
		dsp->callbacks.prvCtl(pdip, PRV_CTL_DISABLE_INTR, NULL, 0);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	}
	curcnt = dsp->poll_ref_cnt++;
	mutex_exit(&dsp->state_mutex);

	if (curcnt == 0) {
		ret = ddi_taskq_dispatch(dsp->tq, bnxef_poll, (void *)dsp,
				DDI_SLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, GENERAL, -1,
				"%s%d: Unable to start polling\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
	}

	return (BNXEF_SUCCESS);
}

/*
 * This will stop the polling when the reference count becomes zero.
 */
void
bnxef_stop_polling(bnxef_driver_state_t *dsp)
{

	ASSERT(dsp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	dsp->poll_ref_cnt--;
	mutex_exit(&dsp->state_mutex);
}

void
bnxef_complete_polling(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{

	volatile uint32_t task_flags;

	mutex_enter(&taskp->task_mutex);
	task_flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);
	while (task_flags & BNXEF_FCOE_TASK_ALLOCATED) {
		bnxef_session_cq_handler(sessionp);
		mutex_enter(&taskp->task_mutex);
		task_flags = taskp->task_flags;
		mutex_exit(&taskp->task_mutex);
	}

}

/*
 * This will poll for the results.
 */
void
bnxef_poll(void  * arg)
{
	bnxef_driver_state_t *dsp = (bnxef_driver_state_t *)arg;
	volatile int ref_cnt = 0;
	dev_info_t *pdip;

	ASSERT(dsp != NULL);

	pdip = ddi_get_parent(dsp->dip);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	ref_cnt = dsp->poll_ref_cnt;
	mutex_exit(&dsp->state_mutex);
	while (ref_cnt > 0) {
		(void) dsp->callbacks.prvPoll(pdip);

		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		ref_cnt = (volatile int) dsp->poll_ref_cnt;
		mutex_exit(&dsp->state_mutex);
	}

}

static int
bnxef_build_ls_acc(ls_code_t *acc, fc_packet_t *pktp, uint32_t size)
{

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)acc,
	(uint8_t *)pktp->pkt_resp, size,
		DDI_DEV_AUTOINCR);
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
#if 0
	pktp->pkt_state = FC_PKT_SUCCESS;
	pktp->pkt_reason = 0;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);
#endif


	return (FC_SUCCESS);
}

/*
 * This will create the LS RJT with appropriate reason code, it will
 * also set the pkt state and pkt_reason codes provided.
 */
static int
bnxef_build_ls_rjt(la_els_rjt_t *rjt, fc_packet_t *pktp, uint8_t reason,
	uint32_t pkt_state, uint32_t pkt_reason)
{

	ASSERT(rjt != NULL);
	ASSERT(pktp != NULL);

	bzero(rjt, sizeof (la_els_rjt_t));
	rjt->ls_code.ls_code = LA_ELS_RJT;
	rjt->reason = reason;

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)rjt,
	(uint8_t *)pktp->pkt_resp, sizeof (rjt),
		DDI_DEV_AUTOINCR);

	bnxef_complete_pkt(pktp, pkt_state, 0, pkt_reason, 0);

#if 0
	pktp->pkt_state = pkt_state;
	pktp->pkt_reason = pkt_reason;
	if (pktp->pkt_comp)
		pktp->pkt_comp(pktp);
#endif


	return (FC_SUCCESS);
}

mblk_t  *
bnxef_prepare_fcoe_mblk_from_pkt(bnxef_driver_state_t *dsp,
	bnxef_port_t *portp, fc_packet_t *pktp)
{
	mblk_t  *ethervlanfcoe;
	int size = 0;
	struct ether_header *ep;
	fcoe_pdu_hdr_t *fcoep;
	int 	payloadflag = 0;
	bnxef_fcoe_task_t *taskp;
	uint32_t	crc, payldsz;
	uint8_t *framehdrp, *payldp;

	ASSERT(pktp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	if (taskp == NULL) {
		return (NULL);
	}


	mutex_enter(&taskp->task_mutex);
	mpfree.free_func = bnxef_mblk_free;
	mpfree.free_arg =  NULL;
	framehdrp = taskp->frame_hdrp;
	payldp = taskp->payloadp;
	payldsz = taskp->payloadsz;
	mutex_exit(&taskp->task_mutex);


	size = sizeof (struct ether_header) +
		sizeof (fcoe_pdu_hdr_t) +
		sizeof (fc_frame_hdr_t) +
		payldsz + 8;

	ethervlanfcoe = allocb(size, 0);
	if (ethervlanfcoe == NULL) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to allocate ethernet headers\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (NULL);
	}
	memset((uint8_t *)ethervlanfcoe->b_wptr, 0, size);

	/* LINTED: alignment */
	ep = (struct ether_header *)ethervlanfcoe->b_wptr;
	fcoep = (fcoe_pdu_hdr_t *)(ep +1);

	/* Now fill in the information for each header */
	bcopy(portp->mac_addr, ep->ether_shost.ether_addr_octet, ETHERADDRL);
	bcopy(portp->fcf->fcoe_mac_addr, ep->ether_dhost.ether_addr_octet,
			ETHERADDRL);
	ep->ether_type = htons(ETHERTYPE_FCOE);

	fcoep->version = 0;

	// ASSERT(pktp->pkt_tran_flags & FC_TRAN_CLASS3);

	fcoep->sof = SOFi3;
	ethervlanfcoe->b_wptr += (sizeof (struct ether_header) +
				sizeof (fcoe_pdu_hdr_t));

	bcopy((uint8_t *)framehdrp, ethervlanfcoe->b_wptr,
		sizeof (fc_frame_hdr_t));
	ethervlanfcoe->b_wptr += sizeof (fc_frame_hdr_t);

	if (pktp->pkt_cmdlen > 0) {
		bcopy(payldp, ethervlanfcoe->b_wptr,
			payldsz);
		ethervlanfcoe->b_wptr += payldsz;
	}

	if (pktp->pkt_cmdlen > 0)  {
		payloadflag++;
	}

	crc = ~bnxef_compute_crc32(ethervlanfcoe, payloadflag);
	*(ethervlanfcoe->b_wptr) =  0xFF & crc;
	*(ethervlanfcoe->b_wptr+1) = 0xFF & (crc >> 8);
	*(ethervlanfcoe->b_wptr+2) = 0xFF & (crc >> 16);
	*(ethervlanfcoe->b_wptr+3) = 0xFF & (crc >> 24);
	*(uint8_t *)(ethervlanfcoe->b_wptr + 4) = EOFt;
	ethervlanfcoe->b_wptr += 8;
	return (ethervlanfcoe);
}


#if 0
/*
 * This will prepare a chain of mblk_t structure to put the frame together
 * for sending it to the destination.
 */
mblk_t  *
bnxef_prepare_fcoe_mblk_from_pkt(bnxef_driver_state_t *dsp,
	bnxef_port_t *portp, fc_packet_t *pktp)
{
	mblk_t  *ethervlanfcoe;
	mblk_t  *fchdrp;
	mblk_t  *payloadp;
	mblk_t  *eofcrc;
	int size = 0;
	struct ether_header *ep;
	fcoe_pdu_hdr_t *fcoep;
	int 	payloadflag = 0;
	bnxef_fcoe_task_t *taskp;
	uint32_t	crc, payldsz;
	uint8_t *framehdrp, *payldp;

	ASSERT(pktp != NULL);
	ASSERT(dsp != NULL);
	ASSERT(portp != NULL);

	size = sizeof (struct ether_header) +
		sizeof (fcoe_pdu_hdr_t);

	ethervlanfcoe = allocb(size, 0);
	if (ethervlanfcoe == NULL) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to allocate ethernet headers\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (NULL);
	}
	memset((uint8_t *)ethervlanfcoe->b_wptr, 0, size);
	cmn_err(CE_NOTE, "ethervlanfcoe mblk ptr 0x%p",
		ethervlanfcoe);
	delay(BNXEF_SEC2TICK(2));

	/* LINTED: alignment */
	ep = (struct ether_header *)ethervlanfcoe->b_wptr;
	fcoep = (fcoe_pdu_hdr_t *)(ep +1);

	/* Now fill in the information for each header */
	bcopy(portp->mac_addr, ep->ether_shost.ether_addr_octet, ETHERADDRL);
	bcopy(portp->fcf->mac_addr, ep->ether_dhost.ether_addr_octet,
			ETHERADDRL);
	ep->ether_type = htons(ETHERTYPE_FCOE);

	fcoep->version = 0;

	// ASSERT(pktp->pkt_tran_flags & FC_TRAN_CLASS3);

	fcoep->sof = SOFi3;
	ethervlanfcoe->b_wptr += size;

	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	mutex_enter(&taskp->task_mutex);
	mpfree.free_func = bnxef_mblk_free;
	mpfree.free_arg =  NULL;
	framehdrp = taskp->frame_hdrp;
	payldp = taskp->payloadp;
	payldsz = taskp->payloadsz;
	mutex_exit(&taskp->task_mutex);
	fchdrp = esballoc((uchar_t *)framehdrp,
			sizeof (fc_frame_hdr_t), 0, &mpfree);
	if (fchdrp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to allocate FC header\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		freeb(ethervlanfcoe);
		return (NULL);
	}

	cmn_err(CE_NOTE, "FC Header pointer 0x%p", fchdrp);
	ethervlanfcoe->b_cont = (struct msgb *)fchdrp;
	fchdrp->b_wptr += sizeof (fc_frame_hdr_t);
	if (pktp->pkt_cmdlen > 0) {
		/* Now allocate the Payload structure */
		payloadp = esballoc((uint8_t *)payldp,
			payldsz, 0, &mpfree);
		if (payloadp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to allocate Plogi Payload\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			freeb(fchdrp);
			freeb(ethervlanfcoe);
			return (NULL);
		}

		fchdrp->b_cont = (struct msgb *)payloadp;
		payloadp->b_wptr += payldsz;
	}

	/* Now allocate the CRC and EOF area */
	eofcrc =  allocb(8, 0);
	if (eofcrc == NULL) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to allocate CRC EOF trailer\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (payloadp)
			freeb(payloadp);
		freeb(fchdrp);
		freeb(ethervlanfcoe);
		return (NULL);
	}
	memset((uint8_t *)eofcrc->b_wptr, 0, 8);
	if (pktp->pkt_cmdlen > 0)  {
		payloadp->b_cont = eofcrc;
		payloadflag++;
	} else {
		fchdrp->b_cont = eofcrc;
	}

	crc = ~bnxef_compute_crc32(ethervlanfcoe, payloadflag);
	*(eofcrc->b_wptr) =  0xFF & crc;
	*(eofcrc->b_wptr+1) = 0xFF & (crc >> 8);
	*(eofcrc->b_wptr+2) = 0xFF & (crc >> 16);
	*(eofcrc->b_wptr+3) = 0xFF & (crc >> 24);
	*(uint8_t *)(eofcrc->b_wptr + 4) = EOFt;
	eofcrc->b_wptr += 8;
	return (ethervlanfcoe);
}
#endif

/*
 * This uses the already defined solaris CRC32 macros, please refer sys/crc32.h
 * THE FC CRC is computed using the FC header and payload and this does not
 * include the SOF and EOF. Therefore, the middle two mblk of the mblk chain
 * passed need to be used for computation of CRC32.
 */
/* ARGSUSED1 */
static uint32_t
bnxef_compute_crc32(mblk_t *mp, int flags)
{

	uint32_t	crc;
	uint32_t size = 0;
	uint8_t *bufstartptr;
	uint8_t *bufendptr;

	ASSERT(mp != NULL);

	/* This mblk contains the the FC header */
	bufstartptr = mp->b_rptr +
		sizeof (struct ether_header) +
		sizeof (fcoe_pdu_hdr_t);
	bufendptr = mp->b_wptr;

	crc = 0xFFFFFFFF; /* ~0; */
	size = bufendptr - bufstartptr;

	CRC32(crc, bufstartptr, size, -1U, crc32_table);

	return (crc);
}


#if 0
/*
 * This uses the already defined solaris CRC32 macros, please refer sys/crc32.h
 * THE FC CRC is computed using the FC header and payload and this does not
 * include the SOF and EOF. Therefore, the middle two mblk of the mblk chain
 * passed need to be used for computation of CRC32.
 */
static uint32_t
bnxef_compute_crc32(mblk_t *mp, int flags)
{

	uint32_t	crc;
	uint32_t	interim_crc;
	uint32_t size = 0;
	mblk_t *nextmp = NULL;

	ASSERT(mp != NULL);

	/* This mblk contains the the FC header */
	nextmp = mp->b_cont;
	ASSERT(nextmp != NULL);
	crc = 0xFFFFFFFF; /* ~0; */
	size = nextmp->b_wptr - nextmp->b_rptr;
	CRC32(interim_crc, nextmp->b_rptr, size, -1U, crc32_table);

	if (flags) {
		/* THis mblk contains the payload */
		nextmp = nextmp->b_cont;
		ASSERT(nextmp != NULL);
		size = nextmp->b_wptr - nextmp->b_rptr;
		CRC32(crc, nextmp->b_rptr, size, interim_crc, crc32_table);
	} else
		crc = interim_crc;

	return (crc);
}
#endif




/*
 * The following code is the ELS rx handlers.
 */
/*
 * This is the main receive handler from the l2.
 * The mblk pointer provided could be a bunch of mblks, so process them
 * one at a time.
 */
boolean_t
bnxef_l2_rx(dev_info_t *dip, mblk_t *mp)
{
	bnxef_tq_params_t *tqp;
	bnxef_driver_state_t *dsp;
	int instance, ret;

	instance = ddi_get_instance(dip);
	dsp = ddi_get_soft_state(bnxef_state, instance);
	ASSERT(dsp != NULL);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_DETACH_IN_PROGRESS) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (B_TRUE);
	}
	mutex_exit(&dsp->state_mutex);

	tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
	if (tqp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to allocate Task Queue params",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (B_FALSE);
	}
	ASSERT(tqp != NULL);

	tqp->reserved1 = (uint64_t)dip;
	tqp->mp	= mp;
	tqp->dsp = dsp;

	ret = ddi_taskq_dispatch(dsp->tq, bnxef_l2_rx_handler, (void *)tqp,
				DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (B_FALSE);
	}

	return (B_TRUE);
}

void
bnxef_l2_rx_handler(void *arg)
{
	bnxef_tq_params_t *tqp = (bnxef_tq_params_t *)arg;
	dev_info_t *dip;
	mblk_t *mp;
	bnxef_fcoe_frame_t *fp;
	mblk_t *tmp, *pmp;
	int unknown = 0;
	bnxef_driver_state_t *dsp;

	ASSERT(tqp != NULL);

	dip = (dev_info_t *)tqp->reserved1;
	mp = tqp->mp;
	dsp = tqp->dsp;

	ASSERT(dip != NULL);
	ASSERT(mp != NULL);
	ASSERT(dsp != NULL);

	/* Free the task Queue params structure allocated */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	tmp = mp;
	do {
	pmp = tmp;
	tmp = tmp->b_next;
	pmp->b_next = NULL;
	pmp->b_prev = NULL;
	/* LINTED: alignment */
	fp = (bnxef_fcoe_frame_t *)pmp->b_rptr;
	ASSERT(pmp->b_cont == NULL);
	BNXEF_STATS(dsp, l2_rx);

	if (ntohs(fp->ether.ether_type) == ETHERTYPE_VLAN) {
		BNXEF_DEBUG(dsp, ELS, -1,
			"%s%d: Ether Type received 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			ntohs(fp->vlan.ether_type));
		if (ntohs(fp->vlan.ether_type) == FIP_ETHERTYPE)
			bnxef_fip_rx_handler(dip, pmp, 1);
		else  if (ntohs(fp->vlan.ether_type) == ETHERTYPE_FCOE)
			bnxef_fcoe_rx_handler(dip, pmp, 1);
		else
			unknown ++;
	} else if (ntohs(fp->ether.ether_type) == FIP_ETHERTYPE) {
		bnxef_fip_rx_handler(dip, pmp, 0);
	} else if (ntohs(fp->ether.ether_type) == ETHERTYPE_FCOE) {
		bnxef_fcoe_rx_handler(dip, pmp, 0);
	} else unknown++;
	if (unknown) {
		BNXEF_STATS(dsp, l2_unknown_rx);
		BNXEF_STATS(dsp, l2_rx_free);
		BNXEF_STATS(dsp, l2_unknown_rx_free);
		freemsg(pmp);
		unknown = 0;
	}
	} while (tmp != NULL);
}


/*
 * This handles the given message block with one full ethernet frame
 * after the complete handling is done, one should free this msg blk.
 */
static void
bnxef_fcoe_rx_handler(dev_info_t *dip, mblk_t *mp, int flags)
{
	bnxef_driver_state_t *dsp;
	bnxef_port_t *portp;
	bnxef_session_t *sessionp;
	bnxef_fcoe_task_t *taskp;
	fcoe_trailer_t   *fcoetrailp;
	int instance;
	uint8_t		*fcoe_framep;
	uint32_t	fcoe_frame_length;
	uint32_t crc, rxcrc = 0, size;
	bnxef_fcoe_frame_t *fcoep;
	bnxef_fcoe_novlan_frame_t *fcoenovlanp;
	fc_frame_hdr_t *fcp;
	struct ether_header *etherp;
	struct ether_vlan_extinfo *vlanp;
	// uint8_t	*payloadp;
	uint32_t *crcptr;
	struct ether_vlan_extinfo f_vlan;

	ASSERT(dip != NULL);
	ASSERT(mp != NULL);

	instance = ddi_get_instance(dip);
	dsp = ddi_get_soft_state(bnxef_state, instance);
	ASSERT(dsp != NULL);

	BNXEF_STATS(dsp, l2_fcoe_rx);

	fcoe_frame_length = (mp->b_wptr - mp->b_rptr);
	fcoe_framep = kmem_zalloc(fcoe_frame_length, KM_NOSLEEP);
	if (fcoe_framep == NULL) {
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return;
	}

	memcpy(fcoe_framep, mp->b_rptr, fcoe_frame_length);
	if (flags) {
		/* LINTED: alignment */
		fcoep = (bnxef_fcoe_frame_t *)fcoe_framep;
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoep->desc;
		// payloadp = (uint8_t *)(fcp + 1);
		if (!((fcoep->pdu.sof == SOFi3) || (fcoep->pdu.sof == SOFn3))) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Wrong SOF, Dropping packet",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoe_framep, fcoe_frame_length);
			freemsg(mp);
			return;
		}
	} else {
		/* LINTED: alignment */
		fcoenovlanp = (bnxef_fcoe_novlan_frame_t *)fcoe_framep;
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoenovlanp->desc;
		// payloadp = (uint8_t *)(fcp + 1);
		if (!((fcoenovlanp->pdu.sof == SOFi3) ||
			(fcoenovlanp->pdu.sof == SOFn3))) {
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Wrong SOF, Dropping packet",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoe_framep, fcoe_frame_length);
			freemsg(mp);
			return;
		}
	}


	fcoetrailp = (fcoe_trailer_t *)
			((uint8_t *)fcoe_framep + fcoe_frame_length  - 4);
	if (!(fcoetrailp->eof == EOFt)) {
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Wrong EOF, Dropping packet",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoe_framep, fcoe_frame_length);
		freemsg(mp);
		return;
	}

	/* Check the CRC before you pass the frames for onward processing */
	size = (fcoe_framep + fcoe_frame_length-8) - (uint8_t *)fcp;
	CRC32(crc, (uint8_t *)(fcp), size, -1U,  crc32_table);
	/* LINTED: alignment */
	crcptr = (uint32_t *)(((uint8_t *)fcoetrailp) - 4);
	rxcrc = htonl(*crcptr);
#if 0
	rxcrc |=  *((uint8_t *)crcptr);
	rxcrc |=  (*((uint8_t *)crcptr +1) << 8);
	rxcrc |=  (*((uint8_t *)crcptr +2) << 16);
	rxcrc |=  (*((uint8_t *)crcptr +3) << 24);
#endif


	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: CRC 0x%x  Rx CRC 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, LE_32(~crc), rxcrc);
	if (BSWAP_32(~crc) != rxcrc) {
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: CRC Wrong, Dropping Frame",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoe_framep, fcoe_frame_length);
		freemsg(mp);
		return;
	}

	bnxef_big_endian(fcp, sizeof (fc_frame_hdr_t));
	etherp = &fcoep->ether;
	if (flags)
		vlanp = &fcoep->vlan;
	else {
		vlanp = &f_vlan;
		vlanp->ether_tci = 0;
	}
	/*
	 * Now get the port structure and identify the session to which the
	 * received frame belongs.
	 */
	portp = bnxef_port_list_find_id(dsp,
			etherp->ether_dhost.ether_addr_octet,
			VLAN_ID(htons(vlanp->ether_tci)), fcp->d_id);
	if (portp == NULL) {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d:FCoE Frame received for unknown FC port - Ignoring\n",
		    BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoe_framep, fcoe_frame_length);
		freemsg(mp);
		return;
	}

	ASSERT(portp != NULL);

	/* Now identify the session to which this ELS belongs */
	sessionp = bnxef_session_find_remote_port(portp,
		VLAN_ID(htons(vlanp->ether_tci)), fcp->s_id,
		etherp->ether_shost.ether_addr_octet);
	if (sessionp == NULL) {
		/* Could be a unsolicited PLOGI Frame */
		BNXEF_DEBUG(dsp, GENERAL, portp->id,
			"%s%d: Unsolicited  FC frame received, possibly PLOGI",
			BNXEF_DRIVER_NAME, dsp->instance);
	}


	/* Now identify the task to which it belongs */
	if (((fcp->f_ctl & F_CTL_XCHG_CONTEXT) == 0) &&
		((fcp->f_ctl & F_CTL_SEQ_CONTEXT) == 0) &&
		((fcp->f_ctl & F_CTL_FIRST_SEQ) == F_CTL_FIRST_SEQ)) {
		taskp = NULL; /* There will not be task already allocated */
	} else if (((fcp->f_ctl & F_CTL_XCHG_CONTEXT) == 0) &&
		((fcp->f_ctl & F_CTL_SEQ_CONTEXT) == 0) &&
		((fcp->f_ctl & F_CTL_END_SEQ) == F_CTL_END_SEQ)) {
		taskp = NULL;
	} else {
		if (((fcp->f_ctl & F_CTL_LAST_SEQ) == 0) ||
			((fcp->f_ctl & F_CTL_END_SEQ) == 0) ||
			(fcp->seq_cnt != 0)) {
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Invalid fctl 0x%x or Sequence Count 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->f_ctl,
			fcp->seq_cnt);
			kmem_free(fcoe_framep, fcoe_frame_length);
			freemsg(mp);
			return;
		}

		if (((int16_t)fcp->ox_id >= 0) &&
			(fcp->ox_id < dsp->max_exchanges)) {
			taskp = dsp->taskarray[fcp->ox_id];
			ASSERT(taskp != NULL);
			BNXEF_DEBUG(dsp, ELS, -1,
				"%s%d: Frame received for X_ID 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance, fcp->ox_id);
			if ((taskp->task_flags &
				BNXEF_FCOE_TASK_ALLOCATED) == 0) {
				BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Frame dropped as task Completed 0x%x, flags 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				taskp->x_id, taskp->task_flags);

				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoe_framep, fcoe_frame_length);
				freemsg(mp);
				return;
			}
		} else  {
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Task Id out of range 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				fcp->ox_id);
			kmem_free(fcoe_framep, fcoe_frame_length);
			freemsg(mp);
			return;
		}

	}
	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Fcp type of Received frame 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, fcp->type);

	if (fcp->type == FC_TYPE_EXTENDED_LS) {
		bnxef_els_rx_handler(portp, sessionp, taskp, fcoep,
			fcoe_frame_length, flags);
		freemsg(mp);
		return;
	} else if (fcp->type == FC_TYPE_FC_SERVICES) {
		bnxef_fcct_rx_handler(portp, sessionp, taskp,  mp, flags);
	} else if (fcp->type == FC_TYPE_SCSI_FCP) {
		bnxef_scsi_rx_handler(portp, sessionp, taskp, mp, flags);
	} else if (fcp->type == FC_TYPE_BASIC_LS) {
		bnxef_bls_rx_handler(portp, sessionp, taskp, mp, flags);
	} else
		cmn_err(CE_PANIC, "%s%d: Unknown FC type\n",
			BNXEF_DRIVER_NAME, dsp->instance);
	kmem_free(fcoe_framep, fcoe_frame_length);
}

/*
 * We donot expect any SCSI/FCP frames via L2 interface, it should not come
 * if it comes ignore and move on.
 */
/*ARGSUSED*/
static int
bnxef_scsi_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, mblk_t *mp, int flags)
{

	bnxef_driver_state_t *dsp;

	ASSERT(portp != NULL);
	dsp = portp->statep;
	ASSERT(dsp != NULL);

	NOTE(ARGUNUSED(sessionp, taskp))
	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	freemsg(mp);
	return (BNXEF_SUCCESS);

}
/*
 * THis handles the BLS frames received on the l2 interface.
 */
static int
bnxef_bls_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, mblk_t *mp, int flags)
{
	bnxef_fcoe_frame_t *fcoep;
	fc_frame_hdr_t *fcp;
	bnxef_driver_state_t *dsp;
	fc_packet_t *pktp;
	int ret;
	bnxef_fcoe_novlan_frame_t *fcoenovlanp;

	ASSERT(portp != NULL);
	ASSERT(mp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	if (sessionp == NULL) {
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		freemsg(mp);
		return (BNXEF_SUCCESS);
	}

	if (taskp != NULL) {
		pktp = taskp->pktp;
		ASSERT(pktp != NULL);
	}
	if (flags) {
		/* LINTED: alignment */
		fcoep = (bnxef_fcoe_frame_t *)mp->b_rptr;
		ASSERT(fcoep != NULL);
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoep->desc;
		ASSERT(fcp != NULL);
	} else {
		/* LINTED: alignment */
		fcoenovlanp = (bnxef_fcoe_novlan_frame_t *)mp->b_rptr;
		ASSERT(fcoenovlanp != NULL);
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoenovlanp->desc;
		ASSERT(fcp != NULL);
	}
	bnxef_big_endian(fcp, sizeof (fc_frame_hdr_t));

	switch (fcp->r_ctl) {
	case R_CTL_LS_ABTS:
		/* If you receive an unsolicited ABTS */
		if (taskp == NULL) {
			la_ba_rjt_t payload;

			payload.reserved = 0;
			payload.reason_code = FC_REASON_LOGICAL_ERROR;
			payload.explanation = FC_EXPLN_INVALID_OX_RX_ID;
			payload.vendor = 0;
			/*
			 * We have received a ABTS for unknown task
			 * send BA_RJT with Invalid OX_ID_ & RX_ID combination
			 */
			ret = bnxef_initiate_ba_rjt(sessionp,
				htons(fcp->ox_id), htons(fcp->rx_id), &payload);
			if (ret != BNXEF_SUCCESS) {
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Failed to Transmit BA RJT for ABTS",
				BNXEF_DRIVER_NAME, dsp->instance);
				return (BNXEF_FAILURE);
			}
		} else {
			ret = bnxef_initiate_ba_acc(sessionp, taskp,
				fcp->ox_id);
			if (ret != BNXEF_SUCCESS) {
				BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Failed to Transmit BA_ACC for ABTS",
				BNXEF_DRIVER_NAME, dsp->instance);
				return (BNXEF_FAILURE);
			}
		}


		break;
	case R_CTL_LS_NOP:
		break;
	case R_CTL_LS_BA_ACC:  {
		uint16_t secondary_x_id;
		uint32_t flags;
		timeout_id_t	tid;
		bnxef_tq_params_t *tqp;
		bnxef_fcoe_task_t *sectaskp;
		int ret;

		/* This will come if we have initiated an ABTS on some task */
		ASSERT(taskp != NULL);
		ASSERT(taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS);

		if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			secondary_x_id = taskp->secondary_x_id;
			sectaskp = dsp->taskarray[secondary_x_id];
			mutex_enter(&sectaskp->task_mutex);
			tid = sectaskp->timerhdl;
			flags = sectaskp->task_flags;
			mutex_exit(&sectaskp->task_mutex);
			if (flags &  BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&sectaskp->task_mutex);
				sectaskp->task_flags &=
					~BNXEF_FCOE_TASK_TIMER_ARMED;
				sectaskp->task_flags |=
					BNXEF_FCOE_TASK_COMPLETED;
				mutex_exit(&sectaskp->task_mutex);
			}
			/* Now free the secondary ID */
			bnxef_task_free(dsp, sectaskp);
		}
		/*
		 * Now make sure  you schedule a task queue routine to send
		 * RRQ for reinstating this resource for subsequent use.
		 */
		tqp = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tqp == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unble to allocate Tq params for RRQ\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return (BNXEF_FAILURE);
		}
		tqp->dsp = dsp;
		tqp->portp = portp;
		tqp->sessp = sessionp;
		tqp->taskp = taskp;
		tqp->type = BNXEF_RRQ_SEND_REQ_TYPE;

		ret = ddi_taskq_dispatch(dsp->mtq, bnxef_send_rrq, (void *)tqp,
				DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
				0, FC_REASON_ABORT_FAILED, 0);
			return (BNXEF_FAILURE);
		}

		break;
	}

	case R_CTL_LS_BA_RJT: {
		uint16_t secondary_x_id;
		uint32_t flags;
		timeout_id_t	tid;
		bnxef_fcoe_task_t *sectaskp;

		/* This will come if we have initiated an ABTS on some task */
		taskp = dsp->taskarray[fcp->ox_id];
		ASSERT(taskp != NULL);
		ASSERT(taskp->task_flags & BNXEF_FCOE_RECOVERY_IN_PROGRESS);

		if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
			secondary_x_id = taskp->secondary_x_id;
			sectaskp = dsp->taskarray[secondary_x_id];
			mutex_enter(&sectaskp->task_mutex);
			tid = sectaskp->timerhdl;
			flags = sectaskp->task_flags;
			mutex_exit(&sectaskp->task_mutex);
			if (flags &  BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&sectaskp->task_mutex);
				sectaskp->task_flags &=
					~BNXEF_FCOE_TASK_TIMER_ARMED;
				sectaskp->task_flags |=
					BNXEF_FCOE_TASK_COMPLETED;
				mutex_exit(&sectaskp->task_mutex);
			}
			kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
			/* Now free the secondary ID */
			bnxef_task_free(dsp, sectaskp);
			mutex_enter(&taskp->task_mutex);
			taskp->task_flags &= ~BNXEF_FCOE_SEC_X_ID_VALID;
			mutex_exit(&taskp->task_mutex);
		}
		bnxef_complete_pkt(pktp, FC_PKT_TRAN_ERROR,
			0, FC_REASON_ABORT_FAILED, 0);
		break;
	}
	deafult:
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unknown BLS received\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		break;
	}

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	freemsg(mp);
	return (BNXEF_SUCCESS);
}

/*
 * This handles the ELS frames received via the L2 interface
 */
static int
bnxef_els_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp,  bnxef_fcoe_frame_t *fcoep, uint32_t
	frame_length, int flags)
{
	fc_frame_hdr_t *fcp;
	ls_code_t	*elsp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_novlan_frame_t *fcoenovlanp;
	int ret;

	ASSERT(portp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	ASSERT(fcoep != NULL);
	if (flags == 0) {
		fcoenovlanp = (bnxef_fcoe_novlan_frame_t *)fcoep;
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoenovlanp->desc;
	} else  {
		/* LINTED: alignment */
		fcp = (fc_frame_hdr_t *)fcoep->desc;
	}
	ASSERT(fcp != NULL);

	elsp = (ls_code_t *)(fcp+1);
	bnxef_big_endian((uint8_t *)elsp, 4);

	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d:  ELS Received 0x%x, ox_id 0x%x, rx_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, elsp->ls_code, fcp->ox_id,
			fcp->rx_id);
	switch (elsp->ls_code) {
	case LA_ELS_ACC:
		ret = bnxef_ls_acc_rx_handler(portp, sessionp, taskp, fcoep,
			frame_length, (void*)fcp, flags);
		break;
	case LA_ELS_RJT:
		ret = bnxef_ls_rjt_rx_handler(portp, sessionp, taskp, fcoep,
				frame_length, (void *)fcp, flags);
		break;
	case LA_ELS_PLOGI: {
		bnxef_tq_params_t *tq;

		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			/* Drop the frame, cannot to anything */
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->portp = portp;
		tq->sessp = sessionp;
		tq->type = BNXEF_PLOGI_L2_RX_HANDLER;
		tq->fcp = (void *)fcp;
		tq->flags = flags;
		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_plogi_rx_handler, (void *)tq, DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (ret);
		}

		break;
	}
	case LA_ELS_PRLI: {
		bnxef_tq_params_t *tq;

		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->portp = portp;
		tq->sessp = sessionp;
		tq->fcp = (void *)fcp;
		tq->flags = flags;
		tq->type = BNXEF_PRLI_L2_RX_HANDLER;

		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_prli_rx_handler, (void *)tq, DDI_NOSLEEP);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (ret);
		}
		break;
	}

	case LA_ELS_LOGO: {
		bnxef_tq_params_t *tq;


		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->sessp = sessionp;
		tq->portp = portp;
		tq->fcp   = (void *)fcp;
		tq->flags = flags;
		tq->type = BNXEF_LOGO_L2_RX_HANDLER;
		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_logo_rx_handler, tq, DDI_NOSLEEP);
		BNXEF_DEBUG(dsp, ELS, -1, "%s%d: ELS Logo Handler Triggered",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (ret);
		}
		break;

	}
	case LA_ELS_TEST:
	case LA_ELS_FAN:
	case LA_ELS_ESTC:
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		break;

	case LA_ELS_ADISC: {
		bnxef_tq_params_t *tq;

		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->sessp = sessionp;
		tq->portp = portp;
		tq->fcp = (void *) fcp;
		tq->flags = flags;
		tq->type = BNXEF_RSCN_L2_RX_HANDLER;
		ret = ddi_taskq_dispatch(dsp->mtq,
			bnxef_adisc_rx_handler, tq, DDI_NOSLEEP);
		BNXEF_DEBUG(dsp, ELS, -1, "%s%d: ELS RSCN Handler Triggered",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
		}
		break;
	}


	case LA_ELS_RSCN: {
		bnxef_tq_params_t *tq;

		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->sessp = sessionp;
		tq->portp = portp;
		tq->fcp = (void *)fcp;
		tq->type = BNXEF_RSCN_L2_RX_HANDLER;
		tq->flags = flags;
		ret = ddi_taskq_dispatch(dsp->mtq,
			bnxef_rscn_rx_handler, tq, DDI_NOSLEEP);
		BNXEF_DEBUG(dsp, ELS, -1, "%s%d: ELS RSCN Handler Triggered",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
		}
		break;
	}

	default: {
		bnxef_tq_params_t *tq;

		tq = kmem_cache_alloc(dsp->tq_params_cache, KM_NOSLEEP);
		if (tq == NULL) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d; Unable to allocate tq params for scheduling\n",
			BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return (DDI_FAILURE);
		}

		ASSERT(tq != NULL);
		tq->dsp   = dsp;
		tq->taskp = taskp;
		tq->framep = fcoep;
		tq->frame_length = frame_length;
		tq->sessp = sessionp;
		tq->portp = (void *)portp;
		tq->fcp = (void *) fcp;
		tq->flags = flags;
		tq->type = BNXEF_UNSOL_ELS_L2_RX_HANDLER;
		ret = ddi_taskq_dispatch(dsp->tq,
			bnxef_unsol_els_l2_rx_handler, tq, DDI_NOSLEEP);
		BNXEF_DEBUG(dsp, ELS, -1, "%s%d: ELS RSCN Handler Triggered",
			BNXEF_DRIVER_NAME, dsp->instance);
		if (ret != DDI_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
		}

		break;
		}
	}

	return (BNXEF_SUCCESS);

}


void
bnxef_unsol_els_l2_rx_handler(void *arg)
{
	bnxef_tq_params_t *tqp;
	bnxef_port_t *portp;
	bnxef_session_t *sessionp;
	bnxef_fcoe_task_t *taskp;
	int ret;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_frame_t *fcoep;
	uint32_t frame_length;
	fc_frame_hdr_t *fcp;

	tqp = (bnxef_tq_params_t *)arg;

	portp = (bnxef_port_t *)tqp->portp;
	sessionp = (bnxef_session_t *)tqp->sessp;
	taskp = tqp->taskp;
	dsp = portp->statep;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	fcp = (fc_frame_hdr_t *)tqp->fcp;


	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	ret = bnxef_unsolicited_els_rx_handler(portp, sessionp, taskp, fcoep,
		frame_length, fcp);
	ASSERT(ret == FC_SUCCESS);
}


/*
 * This handles the ls accept received for an exchange originated via
 * L2 Path. For all cases these are handled in non interrupt context.
 * Therefore a task queue param structure is allocated and a task queue
 * scheduled for calling the appropriate routine.
 */
static int
bnxef_ls_acc_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, bnxef_fcoe_frame_t *fcoep, uint32_t
		frame_length, void *fp, int flags)
{
	bnxef_driver_state_t *dsp;
	fc_packet_t *pktp;
	ls_code_t sentels;
	bnxef_tq_params_t *tq;
	void (*func)(void *);
	int ret;
	timeout_id_t	tid;
	uint8_t	tid_valid = 0;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);
	pktp = taskp->pktp;

	mutex_enter(&dsp->state_mutex);
	if (dsp->physical_port_state & BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return (DDI_SUCCESS);
	}
	mutex_exit(&dsp->state_mutex);

	/* Now the task is completed, shut off the timer enabled */
	mutex_enter(&taskp->task_mutex);
	if (((taskp->task_flags & BNXEF_FCOE_TASK_ALLOCATED) == 0) ||
		(taskp->task_flags & BNXEF_FCOE_TASK_COMPLETED)) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Returing as it is alerady complete 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		mutex_exit(&taskp->task_mutex);
		/* Ignore this packet */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return (DDI_SUCCESS);
	}

	if (taskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		tid = taskp->timerhdl;
		tid_valid = 1;
	}
	taskp->task_flags &= ~ BNXEF_FCOE_TASK_TIMER_ARMED;
	tq = &taskp->tq_params;
	mutex_exit(&taskp->task_mutex);

	/* Cancel the timer */
	if (tid_valid)
		untimeout(tid);

	/* Get the ELS code for analysis from pkt_cmd field. */
	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)&sentels,
		(uint8_t *)pktp->pkt_cmd, 4,  DDI_DEV_AUTOINCR);

	tq->dsp   = dsp;
	tq->portp = portp;
	tq->taskp = taskp;
	tq->framep = fcoep;
	tq->frame_length = frame_length;
	tq->sessp = sessionp;
	tq->fcp = (void *) fp;
	tq->flags = flags;

	BNXEF_DEBUG(dsp, ELS, -1, "%s%d:Sent ELS code 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, sentels.ls_code);
	switch (sentels.ls_code) {
	case LA_ELS_PLOGI:
		func = bnxef_plogi_ls_acc_rx_handler;
		tq->type =  BNXEF_ELS_PLOGI_LS_ACC;
		break;
	case LA_ELS_PRLI:
		func = bnxef_prli_ls_acc_rx_handler;
		tq->type =  BNXEF_ELS_PRLI_LS_ACC;
		break;
	case LA_ELS_LOGO:
		func = bnxef_logo_ls_acc_rx_handler;
		tq->type =  BNXEF_ELS_LOGO_LS_ACC;
		break;
	case LA_ELS_SCR:
		func = bnxef_scr_ls_acc_rx_handler;
		tq->type = BNXEF_ELS_SCR_LS_ACC;
		break;
	case LA_ELS_ADISC:
		func = bnxef_adisc_ls_acc_rx_handler;
		tq->type = BNXEF_ELS_ADISC_LS_ACC;
		break;
	default:
		func = bnxef_els_ls_acc_rx_handler;
		tq->type =  BNXEF_ELS_LS_ACC;
		break;
	}
	ret = ddi_taskq_dispatch(dsp->tq, func, tq, DDI_NOSLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to dispatch Task queue from intr\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return (ret);
	}

	return (DDI_SUCCESS);
}


/*
 * This handles the LS ACC for an RRQ internally generated by this driver.
 */

static void
bnxef_els_ls_acc_rx_handler(void * arg)
{
	bnxef_port_t 		*portp;
	bnxef_driver_state_t 	*dsp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	uint32_t		flags;
	bnxef_fcoe_task_t	*otaskp;
	fc_packet_t		*opktp;
	bnxef_tq_params_t *tqp;
	bnxef_fcoe_frame_t	*fcoep;
	uint32_t frame_length;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	portp = tqp ->portp;
	taskp = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	pktp = taskp->pktp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;


	/* Now the task is completed, shut off the timer enabled */
	mutex_enter(&taskp->task_mutex);
	flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);

	/* Special handling for Localy generated RRQ */
	if (flags & BNXEF_FCOE_TASK_RRQ) {
		/* This was a RRQ generated for ABTS completion */
		if (flags & BNXEF_FCOE_SEC_X_ID_VALID) {

			otaskp = dsp->taskarray[taskp->secondary_x_id];
			opktp = otaskp->pktp;
			bnxef_task_session_list_remove(otaskp->sessionp,
					otaskp);

			bnxef_complete_pkt(opktp, FC_PKT_TIMEOUT, 0,
				FC_REASON_ABORTED, 0);
		}
		// bnxef_task_session_list_remove(taskp->sessionp, taskp);
		/* Free all DMA resources allocated for RRQ */
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_pkt_resp_res_free(pktp, BNXEF_PKT_RESP_ALL);
		kmem_free(pktp, sizeof (fc_packet_t));
		bnxef_task_free(dsp, taskp);
	}

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}



#if 0
/*
 * This handles the LS ACC for any ELS received
 */
void
bnxef_els_ls_acc_rx_handler(bnxef_tq_params_t *tqp)
{

	bnxef_port_t 		*portp;
	bnxef_driver_state_t 	*dsp;
	mblk_t 			*mp;
	bnxef_session_t 	*sessionp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	uint8_t			*elsrsp;
	timeout_id_t		tid;
	int 			size;

	ASSERT(tqp != NULl);
	portp = tqp ->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	mp = tqp->mp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(mp != NULL);

	dsp = taskp->statep;

	kmem_cache_free(dsp->tq_params_cache, tqp);
	ASSERT(sessionp != NULL);

	fcoep = (bnxef_fcoe_frame_t *)mp->datap->b_rptr;
	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)fcoep->desc;
	ASSERT(fcp != NULL);
	elsrsp = (uint8_t *)(fcp +1);

	/* Now the task is completed, shut off the timer enabled */
	mutex_enter(taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		tid = taskp->timerhdl;
	}
	taskp->task_flags &= ~ BNXEF_FCOE_TASK_TIMER_ARMED;
	mutex_exit(taskp->task_mutex);

	/* Cancel the timer */
	untimeout(tid);

	/* This is the FC Payload size received */
	size = (mp->b_datap->db_lim -13) - elsrsp;

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)elsrsp,
		(uint8_t *)pktp->pkt_resp, size, DDI_AUTO_INCR);

	if (sessionp != NULL) {
		/* Remove the task from session list */
		bnxef_task_session_list_remove(sessionp, taskp);
	}

	/* Now complete the pkt and return */
	ret = bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to complete the pkt for LS RJT\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	/* Free the message block */
	freemsg(mp);
}
#endif

/*
 * This handles the LS ACC received for SCR semt out.
 */

static void
bnxef_scr_ls_acc_rx_handler(void *arg)
{
	bnxef_tq_params_t	*tqp;
	bnxef_port_t 		*portp;
	bnxef_session_t 	*sessionp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	uint32_t		*ls_acc;
	bnxef_driver_state_t	*dsp;
	uint32_t frame_length;

	tqp = (bnxef_tq_params_t *)arg;

	ASSERT(tqp != NULL);
	portp = tqp->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	pktp = taskp->pktp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;

	ASSERT(dsp != NULL);

	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)tqp->fcp;
	ASSERT(fcp != NULL);
	ls_acc = (uint32_t *)(fcp + 1);

	*ls_acc = htonl(*ls_acc);

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)ls_acc,
		(uint8_t *)pktp->pkt_resp, 4, DDI_DEV_AUTOINCR);

	if (sessionp != NULL) {
		/* Remove the task from the session task list */
		bnxef_task_session_list_remove(sessionp, taskp);
	}

	/* Now complete the packet */
	pktp->pkt_resp_resid = 0;
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}


static void
bnxef_adisc_ls_acc_rx_handler(void *arg)
{
	bnxef_tq_params_t	*tqp;
	bnxef_port_t 		*portp;
	bnxef_session_t 	*sessionp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_driver_state_t	*dsp;
	la_els_adisc_t   *adiscp;
	uint32_t		frame_length;

	tqp = (bnxef_tq_params_t *)arg;

	ASSERT(tqp != NULL);
	portp = tqp->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	pktp = taskp->pktp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;

	ASSERT(dsp != NULL);

	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)tqp->fcp;
	ASSERT(fcp != NULL);
	adiscp  = (la_els_adisc_t *)(fcp + 1);

	bnxef_big_endian((uint8_t *)&adiscp->ls_code, 4);
	bnxef_big_endian((uint8_t *)&adiscp->hard_addr, 4);
	bnxef_big_endian((uint8_t *)&adiscp->nport_id, 4);

	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)adiscp,
		(uint8_t *)pktp->pkt_resp,
		sizeof (la_els_adisc_t), DDI_DEV_AUTOINCR);

	if (sessionp != NULL) {
		/* Remove the task from the session task list */
		bnxef_task_session_list_remove(sessionp, taskp);
	}

	/* Now complete the packet */
	pktp->pkt_resp_resid = 0;
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	/* Free the message block memory */
	kmem_free(fcoep, frame_length);
}




/*
 * This handles the LS ACC received for PLOGI sent out.
 */
static void
bnxef_plogi_ls_acc_rx_handler(void *arg)
{
	bnxef_tq_params_t	*tqp;
	bnxef_port_t 		*portp;
	bnxef_rport_t 		*rportp; /* Remote port pointer */
	bnxef_driver_state_t 	*dsp;
	bnxef_session_t 	*sessionp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	la_els_logi_t 		*plogi_infop;
	la_els_logi_t		*loginp, *srcloginp;
	uint8_t			hash = 0;
	svc_param_t	*src_class3_param, *class3_param;
	int		newly_allocated = 0, frame_length;


	tqp = (bnxef_tq_params_t *)arg;

	ASSERT(tqp != NULL);
	portp = tqp->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	pktp = taskp->pktp;
	fcp = (fc_frame_hdr_t *)tqp->fcp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;

	fcoep = (bnxef_fcoe_frame_t *)tqp->framep;
	frame_length = tqp->frame_length;

	mutex_enter(&dsp->state_mutex);
	if (dsp->physical_port_state & BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	ASSERT(fcoep != NULL);
	ASSERT(fcp != NULL);
	plogi_infop = (la_els_logi_t *)(fcp + 1);

	/* Allocate a remote port structure from cache and populate info */
	rportp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
	ASSERT(rportp != NULL);

	rportp->id = fcp->s_id;
	bcopy(fcoep->ether.ether_shost.ether_addr_octet, rportp->mac_addr,
			ETHERADDRL);
	if (tqp->flags)
		rportp->vlan_id = VLAN_ID(htons(fcoep->vlan.ether_tci));
	else
		rportp->vlan_id = 0;

	loginp = &rportp->plogi_info;
	srcloginp = (la_els_logi_t *)plogi_infop;
	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	// bnxef_big_endian(loginp, 4);
	bcopy(&srcloginp->nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&srcloginp->node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(srcloginp->common_service.fcph_version);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(srcloginp->common_service.cmn_features);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);

	rportp->flags = BNXEF_FC_PORT_REMOTE | BNXEF_FC_PORT_N_PORT;
	if ((rportp->id >= 0xFFFFF7) && (rportp->id < 0xFFFFFF))
		rportp->flags |= BNXEF_FC_PORT_WELL_KNOWN;

	/*
	 * Allocate a session from the session cache and set up all
	 * information pertaining to this session.
	 */

	if (sessionp == NULL) {
		sessionp = kmem_cache_alloc(dsp->session_cache, KM_SLEEP);
		memset(sessionp, 0, sizeof (bnxef_session_t));
		newly_allocated = 1;
	}
	ASSERT(sessionp != NULL);

	sessionp->lport  = portp;
	sessionp->rport = rportp;
	sessionp->sec_state |= BNXEF_SESSION_PLOGI_COMPLETE;
	sessionp->next = NULL; /* Initialize */
#if 0
	/* Allocate a connection Id */
	sessionp->con_id = bnxef_alloc_session_con_id(dsp, sessionp);
#endif

	/* This will initialize the session task list */
	bnxef_task_session_list_init(dsp, sessionp);

	/* Initialize information which will be used when downloaded. */
	sessionp->max_sqes = BNXEF_SQ_WQES_MAX;
	sessionp->max_cqes = BNXEF_CQ_WQES_MAX;
	sessionp->max_rqes = BNXEF_RQ_WQES_MAX;
	sessionp->doorbell_acc = dsp->doorbell_acc;

	/* Initialize the toggle bit */
	sessionp->sq_toggle = 1;
	sessionp->cq_toggle = 1;
	sessionp->sq_prod_idx = 0;
	sessionp->cq_cons_idx = 0;
	sessionp->rq_prod_idx = 0x8000;
	sessionp->rq_cons_idx = 0;

	if (newly_allocated) {
		/*
		 * Until now this session is not visible to any one, but once
		 * added to the port hash list it is visible.
		 * Once visible, it should
		 * be protected by appropriate mutex.
		 */

		hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
				rportp->mac_addr);

		/*
		 * Now make it visible, from now on anything
		 * updated you should hold
		 * locks appropriately.
		 */
		bnxef_session_list_add(portp, sessionp, hash);
	}


	/* Copy the PLOGI LS ACC information to appropriate packet fields */
	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rportp->plogi_info,
		(uint8_t *)pktp->pkt_resp, sizeof (la_els_logi_t),
		DDI_DEV_AUTOINCR);

	/*
	 * In this case the task is not added to session list, therefore
	 * not removed - This is a special case where session itself is
	 * created in this routine. Therefore that task which helped to
	 * create the session is not in it.
	 */
	pktp->pkt_resp_resid = 0;
	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: PLOGI Accepted for task id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	if (fcp->s_id == 0xFFFFFC) {
		BNXEF_DEBUG(dsp, ELS, -1,
			"%s%d: Completing Pkt for PLOGI task id 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
		delay(BNXEF_SEC2TICK(1));
	} else {
		/* Only needed for BFS support */
		cv_signal(&dsp->fp_up_cv);
	}
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);

}

/*
 * This will handle the LS_ACC received for PRLI. if the destination is a
 * FCP target, it will get offloaded for all the SCSI commands that might be
 * flying on the wire next.
 */
static void
bnxef_prli_ls_acc_rx_handler(void *arg)
{
	bnxef_tq_params_t	*tqp;
	bnxef_port_t 		*portp;
	bnxef_driver_state_t 	*dsp;
	bnxef_session_t 	*sessionp, *sessp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	la_els_prli_t 	*prli_infop;
	int ret, frame_length;
	bnxef_port_t 		*rportp;
	typedef struct __bnxef_prli_service_params__ {
		uint8_t type;
		uint8_t reserved;
		uint16_t  flags;
		uint32_t   opa;
		uint32_t   rpa;
		uint32_t   serv_params;
	} prli_service_params_t;
	prli_service_params_t  *prlisvp;
	struct ether_header *etherp;
	struct ether_vlan_extinfo *vlanp;
	uint32_t	con_id;
	uint16_t	vlan_id;


	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	portp = tqp ->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	pktp = taskp->pktp;
	fcoep = (bnxef_fcoe_frame_t *)tqp->framep;
	ASSERT(fcoep != NULL);
	frame_length = tqp->frame_length;
	fcp = (fc_frame_hdr_t *)tqp->fcp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);
	ASSERT(pktp != NULL);

	dsp = portp->statep;

	mutex_enter(&dsp->state_mutex);
	if (dsp->physical_port_state & BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	if (sessionp == NULL) {
		/* Quietly drop the frame and move on */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}


	ASSERT(sessionp != NULL);
	ASSERT(fcp != NULL);
	prli_infop = (la_els_prli_t *)(fcp + 1);

	etherp = &fcoep->ether;
	ASSERT(etherp != NULL);
	if (tqp->flags) {
		vlanp = &fcoep->vlan;
		ASSERT(vlanp != NULL);
		vlan_id = VLAN_ID(htons(vlanp->ether_tci));
	} else
		vlan_id = 0;

	/*
	 * Now identify the session to which this ELS belongs - Again,
	 * sometimes because of multi-threaded nature, when the frame
	 * was received some session was seen before this routine was
	 * scheduled if the session identified has been cleanedup because
	 * of a transmission of PLOGI, it causes assert issue when
	 * removing the task from task session list. Therfore,
	 * re-checked here again to get upto date state.
	 */
	sessp = bnxef_session_find_remote_port(portp,
		vlan_id, fcp->s_id,
		etherp->ether_shost.ether_addr_octet);
	if (sessp == NULL) {
		/* Quietly drop the frame and move on */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	if (sessp->lport == NULL) {
		/* Still not in goo state - Drop the frame */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_enter(&sessionp->session_mutex);
	if ((sessionp->state & BNXEF_SESSION_OFFLOADED) &&
		(sessionp->state & BNXEF_SESSION_ENABLED)) {
		la_els_rjt_t rjt;
		mutex_exit(&sessionp->session_mutex);
		cmn_err(CE_NOTE,
			"Wrong condition seen when Receiving PRLI LS_ACC");
		bzero(&rjt, sizeof (la_els_rjt_t));
		rjt.ls_code.ls_code = LA_ELS_RJT;
		rjt.reason = 0x3;
		rjt.reserved = 0x0;
		/* Copy the PRLI ACC information to appropriate packet fields */
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
			(uint8_t *)pktp->pkt_resp, sizeof (la_els_rjt_t),
			DDI_DEV_AUTOINCR);

		/* Remove the task from the session task list */
		bnxef_task_session_list_remove(sessionp, taskp);

		mutex_enter(&sessionp->session_mutex);
		sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
		mutex_exit(&sessionp->session_mutex);
		/* Now complete the packet */
		pktp->pkt_resp_resid = 0;
		bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
		/* Still not in goo state - Drop the frame */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&sessionp->session_mutex);


	/*
	 * If the image pair is not established - Drop the frame
	 * and allow it to recover.
	 */
	if ((prli_infop->service_params[2] & 0x20) == 0) {
		la_els_rjt_t rjt;
		bzero(&rjt, sizeof (la_els_rjt_t));
		rjt.ls_code.ls_code = LA_ELS_RJT;
		rjt.reason = 0x3;
		rjt.reserved = 0x0;
		/* Copy the PRLI ACC information to appropriate packet fields */
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
			(uint8_t *)pktp->pkt_resp, sizeof (la_els_rjt_t),
			DDI_DEV_AUTOINCR);

		/* Remove the task from the session task list */
		bnxef_task_session_list_remove(sessionp, taskp);

		mutex_enter(&sessionp->session_mutex);
		sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
		mutex_exit(&sessionp->session_mutex);

		/* Now complete the packet */
		pktp->pkt_resp_resid = 0;
		bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);
		/* Still not in goo state - Drop the frame */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}


	mutex_enter(&sessp->session_mutex);
	sessp->sec_state |= BNXEF_SESSION_PRLI_COMPLETE;
//	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: received LS_ACC for X_ID 0x%x",
//		BNXEF_DRIVER_NAME, dsp->instance, taskp->x_id);
	mutex_exit(&sessp->session_mutex);
	if (prli_infop->service_params[0] == 0x8) { /* FCP */
		if (prli_infop->service_params[15] & PRLI_TARGET_FUNCTION) {
			/*
			 * Offload the connection - since this is a
			 * FCP target, no I/O can be flowing until this
			 * LS_ACC can be sent to Leadville stack
			 * Therefore it is safe to allocate resources
			 * without mutex being held. Also remember that
			 * timeouts are already stopped for the task which
			 * sent PRLI.
			 */
			ret = bnxef_alloc_session_resources(sessionp);
			if (ret != BNXEF_SUCCESS) {
				la_els_rjt_t rjt;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d:Unable to allocate session res\n",
					BNXEF_DRIVER_NAME, dsp->instance);
				bzero(&rjt, sizeof (la_els_rjt_t));
				rjt.ls_code.ls_code = LA_ELS_RJT;
				rjt.reason = 0x3;
				rjt.reserved = 0x0;
				/* Copy the PRLI ACC information to appropriate packet fields */
				ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)&rjt,
					(uint8_t *)pktp->pkt_resp, sizeof (la_els_rjt_t),
					DDI_DEV_AUTOINCR);

				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);

				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);

				/* Now complete the packet */
				pktp->pkt_resp_resid = 0;
				bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				BNXEF_DEBUG(dsp, ELS, -1, 
					"Session Resource Alloc Failed 0x%xp, state 0x%x\n", 
						sessionp, sessionp->state);
				return;
			}
			/*
			 * Hold the Session Mutex and send the offload
			 */
			con_id = bnxef_alloc_session_con_id(dsp,
					sessionp);
			if ((short)con_id < 0) {
				rportp = (bnxef_port_t *)sessionp->rport;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to allocate conn id for 0x%x and 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id,
				rportp->id);
				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			mutex_enter(&sessionp->session_mutex);
			sessionp->con_id = con_id;
			mutex_exit(&sessionp->session_mutex);
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Service Params Word 3 Byte 2 0x%x, Word 3 Byte 3 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		prli_infop->service_params[14],
		prli_infop->service_params[15]);
			GLOBAL_mutex_enter(dsp, &dsp->global_offload_mutex,
				__func__, __LINE__);
			mutex_enter(&sessionp->session_mutex);
			ret = bnxef_offload_session(sessionp,
					prli_infop->service_params[14],
					prli_infop->service_params[15]);
			if (ret != BNXEF_SUCCESS) {
				/*
				 * Anyway Port offline handler would have dealt
				 * with this I/O. Therefore return without
				 * completion.
				 */
				if (dsp->physical_port_state &
					BNXEF_PHYPORT_OFFLINE) {
					mutex_exit(&sessionp->session_mutex);
					mutex_exit(&dsp->global_offload_mutex);
					BNXEF_STATS(dsp, l2_fcoe_rx_free);
					BNXEF_STATS(dsp, l2_rx_free);
					kmem_free(fcoep, frame_length);
					return;
				}

				rportp = (bnxef_port_t *)sessionp->rport;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d:Unable to allocate session res 0x%x and 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id,
				rportp->id);
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);
				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);
				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);

				/* Now complete the packet */
				bnxef_complete_pkt(pktp, FC_PKT_LOCAL_RJT,
					0, FC_REASON_NOMEM, 0);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			/* wait for offload completion */
			cv_wait(&sessionp->session_cv,
				&sessionp->session_mutex);
			if (sessionp->session_req_error) {
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);
				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);
				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);

				/* Now complete the packet */
				bnxef_complete_pkt(pktp, FC_PKT_LOCAL_RJT,
					0, FC_REASON_NOMEM, 0);

				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}

			sessionp->state |= BNXEF_SESSION_OFFLOADED;

			/* Now try to do the enable of the session */
			ret = bnxef_session_enable(sessionp);
			if (ret != BNXEF_SUCCESS) {
				rportp = (bnxef_port_t *)sessionp->rport;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to enable session between 0x%x \
						and 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id,
					rportp->id);
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);

				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);

				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);
				/* Now complete the packet */
				bnxef_complete_pkt(pktp, FC_PKT_LOCAL_RJT,
					0, FC_REASON_NOMEM, 0);

				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			cv_wait(&sessionp->session_cv,
				&sessionp->session_mutex);
			if (sessionp->session_req_error) {
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);
				/* Remove the task from the session task list */
				bnxef_task_session_list_remove(sessionp, taskp);

				mutex_enter(&sessionp->session_mutex);
				sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
				mutex_exit(&sessionp->session_mutex);
				/* Now complete the packet */
				bnxef_complete_pkt(pktp, FC_PKT_LOCAL_RJT,
					0, FC_REASON_NOMEM, 0);

				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			sessionp->state |= BNXEF_SESSION_ENABLED;
			sessionp->prev_cq_cons_idx = 0;
			sessionp->iterate_cnt = 0;
			mutex_exit(&sessionp->session_mutex);
			mutex_exit(&dsp->global_offload_mutex);
		} else {
			BNXEF_DEBUG(dsp, GENERAL, portp->id,
			"%s%d: Should not send PRLI to Initiator, but sent\n"
				BNXEF_DRIVER_NAME, dsp->instance);
		}
	}

	if (prli_infop->service_params[14] & PRLI_RETRY_ALLOWED) {
		prli_infop->service_params[14] &= ~PRLI_RETRY_ALLOWED;
	}
	/* LINTED: alignment */
	prlisvp = (prli_service_params_t *)((uint8_t *)prli_infop + 4);
	prlisvp->flags = htons(prlisvp->flags);
	prlisvp->opa = htonl(prlisvp->opa);
	prlisvp->rpa = htonl(prlisvp->rpa);
	prlisvp->serv_params = htonl(prlisvp->serv_params);

	/* Copy the PRLI ACC information to appropriate packet fields */
	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)prli_infop,
		(uint8_t *)pktp->pkt_resp, sizeof (la_els_prli_t),
		DDI_DEV_AUTOINCR);

	/* Remove the task from the session task list */
	bnxef_task_session_list_remove(sessionp, taskp);

	mutex_enter(&sessionp->session_mutex);
	sessionp->sec_state &= ~BNXEF_SESSION_PRLI_INPROGRESS;
	mutex_exit(&sessionp->session_mutex);
	/* Now complete the packet */
	pktp->pkt_resp_resid = 0;
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}

/*
 * This will call the pkt callback in another threads context, to
 * avoid deadlock when the L2 callback routine blocks.
 */
void
bnxef_pkt_callback(void *arg)
{

	fc_packet_t *pktp = (fc_packet_t *)arg;

	if (pktp->pkt_comp) {
		pktp->pkt_comp(pktp);
	}
}

void
bnxef_log_completion(bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp)
{

	fc_packet_t *pktp;
	bnxef_completion_log_t *logp;
	uint32_t state;

	if (sessionp == NULL)
		return;
	if (taskp == NULL)
		return;
	mutex_enter(&sessionp->session_mutex);
	logp = &sessionp->c_log[sessionp->log_cur_idx];
	sessionp->log_cur_idx = (sessionp->log_cur_idx +1) %
		BNXEF_MAX_LOG_ENTRIES;

	state = sessionp->state;
	mutex_exit(&sessionp->session_mutex);

	mutex_enter(&taskp->task_mutex);
	pktp = taskp->pktp;

	logp->x_id = taskp->x_id;
	logp->task_flags = taskp->task_flags;
	logp->start_lbolt = taskp->start_lbolt;
	logp->end_lbolt = taskp->end_lbolt;
	logp->pktp = pktp;
	logp->session_state = state;
	logp->pkt_state = pktp->pkt_state;
	logp->pkt_reason = pktp->pkt_reason;
	logp->pkt_expln = pktp->pkt_expln;
	logp->pkt_action = pktp->pkt_action;
	logp->sessionp  = sessionp;
	mutex_exit(&taskp->task_mutex);
}


void
bnxef_complete_pkt(fc_packet_t *pktp, uint8_t state,
	uint8_t action, uint32_t reason, uint32_t expln)
{
	bnxef_fcoe_task_t 	*taskp;
	uint32_t		task_flags;
	int ret;
	bnxef_driver_state_t *dsp;

	ASSERT(pktp != NULL);


	ASSERT(pktp != NULL);
	taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
	/* This should not happen, if it does return */
	if (taskp == NULL)
		return; /* Nothing to do */
	ASSERT(taskp != NULL);


	dsp = (bnxef_driver_state_t *)taskp->dsp;
	ASSERT(dsp != NULL);

	mutex_enter(&taskp->task_mutex);
	task_flags = taskp->task_flags;
	mutex_exit(&taskp->task_mutex);


	/*
	 * Now return the packet back to higher level layer with appropriate
	 * status and reason code.
	 */
	pktp->pkt_state = state;
	pktp->pkt_reason = reason;
	pktp->pkt_expln = expln;
	pktp->pkt_action = action;

	bnxef_log_completion((bnxef_session_t *)taskp->tq_params.sessp, taskp);

	if (dsp->task_bd_table_pre_alloc == 0) {
		if ((task_flags &  BNXEF_FCOE_TASK_BD_LIST_ALLOC) ==
			BNXEF_FCOE_TASK_BD_LIST_ALLOC) {
			ret = bnxef_task_bd_table_free(pktp,
				BNXEF_TASK_BD_TABLE_ALL);
			ASSERT(ret == BNXEF_SUCCESS);
		}
	}

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
		bnxef_fcoe_task_t *sectaskp;
		uint16_t sec_xid;

		sec_xid = taskp->secondary_x_id;
		sectaskp = dsp->taskarray[sec_xid];
		if (sectaskp != NULL) {
			mutex_enter(&sectaskp->task_mutex);
			if (sectaskp->task_flags &
				BNXEF_FCOE_TASK_RRQ) {
				sectaskp->sec_flags |=
					BNXEF_FCOE_DROP_RRQ_PROCESSING;
				cmn_err(CE_NOTE,
				"Found xid 0x%x sending RRQ using xid 0x%x",
				taskp->x_id, sectaskp->x_id);
			}
			mutex_exit(&sectaskp->task_mutex);
		}
	}

	if (taskp->task_flags & BNXEF_FCOE_TASK_COMPLETED) {
		mutex_exit(&taskp->task_mutex);
		debug_enter("Got it");
		return;
	}
	if ((taskp->task_flags & BNXEF_FCOE_TASK_ALLOCATED) == 0)  {
		mutex_exit(&taskp->task_mutex);
		debug_enter("Got it - 1");
		return;
	}

	taskp->task_flags &= ~task_flags;
	/*
	 * Only these two flags should be pending, sort of cleared all and
	 * reset what we want. This is to optimize code as we donot want to
	 * check for each one that is set to be reset.
	 */
	taskp->task_flags =
		(BNXEF_FCOE_TASK_COMPLETED | BNXEF_FCOE_TASK_ALLOCATED);
	taskp->sec_flags = 0;

	if (pktp->pkt_tran_flags & FC_TRAN_NO_INTR) {
		cv_signal(&taskp->task_cv);

	}
	mutex_exit(&taskp->task_mutex);


	bnxef_end_task(dsp, pktp);


	ret = ddi_taskq_dispatch(dsp->tq, bnxef_pkt_callback, (void *)pktp,
			DDI_SLEEP);
	if (ret != DDI_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to Schedule Pkt callback routine\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}
}

/*
 * This will handle the LS_ACC received for the LOGO ELS.
 */
static void
bnxef_logo_ls_acc_rx_handler(void *arg)
{
	bnxef_tq_params_t	*tqp;
	bnxef_port_t 		*portp;
	bnxef_driver_state_t 	*dsp;
	bnxef_session_t 	*sessionp;
	bnxef_fcoe_task_t 	*taskp;
	fc_packet_t 		*pktp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	la_els_logo_t 	*logoreplyp;
	int ret;
	uint32_t frame_length;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	portp = tqp ->portp;
	sessionp = tqp->sessp;
	taskp = tqp->taskp;
	pktp = taskp->pktp;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);

	dsp = portp->statep;


	ASSERT(sessionp != NULL);
	fcoep = (bnxef_fcoe_frame_t *)tqp->framep;
	frame_length = tqp->frame_length;
	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)tqp->fcp;
	ASSERT(fcp != NULL);
	logoreplyp = (la_els_logo_t *)(fcp + 1);

	/* Remove this task first from the session Queue */
	bnxef_task_session_list_remove(sessionp, taskp);

	/* We know that we have received LS ACC for logo, start cleanup */
	ret = bnxef_session_cleanup(sessionp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to clean up the required session\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return;
	}


	/* Copy the LOGO LS_ACC information to appropriate packet fields */
	ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)logoreplyp,
		(uint8_t *)pktp->pkt_resp, 4, DDI_DEV_AUTOINCR);

	/*
	 * Because we have cleaned up the session - Make sure the
	 * tq_params reflects that otherwise logging completions
	 * will panic.
	 */
	taskp->tq_params.sessp = NULL;
	/* Now complete the packet */
	bnxef_complete_pkt(pktp, FC_PKT_SUCCESS, 0, 0, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);


}

#if 0
int
bnxef_session_disable_taskclean_enable(bnxef_session_t *sessionp)
{
	bnxef_fcoe_task_t *taskp;
	fc_packet_t *pktp;
	uint32_t task_flags;
	timeout_id_t tid;
	uint8_t	 sessionstate;
	bnxef_driver_state_t *dsp;
	bnxef_port_t	 *portp;
	bnxef_port_t	 *rportp;
	int ret;


	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	rportp = sessionp->rport;
	dsp = portp->statep;

	ASSERT(portp != NULL);
	ASSERT(rportp != NULL);
	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Cleaning up Session 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp);
	mutex_enter(&sessionp->session_mutex);
	sessionstate = sessionp->state;
	mutex_exit(&sessionp->session_mutex);

	if (sessionstate & BNXEF_SESSION_OFFLOADED) {
		mutex_enter(&sessionp->session_mutex);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		ret = bnxef_session_disable(sessionp);
		if (ret != BNXEF_SUCCESS) {
			mutex_exit(&dsp->state_mutex);
			mutex_exit(&sessionp->session_mutex);
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to disable session\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		mutex_exit(&dsp->state_mutex);
		cv_wait(&sessionp->session_cv, &sessionp->session_mutex);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		sessionp->state &= ~BNXEF_SESSION_ENABLED;
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Session 0x%p, Disabled",
			BNXEF_DRIVER_NAME, dsp->instance, sessionp);
		mutex_exit(&dsp->state_mutex);
		mutex_exit(&sessionp->session_mutex);
	}
	taskp = bnxef_task_session_list_get_first(sessionp);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Cleaning up session between 0x%x --> 0x%x State 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id, rportp->id);

	if (taskp != NULL) {
		/*
		 * Send to Leadville all tasks pending on this connection.
		 */
		while (taskp != NULL) {
			mutex_enter(&taskp->task_mutex);
			task_flags = taskp->task_flags;
			tid = taskp->timerhdl;
			mutex_exit(&taskp->task_mutex);

			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: TAsk to be Cleaned up ID = 0x%x session 0x%p",
				BNXEF_DRIVER_NAME, dsp->instance,
				taskp->x_id, sessionp);
			/*
			 * If timer is set, then untimeout the ULP timer
			 */
			if (task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&taskp->task_mutex);
				taskp->task_flags &=
					~BNXEF_FCOE_TASK_TIMER_ARMED;
				mutex_exit(&taskp->task_mutex);
			}
			if (task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
				bnxef_fcoe_task_t *sectaskp;
				uint32_t sec_task_flags;
				sectaskp =
					dsp->taskarray[taskp->secondary_x_id];
				mutex_enter(&sectaskp->task_mutex);
				tid = sectaskp->timerhdl;
				sec_task_flags = sectaskp->task_flags;
				mutex_exit(&sectaskp->task_mutex);
				if (sec_task_flags &
					BNXEF_FCOE_TASK_TIMER_ARMED) {
					mutex_enter(&sectaskp->task_mutex);
					sectaskp->task_flags &=
						~BNXEF_FCOE_TASK_TIMER_ARMED;
					mutex_exit(&sectaskp->task_mutex);
					untimeout(tid);
				}
				kmem_free(sectaskp->pktp, sizeof (fc_packet_t));
				bnxef_task_free((void *)dsp, sectaskp);
				mutex_enter(&taskp->task_mutex);
				taskp->task_flags &=
					~BNXEF_FCOE_SEC_X_ID_VALID;
				mutex_exit(&taskp->task_mutex);
			}


			if (sessionstate & BNXEF_SESSION_OFFLOADED) {
				/*
				 * All the task will run only under offload
				 * mode by firmware.
				 */
				if ((task_flags &
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE)
						== 0) {
					BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: NOT SUBMITTED Task Id 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
						taskp->x_id);
				}
				ASSERT(task_flags &
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
				ret = bnxef_cleanup_task(sessionp, taskp);
				if (ret != BNXEF_SUCCESS) {
					/*
					 * Nothing need to done for this task,
					 * Get the next one and move on.
					 */
				taskp =
				bnxef_task_session_list_get_first(sessionp);
					continue;
				}

			} else {
				/*
				 * All the tasks on this connection should
				 * run on L2 path
				 */
				ASSERT(task_flags &
					BNXEF_FCOE_TASK_SUBMITTED_L2);
				if ((task_flags &
					BNXEF_FCOE_TASK_SUBMITTED_L2) == 0) {
					BNXEF_DEBUG(dsp, ERROR, -1,
					"%s%d: NOT SUBMITTED Task Id 0x%x",
					BNXEF_DRIVER_NAME, dsp->instance,
						taskp->x_id);
				}

			}

			/* Remove this task from the session task List */
			bnxef_task_session_list_remove(sessionp, taskp);

			/* Get the packet */
			pktp = taskp->pktp;
			ASSERT(pktp != NULL);

			if (task_flags & BNXEF_FCOE_TASK_RRQ) {
				/* Free all DMA resources allocated for RRQ */
				bnxef_pkt_cmd_res_free(pktp,
						BNXEF_PKT_CMD_ALL);
				bnxef_pkt_resp_res_free(pktp,
					BNXEF_PKT_RESP_ALL);
			}
			/*
			 * Now complete the packet as Local RJT  reason
			 * No connecion
			 */
			bnxef_complete_pkt(pktp, FC_PKT_LOCAL_RJT, 0,
				FC_REASON_NO_CONNECTION, 0);

			if (task_flags & BNXEF_FCOE_TASK_RRQ) {
				kmem_free(pktp, sizeof (fc_packet_t));
				bnxef_task_free((void *)dsp, taskp);
			}

			taskp = bnxef_task_session_list_get_first(sessionp);
		}
	}

	/*
	 * Now all the tasks are cleared  on this session, it is ready for
	 * destroying.
	 */
	if (sessionstate & BNXEF_SESSION_OFFLOADED) {
		mutex_enter(&sessionp->session_mutex);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		/* Try to destroy the session from firmware */
		ret = bnxef_session_enable(sessionp);
		if (ret != BNXEF_SUCCESS) {
			mutex_exit(&dsp->state_mutex);
			mutex_exit(&sessionp->session_mutex);
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to enable session\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		mutex_exit(&dsp->state_mutex);
		cv_wait(&sessionp->session_cv, &sessionp->session_mutex);
		MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
		sessionp->state |= BNXEF_SESSION_ENABLED;
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Session 0x%p, enabled",
			BNXEF_DRIVER_NAME, dsp->instance, sessionp);
		mutex_exit(&dsp->state_mutex);
		mutex_exit(&sessionp->session_mutex);
	}

	return (BNXEF_SUCCESS);
}
#endif
int
bnxef_cleanup_all_tasks(bnxef_driver_state_t *dsp, bnxef_session_t *sessionp,
	uint16_t *ctlstp, uint16_t num_items)
{
	uint16_t i;
	bnxef_fcoe_task_t *taskp;
	uint16_t x_id;

	for (i = 0; i < num_items; i++) {
		x_id = ctlstp[i];
		taskp = dsp->taskarray[x_id];
		if (taskp != NULL)
			bnxef_cleanup_task(sessionp, taskp);
		if ((i & 0xFF) == 0) delay(5);
	}

	return (BNXEF_SUCCESS);
}


/*
 * This will clearup all the commands pending on that connection.
 * If this connection is offloaded, it will disable and destroy the conection.
 * if the task is submitted for firmware, it will clear the task from firmware
 */
int
bnxef_session_cleanup(bnxef_session_t *sessionp)
{
	bnxef_fcoe_task_t *taskp;
	bnxef_fcoe_task_t *ntaskp;
	fc_packet_t *pktp;
	uint32_t task_flags;
	timeout_id_t tid;
	uint8_t	 sessionstate;
	bnxef_driver_state_t *dsp;
	bnxef_port_t	 *portp;
	bnxef_port_t	 *rportp;
	int ret;
	uint8_t hash;
	volatile int active_ios;
	bnxef_task_list_t *tasklstp;
	// uint32_t sec_state;
	uint16_t *cleanuptasklist = NULL;
	uint16_t num_items;
	uint16_t task_items;
	uint32_t size;



	ASSERT(sessionp != NULL);
	portp = sessionp->lport;
	rportp = sessionp->rport;
	if (portp == NULL)
		return (BNXEF_FAILURE);

	dsp = portp->statep;
	if ((dsp == NULL) || (rportp == NULL))
		return (BNXEF_FAILURE);

	ASSERT(portp != NULL);
	ASSERT(rportp != NULL);
	ASSERT(dsp != NULL);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Cleaning up Session 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, sessionp);
	mutex_enter(&sessionp->session_mutex);
	if (sessionp->state & BNXEF_SESSION_CLEANUP_INPROGRESS) {
		mutex_exit(&sessionp->session_mutex);
		return (BNXEF_SUCCESS);
	}
	sessionp->state |= BNXEF_SESSION_CLEANUP_INPROGRESS;
	sessionstate = sessionp->state;
	mutex_exit(&sessionp->session_mutex);

	if (sessionstate & BNXEF_SESSION_OFFLOADED) {
		GLOBAL_mutex_enter(dsp, &dsp->global_offload_mutex,
			__func__, __LINE__);
		mutex_enter(&sessionp->session_mutex);
		ret = bnxef_session_disable(sessionp);
		if (ret != BNXEF_SUCCESS) {
			mutex_exit(&sessionp->session_mutex);
			mutex_exit(&dsp->global_offload_mutex);
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to disable session\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		cv_wait(&sessionp->session_cv, &sessionp->session_mutex);
		sessionp->state &= ~BNXEF_SESSION_ENABLED;
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Session 0x%p, Disabled",
			BNXEF_DRIVER_NAME, dsp->instance, sessionp);
		mutex_exit(&sessionp->session_mutex);
		mutex_exit(&dsp->global_offload_mutex);
	}
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Cleaning up session between 0x%x --> 0x%x State 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, portp->id, rportp->id);

	mutex_enter(&sessionp->session_mutex);
	tasklstp = &sessionp->sessiontasklist;
	mutex_exit(&sessionp->session_mutex);

	mutex_enter(&tasklstp->tasklist_mutex);
	taskp = NULL;
	if (tasklstp->num_items > 0) {
		taskp = tasklstp->head;
		ASSERT(taskp != NULL);
	}
	task_items = tasklstp->num_items;
	size = task_items * sizeof (uint16_t);

	if (size > 0) {
		cleanuptasklist = kmem_alloc(size, KM_SLEEP);
		if (cleanuptasklist == NULL) {
			cmn_err(CE_PANIC,
			" %s%d: Unable to allocate Cleanuplist",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		num_items = 0;
	}

		/*
		 * Send to Leadville all tasks pending on this connection.
		 */
		while (taskp != NULL) {
			mutex_enter(&taskp->task_mutex);
			task_flags = taskp->task_flags;
			tid = taskp->timerhdl;
			mutex_exit(&taskp->task_mutex);

			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: TAsk to be Cleaned up ID = 0x%x task flags 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			taskp->x_id, task_flags);
			/*
			 * If timer is set, then untimeout the ULP timer
			 */
			if (task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
				untimeout(tid);
				mutex_enter(&taskp->task_mutex);
				taskp->task_flags &=
					~BNXEF_FCOE_TASK_TIMER_ARMED;
				mutex_exit(&taskp->task_mutex);
			}
			if ((task_flags & BNXEF_FCOE_TASK_RRQ) == 0) {
				if (task_flags & BNXEF_FCOE_SEC_X_ID_VALID) {
					bnxef_fcoe_task_t *sectaskp;
					uint32_t sec_task_flags;
					sectaskp =
					dsp->taskarray[taskp->secondary_x_id];
					mutex_enter(&sectaskp->task_mutex);
					tid = sectaskp->timerhdl;
					sec_task_flags = sectaskp->task_flags;
					mutex_exit(&sectaskp->task_mutex);
					if (sec_task_flags &
						BNXEF_FCOE_TASK_TIMER_ARMED) {
					mutex_enter(&sectaskp->task_mutex);
					sectaskp->task_flags &=
						~BNXEF_FCOE_TASK_TIMER_ARMED;
					mutex_exit(&sectaskp->task_mutex);
					untimeout(tid);
					}
					kmem_free(sectaskp->pktp,
						sizeof (fc_packet_t));
					bnxef_task_free((void *)dsp, sectaskp);
					mutex_enter(&taskp->task_mutex);
					taskp->task_flags &=
						~BNXEF_FCOE_SEC_X_ID_VALID;
					mutex_exit(&taskp->task_mutex);
				}
			}


			if (sessionstate & BNXEF_SESSION_OFFLOADED) {
				/*
				 * All the task will run only under offload
				 * mode by firmware.
				 */
				ASSERT(task_flags &
					BNXEF_FCOE_SUBMITTED_TO_FIRMWARE);
				cleanuptasklist[num_items++] = taskp->x_id;
				// ret = bnxef_cleanup_task(sessionp, taskp);
				taskp->state = FC_PKT_LOCAL_RJT;
				taskp->action = 0;
				taskp->reason = FC_REASON_NO_CONNECTION;
				taskp->expln =  0;
				taskp = taskp->snextp;
			} else {
				if ((task_flags &  BNXEF_FCOE_TASK_RRQ) == 0) {
					/*
					 * All the tasks on this connection
					 * should run on L2 path
					 */

					ntaskp = taskp->snextp;
					mutex_exit(&tasklstp->tasklist_mutex);
					/*
					 * Remove this task from the
					 * session task List
					 */
					bnxef_task_session_list_remove(sessionp,
						taskp);
					mutex_enter(&tasklstp->tasklist_mutex);


					/* Get the packet */
					pktp = taskp->pktp;

					if (pktp == NULL) {
						taskp = ntaskp;
						continue;
					}
					ASSERT(pktp != NULL);

					/*
					 * Now complete the packet as Local RJT
					 * reason No connecion
					 */
					bnxef_complete_pkt(pktp,
						FC_PKT_LOCAL_RJT,
						0, FC_REASON_NO_CONNECTION, 0);
					taskp = ntaskp;
				}
		    }

	    }
	mutex_exit(&tasklstp->tasklist_mutex);

	if ((num_items > 0) && (cleanuptasklist))
		bnxef_cleanup_all_tasks(dsp, sessionp,
			cleanuptasklist, num_items);

	if (cleanuptasklist)
		kmem_free(cleanuptasklist, size);

	active_ios = bnxef_get_active_ios(sessionp);
	while (active_ios  != 0) {
		delay(drv_usectohz(100));
		active_ios = bnxef_get_active_ios(sessionp);
	}
	/*
	 * Now all the tasks are cleared  on this session, it is ready for
	 * destroying.
	 */
	if (sessionstate & BNXEF_SESSION_OFFLOADED) {
		GLOBAL_mutex_enter(dsp, &dsp->global_offload_mutex,
			__func__, __LINE__);
		mutex_enter(&sessionp->session_mutex);
		/* Try to destroy the session from firmware */
		ret = bnxef_session_destroy(sessionp);
		if (ret != BNXEF_SUCCESS) {
			mutex_exit(&sessionp->session_mutex);
			mutex_exit(&dsp->global_offload_mutex);
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to destroy session\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		cv_wait(&sessionp->session_cv,
			&sessionp->session_mutex);

		sessionp->state &= ~BNXEF_SESSION_OFFLOADED;
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Session 0x%p, Destroyed",
			BNXEF_DRIVER_NAME, dsp->instance, sessionp);
		mutex_exit(&sessionp->session_mutex);
		mutex_exit(&dsp->global_offload_mutex);

		(void) bnxef_free_session_con_id(dsp, sessionp->con_id);
		/* Clear all session specific resources */
		ret = bnxef_free_session_resources(sessionp,
				BNXEF_SESSION_RESOURCE_ALL);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to free session resources\n",
				BNXEF_DRIVER_NAME, dsp->instance);
			return (BNXEF_FAILURE);
		}
		BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: Session Resources cleared",
			BNXEF_DRIVER_NAME, dsp->instance);
	}


	/*
	 * Now that all offloaded resources are cleared, we can now release
	 * session  back to the pool of sessions. Before we release, we
	 * need to remove it from the hash table for the port.
	 */
#if 0
	mutex_enter(&sessionp->session_mutex);
	sec_state = sessionp->sec_state;
	mutex_exit(&sessionp->session_mutex);
#endif

	/* remove from the hash table of the port */
	hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
			rportp->mac_addr);

	bnxef_session_list_remove(portp, sessionp, hash);

	rportp->flags = 0;
	rportp->id = 0;
	/* Free the remote port */
	kmem_cache_free(dsp->port_cache, rportp);
	sessionp->rport = NULL;
	sessionp->lport = NULL;


	mutex_enter(&sessionp->session_mutex);
	sessionp->state &= ~BNXEF_SESSION_CLEANUP_INPROGRESS;
	sessionp->sec_state = 0;
	mutex_exit(&sessionp->session_mutex);

	kmem_cache_free(dsp->session_cache, sessionp);

	BNXEF_DEBUG(dsp, ELS, -1, "%s%d: Session Cleanup Complete",
		BNXEF_DRIVER_NAME, dsp->instance);


	return (BNXEF_SUCCESS);
}

/*
 * This will carry out the implicit logout
 */
int
bnxef_implicit_logout_handler(bnxef_port_t *portp, bnxef_session_t *sessionp)
{
	bnxef_driver_state_t *dsp;
	int ret;

	ASSERT(portp != NULL);
	ASSERT(sessionp != NULL);

	dsp = portp->statep;
#if 0
	ret = bnxef_find_session(portp, sessionp);
	if (ret == BNXEF_FAILURE)
		return (ret);
#endif
	mutex_enter(&dsp->state_mutex);
	if (dsp->physical_port_state == BNXEF_PHYPORT_OFFLINE) {
		mutex_exit(&dsp->state_mutex);
		return (BNXEF_FAILURE);
	}
	mutex_exit(&dsp->state_mutex);

	mutex_enter(&sessionp->session_mutex);
	if (sessionp->state & BNXEF_SESSION_CLEANUP_INPROGRESS) {
		mutex_exit(&sessionp->session_mutex);
		return (BNXEF_SUCCESS);
	}
	mutex_exit(&sessionp->session_mutex);
	ret = bnxef_session_cleanup(sessionp);
	if (ret != BNXEF_SUCCESS) {
		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to clean up the required session\n",
			BNXEF_DRIVER_NAME, dsp->instance);
		return (BNXEF_FAILURE);
	}

	return (BNXEF_SUCCESS);

}

/*
 * This handles the LS RJT Received for the frame that was sent out
 */
/* ARGSUSED6 */
static int
bnxef_ls_rjt_rx_handler(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_fcoe_task_t *taskp, bnxef_fcoe_frame_t *fcoep, uint32_t
		frame_length, void *fp, int flags)
{
	fc_packet_t 		*pktp;
	fc_frame_hdr_t 		*fcp;
	la_els_rjt_t 		*lsrjtp;
	bnxef_driver_state_t	*dsp;
	timeout_id_t		tid;
	uint8_t 	tid_valid = 0;
	uint32_t	size;
	ls_code_t sentels;

	ASSERT(portp != NULL);
	ASSERT(taskp != NULL);

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	pktp = taskp->pktp;
	ASSERT(pktp != NULL);

	/* Now the task is completed, shut off the timer enabled */
	mutex_enter(&taskp->task_mutex);
	/* Now the task is completed, shut off the timer enabled */
	if (((taskp->task_flags & BNXEF_FCOE_TASK_ALLOCATED) == 0) ||
		(taskp->task_flags & BNXEF_FCOE_TASK_COMPLETED)) {
		mutex_exit(&taskp->task_mutex);
		/* Ignore this packet */
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return (DDI_SUCCESS);
	}

	if (taskp->task_flags & BNXEF_FCOE_TASK_TIMER_ARMED) {
		tid = taskp->timerhdl;
		tid_valid = 1;
	}
	taskp->task_flags &= ~ BNXEF_FCOE_TASK_TIMER_ARMED;
	mutex_exit(&taskp->task_mutex);

	if (tid_valid) {
		/* Cancel the timer */
		untimeout(tid);
	}

	/* Get the ELS code for analysis from pkt_cmd field. */
	ddi_rep_get8(pktp->pkt_cmd_acc, (uint8_t *)&sentels,
		(uint8_t *)pktp->pkt_cmd, 4,  DDI_DEV_AUTOINCR);

	if (sentels.ls_code == LA_ELS_PRLI) {
		mutex_enter(&sessionp->session_mutex);
		sessionp->sec_state &= ~ BNXEF_SESSION_PRLI_INPROGRESS;
		mutex_exit(&sessionp->session_mutex);
	}

	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)fp;
	size =  ((uint8_t *)fcoep + frame_length -8) - (uint8_t *)fcp;
	size = size - sizeof (fc_frame_hdr_t);

	ASSERT(fcp != NULL);
	lsrjtp = (la_els_rjt_t *)(fcp + 1);

	if (size >= sizeof (la_els_rjt_t)) {
		/* Copy the response received into the  pkt_response buffer */
		ddi_rep_put8(pktp->pkt_resp_acc, (uint8_t *)lsrjtp,
			(uint8_t *)pktp->pkt_resp, sizeof (la_els_rjt_t),
			DDI_DEV_AUTOINCR);
	} else {
		cmn_err(CE_NOTE,
		"LS RJT size less than expected, setting Logical Error");
		lsrjtp->reason = FC_REASON_LOGICAL_ERROR;
	}

	if (sessionp != NULL) {
		/* Remove the task from session list */
		bnxef_task_session_list_remove(sessionp, taskp);
	}


	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Ls RJT reason 0x%x, expln 0x%x, VU 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		lsrjtp->reason, lsrjtp->reserved, lsrjtp->vu);

	/* Now complete the pkt and return */
	(void) bnxef_complete_pkt(pktp, FC_PKT_LS_RJT,
			0, (uint32_t)lsrjtp->reason, 0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);

	kmem_free(fcoep, frame_length);

	return (BNXEF_SUCCESS);
}

fc_packet_t *
bnxef_prep_plogi_resp(bnxef_driver_state_t *dsp, fc_unsol_buf_t *ubp)
{

	fc_packet_t *pktp;
	bnxef_fcoe_task_t *taskp;

	ASSERT(ubp != NULL);
	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = ubp->ub_frame.s_id;
	pktp->pkt_cmd_fhdr.s_id = ubp->ub_frame.d_id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_EXTENDED_LS;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_RSP;
	pktp->pkt_cmd_fhdr.ro   =  0;
	pktp->pkt_cmd_fhdr.f_ctl =
		(F_CTL_XCHG_CONTEXT |F_CTL_LAST_SEQ | F_CTL_END_SEQ |
				F_CTL_SEQ_INITIATIVE);
	pktp->pkt_timeout = BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = sizeof (la_els_logi_t);

	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);

	taskp->pktp = pktp;
	taskp->task_flags |=  (BNXEF_FCOE_TASK_ELS |
				BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP);

	pktp->pkt_fca_private = taskp;
	/* This was already swapped as a 4 byte quantity, therefore use rx_id */
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d, OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		ubp->ub_frame.ox_id, ubp->ub_frame.rx_id);
	pktp->pkt_cmd_fhdr.ox_id = ubp->ub_frame.ox_id;
	pktp->pkt_ub_resp_token = ubp;

	pktp->pkt_cmdlen = sizeof (la_els_logi_t);

	return (pktp);
}

fc_packet_t *
bnxef_prep_prli_resp(bnxef_driver_state_t *dsp, fc_unsol_buf_t *ubp)
{

	fc_packet_t *pktp;
	bnxef_fcoe_task_t *taskp;

	ASSERT(ubp != NULL);

	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = ubp->ub_frame.s_id;
	pktp->pkt_cmd_fhdr.s_id = ubp->ub_frame.d_id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_EXTENDED_LS;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_RSP;
	pktp->pkt_cmd_fhdr.ro   =  0;
	pktp->pkt_cmd_fhdr.f_ctl =
		(F_CTL_XCHG_CONTEXT |F_CTL_LAST_SEQ | F_CTL_END_SEQ |
			F_CTL_SEQ_INITIATIVE);
	pktp->pkt_timeout  = BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = sizeof (la_els_prli_t); /* No Payload for ABTS */

	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);

	taskp->pktp = pktp;
	taskp->task_flags |=  (BNXEF_FCOE_TASK_ELS |
				BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP);

	pktp->pkt_fca_private = taskp;
	/* This was already swapped as a 4 byte quantity, therefore use rx_id */
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d, OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		ubp->ub_frame.ox_id, ubp->ub_frame.rx_id);
	pktp->pkt_cmd_fhdr.ox_id = ubp->ub_frame.ox_id;
	pktp->pkt_ub_resp_token = ubp;

	pktp->pkt_cmdlen = sizeof (la_els_prli_t);

	return (pktp);
}





static void
bnxef_prli_rx_handler(void *arg)
{
	bnxef_tq_params_t  *tqp;
	bnxef_driver_state_t *dsp;
	bnxef_port_t  *portp, *rportp;
	bnxef_session_t	*sessionp;
	bnxef_fcoe_task_t	*taskp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	int			ret;
	uint32_t		id;
	uint8_t		mac_addr[ETHERADDRL];
	uint16_t		vlan_id;
	la_els_prli_t		*prli_infop;
	typedef struct __bnxef_prli_service_params__ {
		uint8_t type;
		uint8_t reserved;
		uint16_t  flags;
		uint32_t   opa;
		uint32_t   rpa;
		uint32_t   serv_params;
	} prli_service_params_t;
	prli_service_params_t  *prlisvp;
	uint8_t			*payloadp;
	uint32_t		frame_length;
	int flags;


	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	portp = tqp->portp;
	dsp   = tqp->dsp;
	sessionp = tqp->sessp;
	taskp    = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);
	fcp = tqp->fcp;
	flags = tqp->flags;

	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	ASSERT(fcoep != NULL);
	ASSERT(fcp != NULL);
	payloadp = (uint8_t *)(fcp + 1);
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: fcp 0x%p, payloadp 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, fcp, payloadp);
	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if (unsolbufp == NULL) {
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;
		la_els_rjt_t rjt;

		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to find a release buffer of type 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;

	id = fcp->s_id;
	bcopy(fcoep->ether.ether_shost.ether_addr_octet, mac_addr,
			ETHERADDRL);
	if (flags)
		vlan_id = VLAN_ID(htons(fcoep->vlan.ether_tci));
	else
		vlan_id = 0;

	/* find the session if it is already existing */
	sessionp = bnxef_session_find_remote_port(portp, vlan_id,
		id, mac_addr);
	if (sessionp == NULL) {
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;
		la_els_rjt_t rjt;

		/*
		 * PLOGI didnot happen - PRLI HAs come to us
		 * We should send LS_RJT with reason LOGI
		 * required
		 */
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: No Session  Existing- Ignoring for  now ",
			BNXEF_DRIVER_NAME, dsp->instance);

		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	ASSERT(sessionp != NULL);

	prli_infop = (la_els_prli_t *)(fcp + 1);
	bnxef_big_endian((uint8_t *)prli_infop, 4);
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: fcp 0x%p, prli_infop 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, fcp, prli_infop);
	if (prli_infop->service_params[0] == 0x8) { /* FCP */
		if (prli_infop->service_params[15] & PRLI_TARGET_FUNCTION) {
			/*
			 * Offload the connection - since this is a
			 * FCP target, no I/O can be flowing until this
			 * LS_ACC can be sent to Leadville stack
			 * Therefore it is safe to allocate resources
			 * without mutex being held. Also remember that
			 * timeouts are already stopped for the task which
			 * sent PRLI.
			 */
			ret = bnxef_alloc_session_resources(sessionp);
			if (ret != BNXEF_SUCCESS) {
				BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d:Unable to allocate session res\n",
					BNXEF_DRIVER_NAME, dsp->instance);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			/*
			 * our firmware expects offloading of session to
			 * to happen serially one at a time. Therefore, here
			 * here we hold the state_mutex which is also the
			 * hardware mutex and offload the complete session.
			 */
			mutex_enter(&sessionp->session_mutex);
			sessionp->con_id = bnxef_alloc_session_con_id(dsp,
					sessionp);
			mutex_exit(&sessionp->session_mutex);

			GLOBAL_mutex_enter(dsp,
				&dsp->global_offload_mutex, __func__, __LINE__);
			mutex_enter(&sessionp->session_mutex);
			ret = bnxef_offload_session(sessionp,
				prli_infop->service_params[14],
				prli_infop->service_params[15]);
			if (ret != BNXEF_SUCCESS) {
				rportp = (bnxef_port_t *)sessionp->rport;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d:Unable to allocate session res 0x%x and 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id,
				rportp->id);
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}

			/* wait for offload completion */
			cv_wait(&sessionp->session_cv,
				&sessionp->session_mutex);
			sessionp->state |= BNXEF_SESSION_OFFLOADED;
			/* Now try to do the enable of the session */
			ret = bnxef_session_enable(sessionp);
			if (ret != BNXEF_SUCCESS) {
				rportp = (bnxef_port_t *)sessionp->rport;
				BNXEF_DEBUG(dsp, ERROR, portp->id,
				"%s%d: Unable to enable session between 0x%x \
						and 0x%x\n",
				BNXEF_DRIVER_NAME, dsp->instance, portp->id,
					rportp->id);
				mutex_exit(&sessionp->session_mutex);
				mutex_exit(&dsp->global_offload_mutex);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				kmem_free(fcoep, frame_length);
				return;
			}
			cv_wait(&sessionp->session_cv,
				&sessionp->session_mutex);
			sessionp->state |= BNXEF_SESSION_ENABLED;
			mutex_exit(&sessionp->session_mutex);
			mutex_exit(&dsp->global_offload_mutex);
		}
	}

	/* Copy the frame received */
	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
		sizeof (fc_frame_hdr_t));

	bcopy((uint8_t *)prli_infop, (uint8_t *)ubp->ub_buffer,
		sizeof (la_els_prli_t));

	if (((fcp->s_id >= NPORT_ID_DOM_CTLR_START) &&
		(fcp->s_id < NPORT_ID_DOM_CTLR_END)) &&
		((prli_infop->service_params[0] == 0x8) &&
		    (prli_infop->service_params[15] &
			PRLI_INITIATOR_FUNCTION))) {
		fc_packet_t *pktp;
		uint64_t token[1];
		bnxef_tq_params_t tq;
		/* Donot callback LV instead respond here */
		pktp = bnxef_prep_prli_resp(dsp, ubp);

		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bcopy(ubp->ub_buffer, pktp->pkt_cmd, pktp->pkt_cmdlen);
		pktp->pkt_cmd[0] = LA_ELS_ACC;
		bnxef_big_endian(pktp->pkt_cmd, 4);

		/* LINTED: alignment */
		prlisvp = (prli_service_params_t *)(pktp->pkt_cmd + 4);
		prlisvp->flags = htons(prlisvp->flags);
		prlisvp->opa = htonl(prlisvp->opa);
		prlisvp->rpa = htonl(prlisvp->rpa);
		prlisvp->serv_params = htonl(prlisvp->serv_params);

		bnxef_send_els((void *)portp, pktp);
		token[0] = (uint64_t)unsolbufp;
		bnxef_ub_release(portp,  1, token);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		bnxef_task_free(dsp, taskp);
		kmem_free(pktp, sizeof (fc_packet_t));
	} else {
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Callback LV for handling PRLI ox_id 0x%x, rx_id 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
			ubp->ub_frame.ox_id, ubp->ub_frame.rx_id);
		if ((prli_infop->service_params[0] == 0x8) &&
		    (prli_infop->service_params[15] &
			PRLI_INITIATOR_FUNCTION)) {
			fc_packet_t *pktp;
			uint64_t token[1];
			bnxef_tq_params_t tq;
			/* Donot callback LV instead respond here */
			pktp = bnxef_prep_prli_resp(dsp, ubp);

			tq.dsp = dsp;
			tq.portp = portp;
			tq.sessp = sessionp;
			bnxef_pkt_cmd_res_alloc(&tq, pktp);
			bcopy(ubp->ub_buffer, pktp->pkt_cmd, pktp->pkt_cmdlen);
			pktp->pkt_cmd[0] = LA_ELS_ACC;
			bnxef_big_endian(pktp->pkt_cmd, 4);
			/* LINTED: alignment */
			prlisvp = (prli_service_params_t *)(pktp->pkt_cmd + 4);
			prlisvp->flags = htons(prlisvp->flags);
			prlisvp->opa = htonl(prlisvp->opa);
			prlisvp->rpa = htonl(prlisvp->rpa);
			prlisvp->serv_params = htonl(prlisvp->serv_params);


			bnxef_send_els((void *)portp, pktp);
			token[0] = (uint64_t)unsolbufp;
			bnxef_ub_release(portp,  1, token);
			bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
			taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
			bnxef_task_free(dsp, taskp);
			kmem_free(pktp, sizeof (fc_packet_t));
		} else {
			portp->pbind.port_unsol_cb(
				(opaque_t)portp->pbind.port_handle,
				ubp, fcp->type);
		}
	}
	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}


static void
bnxef_adisc_rx_handler(void *arg)
{
	bnxef_tq_params_t *tqp;
	bnxef_port_t *portp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_task_t *taskp;
	bnxef_session_t	*sessionp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	la_els_adisc_t		*adiscp;
	int			ret;
	uint32_t		id;
	uint8_t		mac_addr[ETHERADDRL];
	uint16_t		vlan_id;
	uint8_t			*payloadp;
	uint32_t		frame_length;
	int flags;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	portp = tqp->portp;
	dsp   = tqp->dsp;
	sessionp = tqp->sessp;
	taskp    = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);
	fcp = (fc_frame_hdr_t *)tqp->fcp;
	flags = tqp->flags;

	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	ASSERT(fcoep != NULL);
	ASSERT(fcp != NULL);
	payloadp = (uint8_t *)(fcp + 1);
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d: fcp 0x%p, payloadp 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, fcp, payloadp);
	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if (unsolbufp == NULL) {
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;
		la_els_rjt_t rjt;

		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to find a release buffer of type 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;

	id = fcp->s_id;
	bcopy(fcoep->ether.ether_shost.ether_addr_octet, mac_addr,
			ETHERADDRL);
	if (flags)
		vlan_id = VLAN_ID(htons(fcoep->vlan.ether_tci));
	else
		vlan_id = 0;

	/* find the session if it is already existing */
	sessionp = bnxef_session_find_remote_port(portp, vlan_id,
		id, mac_addr);
	if (sessionp == NULL) {
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;
		la_els_rjt_t rjt;

		/*
		 * PLOGI didnot happen - PRLI HAs come to us
		 * We should send LS_RJT with reason LOGI
		 * required
		 */
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: No Session  Existing- Ignoring for  now ",
			BNXEF_DRIVER_NAME, dsp->instance);

		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
			sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	ASSERT(sessionp != NULL);

	adiscp = (la_els_adisc_t *)(fcp + 1);
	bnxef_big_endian((uint8_t *)adiscp, 4);
	/* Copy the frame received */
	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
		sizeof (fc_frame_hdr_t));

	bcopy((uint8_t *)adiscp, (uint8_t *)ubp->ub_buffer,
		sizeof (la_els_adisc_t));

	portp->pbind.port_unsol_cb(
			(opaque_t)portp->pbind.port_handle,
			ubp, fcp->type);
	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}

/*
 * This handles the unsolicited PLOGI request.
 */
static void
bnxef_plogi_rx_handler(void * arg)
{
	bnxef_tq_params_t  *tqp;
	bnxef_driver_state_t *dsp;
	bnxef_port_t  *portp, *rportp;
	bnxef_session_t	*sessionp, *sesp;
	bnxef_fcoe_task_t	*taskp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	la_els_logi_t		*loginp, *srcloginp;
	svc_param_t	*class3_param, *src_class3_param;
	uint8_t			hash;
	int			ret;
	uint32_t frame_length;
	int flags;


	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);

	portp = tqp->portp;
	dsp   = tqp->dsp;
	sessionp = tqp->sessp;
	taskp    = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	fcp = (fc_frame_hdr_t *)tqp->fcp;
	ASSERT(fcp != NULL);
	flags = tqp->flags;

	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);

	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	dsp = portp->statep;
	mutex_enter(&dsp->state_mutex);
	if ((dsp->state & BNXEF_L2_UNLOAD_CALLED) ||
		(dsp->state & BNXEF_DETACH_IN_PROGRESS)) {
		mutex_exit(&dsp->state_mutex);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	ASSERT(fcoep != NULL);

	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if (unsolbufp == NULL) {
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;
		la_els_rjt_t rjt;

		BNXEF_DEBUG(dsp, ERROR, portp->id,
			"%s%d: Unable to find a release buffer of type 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}



	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3;


	srcloginp = (la_els_logi_t *)(fcp + 1);


	/* Allocate a remote port structure from cache and populate info */
	rportp = kmem_cache_alloc(dsp->port_cache, KM_SLEEP);
	ASSERT(rportp != NULL);

	rportp->id = fcp->s_id;
	bcopy(fcoep->ether.ether_shost.ether_addr_octet, rportp->mac_addr,
			ETHERADDRL);

	if (flags)
		rportp->vlan_id = VLAN_ID(htons(fcoep->vlan.ether_tci));
	else
		rportp->vlan_id = 0;

	/* find the session if it is already existing */
	sesp = bnxef_session_find_remote_port(portp, rportp->vlan_id,
		rportp->id, rportp->mac_addr);
	if (sesp != NULL) {
		ret = bnxef_implicit_logout_handler(portp, sesp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_DEBUG(dsp, ELS, -1,
				"%s%d: implicit logout failed",
				BNXEF_DRIVER_NAME, dsp->instance);
			cmn_err(CE_NOTE, "%s%d:Implciit logout failed - 2",
				BNXEF_DRIVER_NAME, dsp->instance);
			rportp->flags = 0;
			rportp->id = 0;
			kmem_cache_free(dsp->port_cache, rportp);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return;
		}
	}


	loginp = &rportp->plogi_info;
	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	bnxef_big_endian(loginp, 4);
	bcopy(&srcloginp->nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&srcloginp->node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(srcloginp->common_service.fcph_version);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(srcloginp->common_service.cmn_features);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);

	rportp->flags = BNXEF_FC_PORT_REMOTE | BNXEF_FC_PORT_N_PORT;
	if ((rportp->id >= 0xFFFFF7) && (rportp->id < 0xFFFFFF))
		rportp->flags |= BNXEF_FC_PORT_WELL_KNOWN;

	/*
	 * Allocate a session from the session cache and set up all
	 * information pertaining to this session.
	 */

	sessionp = kmem_cache_alloc(dsp->session_cache, KM_SLEEP);
	ASSERT(sessionp != NULL);

	sessionp->lport  = portp;
	sessionp->rport = rportp;
	sessionp->next = NULL;

#if 0
	/* Allocate a connection Id */
	sessionp->con_id = bnxef_alloc_session_con_id(dsp, sessionp);
#endif

	/* This will initialize the session task list */
	bnxef_task_session_list_init(dsp, sessionp);

	/* Initialize information which will be used when downloaded. */
	sessionp->max_sqes = BNXEF_SQ_WQES_MAX;
	sessionp->max_cqes = BNXEF_CQ_WQES_MAX;
	sessionp->max_rqes = BNXEF_RQ_WQES_MAX;
	sessionp->doorbell_acc = dsp->doorbell_acc;

	/* Initialize the toggle bit */
	sessionp->sq_toggle = 1;
	sessionp->cq_toggle = 1;
	sessionp->sq_prod_idx = 0;
	sessionp->cq_cons_idx = 0;
	sessionp->rq_prod_idx = 0x8000;
	sessionp->rq_cons_idx = 0;


	/*
	 * Until now this session is not visible to any one, but once
	 * added to the port hash list it is visible. Once visible, it should
	 * be protected by appropriate mutex.
	 */

	hash = bnxef_session_gen_hash(rportp->vlan_id, rportp->id,
			rportp->mac_addr);

	/*
	 * Now make it visible, from now on anything updated you should hold
	 * locks appropriately.
	 */
	bnxef_session_list_add(portp, sessionp, hash);

	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
		sizeof (fc_frame_hdr_t));

	/* LINTED: alignment */
	loginp = (la_els_logi_t *)ubp->ub_buffer;

	loginp->ls_code.ls_code = srcloginp->ls_code.ls_code;
	bnxef_big_endian(loginp, 4);
	bcopy(&srcloginp->nport_ww_name.raw_wwn[0],
		&loginp->nport_ww_name.raw_wwn[0],  8);
	bcopy(&srcloginp->node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);
	loginp->common_service.fcph_version =
		htons(srcloginp->common_service.fcph_version);
	loginp->common_service.btob_credit =
		htons(srcloginp->common_service.btob_credit);
	loginp->common_service.cmn_features =
		htons(srcloginp->common_service.cmn_features);
	loginp->common_service.conc_sequences =
		htons(srcloginp->common_service.conc_sequences);
	loginp->common_service.relative_offset =
		htons(srcloginp->common_service.relative_offset);
	loginp->common_service.e_d_tov =
		htonl(srcloginp->common_service.e_d_tov);
	class3_param = (svc_param_t *)&loginp->class_3;
	src_class3_param = (svc_param_t *)&srcloginp->class_3;
	class3_param->class_opt = htons(src_class3_param->class_opt);

	class3_param->rcv_size = loginp->common_service.rx_bufsize =
		htons(srcloginp->common_service.rx_bufsize);
	class3_param->conc_sequences = htons(src_class3_param->conc_sequences);
	class3_param->open_seq_per_xchng =
		htons(src_class3_param->open_seq_per_xchng);

	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Information arrival of PLOGI to leadville",
		BNXEF_DRIVER_NAME, dsp->instance);
	{
		bnxef_tq_params_t tq;
		fc_packet_t *pktp;

		pktp = bnxef_prep_plogi_resp(dsp, ubp);

		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bcopy(ubp->ub_buffer,  pktp->pkt_cmd, pktp->pkt_cmdlen);
		pktp->pkt_cmd[0] = LA_ELS_ACC;
		pktp->pkt_cmd[1] = 0;
		pktp->pkt_cmd[2] = 0;
		pktp->pkt_cmd[3] = 0;
		bnxef_big_endian(pktp->pkt_cmd, 4);


		/* LINTED: alignment */
		loginp = (la_els_logi_t *)pktp->pkt_cmd;

		bcopy(&portp->plogi_info.nport_ww_name.raw_wwn[0],
			&loginp->nport_ww_name.raw_wwn[0],  8);
		bcopy(&portp->plogi_info.node_ww_name.raw_wwn[0],
		&loginp->node_ww_name.raw_wwn[0], 8);


		bnxef_send_els((void *)portp, pktp);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		bnxef_task_free(dsp, taskp);
		kmem_free(pktp, sizeof (fc_packet_t));
	}
	// delay(BNXEF_SEC2TICK(2));
	portp->pbind.port_unsol_cb((opaque_t)portp->pbind.port_handle,
			ubp, fcp->type);
	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}

fc_packet_t *
bnxef_prep_ls_rjt_with_fhdr(bnxef_driver_state_t *dsp, fc_frame_hdr_t *fcp)
{

	fc_packet_t *pktp;
	bnxef_fcoe_task_t *taskp;

	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = fcp->s_id;
	pktp->pkt_cmd_fhdr.s_id = fcp->d_id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_EXTENDED_LS;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_RSP;
	pktp->pkt_cmd_fhdr.ro   =  0;
	pktp->pkt_cmd_fhdr.f_ctl =
		(F_CTL_XCHG_CONTEXT |F_CTL_LAST_SEQ | F_CTL_END_SEQ |
				F_CTL_SEQ_INITIATIVE);
	pktp->pkt_timeout = BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);
	pktp->pkt_cmdlen = 8;

	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);

	taskp->pktp = pktp;
	taskp->task_flags |= BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP|
			BNXEF_FCOE_TASK_ELS | BNXEF_FCOE_TASK_UNSOLICITED_ELS;

	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
	ASSERT(taskp->payloadp != NULL);

	pktp->pkt_fca_private = taskp;
	/* This was already swapped as a 4 byte quantity, therefore use rx_id */
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d, OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		fcp->ox_id, taskp->x_id);
	pktp->pkt_cmd_fhdr.ox_id = fcp->ox_id;
	pktp->pkt_cmd_fhdr.rx_id = taskp->x_id;


	return (pktp);
}


fc_packet_t *
bnxef_prep_rscn_resp(bnxef_driver_state_t *dsp, fc_unsol_buf_t *ubp)
{
	fc_packet_t *pktp;
	bnxef_fcoe_task_t *taskp;

	ASSERT(ubp != NULL);

	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmd_fhdr.d_id = ubp->ub_frame.s_id;
	pktp->pkt_cmd_fhdr.s_id = ubp->ub_frame.d_id;
	pktp->pkt_cmd_fhdr.type = FC_TYPE_EXTENDED_LS;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_RSP;
	pktp->pkt_cmd_fhdr.ro   =  0;
	pktp->pkt_cmd_fhdr.f_ctl =
		(F_CTL_XCHG_CONTEXT |F_CTL_LAST_SEQ |
		    F_CTL_END_SEQ | F_CTL_SEQ_INITIATIVE);
	pktp->pkt_timeout = BNXEF_RA_TOV;
	pktp->pkt_tran_flags |= (FC_TRAN_CLASS3 | FC_TRAN_INTR);

	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);

	taskp->pktp = pktp;
	taskp->task_flags |=
		(BNXEF_FCOE_TASK_UNSOL_LOCAL_RESP|
			BNXEF_FCOE_TASK_ELS);

	pktp->pkt_fca_private = taskp;
	/* This was already swapped as a 4 byte quantity, therefore use rx_id */
	BNXEF_DEBUG(dsp, ERROR, -1, "%s%d, OX_ID 0x%x, RX_ID 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance,
		ubp->ub_frame.ox_id, ubp->ub_frame.rx_id);
	pktp->pkt_cmd_fhdr.ox_id = ubp->ub_frame.ox_id;
	pktp->pkt_ub_resp_token = ubp;

	pktp->pkt_cmdlen = 4;

	return (pktp);
}

void
bnxef_generate_fabric_rscn(void *arg)
{
	bnxef_port_t *portp = (bnxef_port_t *)arg;
	uint32_t flags;
	timeout_id_t  tid;
	bnxef_driver_state_t *dsp;

	mutex_enter(&portp->port_mutex);
	flags = portp->flags;
	dsp = (bnxef_driver_state_t *)portp->statep;
	mutex_exit(&portp->port_mutex);

	if ((ddi_get_lbolt64() - portp->rscn_rx_lbolt)
		    >= BNXEF_SEC2TICK(2*60)) {
		if (flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) {
			(void) ddi_taskq_dispatch(dsp->tq,
				bnxef_generate_fabric_rscn_impl, (void *) portp,
				DDI_NOSLEEP);
		}
	} else {
		if (flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) {
			tid = timeout(bnxef_generate_fabric_rscn,
				(void *) portp,
				BNXEF_SEC2TICK(60));
			mutex_enter(&portp->port_mutex);
			portp->flags |= BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
			portp->rscn_tid = tid;
			mutex_exit(&portp->port_mutex);
		}
	}
}

/*
 * This will generate fabric RSCN depending on whether we could
 * get an unsolicited buffer or not, but we generate fabric RSCN
 * based on the time.
 */
void
bnxef_generate_fabric_rscn_impl(void  *arg)
{
	bnxef_driver_state_t 	*dsp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_frame_hdr_t		*fcp;
	fc_unsol_buf_t		*ubp;
	fc_rscn_t		*rscnp;
	fc_affected_id_t		*aff_id;
	uint8_t ignore_rscn = 0;
	bnxef_port_t *portp = (bnxef_port_t *)arg;

	ASSERT(portp != NULL);
	dsp = (bnxef_driver_state_t *)portp->statep;
	ASSERT(dsp != NULL);

	mutex_enter(&portp->port_mutex);
	// portp->flags &= ~BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
	portp->flags &= ~BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
	mutex_exit(&portp->port_mutex);
	/*
	 * If we ever reject RSCN, that means we may
	 * not see changes in some targets
	 * Therefore generate a Fabric RSCN internally to
	 * Leadville to make it scan all fabric once
	 * after 1 minute at the end of all the RSCN's are done.
	 */
	do {
		delay(BNXEF_SEC2TICK(10));
		if (dsp->state & BNXEF_L2_UNLOAD_CALLED) {
			ignore_rscn = 1;
			break;
		}
		unsolbufp = bnxef_find_unsol_buf(portp, 0x1);
	} while (unsolbufp == NULL);
	if (ignore_rscn) {
		return;
	}
	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;
	fcp = (fc_frame_hdr_t *)&ubp->ub_frame;

	/* This is the frame header of concoted RSCN */
	fcp->r_ctl = 0x22;
	fcp->d_id = portp->id;
	fcp->s_id = 0xFFFFFD;
	fcp->type = 0x01;
	fcp->f_ctl = 0x290000;
	fcp->seq_id = 0x21;
	fcp->df_ctl = 0;
	fcp->seq_cnt = 0x0;
	fcp->ox_id = 0xfffe;
	fcp->rx_id = 0xffff;
	fcp->ro = 0x0;

	/* set the Payload for Fabric RSCN */
	/* LINTED: alignment */
	rscnp = (fc_rscn_t *)ubp->ub_buffer;
	rscnp->rscn_code = 0x61;
	rscnp->rscn_len = 4;
	rscnp->rscn_payload_len = 0x8;
	/* LINTED: alignment */
	aff_id = (fc_affected_id_t *)((uint8_t *)ubp->ub_buffer + 4);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Affected Ids 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, *((uint32_t *)aff_id));
	aff_id->aff_format = 0x2;
	aff_id->aff_d_id = (aff_id->aff_d_id & 0xFF0000);

	portp->pbind.port_unsol_cb((opaque_t)portp->pbind.port_handle,
			ubp, 0x1);

	delay(BNXEF_SEC2TICK(2));
	mutex_enter(&portp->port_mutex);
	portp->flags &= ~BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
	mutex_exit(&portp->port_mutex);
}



/*
 * This handles the unsolicited RSCN request
 */
static void
bnxef_rscn_rx_handler(void * arg)
{
	bnxef_tq_params_t 	*tqp;
	bnxef_port_t		*portp;
	bnxef_session_t		*sessionp;
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	fc_rscn_t		*rscnp;
	fc_affected_id_t	*aff_id;
	fc_packet_t *pktp;
	uint64_t token[1];
	bnxef_tq_params_t	tq;
	int 			i;
	int			generate_fabric_rscn = 0;
	// uint8_t			ignore_rscn = 0;
	uint32_t		flags;
	timeout_id_t		tid;
	int			active_ubs;
	uint32_t		frame_length;

	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	portp = tqp->portp;
	dsp   = tqp->dsp;
	sessionp = tqp->sessp;
	taskp    = tqp->taskp;
	fcoep = tqp->framep;
	frame_length = tqp->frame_length;
	flags = tqp->flags;
	fcp = (fc_frame_hdr_t *)tqp->fcp;


	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);

	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Entered rscn Rx handler",
		BNXEF_DRIVER_NAME, dsp->instance);

	MUTEX_ENTER(dsp, &dsp->state_mutex, __func__, __LINE__);
	if (dsp->state & BNXEF_PORT_CVL_PROCESSING_INPROGRESS) {
		mutex_exit(&dsp->state_mutex);
	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Exiting rscn Rx handler, CVL processing in progress",
		BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&dsp->state_mutex);

	mutex_enter(&portp->port_mutex);
	if (portp->fip_state & FIP_VIRTUAL_LINK_CLEAR_IN_PROGRESS) {
		mutex_exit(&portp->port_mutex);
	BNXEF_DEBUG(dsp, ELS, -1,
		"%s%d: Exiting, Link Clear processing in progress",
		BNXEF_DRIVER_NAME, dsp->instance);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}
	mutex_exit(&portp->port_mutex);

	ASSERT(fcoep != NULL);
	ASSERT(fcp != NULL);

	mutex_enter(&portp->port_mutex);
	portp->rscn_rx_lbolt = ddi_get_lbolt64();
	mutex_exit(&portp->port_mutex);

//	if (portp->flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN)  {
	active_ubs = bnxef_get_active_ub_count(portp);
	if (active_ubs > 8) {
		la_els_rjt_t rjt;
		int ret;

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: RSCN: Fabric RSCN requested",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		mutex_enter(&portp->port_mutex);
		flags = portp->flags;
		mutex_exit(&portp->port_mutex);
		if ((flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) == 0) {
			tid = timeout(bnxef_generate_fabric_rscn,
				(void *) portp,
				BNXEF_SEC2TICK(60));
			mutex_enter(&portp->port_mutex);
			portp->flags |= BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
				// | BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
			portp->rscn_tid = tid;
			mutex_exit(&portp->port_mutex);
		}

		mutex_enter(&portp->port_mutex);
		portp->flags |= BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
		mutex_exit(&portp->port_mutex);

		BNXEF_STATS(dsp, rscn_rx);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}


	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if (unsolbufp == NULL) {
		la_els_rjt_t rjt;
		int ret;

		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: RSCN: Unable to find a release buffer of type 0x%x\n",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		mutex_enter(&portp->port_mutex);
		flags = portp->flags;
		mutex_exit(&portp->port_mutex);

		if ((flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) == 0) {
			tid = timeout(bnxef_generate_fabric_rscn,
				(void *) portp,
				BNXEF_SEC2TICK(60));
			mutex_enter(&portp->port_mutex);
			portp->flags |= BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
				// | BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
			portp->rscn_tid = tid;
			mutex_exit(&portp->port_mutex);
		}

		mutex_enter(&portp->port_mutex);
		portp->flags |= BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
		// cmn_err(CE_NOTE, "%s%d: Generate Fabric RSCN requested",
		//	BNXEF_DRIVER_NAME, dsp->instance);
		mutex_exit(&portp->port_mutex);
		BNXEF_STATS(dsp, rscn_rx);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
#if 0
		/*
		 * If we ever reject RSCN, that means we may
		 * not see changes in some targets
		 * Therefore generate a Fabric RSCN internally to
		 * Leadville to make it scan all fabric once
		 * after 10-15 secs.
		 */
		mutex_enter(&portp->port_mutex);
		if ((portp->flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) == 0) {
			portp->flags |= BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
			mutex_exit(&portp->port_mutex);
			do {
				delay(BNXEF_SEC2TICK(10));
				if (dsp->state & BNXEF_L2_UNLOAD_CALLED) {
					ignore_rscn = 1;
					break;
				}
				unsolbufp =
					bnxef_find_unsol_buf(portp, fcp->type);
			} while (unsolbufp == NULL);
			if (ignore_rscn) {
				mutex_enter(&portp->port_mutex);
				portp->flags &=
					~BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
				mutex_exit(&portp->port_mutex);
				BNXEF_STATS(dsp, rscn_rx);
				BNXEF_STATS(dsp, l2_fcoe_rx_free);
				BNXEF_STATS(dsp, l2_rx_free);
				freemsg(mp);
				return;
			}

			generate_fabric_rscn = 1;
			delay(BNXEF_SEC2TICK(3*60));
		} else {
			mutex_exit(&portp->port_mutex);
			BNXEF_STATS(dsp, rscn_rx);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			return;
		}
		ASSERT(unsolbufp != NULL);
		ASSERT(generate_fabric_rscn == 1);
#endif
	}

	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;

	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
		sizeof (fc_frame_hdr_t));
	bcopy((uint8_t *)(fcp+1), (uint8_t *)ubp->ub_buffer, 4);
	bnxef_big_endian(ubp->ub_buffer, 4);
	/* LINTED: alignment */
	rscnp = (fc_rscn_t *)(ubp->ub_buffer);
	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: RSCN Payload Length Original 0x%x",
		BNXEF_DRIVER_NAME, dsp->instance, rscnp->rscn_payload_len);
	rscnp->rscn_payload_len = htons(rscnp->rscn_payload_len);

	if ((rscnp->rscn_payload_len < 8) ||
		((rscnp->rscn_payload_len % 4) != 0) ||
		(rscnp->rscn_len != 4)) {

		la_els_rjt_t rjt;
		int ret;

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: RSCN: Payload length, page length Incorrect",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_LOGICAL_ERR,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
				sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

		mutex_enter(&portp->port_mutex);
		flags = portp->flags;
		mutex_exit(&portp->port_mutex);
		if ((flags & BNXEF_FC_PORT_GENERATE_FABRIC_RSCN) == 0) {
			tid = timeout(bnxef_generate_fabric_rscn,
				(void *) portp,
				BNXEF_SEC2TICK(60));
			mutex_enter(&portp->port_mutex);
			portp->flags |= BNXEF_FC_PORT_RSCN_TIMEOUT_VALID;
				// | BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
			portp->rscn_tid = tid;
			mutex_exit(&portp->port_mutex);
		}

		mutex_enter(&portp->port_mutex);
		portp->flags |= BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
		mutex_exit(&portp->port_mutex);

		BNXEF_STATS(dsp, rscn_rx);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;

	}

	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: RSCN unsol_buf allocated 0x%p",
		BNXEF_DRIVER_NAME, dsp->instance, unsolbufp);
	bcopy(((uint8_t *)(fcp+1)+4), ((uint8_t *)ubp->ub_buffer+4),
		rscnp->rscn_payload_len-4);
	bnxef_big_endian(ubp->ub_buffer+4, rscnp->rscn_payload_len-4);
	if ((rscnp->rscn_payload_len > 8) || (generate_fabric_rscn)) {
		/*
		 * The last page is coverted to a domain RSCN
		 * if it is port RSCN
		 */
		i = (rscnp->rscn_payload_len-4)/4 -1;
		/* LINTED: alignment */
		aff_id = (fc_affected_id_t *)
			((uint8_t *)ubp->ub_buffer + 4 + i*4);
		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Affected Ids 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance,
			 *((uint32_t *)aff_id));
		if (aff_id->aff_format == 0x00) {
			aff_id->aff_format = 0x2;
			aff_id->aff_d_id = (aff_id->aff_d_id & 0xFF0000);
			BNXEF_DEBUG(dsp, ERROR, -1,
				"%s%d: Affected Ids 0x%x",
				BNXEF_DRIVER_NAME, dsp->instance,
				*((uint32_t *)aff_id));
		}
	}

	if (generate_fabric_rscn == 0) {
		/*
		 * Before you inform the Leadville stack,
		 * please respond to it, with LS_ACC
		 * when Leadville gives the response,
		 * ignore that response and donot respond.
		 * Also indicate that this response created internally
		 * should be allowedby
		 * bnxef_send_els, by special flag in the task structure.
		 * If that flag is not
		 * set and it is a response for RSCN then it is
		 * response coming from Leadville
		 * therefore do everything and indicate success
		 * to Leadville instead of transmitting
		 * the response from Leadville.
		 */
		pktp = bnxef_prep_rscn_resp(dsp, ubp);

		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bcopy(ubp->ub_buffer, pktp->pkt_cmd, pktp->pkt_cmdlen);
		pktp->pkt_cmd[0] = LA_ELS_ACC;
		pktp->pkt_cmd[1] = 0;
		pktp->pkt_cmd[2] = 0;
		pktp->pkt_cmd[3] = 0;
		bnxef_big_endian(pktp->pkt_cmd, 4);

		token[0] = (uint64_t)unsolbufp;
		bnxef_send_els((void *)portp, pktp);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));

	}


#if 0
	else {
		mutex_enter(&portp->port_mutex);
		portp->flags &= ~BNXEF_FC_PORT_GENERATE_FABRIC_RSCN;
		mutex_exit(&portp->port_mutex);
	}
#endif


	portp->pbind.port_unsol_cb((opaque_t)portp->pbind.port_handle,
		ubp, fcp->type);

	BNXEF_STATS(dsp, rscn_rx);
	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);

	kmem_free(fcoep, frame_length);
}


/*
 * This handles the unsolicited LOGO request
 */
static void
bnxef_logo_rx_handler(void * arg)
{
	bnxef_tq_params_t 	*tqp;
	bnxef_port_t		*portp;
	bnxef_session_t		*sessionp;
	bnxef_fcoe_task_t	*taskp;
	bnxef_driver_state_t *dsp;
	bnxef_fcoe_frame_t 	*fcoep;
	fc_frame_hdr_t 		*fcp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	fc_packet_t *pktp;
	bnxef_tq_params_t	tq;
	int 			active_ubs;
	int frame_length;



	tqp = (bnxef_tq_params_t *)arg;
	ASSERT(tqp != NULL);
	portp = tqp->portp;
	dsp   = tqp->dsp;
	sessionp = tqp->sessp;
	taskp    = tqp->taskp;
	fcoep 	= tqp->framep;
	frame_length = tqp->frame_length;
	fcp = (fc_frame_hdr_t *)tqp->fcp;

	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);

	if (dsp != NULL) {
		mutex_enter(&dsp->state_mutex);
		if (dsp->state & BNXEF_L2_UNLOAD_CALLED) {
			mutex_exit(&dsp->state_mutex);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			kmem_free(fcoep, frame_length);
			return;
		}
		mutex_exit(&dsp->state_mutex);
	} else {
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	if (portp == NULL) {
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}



	/* We have recovered all we need, we can free th tqp structure */
	kmem_cache_free(dsp->tq_params_cache, tqp);

	ASSERT(fcoep != NULL);
	ASSERT(fcp != NULL);

	/*
	 * the following check if it is true means that continuous
	 * slew of RSCNs are happening which could cause Leadville to
	 * be confused. Therefore until the RSCN slew stops and
	 * the fabric discovery is done, donot allow LOGO to be
	 * sent to Leadville as it confuses the brain and causes
	 * various problems.
	 */
	active_ubs = bnxef_get_active_ub_count(portp);
	if (active_ubs > 8) {
		la_els_rjt_t rjt;
		int ret;

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: RSCN: Fabric RSCN requested",
			BNXEF_DRIVER_NAME, dsp->instance);
		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
			    sessionp, pktp, BNXEF_USE_RX_ID);

		ASSERT(ret == FC_SUCCESS);
		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			(bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));
		BNXEF_STATS(dsp, rscn_rx);
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if ((unsolbufp == NULL)) {
		la_els_rjt_t rjt;
		int ret;
		BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: LOGO:Unable to find a release buffer of type 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);

		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
			    sessionp, pktp, BNXEF_USE_RX_ID);
		ASSERT(ret == FC_SUCCESS);

		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			    (bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return;
	}

	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;

	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
			    sizeof (fc_frame_hdr_t));
	bcopy((uint8_t *)(fcp+1), (uint8_t *)ubp->ub_buffer,
			sizeof (la_els_logo_t));
	bnxef_big_endian(ubp->ub_buffer, 4);

#if 0
	if (sessionp != NULL) {
		mutex_enter(&sessionp->session_mutex);
		if (sessionp->state & BNXEF_SESSION_CLEANUP_INPROGRESS) {
			mutex_exit(&sessionp->session_mutex);
			BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Session Cleanup in progress- Dropping Frame",
				    BNXEF_DRIVER_NAME, dsp->instance);
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			return;
		}
		mutex_exit(&sessionp->session_mutex);
		/* Delay for sometime to drain I/Os */
		// delay(BNXEF_SEC2TICK(3));
		BNXEF_DEBUG(dsp, GENERAL, -1, "%s%d: Implicit logo Called",
			BNXEF_DRIVER_NAME, dsp->instance);
		ret = bnxef_implicit_logout_handler(portp, sessionp);
		if (ret != BNXEF_SUCCESS) {
			BNXEF_STATS(dsp, l2_fcoe_rx_free);
			BNXEF_STATS(dsp, l2_rx_free);
			freemsg(mp);
			return;
		}
	}
#endif

	/* debug_enter("Verify Logo data"); */

	mutex_enter(&dsp->state_mutex);
	if ((dsp->state & BNXEF_L2_UNLOAD_CALLED) == 0) {
		mutex_exit(&dsp->state_mutex);
		portp->pbind.port_unsol_cb((opaque_t)portp->pbind.port_handle,
			ubp, fcp->type);
		mutex_enter(&dsp->state_mutex);
	} else {
		cmn_err(CE_NOTE, "Leadville not called as Unload is going on");
	}
	mutex_exit(&dsp->state_mutex);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	kmem_free(fcoep, frame_length);
}

/*
 * This handles any other unsolicited ELS that was received via L2 interface.
 */
static int
bnxef_unsolicited_els_rx_handler(bnxef_port_t *portp,
	bnxef_session_t *sessionp, bnxef_fcoe_task_t *taskp,
	bnxef_fcoe_frame_t *fcoep, uint32_t frame_length, void *fp)
{
	bnxef_driver_state_t *dsp;
	fc_frame_hdr_t 		*fcp;
	// uint8_t 		*elsp;
	bnxef_unsol_buf_t	*unsolbufp;
	fc_unsol_buf_t		*ubp;
	uint32_t size;

	ASSERT(portp != NULL);
	ASSERT(taskp == NULL);

	dsp = portp->statep;

	ASSERT(fcoep != NULL);
	fcp = (fc_frame_hdr_t *)fp;
	ASSERT(fcp != NULL);
	// elsp = (uint8_t *)(fcp + 1);

	/* FC paylaod size */
	size = frame_length - sizeof (fc_frame_hdr_t);

	/*
	 * Now look for the unsolicited buffer from the Unsolicited buffer pool
	 */
	unsolbufp = bnxef_find_unsol_buf(portp, fcp->type);
	if (unsolbufp == NULL) {
		la_els_rjt_t rjt;
		int ret;
		fc_packet_t *pktp;
		bnxef_tq_params_t	tq;

		BNXEF_DEBUG(dsp, ERROR, -1,
			"%s%d: Unable to find a release buffer of type 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, fcp->type);

		/* Prepare LS_RJT */
		pktp = bnxef_prep_ls_rjt_with_fhdr(dsp, fcp);
		ASSERT(pktp != NULL);
		tq.dsp = dsp;
		tq.portp = portp;
		tq.sessp = sessionp;
		bnxef_pkt_cmd_res_alloc(&tq, pktp);
		bnxef_build_ls_rjt_cmd(&rjt, pktp,
			BNXEF_LA_RJT_UNABLE_TO_PERFORM,	0);
		taskp = (bnxef_fcoe_task_t *)pktp->pkt_fca_private;
		ASSERT(taskp != NULL);
		bcopy(&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
				sizeof (fc_frame_hdr_t));
		bcopy(pktp->pkt_cmd, taskp->payloadp, sizeof (la_els_rjt_t));
		taskp->payloadsz = sizeof (la_els_rjt_t);
		bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		bnxef_big_endian(taskp->payloadp, 4);
		ret = bnxef_els_tx_nonofld_session_noresp(portp,
			    sessionp, pktp, BNXEF_USE_RX_ID);
		ASSERT(ret == FC_SUCCESS);

		bnxef_pkt_cmd_res_free(pktp, BNXEF_PKT_CMD_ALL);
		kmem_free(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
		kmem_free(taskp->payloadp, sizeof (la_els_rjt_t));
		bnxef_task_free(dsp,
			    (bnxef_fcoe_task_t *)pktp->pkt_fca_private);
		kmem_free(pktp, sizeof (fc_packet_t));
		BNXEF_STATS(dsp, l2_fcoe_rx_free);
		BNXEF_STATS(dsp, l2_rx_free);
		kmem_free(fcoep, frame_length);
		return (BNXEF_FAILURE);
	}

	ubp = unsolbufp->unsol_bufp;

	/* Now set the Unsolicited buffer with all the information. */
	ubp->ub_class = FC_TRAN_CLASS3 | FC_TRAN_INTR;

	bcopy((uint8_t *)fcp, (uint8_t *)&ubp->ub_frame,
		sizeof (fc_frame_hdr_t));
	bcopy((uint8_t *)(fcp+1), (uint8_t *)ubp->ub_buffer, size);

	bnxef_send_ls_rjt(portp, sessionp, unsolbufp,
		BNXEF_LA_RJT_UNABLE_TO_PERFORM, 0x0);

	BNXEF_STATS(dsp, l2_fcoe_rx_free);
	BNXEF_STATS(dsp, l2_rx_free);
	/* Free the message Block */
	kmem_free(fcoep, frame_length);

	return (BNXEF_SUCCESS);
}


void
bnxef_send_ls_rjt(bnxef_port_t *portp, bnxef_session_t *sessionp,
	bnxef_unsol_buf_t *unsolbufp, uint8_t reason, uint8_t expln)
{
	bnxef_driver_state_t *dsp;
	fc_packet_t *pktp;
	bnxef_fcoe_task_t *taskp;
	la_els_rjt_t	rjt;
	fc_unsol_buf_t *ubp;
	uint64_t token[1];
	int ret;
	uint32_t d_id;

	dsp = portp->statep;
	ASSERT(dsp != NULL);

	ASSERT(unsolbufp != NULL);

	ubp = unsolbufp->unsol_bufp;

	pktp = kmem_zalloc(sizeof (fc_packet_t), KM_SLEEP);
	ASSERT(pktp != NULL);

	pktp->pkt_cmd = kmem_zalloc(sizeof (la_els_rjt_t), KM_SLEEP);
	ASSERT(pktp != NULL);
	pktp->pkt_cmdlen = sizeof (la_els_rjt_t);
	taskp = bnxef_task_alloc(dsp, KM_SLEEP);
	ASSERT(taskp != NULL);

	taskp->frame_hdrp = kmem_zalloc(sizeof (fc_frame_hdr_t), KM_SLEEP);
	ASSERT(taskp->frame_hdrp != NULL);
	if (pktp->pkt_cmdlen > 0)  {
		taskp->payloadp = kmem_zalloc(pktp->pkt_cmdlen, KM_SLEEP);
		ASSERT(taskp->payloadp != NULL);
	}

	mutex_enter(&taskp->task_mutex);
	taskp->task_flags |= BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;

	if (pktp->pkt_cmdlen > 0) {
		taskp->task_flags |= BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
	}
	taskp->task_flags |= BNXEF_FCOE_TASK_UNSOLICITED_ELS;
	taskp->pktp = pktp;

	bcopy((uint8_t *)&ubp->ub_frame, (uint8_t *)&pktp->pkt_cmd_fhdr,
		sizeof (fc_frame_hdr_t));

	d_id = pktp->pkt_cmd_fhdr.d_id;
	pktp->pkt_cmd_fhdr.d_id = pktp->pkt_cmd_fhdr.s_id;
	pktp->pkt_cmd_fhdr.s_id = d_id;
	pktp->pkt_cmd_fhdr.r_ctl = R_CTL_ELS_RSP;
	pktp->pkt_cmd_fhdr.f_ctl =
		F_CTL_XCHG_CONTEXT | F_CTL_LAST_SEQ | F_CTL_END_SEQ;
	pktp->pkt_cmd_fhdr.rx_id = taskp->x_id;

	bcopy((uint8_t *)&pktp->pkt_cmd_fhdr, taskp->frame_hdrp,
			sizeof (fc_frame_hdr_t));

	bnxef_big_endian(taskp->frame_hdrp, sizeof (fc_frame_hdr_t));
	pktp->pkt_fca_private = (void *)taskp;
	mutex_exit(&taskp->task_mutex);

	bnxef_build_ls_rjt_cmd(&rjt, pktp, reason, expln);

	bcopy(pktp->pkt_cmd, taskp->payloadp, pktp->pkt_cmdlen);
	bnxef_big_endian(taskp->payloadp, 4);
	taskp->payloadsz = sizeof (la_els_rjt_t);


	BNXEF_DEBUG(dsp, ERROR, -1,
		"%s%d: Sending LS_RJT for ELS 0x%x",
			BNXEF_DRIVER_NAME, dsp->instance, ubp->ub_buffer[0]);
	ret = bnxef_els_tx_nonofld_session_noresp(portp,
			    sessionp, pktp, BNXEF_USE_RX_ID);

	ASSERT(ret == FC_SUCCESS);

	mutex_enter(&taskp->task_mutex);
	if (taskp->task_flags & BNXEF_FCOE_TASK_PAYLOAD_ALLOC)
		taskp->task_flags &= ~BNXEF_FCOE_TASK_PAYLOAD_ALLOC;
	if (taskp->task_flags & BNXEF_FCOE_TASK_FRAME_HDR_ALLOC)
		taskp->task_flags &= ~BNXEF_FCOE_TASK_FRAME_HDR_ALLOC;
	if (taskp->task_flags & BNXEF_FCOE_TASK_UNSOLICITED_ELS)
		taskp->task_flags &= ~BNXEF_FCOE_TASK_UNSOLICITED_ELS;
	mutex_exit(&taskp->task_mutex);

	bnxef_end_task(dsp, pktp);

	kmem_free(pktp, sizeof (fc_packet_t));

	token[0] = (uint64_t)unsolbufp;
	bnxef_ub_release((opaque_t)portp, 1, token);
}


void
bnxef_build_ls_rjt_cmd(la_els_rjt_t *rjt, fc_packet_t *pktp, uint8_t reason,
	uint8_t expln)
{

	ASSERT(rjt != NULL);
	ASSERT(pktp != NULL);

	bzero(rjt, sizeof (la_els_rjt_t));
	rjt->ls_code.ls_code = LA_ELS_RJT;
	rjt->reason = reason;
	rjt->reserved = expln;

	bcopy(rjt, pktp->pkt_cmd, sizeof (la_els_rjt_t));

}


/*
 * Compare two WWNs.
 * The NAA can't be omitted for comparison.
 *
 * Return Values:
 *   if src == dst return  0
 *   if src > dst  return  1
 *   if src < dst  return -1
 */
int
bnxef_wwn_cmp(la_wwn_t *src, la_wwn_t *dst)
{
	uint8_t *l, *r;
	int i;
	uint64_t wl, wr;

	l = (uint8_t *)src;
	r = (uint8_t *)dst;

	for (i = 0, wl = 0; i < 8; i++) {
		wl <<= 8;
		wl |= l[i];
	}
	for (i = 0, wr = 0; i < 8; i++) {
		wr <<= 8;
		wr |= r[i];
	}

	if (wl > wr) {
		return (1);
	} else if (wl == wr) {
		return (0);
	} else {
		return (-1);
	}
}

void
bnxef_log_session_life_cycle(bnxef_port_t *portp, bnxef_session_t *sessionp,
		int type)
{

	bnxef_session_life_cycle_t *slcp;
	mutex_enter(&portp->port_mutex);
	slcp = &portp->slcp[portp->slcpidx];
	slcp->sessionp = sessionp;
	slcp->type = type;
	slcp->lbolt64 = ddi_get_lbolt64();
	portp->slcpidx = (portp->slcpidx+1) % BNXEF_SLCP_MAX_IDX;
	mutex_exit(&portp->port_mutex);
}
